"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _webgl = require("@luma.gl/webgl");

var _constants = require("@luma.gl/constants");

var _core = require("@deck.gl/core");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var MaskPass = function (_LayersPass) {
  (0, _inherits2.default)(MaskPass, _LayersPass);

  var _super = _createSuper(MaskPass);

  function MaskPass(device, props) {
    var _this;

    (0, _classCallCheck2.default)(this, MaskPass);
    _this = _super.call(this, device, props);
    _this.maskMap = void 0;
    _this.fbo = void 0;
    var _props$mapSize = props.mapSize,
        mapSize = _props$mapSize === void 0 ? 2048 : _props$mapSize;
    _this.maskMap = device.createTexture({
      format: 'rgba8unorm',
      width: mapSize,
      height: mapSize,
      sampler: {
        minFilter: 'linear',
        magFilter: 'linear',
        addressModeU: 'clamp-to-edge',
        addressModeV: 'clamp-to-edge'
      }
    });
    _this.fbo = device.createFramebuffer({
      id: 'maskmap',
      width: mapSize,
      height: mapSize,
      colorAttachments: [_this.maskMap]
    });
    return _this;
  }

  var _proto = MaskPass.prototype;

  _proto.render = function render(options) {
    var _this2 = this;

    var colorMask = [false, false, false, false];
    colorMask[options.channel] = true;
    var clearColor = [255, 255, 255, 255];
    return (0, _webgl.withGLParameters)(this.device, {
      blend: true,
      blendFunc: [0, 1],
      blendEquation: 32778,
      colorMask: colorMask,
      depthTest: false
    }, function () {
      return (0, _get2.default)((0, _getPrototypeOf2.default)(MaskPass.prototype), "render", _this2).call(_this2, _objectSpread(_objectSpread({}, options), {}, {
        clearColor: clearColor,
        target: _this2.fbo,
        pass: 'mask'
      }));
    });
  };

  _proto.shouldDrawLayer = function shouldDrawLayer(layer) {
    return layer.props.operation.includes('mask');
  };

  _proto.delete = function _delete() {
    this.fbo.delete();
    this.maskMap.delete();
  };

  return MaskPass;
}(_core._LayersPass);

exports.default = MaskPass;
//# sourceMappingURL=mask-pass.js.map