import { withGLParameters } from '@luma.gl/webgl';
import { _LayersPass as LayersPass } from '@deck.gl/core';
export default class CollisionFilterPass extends LayersPass {
  renderCollisionMap(target, options) {
    const padding = 1;
    const clearColor = [0, 0, 0, 0];
    return withGLParameters(this.device, {
      scissorTest: true,
      scissor: [padding, padding, target.width - 2 * padding, target.height - 2 * padding],
      blend: false,
      depthTest: true,
      depthRange: [0, 1]
    }, () => this.render({ ...options,
      clearColor,
      target,
      pass: 'collision'
    }));
  }

  getModuleParameters() {
    return {
      drawToCollisionMap: true,
      pickingActive: 1,
      pickingAttribute: false,
      lightSources: {}
    };
  }

}
//# sourceMappingURL=collision-filter-pass.js.map