(function webpackUniversalModuleDefinition(root, factory) {
  if (typeof exports === 'object' && typeof module === 'object')
    module.exports = factory();
  else if (typeof define === 'function' && define.amd) define([], factory);
        else if (typeof exports === 'object') exports['deck'] = factory();
  else root['deck'] = factory();})(globalThis, function () {
"use strict";
var __exports__ = (() => {
  var __create = Object.create;
  var __defProp = Object.defineProperty;
  var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames = Object.getOwnPropertyNames;
  var __getProtoOf = Object.getPrototypeOf;
  var __hasOwnProp = Object.prototype.hasOwnProperty;
  var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
  var __commonJS = (cb, mod) => function __require() {
    return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
  };
  var __export = (target, all) => {
    for (var name in all)
      __defProp(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key of __getOwnPropNames(from))
        if (!__hasOwnProp.call(to, key) && key !== except)
          __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
    }
    return to;
  };
  var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
  var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
    isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
    mod
  ));
  var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
  var __publicField = (obj, key, value) => {
    __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
    return value;
  };

  // external-global-plugin:@deck.gl/core
  var require_core = __commonJS({
    "external-global-plugin:@deck.gl/core"(exports, module) {
      module.exports = globalThis.deck;
    }
  });

  // external-global-plugin:@luma.gl/core
  var require_core2 = __commonJS({
    "external-global-plugin:@luma.gl/core"(exports, module) {
      module.exports = globalThis.luma;
    }
  });

  // bundle.ts
  var bundle_exports = {};
  __export(bundle_exports, {
    BrushingExtension: () => BrushingExtension,
    ClipExtension: () => ClipExtension,
    CollisionFilterExtension: () => CollisionFilterExtension,
    DataFilterExtension: () => DataFilterExtension,
    FillStyleExtension: () => FillStyleExtension,
    Fp64Extension: () => Fp64Extension,
    MaskExtension: () => MaskExtension,
    PathStyleExtension: () => PathStyleExtension,
    _TerrainExtension: () => TerrainExtension,
    project64: () => project64_default
  });

  // ../core/bundle/peer-dependency.ts
  var peer_dependency_exports = {};
  var import_core = __toESM(require_core());
  __reExport(peer_dependency_exports, __toESM(require_core()));
  if (!import_core.Layer) {
    throw new Error("@deck.gl/core is not found");
  }

  // bundle.ts
  __reExport(bundle_exports, peer_dependency_exports);

  // src/brushing/brushing-extension.ts
  var import_core3 = __toESM(require_core());

  // src/brushing/shader-module.ts
  var import_core2 = __toESM(require_core());
  var vs = `
  uniform bool brushing_enabled;
  uniform int brushing_target;
  uniform vec2 brushing_mousePos;
  uniform float brushing_radius;

  #ifdef NON_INSTANCED_MODEL
  attribute vec2 brushingTargets;
  #else
  attribute vec2 instanceBrushingTargets;
  #endif

  varying float brushing_isVisible;

  bool brushing_isPointInRange(vec2 position) {
    if (!brushing_enabled) {
      return true;
    }
    vec2 source_commonspace = project_position(position);
    vec2 target_commonspace = project_position(brushing_mousePos);
    float distance = length((target_commonspace - source_commonspace) / project_uCommonUnitsPerMeter.xy);

    return distance <= brushing_radius;
  }

  bool brushing_arePointsInRange(vec2 sourcePos, vec2 targetPos) {
    return brushing_isPointInRange(sourcePos) || brushing_isPointInRange(targetPos);
  }

  void brushing_setVisible(bool visible) {
    brushing_isVisible = float(visible);
  }
`;
  var fs = `
  uniform bool brushing_enabled;
  varying float brushing_isVisible;
`;
  var TARGET = {
    source: 0,
    target: 1,
    custom: 2,
    source_target: 3
  };
  var inject = {
    "vs:DECKGL_FILTER_GL_POSITION": `
    vec2 brushingTarget;
    vec2 brushingSource;
    if (brushing_target == 3) {
      brushingTarget = geometry.worldPositionAlt.xy;
      brushingSource = geometry.worldPosition.xy;
    } else if (brushing_target == 0) {
      brushingTarget = geometry.worldPosition.xy;
    } else if (brushing_target == 1) {
      brushingTarget = geometry.worldPositionAlt.xy;
    } else {
      #ifdef NON_INSTANCED_MODEL
      brushingTarget = brushingTargets;
      #else
      brushingTarget = instanceBrushingTargets;
      #endif
    }
    bool visible;
    if (brushing_target == 3) {
      visible = brushing_arePointsInRange(brushingSource, brushingTarget);
    } else {
      visible = brushing_isPointInRange(brushingTarget);
    }
    brushing_setVisible(visible);
  `,
    "fs:DECKGL_FILTER_COLOR": `
    if (brushing_enabled && brushing_isVisible < 0.5) {
      discard;
    }
  `
  };
  var shader_module_default = {
    name: "brushing",
    dependencies: [import_core2.project],
    vs,
    fs,
    inject,
    getUniforms: (opts) => {
      if (!opts || !("viewport" in opts)) {
        return {};
      }
      const {
        brushingEnabled = true,
        brushingRadius = 1e4,
        brushingTarget = "source",
        mousePosition,
        viewport
      } = opts;
      return {
        brushing_enabled: Boolean(brushingEnabled && mousePosition && viewport.containsPixel(mousePosition)),
        brushing_radius: brushingRadius,
        brushing_target: TARGET[brushingTarget] || 0,
        brushing_mousePos: mousePosition ? viewport.unproject([mousePosition.x - viewport.x, mousePosition.y - viewport.y]) : [0, 0]
      };
    }
  };

  // src/brushing/brushing-extension.ts
  var defaultProps = {
    getBrushingTarget: {
      type: "accessor",
      value: [0, 0]
    },
    brushingTarget: "source",
    brushingEnabled: true,
    brushingRadius: 1e4
  };
  var BrushingExtension = class extends import_core3.LayerExtension {
    getShaders() {
      return {
        modules: [shader_module_default]
      };
    }
    initializeState(context, extension) {
      const attributeManager = this.getAttributeManager();
      if (attributeManager) {
        attributeManager.add({
          brushingTargets: {
            size: 2,
            accessor: "getBrushingTarget",
            shaderAttributes: {
              brushingTargets: {
                divisor: 0
              },
              instanceBrushingTargets: {
                divisor: 1
              }
            }
          }
        });
      }
      const onMouseMove = () => {
        this.getCurrentLayer()?.setNeedsRedraw();
      };
      this.state.onMouseMove = onMouseMove;
      if (context.deck) {
        context.deck.eventManager.on({
          pointermove: onMouseMove,
          pointerleave: onMouseMove
        });
      }
    }
    finalizeState(context, extension) {
      if (context.deck) {
        const onMouseMove = this.state.onMouseMove;
        context.deck.eventManager.off({
          pointermove: onMouseMove,
          pointerleave: onMouseMove
        });
      }
    }
  };
  __publicField(BrushingExtension, "defaultProps", defaultProps);
  __publicField(BrushingExtension, "extensionName", "BrushingExtension");

  // ../../node_modules/@luma.gl/webgl/dist/context/context/create-headless-context.js
  var ERR_HEADLESSGL_FAILED = "Failed to create WebGL context in Node.js, headless gl returned null";
  var ERR_HEADLESSGL_LOAD = "  luma.gl: loaded under Node.js without headless gl installed, meaning that WebGL   contexts can not be created. This may not be an error. For example, this is a   typical configuration for isorender applications running on the server.";
  var CONTEXT_DEFAULTS = {
    width: 1,
    height: 1,
    debug: true,
    throwOnError: false
  };
  var headlessGL = null;
  function isHeadlessGLRegistered() {
    return headlessGL !== null;
  }
  function createHeadlessContext(options) {
    options = {
      ...CONTEXT_DEFAULTS,
      ...options
    };
    const {
      width,
      height,
      webgl1,
      webgl2
    } = options;
    if (webgl2 && !webgl1) {
      throw new Error("headless-gl does not support WebGL2");
    }
    if (!headlessGL) {
      throw new Error(ERR_HEADLESSGL_LOAD);
    }
    const gl = headlessGL(width, height, options);
    if (!gl) {
      throw new Error(ERR_HEADLESSGL_FAILED);
    }
    return gl;
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/webgl-device.js
  var import_core30 = __toESM(require_core2(), 1);

  // ../../node_modules/@probe.gl/env/dist/lib/is-electron.js
  function isElectron(mockUserAgent) {
    if (typeof window !== "undefined" && typeof window.process === "object" && window.process.type === "renderer") {
      return true;
    }
    if (typeof process !== "undefined" && typeof process.versions === "object" && Boolean(process.versions["electron"])) {
      return true;
    }
    const realUserAgent = typeof navigator === "object" && typeof navigator.userAgent === "string" && navigator.userAgent;
    const userAgent = mockUserAgent || realUserAgent;
    if (userAgent && userAgent.indexOf("Electron") >= 0) {
      return true;
    }
    return false;
  }

  // ../../node_modules/@probe.gl/env/dist/lib/is-browser.js
  function isBrowser() {
    const isNode = typeof process === "object" && String(process) === "[object process]" && !process.browser;
    return !isNode || isElectron();
  }

  // ../../node_modules/@probe.gl/env/dist/lib/globals.js
  var self_ = globalThis.self || globalThis.window || globalThis.global;
  var window_ = globalThis.window || globalThis.self || globalThis.global;
  var document_ = globalThis.document || {};
  var process_ = globalThis.process || {};
  var console_ = globalThis.console;
  var navigator_ = globalThis.navigator || {};

  // ../../node_modules/@probe.gl/env/dist/lib/get-browser.js
  var window2 = globalThis;
  function getBrowser(mockUserAgent) {
    if (!mockUserAgent && !isBrowser()) {
      return "Node";
    }
    if (isElectron(mockUserAgent)) {
      return "Electron";
    }
    const userAgent = mockUserAgent || navigator_.userAgent || "";
    if (userAgent.indexOf("Edge") > -1) {
      return "Edge";
    }
    const isMSIE = userAgent.indexOf("MSIE ") !== -1;
    const isTrident = userAgent.indexOf("Trident/") !== -1;
    if (isMSIE || isTrident) {
      return "IE";
    }
    if (window2.chrome) {
      return "Chrome";
    }
    if (window2.safari) {
      return "Safari";
    }
    if (window2.mozInnerScreenX) {
      return "Firefox";
    }
    return "Unknown";
  }

  // ../../node_modules/@luma.gl/webgl/dist/context/polyfill/polyfill-context.js
  var import_core6 = __toESM(require_core2(), 1);

  // ../../node_modules/@luma.gl/webgl/dist/context/polyfill/polyfill-vertex-array-object.js
  var glErrorShadow = {};
  function error(msg) {
    if (globalThis.console && globalThis.console.error) {
      globalThis.console.error(msg);
    }
  }
  function log(msg) {
    if (globalThis.console && globalThis.console.log) {
      globalThis.console.log(msg);
    }
  }
  function synthesizeGLError(err, opt_msg) {
    glErrorShadow[err] = true;
    if (opt_msg !== void 0) {
      error(opt_msg);
    }
  }
  function wrapGLError(gl) {
    const f = gl.getError;
    gl.getError = function getError() {
      let err;
      do {
        err = f.apply(gl);
        if (err !== gl.NO_ERROR) {
          glErrorShadow[err] = true;
        }
      } while (err !== gl.NO_ERROR);
      for (err in glErrorShadow) {
        if (glErrorShadow[err]) {
          delete glErrorShadow[err];
          return parseInt(err, 10);
        }
      }
      return gl.NO_ERROR;
    };
  }
  var WebGLVertexArrayObjectOES = function WebGLVertexArrayObjectOES2(ext) {
    const gl = ext.gl;
    this.ext = ext;
    this.isAlive = true;
    this.hasBeenBound = false;
    this.elementArrayBuffer = null;
    this.attribs = new Array(ext.maxVertexAttribs);
    for (let n = 0; n < this.attribs.length; n++) {
      const attrib = new WebGLVertexArrayObjectOES2.VertexAttrib(gl);
      this.attribs[n] = attrib;
    }
    this.maxAttrib = 0;
  };
  WebGLVertexArrayObjectOES.VertexAttrib = function VertexAttrib(gl) {
    this.enabled = false;
    this.buffer = null;
    this.size = 4;
    this.type = gl.FLOAT;
    this.normalized = false;
    this.stride = 16;
    this.offset = 0;
    this.cached = "";
    this.recache();
  };
  WebGLVertexArrayObjectOES.VertexAttrib.prototype.recache = function recache() {
    this.cached = [this.size, this.type, this.normalized, this.stride, this.offset].join(":");
  };
  var OESVertexArrayObject = function OESVertexArrayObject2(gl) {
    const self = this;
    this.gl = gl;
    wrapGLError(gl);
    const original = this.original = {
      getParameter: gl.getParameter,
      enableVertexAttribArray: gl.enableVertexAttribArray,
      disableVertexAttribArray: gl.disableVertexAttribArray,
      bindBuffer: gl.bindBuffer,
      getVertexAttrib: gl.getVertexAttrib,
      vertexAttribPointer: gl.vertexAttribPointer
    };
    gl.getParameter = function getParameter(pname) {
      if (pname === self.VERTEX_ARRAY_BINDING_OES) {
        if (self.currentVertexArrayObject === self.defaultVertexArrayObject) {
          return null;
        }
        return self.currentVertexArrayObject;
      }
      return original.getParameter.apply(this, arguments);
    };
    gl.enableVertexAttribArray = function enableVertexAttribArray(index) {
      const vao = self.currentVertexArrayObject;
      vao.maxAttrib = Math.max(vao.maxAttrib, index);
      const attrib = vao.attribs[index];
      attrib.enabled = true;
      return original.enableVertexAttribArray.apply(this, arguments);
    };
    gl.disableVertexAttribArray = function disableVertexAttribArray(index) {
      const vao = self.currentVertexArrayObject;
      vao.maxAttrib = Math.max(vao.maxAttrib, index);
      const attrib = vao.attribs[index];
      attrib.enabled = false;
      return original.disableVertexAttribArray.apply(this, arguments);
    };
    gl.bindBuffer = function bindBuffer2(target, buffer) {
      switch (target) {
        case gl.ARRAY_BUFFER:
          self.currentArrayBuffer = buffer;
          break;
        case gl.ELEMENT_ARRAY_BUFFER:
          self.currentVertexArrayObject.elementArrayBuffer = buffer;
          break;
        default:
      }
      return original.bindBuffer.apply(this, arguments);
    };
    gl.getVertexAttrib = function getVertexAttrib(index, pname) {
      const vao = self.currentVertexArrayObject;
      const attrib = vao.attribs[index];
      switch (pname) {
        case gl.VERTEX_ATTRIB_ARRAY_BUFFER_BINDING:
          return attrib.buffer;
        case gl.VERTEX_ATTRIB_ARRAY_ENABLED:
          return attrib.enabled;
        case gl.VERTEX_ATTRIB_ARRAY_SIZE:
          return attrib.size;
        case gl.VERTEX_ATTRIB_ARRAY_STRIDE:
          return attrib.stride;
        case gl.VERTEX_ATTRIB_ARRAY_TYPE:
          return attrib.type;
        case gl.VERTEX_ATTRIB_ARRAY_NORMALIZED:
          return attrib.normalized;
        default:
          return original.getVertexAttrib.apply(this, arguments);
      }
    };
    gl.vertexAttribPointer = function vertexAttribPointer(indx, size, type, normalized, stride, offset) {
      const vao = self.currentVertexArrayObject;
      vao.maxAttrib = Math.max(vao.maxAttrib, indx);
      const attrib = vao.attribs[indx];
      attrib.buffer = self.currentArrayBuffer;
      attrib.size = size;
      attrib.type = type;
      attrib.normalized = normalized;
      attrib.stride = stride;
      attrib.offset = offset;
      attrib.recache();
      return original.vertexAttribPointer.apply(this, arguments);
    };
    if (gl.instrumentExtension) {
      gl.instrumentExtension(this, "OES_vertex_array_object");
    }
    if (gl.canvas) {
      gl.canvas.addEventListener("webglcontextrestored", () => {
        log("OESVertexArrayObject emulation library context restored");
        self.reset_();
      }, true);
    }
    this.reset_();
  };
  OESVertexArrayObject.prototype.VERTEX_ARRAY_BINDING_OES = 34229;
  OESVertexArrayObject.prototype.reset_ = function reset_() {
    const contextWasLost = this.vertexArrayObjects !== void 0;
    if (contextWasLost) {
      for (let ii = 0; ii < this.vertexArrayObjects.length; ++ii) {
        this.vertexArrayObjects.isAlive = false;
      }
    }
    const gl = this.gl;
    this.maxVertexAttribs = gl.getParameter(gl.MAX_VERTEX_ATTRIBS);
    this.defaultVertexArrayObject = new WebGLVertexArrayObjectOES(this);
    this.currentVertexArrayObject = null;
    this.currentArrayBuffer = null;
    this.vertexArrayObjects = [this.defaultVertexArrayObject];
    this.bindVertexArrayOES(null);
  };
  OESVertexArrayObject.prototype.createVertexArrayOES = function createVertexArrayOES() {
    const arrayObject = new WebGLVertexArrayObjectOES(this);
    this.vertexArrayObjects.push(arrayObject);
    return arrayObject;
  };
  OESVertexArrayObject.prototype.deleteVertexArrayOES = function deleteVertexArrayOES(arrayObject) {
    arrayObject.isAlive = false;
    this.vertexArrayObjects.splice(this.vertexArrayObjects.indexOf(arrayObject), 1);
    if (this.currentVertexArrayObject === arrayObject) {
      this.bindVertexArrayOES(null);
    }
  };
  OESVertexArrayObject.prototype.isVertexArrayOES = function isVertexArrayOES(arrayObject) {
    if (arrayObject && arrayObject instanceof WebGLVertexArrayObjectOES) {
      if (arrayObject.hasBeenBound && arrayObject.ext === this) {
        return true;
      }
    }
    return false;
  };
  OESVertexArrayObject.prototype.bindVertexArrayOES = function bindVertexArrayOES(arrayObject) {
    const gl = this.gl;
    if (arrayObject && !arrayObject.isAlive) {
      synthesizeGLError(gl.INVALID_OPERATION, "bindVertexArrayOES: attempt to bind deleted arrayObject");
      return;
    }
    const original = this.original;
    const oldVAO = this.currentVertexArrayObject;
    this.currentVertexArrayObject = arrayObject || this.defaultVertexArrayObject;
    this.currentVertexArrayObject.hasBeenBound = true;
    const newVAO = this.currentVertexArrayObject;
    if (oldVAO === newVAO) {
      return;
    }
    if (!oldVAO || newVAO.elementArrayBuffer !== oldVAO.elementArrayBuffer) {
      original.bindBuffer.call(gl, gl.ELEMENT_ARRAY_BUFFER, newVAO.elementArrayBuffer);
    }
    let currentBinding = this.currentArrayBuffer;
    const maxAttrib = Math.max(oldVAO ? oldVAO.maxAttrib : 0, newVAO.maxAttrib);
    for (let n = 0; n <= maxAttrib; n++) {
      const attrib = newVAO.attribs[n];
      const oldAttrib = oldVAO ? oldVAO.attribs[n] : null;
      if (!oldVAO || attrib.enabled !== oldAttrib.enabled) {
        if (attrib.enabled) {
          original.enableVertexAttribArray.call(gl, n);
        } else {
          original.disableVertexAttribArray.call(gl, n);
        }
      }
      if (attrib.enabled) {
        let bufferChanged = false;
        if (!oldVAO || attrib.buffer !== oldAttrib.buffer) {
          if (currentBinding !== attrib.buffer) {
            original.bindBuffer.call(gl, gl.ARRAY_BUFFER, attrib.buffer);
            currentBinding = attrib.buffer;
          }
          bufferChanged = true;
        }
        if (bufferChanged || attrib.cached !== oldAttrib.cached) {
          original.vertexAttribPointer.call(gl, n, attrib.size, attrib.type, attrib.normalized, attrib.stride, attrib.offset);
        }
      }
    }
    if (this.currentArrayBuffer !== currentBinding) {
      original.bindBuffer.call(gl, gl.ARRAY_BUFFER, this.currentArrayBuffer);
    }
  };
  function polyfillVertexArrayObject(gl) {
    if (typeof gl.createVertexArray === "function") {
      return;
    }
    const original_getSupportedExtensions = gl.getSupportedExtensions;
    gl.getSupportedExtensions = function getSupportedExtensions() {
      const list = original_getSupportedExtensions.call(this) || [];
      if (list.indexOf("OES_vertex_array_object") < 0) {
        list.push("OES_vertex_array_object");
      }
      return list;
    };
    const original_getExtension = gl.getExtension;
    gl.getExtension = function getExtension(name) {
      const ext = original_getExtension.call(this, name);
      if (ext) {
        return ext;
      }
      if (name !== "OES_vertex_array_object") {
        return null;
      }
      if (!gl.__OESVertexArrayObject) {
        this.__OESVertexArrayObject = new OESVertexArrayObject(this);
      }
      return this.__OESVertexArrayObject;
    };
  }

  // ../../node_modules/@luma.gl/webgl/dist/context/polyfill/polyfill-table.js
  var import_core5 = __toESM(require_core2(), 1);

  // ../../node_modules/@luma.gl/constants/dist/constants-enum.js
  var GL = function(GL2) {
    GL2[GL2["DEPTH_BUFFER_BIT"] = 256] = "DEPTH_BUFFER_BIT";
    GL2[GL2["STENCIL_BUFFER_BIT"] = 1024] = "STENCIL_BUFFER_BIT";
    GL2[GL2["COLOR_BUFFER_BIT"] = 16384] = "COLOR_BUFFER_BIT";
    GL2[GL2["POINTS"] = 0] = "POINTS";
    GL2[GL2["LINES"] = 1] = "LINES";
    GL2[GL2["LINE_LOOP"] = 2] = "LINE_LOOP";
    GL2[GL2["LINE_STRIP"] = 3] = "LINE_STRIP";
    GL2[GL2["TRIANGLES"] = 4] = "TRIANGLES";
    GL2[GL2["TRIANGLE_STRIP"] = 5] = "TRIANGLE_STRIP";
    GL2[GL2["TRIANGLE_FAN"] = 6] = "TRIANGLE_FAN";
    GL2[GL2["ZERO"] = 0] = "ZERO";
    GL2[GL2["ONE"] = 1] = "ONE";
    GL2[GL2["SRC_COLOR"] = 768] = "SRC_COLOR";
    GL2[GL2["ONE_MINUS_SRC_COLOR"] = 769] = "ONE_MINUS_SRC_COLOR";
    GL2[GL2["SRC_ALPHA"] = 770] = "SRC_ALPHA";
    GL2[GL2["ONE_MINUS_SRC_ALPHA"] = 771] = "ONE_MINUS_SRC_ALPHA";
    GL2[GL2["DST_ALPHA"] = 772] = "DST_ALPHA";
    GL2[GL2["ONE_MINUS_DST_ALPHA"] = 773] = "ONE_MINUS_DST_ALPHA";
    GL2[GL2["DST_COLOR"] = 774] = "DST_COLOR";
    GL2[GL2["ONE_MINUS_DST_COLOR"] = 775] = "ONE_MINUS_DST_COLOR";
    GL2[GL2["SRC_ALPHA_SATURATE"] = 776] = "SRC_ALPHA_SATURATE";
    GL2[GL2["CONSTANT_COLOR"] = 32769] = "CONSTANT_COLOR";
    GL2[GL2["ONE_MINUS_CONSTANT_COLOR"] = 32770] = "ONE_MINUS_CONSTANT_COLOR";
    GL2[GL2["CONSTANT_ALPHA"] = 32771] = "CONSTANT_ALPHA";
    GL2[GL2["ONE_MINUS_CONSTANT_ALPHA"] = 32772] = "ONE_MINUS_CONSTANT_ALPHA";
    GL2[GL2["FUNC_ADD"] = 32774] = "FUNC_ADD";
    GL2[GL2["FUNC_SUBTRACT"] = 32778] = "FUNC_SUBTRACT";
    GL2[GL2["FUNC_REVERSE_SUBTRACT"] = 32779] = "FUNC_REVERSE_SUBTRACT";
    GL2[GL2["BLEND_EQUATION"] = 32777] = "BLEND_EQUATION";
    GL2[GL2["BLEND_EQUATION_RGB"] = 32777] = "BLEND_EQUATION_RGB";
    GL2[GL2["BLEND_EQUATION_ALPHA"] = 34877] = "BLEND_EQUATION_ALPHA";
    GL2[GL2["BLEND_DST_RGB"] = 32968] = "BLEND_DST_RGB";
    GL2[GL2["BLEND_SRC_RGB"] = 32969] = "BLEND_SRC_RGB";
    GL2[GL2["BLEND_DST_ALPHA"] = 32970] = "BLEND_DST_ALPHA";
    GL2[GL2["BLEND_SRC_ALPHA"] = 32971] = "BLEND_SRC_ALPHA";
    GL2[GL2["BLEND_COLOR"] = 32773] = "BLEND_COLOR";
    GL2[GL2["ARRAY_BUFFER_BINDING"] = 34964] = "ARRAY_BUFFER_BINDING";
    GL2[GL2["ELEMENT_ARRAY_BUFFER_BINDING"] = 34965] = "ELEMENT_ARRAY_BUFFER_BINDING";
    GL2[GL2["LINE_WIDTH"] = 2849] = "LINE_WIDTH";
    GL2[GL2["ALIASED_POINT_SIZE_RANGE"] = 33901] = "ALIASED_POINT_SIZE_RANGE";
    GL2[GL2["ALIASED_LINE_WIDTH_RANGE"] = 33902] = "ALIASED_LINE_WIDTH_RANGE";
    GL2[GL2["CULL_FACE_MODE"] = 2885] = "CULL_FACE_MODE";
    GL2[GL2["FRONT_FACE"] = 2886] = "FRONT_FACE";
    GL2[GL2["DEPTH_RANGE"] = 2928] = "DEPTH_RANGE";
    GL2[GL2["DEPTH_WRITEMASK"] = 2930] = "DEPTH_WRITEMASK";
    GL2[GL2["DEPTH_CLEAR_VALUE"] = 2931] = "DEPTH_CLEAR_VALUE";
    GL2[GL2["DEPTH_FUNC"] = 2932] = "DEPTH_FUNC";
    GL2[GL2["STENCIL_CLEAR_VALUE"] = 2961] = "STENCIL_CLEAR_VALUE";
    GL2[GL2["STENCIL_FUNC"] = 2962] = "STENCIL_FUNC";
    GL2[GL2["STENCIL_FAIL"] = 2964] = "STENCIL_FAIL";
    GL2[GL2["STENCIL_PASS_DEPTH_FAIL"] = 2965] = "STENCIL_PASS_DEPTH_FAIL";
    GL2[GL2["STENCIL_PASS_DEPTH_PASS"] = 2966] = "STENCIL_PASS_DEPTH_PASS";
    GL2[GL2["STENCIL_REF"] = 2967] = "STENCIL_REF";
    GL2[GL2["STENCIL_VALUE_MASK"] = 2963] = "STENCIL_VALUE_MASK";
    GL2[GL2["STENCIL_WRITEMASK"] = 2968] = "STENCIL_WRITEMASK";
    GL2[GL2["STENCIL_BACK_FUNC"] = 34816] = "STENCIL_BACK_FUNC";
    GL2[GL2["STENCIL_BACK_FAIL"] = 34817] = "STENCIL_BACK_FAIL";
    GL2[GL2["STENCIL_BACK_PASS_DEPTH_FAIL"] = 34818] = "STENCIL_BACK_PASS_DEPTH_FAIL";
    GL2[GL2["STENCIL_BACK_PASS_DEPTH_PASS"] = 34819] = "STENCIL_BACK_PASS_DEPTH_PASS";
    GL2[GL2["STENCIL_BACK_REF"] = 36003] = "STENCIL_BACK_REF";
    GL2[GL2["STENCIL_BACK_VALUE_MASK"] = 36004] = "STENCIL_BACK_VALUE_MASK";
    GL2[GL2["STENCIL_BACK_WRITEMASK"] = 36005] = "STENCIL_BACK_WRITEMASK";
    GL2[GL2["VIEWPORT"] = 2978] = "VIEWPORT";
    GL2[GL2["SCISSOR_BOX"] = 3088] = "SCISSOR_BOX";
    GL2[GL2["COLOR_CLEAR_VALUE"] = 3106] = "COLOR_CLEAR_VALUE";
    GL2[GL2["COLOR_WRITEMASK"] = 3107] = "COLOR_WRITEMASK";
    GL2[GL2["UNPACK_ALIGNMENT"] = 3317] = "UNPACK_ALIGNMENT";
    GL2[GL2["PACK_ALIGNMENT"] = 3333] = "PACK_ALIGNMENT";
    GL2[GL2["MAX_TEXTURE_SIZE"] = 3379] = "MAX_TEXTURE_SIZE";
    GL2[GL2["MAX_VIEWPORT_DIMS"] = 3386] = "MAX_VIEWPORT_DIMS";
    GL2[GL2["SUBPIXEL_BITS"] = 3408] = "SUBPIXEL_BITS";
    GL2[GL2["RED_BITS"] = 3410] = "RED_BITS";
    GL2[GL2["GREEN_BITS"] = 3411] = "GREEN_BITS";
    GL2[GL2["BLUE_BITS"] = 3412] = "BLUE_BITS";
    GL2[GL2["ALPHA_BITS"] = 3413] = "ALPHA_BITS";
    GL2[GL2["DEPTH_BITS"] = 3414] = "DEPTH_BITS";
    GL2[GL2["STENCIL_BITS"] = 3415] = "STENCIL_BITS";
    GL2[GL2["POLYGON_OFFSET_UNITS"] = 10752] = "POLYGON_OFFSET_UNITS";
    GL2[GL2["POLYGON_OFFSET_FACTOR"] = 32824] = "POLYGON_OFFSET_FACTOR";
    GL2[GL2["TEXTURE_BINDING_2D"] = 32873] = "TEXTURE_BINDING_2D";
    GL2[GL2["SAMPLE_BUFFERS"] = 32936] = "SAMPLE_BUFFERS";
    GL2[GL2["SAMPLES"] = 32937] = "SAMPLES";
    GL2[GL2["SAMPLE_COVERAGE_VALUE"] = 32938] = "SAMPLE_COVERAGE_VALUE";
    GL2[GL2["SAMPLE_COVERAGE_INVERT"] = 32939] = "SAMPLE_COVERAGE_INVERT";
    GL2[GL2["COMPRESSED_TEXTURE_FORMATS"] = 34467] = "COMPRESSED_TEXTURE_FORMATS";
    GL2[GL2["VENDOR"] = 7936] = "VENDOR";
    GL2[GL2["RENDERER"] = 7937] = "RENDERER";
    GL2[GL2["VERSION"] = 7938] = "VERSION";
    GL2[GL2["IMPLEMENTATION_COLOR_READ_TYPE"] = 35738] = "IMPLEMENTATION_COLOR_READ_TYPE";
    GL2[GL2["IMPLEMENTATION_COLOR_READ_FORMAT"] = 35739] = "IMPLEMENTATION_COLOR_READ_FORMAT";
    GL2[GL2["BROWSER_DEFAULT_WEBGL"] = 37444] = "BROWSER_DEFAULT_WEBGL";
    GL2[GL2["STATIC_DRAW"] = 35044] = "STATIC_DRAW";
    GL2[GL2["STREAM_DRAW"] = 35040] = "STREAM_DRAW";
    GL2[GL2["DYNAMIC_DRAW"] = 35048] = "DYNAMIC_DRAW";
    GL2[GL2["ARRAY_BUFFER"] = 34962] = "ARRAY_BUFFER";
    GL2[GL2["ELEMENT_ARRAY_BUFFER"] = 34963] = "ELEMENT_ARRAY_BUFFER";
    GL2[GL2["BUFFER_SIZE"] = 34660] = "BUFFER_SIZE";
    GL2[GL2["BUFFER_USAGE"] = 34661] = "BUFFER_USAGE";
    GL2[GL2["CURRENT_VERTEX_ATTRIB"] = 34342] = "CURRENT_VERTEX_ATTRIB";
    GL2[GL2["VERTEX_ATTRIB_ARRAY_ENABLED"] = 34338] = "VERTEX_ATTRIB_ARRAY_ENABLED";
    GL2[GL2["VERTEX_ATTRIB_ARRAY_SIZE"] = 34339] = "VERTEX_ATTRIB_ARRAY_SIZE";
    GL2[GL2["VERTEX_ATTRIB_ARRAY_STRIDE"] = 34340] = "VERTEX_ATTRIB_ARRAY_STRIDE";
    GL2[GL2["VERTEX_ATTRIB_ARRAY_TYPE"] = 34341] = "VERTEX_ATTRIB_ARRAY_TYPE";
    GL2[GL2["VERTEX_ATTRIB_ARRAY_NORMALIZED"] = 34922] = "VERTEX_ATTRIB_ARRAY_NORMALIZED";
    GL2[GL2["VERTEX_ATTRIB_ARRAY_POINTER"] = 34373] = "VERTEX_ATTRIB_ARRAY_POINTER";
    GL2[GL2["VERTEX_ATTRIB_ARRAY_BUFFER_BINDING"] = 34975] = "VERTEX_ATTRIB_ARRAY_BUFFER_BINDING";
    GL2[GL2["CULL_FACE"] = 2884] = "CULL_FACE";
    GL2[GL2["FRONT"] = 1028] = "FRONT";
    GL2[GL2["BACK"] = 1029] = "BACK";
    GL2[GL2["FRONT_AND_BACK"] = 1032] = "FRONT_AND_BACK";
    GL2[GL2["BLEND"] = 3042] = "BLEND";
    GL2[GL2["DEPTH_TEST"] = 2929] = "DEPTH_TEST";
    GL2[GL2["DITHER"] = 3024] = "DITHER";
    GL2[GL2["POLYGON_OFFSET_FILL"] = 32823] = "POLYGON_OFFSET_FILL";
    GL2[GL2["SAMPLE_ALPHA_TO_COVERAGE"] = 32926] = "SAMPLE_ALPHA_TO_COVERAGE";
    GL2[GL2["SAMPLE_COVERAGE"] = 32928] = "SAMPLE_COVERAGE";
    GL2[GL2["SCISSOR_TEST"] = 3089] = "SCISSOR_TEST";
    GL2[GL2["STENCIL_TEST"] = 2960] = "STENCIL_TEST";
    GL2[GL2["NO_ERROR"] = 0] = "NO_ERROR";
    GL2[GL2["INVALID_ENUM"] = 1280] = "INVALID_ENUM";
    GL2[GL2["INVALID_VALUE"] = 1281] = "INVALID_VALUE";
    GL2[GL2["INVALID_OPERATION"] = 1282] = "INVALID_OPERATION";
    GL2[GL2["OUT_OF_MEMORY"] = 1285] = "OUT_OF_MEMORY";
    GL2[GL2["CONTEXT_LOST_WEBGL"] = 37442] = "CONTEXT_LOST_WEBGL";
    GL2[GL2["CW"] = 2304] = "CW";
    GL2[GL2["CCW"] = 2305] = "CCW";
    GL2[GL2["DONT_CARE"] = 4352] = "DONT_CARE";
    GL2[GL2["FASTEST"] = 4353] = "FASTEST";
    GL2[GL2["NICEST"] = 4354] = "NICEST";
    GL2[GL2["GENERATE_MIPMAP_HINT"] = 33170] = "GENERATE_MIPMAP_HINT";
    GL2[GL2["BYTE"] = 5120] = "BYTE";
    GL2[GL2["UNSIGNED_BYTE"] = 5121] = "UNSIGNED_BYTE";
    GL2[GL2["SHORT"] = 5122] = "SHORT";
    GL2[GL2["UNSIGNED_SHORT"] = 5123] = "UNSIGNED_SHORT";
    GL2[GL2["INT"] = 5124] = "INT";
    GL2[GL2["UNSIGNED_INT"] = 5125] = "UNSIGNED_INT";
    GL2[GL2["FLOAT"] = 5126] = "FLOAT";
    GL2[GL2["DOUBLE"] = 5130] = "DOUBLE";
    GL2[GL2["DEPTH_COMPONENT"] = 6402] = "DEPTH_COMPONENT";
    GL2[GL2["ALPHA"] = 6406] = "ALPHA";
    GL2[GL2["RGB"] = 6407] = "RGB";
    GL2[GL2["RGBA"] = 6408] = "RGBA";
    GL2[GL2["LUMINANCE"] = 6409] = "LUMINANCE";
    GL2[GL2["LUMINANCE_ALPHA"] = 6410] = "LUMINANCE_ALPHA";
    GL2[GL2["UNSIGNED_SHORT_4_4_4_4"] = 32819] = "UNSIGNED_SHORT_4_4_4_4";
    GL2[GL2["UNSIGNED_SHORT_5_5_5_1"] = 32820] = "UNSIGNED_SHORT_5_5_5_1";
    GL2[GL2["UNSIGNED_SHORT_5_6_5"] = 33635] = "UNSIGNED_SHORT_5_6_5";
    GL2[GL2["FRAGMENT_SHADER"] = 35632] = "FRAGMENT_SHADER";
    GL2[GL2["VERTEX_SHADER"] = 35633] = "VERTEX_SHADER";
    GL2[GL2["COMPILE_STATUS"] = 35713] = "COMPILE_STATUS";
    GL2[GL2["DELETE_STATUS"] = 35712] = "DELETE_STATUS";
    GL2[GL2["LINK_STATUS"] = 35714] = "LINK_STATUS";
    GL2[GL2["VALIDATE_STATUS"] = 35715] = "VALIDATE_STATUS";
    GL2[GL2["ATTACHED_SHADERS"] = 35717] = "ATTACHED_SHADERS";
    GL2[GL2["ACTIVE_ATTRIBUTES"] = 35721] = "ACTIVE_ATTRIBUTES";
    GL2[GL2["ACTIVE_UNIFORMS"] = 35718] = "ACTIVE_UNIFORMS";
    GL2[GL2["MAX_VERTEX_ATTRIBS"] = 34921] = "MAX_VERTEX_ATTRIBS";
    GL2[GL2["MAX_VERTEX_UNIFORM_VECTORS"] = 36347] = "MAX_VERTEX_UNIFORM_VECTORS";
    GL2[GL2["MAX_VARYING_VECTORS"] = 36348] = "MAX_VARYING_VECTORS";
    GL2[GL2["MAX_COMBINED_TEXTURE_IMAGE_UNITS"] = 35661] = "MAX_COMBINED_TEXTURE_IMAGE_UNITS";
    GL2[GL2["MAX_VERTEX_TEXTURE_IMAGE_UNITS"] = 35660] = "MAX_VERTEX_TEXTURE_IMAGE_UNITS";
    GL2[GL2["MAX_TEXTURE_IMAGE_UNITS"] = 34930] = "MAX_TEXTURE_IMAGE_UNITS";
    GL2[GL2["MAX_FRAGMENT_UNIFORM_VECTORS"] = 36349] = "MAX_FRAGMENT_UNIFORM_VECTORS";
    GL2[GL2["SHADER_TYPE"] = 35663] = "SHADER_TYPE";
    GL2[GL2["SHADING_LANGUAGE_VERSION"] = 35724] = "SHADING_LANGUAGE_VERSION";
    GL2[GL2["CURRENT_PROGRAM"] = 35725] = "CURRENT_PROGRAM";
    GL2[GL2["NEVER"] = 512] = "NEVER";
    GL2[GL2["LESS"] = 513] = "LESS";
    GL2[GL2["EQUAL"] = 514] = "EQUAL";
    GL2[GL2["LEQUAL"] = 515] = "LEQUAL";
    GL2[GL2["GREATER"] = 516] = "GREATER";
    GL2[GL2["NOTEQUAL"] = 517] = "NOTEQUAL";
    GL2[GL2["GEQUAL"] = 518] = "GEQUAL";
    GL2[GL2["ALWAYS"] = 519] = "ALWAYS";
    GL2[GL2["KEEP"] = 7680] = "KEEP";
    GL2[GL2["REPLACE"] = 7681] = "REPLACE";
    GL2[GL2["INCR"] = 7682] = "INCR";
    GL2[GL2["DECR"] = 7683] = "DECR";
    GL2[GL2["INVERT"] = 5386] = "INVERT";
    GL2[GL2["INCR_WRAP"] = 34055] = "INCR_WRAP";
    GL2[GL2["DECR_WRAP"] = 34056] = "DECR_WRAP";
    GL2[GL2["NEAREST"] = 9728] = "NEAREST";
    GL2[GL2["LINEAR"] = 9729] = "LINEAR";
    GL2[GL2["NEAREST_MIPMAP_NEAREST"] = 9984] = "NEAREST_MIPMAP_NEAREST";
    GL2[GL2["LINEAR_MIPMAP_NEAREST"] = 9985] = "LINEAR_MIPMAP_NEAREST";
    GL2[GL2["NEAREST_MIPMAP_LINEAR"] = 9986] = "NEAREST_MIPMAP_LINEAR";
    GL2[GL2["LINEAR_MIPMAP_LINEAR"] = 9987] = "LINEAR_MIPMAP_LINEAR";
    GL2[GL2["TEXTURE_MAG_FILTER"] = 10240] = "TEXTURE_MAG_FILTER";
    GL2[GL2["TEXTURE_MIN_FILTER"] = 10241] = "TEXTURE_MIN_FILTER";
    GL2[GL2["TEXTURE_WRAP_S"] = 10242] = "TEXTURE_WRAP_S";
    GL2[GL2["TEXTURE_WRAP_T"] = 10243] = "TEXTURE_WRAP_T";
    GL2[GL2["TEXTURE_2D"] = 3553] = "TEXTURE_2D";
    GL2[GL2["TEXTURE"] = 5890] = "TEXTURE";
    GL2[GL2["TEXTURE_CUBE_MAP"] = 34067] = "TEXTURE_CUBE_MAP";
    GL2[GL2["TEXTURE_BINDING_CUBE_MAP"] = 34068] = "TEXTURE_BINDING_CUBE_MAP";
    GL2[GL2["TEXTURE_CUBE_MAP_POSITIVE_X"] = 34069] = "TEXTURE_CUBE_MAP_POSITIVE_X";
    GL2[GL2["TEXTURE_CUBE_MAP_NEGATIVE_X"] = 34070] = "TEXTURE_CUBE_MAP_NEGATIVE_X";
    GL2[GL2["TEXTURE_CUBE_MAP_POSITIVE_Y"] = 34071] = "TEXTURE_CUBE_MAP_POSITIVE_Y";
    GL2[GL2["TEXTURE_CUBE_MAP_NEGATIVE_Y"] = 34072] = "TEXTURE_CUBE_MAP_NEGATIVE_Y";
    GL2[GL2["TEXTURE_CUBE_MAP_POSITIVE_Z"] = 34073] = "TEXTURE_CUBE_MAP_POSITIVE_Z";
    GL2[GL2["TEXTURE_CUBE_MAP_NEGATIVE_Z"] = 34074] = "TEXTURE_CUBE_MAP_NEGATIVE_Z";
    GL2[GL2["MAX_CUBE_MAP_TEXTURE_SIZE"] = 34076] = "MAX_CUBE_MAP_TEXTURE_SIZE";
    GL2[GL2["TEXTURE0"] = 33984] = "TEXTURE0";
    GL2[GL2["ACTIVE_TEXTURE"] = 34016] = "ACTIVE_TEXTURE";
    GL2[GL2["REPEAT"] = 10497] = "REPEAT";
    GL2[GL2["CLAMP_TO_EDGE"] = 33071] = "CLAMP_TO_EDGE";
    GL2[GL2["MIRRORED_REPEAT"] = 33648] = "MIRRORED_REPEAT";
    GL2[GL2["TEXTURE_WIDTH"] = 4096] = "TEXTURE_WIDTH";
    GL2[GL2["TEXTURE_HEIGHT"] = 4097] = "TEXTURE_HEIGHT";
    GL2[GL2["FLOAT_VEC2"] = 35664] = "FLOAT_VEC2";
    GL2[GL2["FLOAT_VEC3"] = 35665] = "FLOAT_VEC3";
    GL2[GL2["FLOAT_VEC4"] = 35666] = "FLOAT_VEC4";
    GL2[GL2["INT_VEC2"] = 35667] = "INT_VEC2";
    GL2[GL2["INT_VEC3"] = 35668] = "INT_VEC3";
    GL2[GL2["INT_VEC4"] = 35669] = "INT_VEC4";
    GL2[GL2["BOOL"] = 35670] = "BOOL";
    GL2[GL2["BOOL_VEC2"] = 35671] = "BOOL_VEC2";
    GL2[GL2["BOOL_VEC3"] = 35672] = "BOOL_VEC3";
    GL2[GL2["BOOL_VEC4"] = 35673] = "BOOL_VEC4";
    GL2[GL2["FLOAT_MAT2"] = 35674] = "FLOAT_MAT2";
    GL2[GL2["FLOAT_MAT3"] = 35675] = "FLOAT_MAT3";
    GL2[GL2["FLOAT_MAT4"] = 35676] = "FLOAT_MAT4";
    GL2[GL2["SAMPLER_2D"] = 35678] = "SAMPLER_2D";
    GL2[GL2["SAMPLER_CUBE"] = 35680] = "SAMPLER_CUBE";
    GL2[GL2["LOW_FLOAT"] = 36336] = "LOW_FLOAT";
    GL2[GL2["MEDIUM_FLOAT"] = 36337] = "MEDIUM_FLOAT";
    GL2[GL2["HIGH_FLOAT"] = 36338] = "HIGH_FLOAT";
    GL2[GL2["LOW_INT"] = 36339] = "LOW_INT";
    GL2[GL2["MEDIUM_INT"] = 36340] = "MEDIUM_INT";
    GL2[GL2["HIGH_INT"] = 36341] = "HIGH_INT";
    GL2[GL2["FRAMEBUFFER"] = 36160] = "FRAMEBUFFER";
    GL2[GL2["RENDERBUFFER"] = 36161] = "RENDERBUFFER";
    GL2[GL2["RGBA4"] = 32854] = "RGBA4";
    GL2[GL2["RGB5_A1"] = 32855] = "RGB5_A1";
    GL2[GL2["RGB565"] = 36194] = "RGB565";
    GL2[GL2["DEPTH_COMPONENT16"] = 33189] = "DEPTH_COMPONENT16";
    GL2[GL2["STENCIL_INDEX"] = 6401] = "STENCIL_INDEX";
    GL2[GL2["STENCIL_INDEX8"] = 36168] = "STENCIL_INDEX8";
    GL2[GL2["DEPTH_STENCIL"] = 34041] = "DEPTH_STENCIL";
    GL2[GL2["RENDERBUFFER_WIDTH"] = 36162] = "RENDERBUFFER_WIDTH";
    GL2[GL2["RENDERBUFFER_HEIGHT"] = 36163] = "RENDERBUFFER_HEIGHT";
    GL2[GL2["RENDERBUFFER_INTERNAL_FORMAT"] = 36164] = "RENDERBUFFER_INTERNAL_FORMAT";
    GL2[GL2["RENDERBUFFER_RED_SIZE"] = 36176] = "RENDERBUFFER_RED_SIZE";
    GL2[GL2["RENDERBUFFER_GREEN_SIZE"] = 36177] = "RENDERBUFFER_GREEN_SIZE";
    GL2[GL2["RENDERBUFFER_BLUE_SIZE"] = 36178] = "RENDERBUFFER_BLUE_SIZE";
    GL2[GL2["RENDERBUFFER_ALPHA_SIZE"] = 36179] = "RENDERBUFFER_ALPHA_SIZE";
    GL2[GL2["RENDERBUFFER_DEPTH_SIZE"] = 36180] = "RENDERBUFFER_DEPTH_SIZE";
    GL2[GL2["RENDERBUFFER_STENCIL_SIZE"] = 36181] = "RENDERBUFFER_STENCIL_SIZE";
    GL2[GL2["FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE"] = 36048] = "FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE";
    GL2[GL2["FRAMEBUFFER_ATTACHMENT_OBJECT_NAME"] = 36049] = "FRAMEBUFFER_ATTACHMENT_OBJECT_NAME";
    GL2[GL2["FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL"] = 36050] = "FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL";
    GL2[GL2["FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE"] = 36051] = "FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE";
    GL2[GL2["COLOR_ATTACHMENT0"] = 36064] = "COLOR_ATTACHMENT0";
    GL2[GL2["DEPTH_ATTACHMENT"] = 36096] = "DEPTH_ATTACHMENT";
    GL2[GL2["STENCIL_ATTACHMENT"] = 36128] = "STENCIL_ATTACHMENT";
    GL2[GL2["DEPTH_STENCIL_ATTACHMENT"] = 33306] = "DEPTH_STENCIL_ATTACHMENT";
    GL2[GL2["NONE"] = 0] = "NONE";
    GL2[GL2["FRAMEBUFFER_COMPLETE"] = 36053] = "FRAMEBUFFER_COMPLETE";
    GL2[GL2["FRAMEBUFFER_INCOMPLETE_ATTACHMENT"] = 36054] = "FRAMEBUFFER_INCOMPLETE_ATTACHMENT";
    GL2[GL2["FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT"] = 36055] = "FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT";
    GL2[GL2["FRAMEBUFFER_INCOMPLETE_DIMENSIONS"] = 36057] = "FRAMEBUFFER_INCOMPLETE_DIMENSIONS";
    GL2[GL2["FRAMEBUFFER_UNSUPPORTED"] = 36061] = "FRAMEBUFFER_UNSUPPORTED";
    GL2[GL2["FRAMEBUFFER_BINDING"] = 36006] = "FRAMEBUFFER_BINDING";
    GL2[GL2["RENDERBUFFER_BINDING"] = 36007] = "RENDERBUFFER_BINDING";
    GL2[GL2["READ_FRAMEBUFFER"] = 36008] = "READ_FRAMEBUFFER";
    GL2[GL2["DRAW_FRAMEBUFFER"] = 36009] = "DRAW_FRAMEBUFFER";
    GL2[GL2["MAX_RENDERBUFFER_SIZE"] = 34024] = "MAX_RENDERBUFFER_SIZE";
    GL2[GL2["INVALID_FRAMEBUFFER_OPERATION"] = 1286] = "INVALID_FRAMEBUFFER_OPERATION";
    GL2[GL2["UNPACK_FLIP_Y_WEBGL"] = 37440] = "UNPACK_FLIP_Y_WEBGL";
    GL2[GL2["UNPACK_PREMULTIPLY_ALPHA_WEBGL"] = 37441] = "UNPACK_PREMULTIPLY_ALPHA_WEBGL";
    GL2[GL2["UNPACK_COLORSPACE_CONVERSION_WEBGL"] = 37443] = "UNPACK_COLORSPACE_CONVERSION_WEBGL";
    GL2[GL2["READ_BUFFER"] = 3074] = "READ_BUFFER";
    GL2[GL2["UNPACK_ROW_LENGTH"] = 3314] = "UNPACK_ROW_LENGTH";
    GL2[GL2["UNPACK_SKIP_ROWS"] = 3315] = "UNPACK_SKIP_ROWS";
    GL2[GL2["UNPACK_SKIP_PIXELS"] = 3316] = "UNPACK_SKIP_PIXELS";
    GL2[GL2["PACK_ROW_LENGTH"] = 3330] = "PACK_ROW_LENGTH";
    GL2[GL2["PACK_SKIP_ROWS"] = 3331] = "PACK_SKIP_ROWS";
    GL2[GL2["PACK_SKIP_PIXELS"] = 3332] = "PACK_SKIP_PIXELS";
    GL2[GL2["TEXTURE_BINDING_3D"] = 32874] = "TEXTURE_BINDING_3D";
    GL2[GL2["UNPACK_SKIP_IMAGES"] = 32877] = "UNPACK_SKIP_IMAGES";
    GL2[GL2["UNPACK_IMAGE_HEIGHT"] = 32878] = "UNPACK_IMAGE_HEIGHT";
    GL2[GL2["MAX_3D_TEXTURE_SIZE"] = 32883] = "MAX_3D_TEXTURE_SIZE";
    GL2[GL2["MAX_ELEMENTS_VERTICES"] = 33e3] = "MAX_ELEMENTS_VERTICES";
    GL2[GL2["MAX_ELEMENTS_INDICES"] = 33001] = "MAX_ELEMENTS_INDICES";
    GL2[GL2["MAX_TEXTURE_LOD_BIAS"] = 34045] = "MAX_TEXTURE_LOD_BIAS";
    GL2[GL2["MAX_FRAGMENT_UNIFORM_COMPONENTS"] = 35657] = "MAX_FRAGMENT_UNIFORM_COMPONENTS";
    GL2[GL2["MAX_VERTEX_UNIFORM_COMPONENTS"] = 35658] = "MAX_VERTEX_UNIFORM_COMPONENTS";
    GL2[GL2["MAX_ARRAY_TEXTURE_LAYERS"] = 35071] = "MAX_ARRAY_TEXTURE_LAYERS";
    GL2[GL2["MIN_PROGRAM_TEXEL_OFFSET"] = 35076] = "MIN_PROGRAM_TEXEL_OFFSET";
    GL2[GL2["MAX_PROGRAM_TEXEL_OFFSET"] = 35077] = "MAX_PROGRAM_TEXEL_OFFSET";
    GL2[GL2["MAX_VARYING_COMPONENTS"] = 35659] = "MAX_VARYING_COMPONENTS";
    GL2[GL2["FRAGMENT_SHADER_DERIVATIVE_HINT"] = 35723] = "FRAGMENT_SHADER_DERIVATIVE_HINT";
    GL2[GL2["RASTERIZER_DISCARD"] = 35977] = "RASTERIZER_DISCARD";
    GL2[GL2["VERTEX_ARRAY_BINDING"] = 34229] = "VERTEX_ARRAY_BINDING";
    GL2[GL2["MAX_VERTEX_OUTPUT_COMPONENTS"] = 37154] = "MAX_VERTEX_OUTPUT_COMPONENTS";
    GL2[GL2["MAX_FRAGMENT_INPUT_COMPONENTS"] = 37157] = "MAX_FRAGMENT_INPUT_COMPONENTS";
    GL2[GL2["MAX_SERVER_WAIT_TIMEOUT"] = 37137] = "MAX_SERVER_WAIT_TIMEOUT";
    GL2[GL2["MAX_ELEMENT_INDEX"] = 36203] = "MAX_ELEMENT_INDEX";
    GL2[GL2["RED"] = 6403] = "RED";
    GL2[GL2["RGB8"] = 32849] = "RGB8";
    GL2[GL2["RGBA8"] = 32856] = "RGBA8";
    GL2[GL2["RGB10_A2"] = 32857] = "RGB10_A2";
    GL2[GL2["TEXTURE_3D"] = 32879] = "TEXTURE_3D";
    GL2[GL2["TEXTURE_WRAP_R"] = 32882] = "TEXTURE_WRAP_R";
    GL2[GL2["TEXTURE_MIN_LOD"] = 33082] = "TEXTURE_MIN_LOD";
    GL2[GL2["TEXTURE_MAX_LOD"] = 33083] = "TEXTURE_MAX_LOD";
    GL2[GL2["TEXTURE_BASE_LEVEL"] = 33084] = "TEXTURE_BASE_LEVEL";
    GL2[GL2["TEXTURE_MAX_LEVEL"] = 33085] = "TEXTURE_MAX_LEVEL";
    GL2[GL2["TEXTURE_COMPARE_MODE"] = 34892] = "TEXTURE_COMPARE_MODE";
    GL2[GL2["TEXTURE_COMPARE_FUNC"] = 34893] = "TEXTURE_COMPARE_FUNC";
    GL2[GL2["SRGB"] = 35904] = "SRGB";
    GL2[GL2["SRGB8"] = 35905] = "SRGB8";
    GL2[GL2["SRGB8_ALPHA8"] = 35907] = "SRGB8_ALPHA8";
    GL2[GL2["COMPARE_REF_TO_TEXTURE"] = 34894] = "COMPARE_REF_TO_TEXTURE";
    GL2[GL2["RGBA32F"] = 34836] = "RGBA32F";
    GL2[GL2["RGB32F"] = 34837] = "RGB32F";
    GL2[GL2["RGBA16F"] = 34842] = "RGBA16F";
    GL2[GL2["RGB16F"] = 34843] = "RGB16F";
    GL2[GL2["TEXTURE_2D_ARRAY"] = 35866] = "TEXTURE_2D_ARRAY";
    GL2[GL2["TEXTURE_BINDING_2D_ARRAY"] = 35869] = "TEXTURE_BINDING_2D_ARRAY";
    GL2[GL2["R11F_G11F_B10F"] = 35898] = "R11F_G11F_B10F";
    GL2[GL2["RGB9_E5"] = 35901] = "RGB9_E5";
    GL2[GL2["RGBA32UI"] = 36208] = "RGBA32UI";
    GL2[GL2["RGB32UI"] = 36209] = "RGB32UI";
    GL2[GL2["RGBA16UI"] = 36214] = "RGBA16UI";
    GL2[GL2["RGB16UI"] = 36215] = "RGB16UI";
    GL2[GL2["RGBA8UI"] = 36220] = "RGBA8UI";
    GL2[GL2["RGB8UI"] = 36221] = "RGB8UI";
    GL2[GL2["RGBA32I"] = 36226] = "RGBA32I";
    GL2[GL2["RGB32I"] = 36227] = "RGB32I";
    GL2[GL2["RGBA16I"] = 36232] = "RGBA16I";
    GL2[GL2["RGB16I"] = 36233] = "RGB16I";
    GL2[GL2["RGBA8I"] = 36238] = "RGBA8I";
    GL2[GL2["RGB8I"] = 36239] = "RGB8I";
    GL2[GL2["RED_INTEGER"] = 36244] = "RED_INTEGER";
    GL2[GL2["RGB_INTEGER"] = 36248] = "RGB_INTEGER";
    GL2[GL2["RGBA_INTEGER"] = 36249] = "RGBA_INTEGER";
    GL2[GL2["R8"] = 33321] = "R8";
    GL2[GL2["RG8"] = 33323] = "RG8";
    GL2[GL2["R16F"] = 33325] = "R16F";
    GL2[GL2["R32F"] = 33326] = "R32F";
    GL2[GL2["RG16F"] = 33327] = "RG16F";
    GL2[GL2["RG32F"] = 33328] = "RG32F";
    GL2[GL2["R8I"] = 33329] = "R8I";
    GL2[GL2["R8UI"] = 33330] = "R8UI";
    GL2[GL2["R16I"] = 33331] = "R16I";
    GL2[GL2["R16UI"] = 33332] = "R16UI";
    GL2[GL2["R32I"] = 33333] = "R32I";
    GL2[GL2["R32UI"] = 33334] = "R32UI";
    GL2[GL2["RG8I"] = 33335] = "RG8I";
    GL2[GL2["RG8UI"] = 33336] = "RG8UI";
    GL2[GL2["RG16I"] = 33337] = "RG16I";
    GL2[GL2["RG16UI"] = 33338] = "RG16UI";
    GL2[GL2["RG32I"] = 33339] = "RG32I";
    GL2[GL2["RG32UI"] = 33340] = "RG32UI";
    GL2[GL2["R8_SNORM"] = 36756] = "R8_SNORM";
    GL2[GL2["RG8_SNORM"] = 36757] = "RG8_SNORM";
    GL2[GL2["RGB8_SNORM"] = 36758] = "RGB8_SNORM";
    GL2[GL2["RGBA8_SNORM"] = 36759] = "RGBA8_SNORM";
    GL2[GL2["RGB10_A2UI"] = 36975] = "RGB10_A2UI";
    GL2[GL2["TEXTURE_IMMUTABLE_FORMAT"] = 37167] = "TEXTURE_IMMUTABLE_FORMAT";
    GL2[GL2["TEXTURE_IMMUTABLE_LEVELS"] = 33503] = "TEXTURE_IMMUTABLE_LEVELS";
    GL2[GL2["UNSIGNED_INT_2_10_10_10_REV"] = 33640] = "UNSIGNED_INT_2_10_10_10_REV";
    GL2[GL2["UNSIGNED_INT_10F_11F_11F_REV"] = 35899] = "UNSIGNED_INT_10F_11F_11F_REV";
    GL2[GL2["UNSIGNED_INT_5_9_9_9_REV"] = 35902] = "UNSIGNED_INT_5_9_9_9_REV";
    GL2[GL2["FLOAT_32_UNSIGNED_INT_24_8_REV"] = 36269] = "FLOAT_32_UNSIGNED_INT_24_8_REV";
    GL2[GL2["UNSIGNED_INT_24_8"] = 34042] = "UNSIGNED_INT_24_8";
    GL2[GL2["HALF_FLOAT"] = 5131] = "HALF_FLOAT";
    GL2[GL2["RG"] = 33319] = "RG";
    GL2[GL2["RG_INTEGER"] = 33320] = "RG_INTEGER";
    GL2[GL2["INT_2_10_10_10_REV"] = 36255] = "INT_2_10_10_10_REV";
    GL2[GL2["CURRENT_QUERY"] = 34917] = "CURRENT_QUERY";
    GL2[GL2["QUERY_RESULT"] = 34918] = "QUERY_RESULT";
    GL2[GL2["QUERY_RESULT_AVAILABLE"] = 34919] = "QUERY_RESULT_AVAILABLE";
    GL2[GL2["ANY_SAMPLES_PASSED"] = 35887] = "ANY_SAMPLES_PASSED";
    GL2[GL2["ANY_SAMPLES_PASSED_CONSERVATIVE"] = 36202] = "ANY_SAMPLES_PASSED_CONSERVATIVE";
    GL2[GL2["MAX_DRAW_BUFFERS"] = 34852] = "MAX_DRAW_BUFFERS";
    GL2[GL2["DRAW_BUFFER0"] = 34853] = "DRAW_BUFFER0";
    GL2[GL2["DRAW_BUFFER1"] = 34854] = "DRAW_BUFFER1";
    GL2[GL2["DRAW_BUFFER2"] = 34855] = "DRAW_BUFFER2";
    GL2[GL2["DRAW_BUFFER3"] = 34856] = "DRAW_BUFFER3";
    GL2[GL2["DRAW_BUFFER4"] = 34857] = "DRAW_BUFFER4";
    GL2[GL2["DRAW_BUFFER5"] = 34858] = "DRAW_BUFFER5";
    GL2[GL2["DRAW_BUFFER6"] = 34859] = "DRAW_BUFFER6";
    GL2[GL2["DRAW_BUFFER7"] = 34860] = "DRAW_BUFFER7";
    GL2[GL2["DRAW_BUFFER8"] = 34861] = "DRAW_BUFFER8";
    GL2[GL2["DRAW_BUFFER9"] = 34862] = "DRAW_BUFFER9";
    GL2[GL2["DRAW_BUFFER10"] = 34863] = "DRAW_BUFFER10";
    GL2[GL2["DRAW_BUFFER11"] = 34864] = "DRAW_BUFFER11";
    GL2[GL2["DRAW_BUFFER12"] = 34865] = "DRAW_BUFFER12";
    GL2[GL2["DRAW_BUFFER13"] = 34866] = "DRAW_BUFFER13";
    GL2[GL2["DRAW_BUFFER14"] = 34867] = "DRAW_BUFFER14";
    GL2[GL2["DRAW_BUFFER15"] = 34868] = "DRAW_BUFFER15";
    GL2[GL2["MAX_COLOR_ATTACHMENTS"] = 36063] = "MAX_COLOR_ATTACHMENTS";
    GL2[GL2["COLOR_ATTACHMENT1"] = 36065] = "COLOR_ATTACHMENT1";
    GL2[GL2["COLOR_ATTACHMENT2"] = 36066] = "COLOR_ATTACHMENT2";
    GL2[GL2["COLOR_ATTACHMENT3"] = 36067] = "COLOR_ATTACHMENT3";
    GL2[GL2["COLOR_ATTACHMENT4"] = 36068] = "COLOR_ATTACHMENT4";
    GL2[GL2["COLOR_ATTACHMENT5"] = 36069] = "COLOR_ATTACHMENT5";
    GL2[GL2["COLOR_ATTACHMENT6"] = 36070] = "COLOR_ATTACHMENT6";
    GL2[GL2["COLOR_ATTACHMENT7"] = 36071] = "COLOR_ATTACHMENT7";
    GL2[GL2["COLOR_ATTACHMENT8"] = 36072] = "COLOR_ATTACHMENT8";
    GL2[GL2["COLOR_ATTACHMENT9"] = 36073] = "COLOR_ATTACHMENT9";
    GL2[GL2["COLOR_ATTACHMENT10"] = 36074] = "COLOR_ATTACHMENT10";
    GL2[GL2["COLOR_ATTACHMENT11"] = 36075] = "COLOR_ATTACHMENT11";
    GL2[GL2["COLOR_ATTACHMENT12"] = 36076] = "COLOR_ATTACHMENT12";
    GL2[GL2["COLOR_ATTACHMENT13"] = 36077] = "COLOR_ATTACHMENT13";
    GL2[GL2["COLOR_ATTACHMENT14"] = 36078] = "COLOR_ATTACHMENT14";
    GL2[GL2["COLOR_ATTACHMENT15"] = 36079] = "COLOR_ATTACHMENT15";
    GL2[GL2["SAMPLER_3D"] = 35679] = "SAMPLER_3D";
    GL2[GL2["SAMPLER_2D_SHADOW"] = 35682] = "SAMPLER_2D_SHADOW";
    GL2[GL2["SAMPLER_2D_ARRAY"] = 36289] = "SAMPLER_2D_ARRAY";
    GL2[GL2["SAMPLER_2D_ARRAY_SHADOW"] = 36292] = "SAMPLER_2D_ARRAY_SHADOW";
    GL2[GL2["SAMPLER_CUBE_SHADOW"] = 36293] = "SAMPLER_CUBE_SHADOW";
    GL2[GL2["INT_SAMPLER_2D"] = 36298] = "INT_SAMPLER_2D";
    GL2[GL2["INT_SAMPLER_3D"] = 36299] = "INT_SAMPLER_3D";
    GL2[GL2["INT_SAMPLER_CUBE"] = 36300] = "INT_SAMPLER_CUBE";
    GL2[GL2["INT_SAMPLER_2D_ARRAY"] = 36303] = "INT_SAMPLER_2D_ARRAY";
    GL2[GL2["UNSIGNED_INT_SAMPLER_2D"] = 36306] = "UNSIGNED_INT_SAMPLER_2D";
    GL2[GL2["UNSIGNED_INT_SAMPLER_3D"] = 36307] = "UNSIGNED_INT_SAMPLER_3D";
    GL2[GL2["UNSIGNED_INT_SAMPLER_CUBE"] = 36308] = "UNSIGNED_INT_SAMPLER_CUBE";
    GL2[GL2["UNSIGNED_INT_SAMPLER_2D_ARRAY"] = 36311] = "UNSIGNED_INT_SAMPLER_2D_ARRAY";
    GL2[GL2["MAX_SAMPLES"] = 36183] = "MAX_SAMPLES";
    GL2[GL2["SAMPLER_BINDING"] = 35097] = "SAMPLER_BINDING";
    GL2[GL2["PIXEL_PACK_BUFFER"] = 35051] = "PIXEL_PACK_BUFFER";
    GL2[GL2["PIXEL_UNPACK_BUFFER"] = 35052] = "PIXEL_UNPACK_BUFFER";
    GL2[GL2["PIXEL_PACK_BUFFER_BINDING"] = 35053] = "PIXEL_PACK_BUFFER_BINDING";
    GL2[GL2["PIXEL_UNPACK_BUFFER_BINDING"] = 35055] = "PIXEL_UNPACK_BUFFER_BINDING";
    GL2[GL2["COPY_READ_BUFFER"] = 36662] = "COPY_READ_BUFFER";
    GL2[GL2["COPY_WRITE_BUFFER"] = 36663] = "COPY_WRITE_BUFFER";
    GL2[GL2["COPY_READ_BUFFER_BINDING"] = 36662] = "COPY_READ_BUFFER_BINDING";
    GL2[GL2["COPY_WRITE_BUFFER_BINDING"] = 36663] = "COPY_WRITE_BUFFER_BINDING";
    GL2[GL2["FLOAT_MAT2x3"] = 35685] = "FLOAT_MAT2x3";
    GL2[GL2["FLOAT_MAT2x4"] = 35686] = "FLOAT_MAT2x4";
    GL2[GL2["FLOAT_MAT3x2"] = 35687] = "FLOAT_MAT3x2";
    GL2[GL2["FLOAT_MAT3x4"] = 35688] = "FLOAT_MAT3x4";
    GL2[GL2["FLOAT_MAT4x2"] = 35689] = "FLOAT_MAT4x2";
    GL2[GL2["FLOAT_MAT4x3"] = 35690] = "FLOAT_MAT4x3";
    GL2[GL2["UNSIGNED_INT_VEC2"] = 36294] = "UNSIGNED_INT_VEC2";
    GL2[GL2["UNSIGNED_INT_VEC3"] = 36295] = "UNSIGNED_INT_VEC3";
    GL2[GL2["UNSIGNED_INT_VEC4"] = 36296] = "UNSIGNED_INT_VEC4";
    GL2[GL2["UNSIGNED_NORMALIZED"] = 35863] = "UNSIGNED_NORMALIZED";
    GL2[GL2["SIGNED_NORMALIZED"] = 36764] = "SIGNED_NORMALIZED";
    GL2[GL2["VERTEX_ATTRIB_ARRAY_INTEGER"] = 35069] = "VERTEX_ATTRIB_ARRAY_INTEGER";
    GL2[GL2["VERTEX_ATTRIB_ARRAY_DIVISOR"] = 35070] = "VERTEX_ATTRIB_ARRAY_DIVISOR";
    GL2[GL2["TRANSFORM_FEEDBACK_BUFFER_MODE"] = 35967] = "TRANSFORM_FEEDBACK_BUFFER_MODE";
    GL2[GL2["MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS"] = 35968] = "MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS";
    GL2[GL2["TRANSFORM_FEEDBACK_VARYINGS"] = 35971] = "TRANSFORM_FEEDBACK_VARYINGS";
    GL2[GL2["TRANSFORM_FEEDBACK_BUFFER_START"] = 35972] = "TRANSFORM_FEEDBACK_BUFFER_START";
    GL2[GL2["TRANSFORM_FEEDBACK_BUFFER_SIZE"] = 35973] = "TRANSFORM_FEEDBACK_BUFFER_SIZE";
    GL2[GL2["TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN"] = 35976] = "TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN";
    GL2[GL2["MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS"] = 35978] = "MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS";
    GL2[GL2["MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS"] = 35979] = "MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS";
    GL2[GL2["INTERLEAVED_ATTRIBS"] = 35980] = "INTERLEAVED_ATTRIBS";
    GL2[GL2["SEPARATE_ATTRIBS"] = 35981] = "SEPARATE_ATTRIBS";
    GL2[GL2["TRANSFORM_FEEDBACK_BUFFER"] = 35982] = "TRANSFORM_FEEDBACK_BUFFER";
    GL2[GL2["TRANSFORM_FEEDBACK_BUFFER_BINDING"] = 35983] = "TRANSFORM_FEEDBACK_BUFFER_BINDING";
    GL2[GL2["TRANSFORM_FEEDBACK"] = 36386] = "TRANSFORM_FEEDBACK";
    GL2[GL2["TRANSFORM_FEEDBACK_PAUSED"] = 36387] = "TRANSFORM_FEEDBACK_PAUSED";
    GL2[GL2["TRANSFORM_FEEDBACK_ACTIVE"] = 36388] = "TRANSFORM_FEEDBACK_ACTIVE";
    GL2[GL2["TRANSFORM_FEEDBACK_BINDING"] = 36389] = "TRANSFORM_FEEDBACK_BINDING";
    GL2[GL2["FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING"] = 33296] = "FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING";
    GL2[GL2["FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE"] = 33297] = "FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE";
    GL2[GL2["FRAMEBUFFER_ATTACHMENT_RED_SIZE"] = 33298] = "FRAMEBUFFER_ATTACHMENT_RED_SIZE";
    GL2[GL2["FRAMEBUFFER_ATTACHMENT_GREEN_SIZE"] = 33299] = "FRAMEBUFFER_ATTACHMENT_GREEN_SIZE";
    GL2[GL2["FRAMEBUFFER_ATTACHMENT_BLUE_SIZE"] = 33300] = "FRAMEBUFFER_ATTACHMENT_BLUE_SIZE";
    GL2[GL2["FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE"] = 33301] = "FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE";
    GL2[GL2["FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE"] = 33302] = "FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE";
    GL2[GL2["FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE"] = 33303] = "FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE";
    GL2[GL2["FRAMEBUFFER_DEFAULT"] = 33304] = "FRAMEBUFFER_DEFAULT";
    GL2[GL2["DEPTH24_STENCIL8"] = 35056] = "DEPTH24_STENCIL8";
    GL2[GL2["DRAW_FRAMEBUFFER_BINDING"] = 36006] = "DRAW_FRAMEBUFFER_BINDING";
    GL2[GL2["READ_FRAMEBUFFER_BINDING"] = 36010] = "READ_FRAMEBUFFER_BINDING";
    GL2[GL2["RENDERBUFFER_SAMPLES"] = 36011] = "RENDERBUFFER_SAMPLES";
    GL2[GL2["FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER"] = 36052] = "FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER";
    GL2[GL2["FRAMEBUFFER_INCOMPLETE_MULTISAMPLE"] = 36182] = "FRAMEBUFFER_INCOMPLETE_MULTISAMPLE";
    GL2[GL2["UNIFORM_BUFFER"] = 35345] = "UNIFORM_BUFFER";
    GL2[GL2["UNIFORM_BUFFER_BINDING"] = 35368] = "UNIFORM_BUFFER_BINDING";
    GL2[GL2["UNIFORM_BUFFER_START"] = 35369] = "UNIFORM_BUFFER_START";
    GL2[GL2["UNIFORM_BUFFER_SIZE"] = 35370] = "UNIFORM_BUFFER_SIZE";
    GL2[GL2["MAX_VERTEX_UNIFORM_BLOCKS"] = 35371] = "MAX_VERTEX_UNIFORM_BLOCKS";
    GL2[GL2["MAX_FRAGMENT_UNIFORM_BLOCKS"] = 35373] = "MAX_FRAGMENT_UNIFORM_BLOCKS";
    GL2[GL2["MAX_COMBINED_UNIFORM_BLOCKS"] = 35374] = "MAX_COMBINED_UNIFORM_BLOCKS";
    GL2[GL2["MAX_UNIFORM_BUFFER_BINDINGS"] = 35375] = "MAX_UNIFORM_BUFFER_BINDINGS";
    GL2[GL2["MAX_UNIFORM_BLOCK_SIZE"] = 35376] = "MAX_UNIFORM_BLOCK_SIZE";
    GL2[GL2["MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS"] = 35377] = "MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS";
    GL2[GL2["MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS"] = 35379] = "MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS";
    GL2[GL2["UNIFORM_BUFFER_OFFSET_ALIGNMENT"] = 35380] = "UNIFORM_BUFFER_OFFSET_ALIGNMENT";
    GL2[GL2["ACTIVE_UNIFORM_BLOCKS"] = 35382] = "ACTIVE_UNIFORM_BLOCKS";
    GL2[GL2["UNIFORM_TYPE"] = 35383] = "UNIFORM_TYPE";
    GL2[GL2["UNIFORM_SIZE"] = 35384] = "UNIFORM_SIZE";
    GL2[GL2["UNIFORM_BLOCK_INDEX"] = 35386] = "UNIFORM_BLOCK_INDEX";
    GL2[GL2["UNIFORM_OFFSET"] = 35387] = "UNIFORM_OFFSET";
    GL2[GL2["UNIFORM_ARRAY_STRIDE"] = 35388] = "UNIFORM_ARRAY_STRIDE";
    GL2[GL2["UNIFORM_MATRIX_STRIDE"] = 35389] = "UNIFORM_MATRIX_STRIDE";
    GL2[GL2["UNIFORM_IS_ROW_MAJOR"] = 35390] = "UNIFORM_IS_ROW_MAJOR";
    GL2[GL2["UNIFORM_BLOCK_BINDING"] = 35391] = "UNIFORM_BLOCK_BINDING";
    GL2[GL2["UNIFORM_BLOCK_DATA_SIZE"] = 35392] = "UNIFORM_BLOCK_DATA_SIZE";
    GL2[GL2["UNIFORM_BLOCK_ACTIVE_UNIFORMS"] = 35394] = "UNIFORM_BLOCK_ACTIVE_UNIFORMS";
    GL2[GL2["UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES"] = 35395] = "UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES";
    GL2[GL2["UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER"] = 35396] = "UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER";
    GL2[GL2["UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER"] = 35398] = "UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER";
    GL2[GL2["OBJECT_TYPE"] = 37138] = "OBJECT_TYPE";
    GL2[GL2["SYNC_CONDITION"] = 37139] = "SYNC_CONDITION";
    GL2[GL2["SYNC_STATUS"] = 37140] = "SYNC_STATUS";
    GL2[GL2["SYNC_FLAGS"] = 37141] = "SYNC_FLAGS";
    GL2[GL2["SYNC_FENCE"] = 37142] = "SYNC_FENCE";
    GL2[GL2["SYNC_GPU_COMMANDS_COMPLETE"] = 37143] = "SYNC_GPU_COMMANDS_COMPLETE";
    GL2[GL2["UNSIGNALED"] = 37144] = "UNSIGNALED";
    GL2[GL2["SIGNALED"] = 37145] = "SIGNALED";
    GL2[GL2["ALREADY_SIGNALED"] = 37146] = "ALREADY_SIGNALED";
    GL2[GL2["TIMEOUT_EXPIRED"] = 37147] = "TIMEOUT_EXPIRED";
    GL2[GL2["CONDITION_SATISFIED"] = 37148] = "CONDITION_SATISFIED";
    GL2[GL2["WAIT_FAILED"] = 37149] = "WAIT_FAILED";
    GL2[GL2["SYNC_FLUSH_COMMANDS_BIT"] = 1] = "SYNC_FLUSH_COMMANDS_BIT";
    GL2[GL2["COLOR"] = 6144] = "COLOR";
    GL2[GL2["DEPTH"] = 6145] = "DEPTH";
    GL2[GL2["STENCIL"] = 6146] = "STENCIL";
    GL2[GL2["MIN"] = 32775] = "MIN";
    GL2[GL2["MAX"] = 32776] = "MAX";
    GL2[GL2["DEPTH_COMPONENT24"] = 33190] = "DEPTH_COMPONENT24";
    GL2[GL2["STREAM_READ"] = 35041] = "STREAM_READ";
    GL2[GL2["STREAM_COPY"] = 35042] = "STREAM_COPY";
    GL2[GL2["STATIC_READ"] = 35045] = "STATIC_READ";
    GL2[GL2["STATIC_COPY"] = 35046] = "STATIC_COPY";
    GL2[GL2["DYNAMIC_READ"] = 35049] = "DYNAMIC_READ";
    GL2[GL2["DYNAMIC_COPY"] = 35050] = "DYNAMIC_COPY";
    GL2[GL2["DEPTH_COMPONENT32F"] = 36012] = "DEPTH_COMPONENT32F";
    GL2[GL2["DEPTH32F_STENCIL8"] = 36013] = "DEPTH32F_STENCIL8";
    GL2[GL2["INVALID_INDEX"] = 4294967295] = "INVALID_INDEX";
    GL2[GL2["TIMEOUT_IGNORED"] = -1] = "TIMEOUT_IGNORED";
    GL2[GL2["MAX_CLIENT_WAIT_TIMEOUT_WEBGL"] = 37447] = "MAX_CLIENT_WAIT_TIMEOUT_WEBGL";
    GL2[GL2["VERTEX_ATTRIB_ARRAY_DIVISOR_ANGLE"] = 35070] = "VERTEX_ATTRIB_ARRAY_DIVISOR_ANGLE";
    GL2[GL2["UNMASKED_VENDOR_WEBGL"] = 37445] = "UNMASKED_VENDOR_WEBGL";
    GL2[GL2["UNMASKED_RENDERER_WEBGL"] = 37446] = "UNMASKED_RENDERER_WEBGL";
    GL2[GL2["MAX_TEXTURE_MAX_ANISOTROPY_EXT"] = 34047] = "MAX_TEXTURE_MAX_ANISOTROPY_EXT";
    GL2[GL2["TEXTURE_MAX_ANISOTROPY_EXT"] = 34046] = "TEXTURE_MAX_ANISOTROPY_EXT";
    GL2[GL2["SRGB_EXT"] = 35904] = "SRGB_EXT";
    GL2[GL2["SRGB_ALPHA_EXT"] = 35906] = "SRGB_ALPHA_EXT";
    GL2[GL2["SRGB8_ALPHA8_EXT"] = 35907] = "SRGB8_ALPHA8_EXT";
    GL2[GL2["FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT"] = 33296] = "FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT";
    GL2[GL2["R16_EXT"] = 33322] = "R16_EXT";
    GL2[GL2["RG16_EXT"] = 33324] = "RG16_EXT";
    GL2[GL2["RGB16_EXT"] = 32852] = "RGB16_EXT";
    GL2[GL2["RGBA16_EXT"] = 32859] = "RGBA16_EXT";
    GL2[GL2["R16_SNORM_EXT"] = 36760] = "R16_SNORM_EXT";
    GL2[GL2["RG16_SNORM_EXT"] = 36761] = "RG16_SNORM_EXT";
    GL2[GL2["RGB16_SNORM_EXT"] = 36762] = "RGB16_SNORM_EXT";
    GL2[GL2["RGBA16_SNORM_EXT"] = 36763] = "RGBA16_SNORM_EXT";
    GL2[GL2["COMPRESSED_RGB_S3TC_DXT1_EXT"] = 33776] = "COMPRESSED_RGB_S3TC_DXT1_EXT";
    GL2[GL2["COMPRESSED_RGBA_S3TC_DXT1_EXT"] = 33777] = "COMPRESSED_RGBA_S3TC_DXT1_EXT";
    GL2[GL2["COMPRESSED_RGBA_S3TC_DXT3_EXT"] = 33778] = "COMPRESSED_RGBA_S3TC_DXT3_EXT";
    GL2[GL2["COMPRESSED_RGBA_S3TC_DXT5_EXT"] = 33779] = "COMPRESSED_RGBA_S3TC_DXT5_EXT";
    GL2[GL2["COMPRESSED_SRGB_S3TC_DXT1_EXT"] = 35916] = "COMPRESSED_SRGB_S3TC_DXT1_EXT";
    GL2[GL2["COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT"] = 35917] = "COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT";
    GL2[GL2["COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT"] = 35918] = "COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT";
    GL2[GL2["COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT"] = 35919] = "COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT";
    GL2[GL2["COMPRESSED_RED_RGTC1_EXT"] = 36283] = "COMPRESSED_RED_RGTC1_EXT";
    GL2[GL2["COMPRESSED_SIGNED_RED_RGTC1_EXT"] = 36284] = "COMPRESSED_SIGNED_RED_RGTC1_EXT";
    GL2[GL2["COMPRESSED_RED_GREEN_RGTC2_EXT"] = 36285] = "COMPRESSED_RED_GREEN_RGTC2_EXT";
    GL2[GL2["COMPRESSED_SIGNED_RED_GREEN_RGTC2_EXT"] = 36286] = "COMPRESSED_SIGNED_RED_GREEN_RGTC2_EXT";
    GL2[GL2["COMPRESSED_RGBA_BPTC_UNORM_EXT"] = 36492] = "COMPRESSED_RGBA_BPTC_UNORM_EXT";
    GL2[GL2["COMPRESSED_SRGB_ALPHA_BPTC_UNORM_EXT"] = 36493] = "COMPRESSED_SRGB_ALPHA_BPTC_UNORM_EXT";
    GL2[GL2["COMPRESSED_RGB_BPTC_SIGNED_FLOAT_EXT"] = 36494] = "COMPRESSED_RGB_BPTC_SIGNED_FLOAT_EXT";
    GL2[GL2["COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_EXT"] = 36495] = "COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_EXT";
    GL2[GL2["COMPRESSED_R11_EAC"] = 37488] = "COMPRESSED_R11_EAC";
    GL2[GL2["COMPRESSED_SIGNED_R11_EAC"] = 37489] = "COMPRESSED_SIGNED_R11_EAC";
    GL2[GL2["COMPRESSED_RG11_EAC"] = 37490] = "COMPRESSED_RG11_EAC";
    GL2[GL2["COMPRESSED_SIGNED_RG11_EAC"] = 37491] = "COMPRESSED_SIGNED_RG11_EAC";
    GL2[GL2["COMPRESSED_RGB8_ETC2"] = 37492] = "COMPRESSED_RGB8_ETC2";
    GL2[GL2["COMPRESSED_RGBA8_ETC2_EAC"] = 37493] = "COMPRESSED_RGBA8_ETC2_EAC";
    GL2[GL2["COMPRESSED_SRGB8_ETC2"] = 37494] = "COMPRESSED_SRGB8_ETC2";
    GL2[GL2["COMPRESSED_SRGB8_ALPHA8_ETC2_EAC"] = 37495] = "COMPRESSED_SRGB8_ALPHA8_ETC2_EAC";
    GL2[GL2["COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2"] = 37496] = "COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2";
    GL2[GL2["COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2"] = 37497] = "COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2";
    GL2[GL2["COMPRESSED_RGB_PVRTC_4BPPV1_IMG"] = 35840] = "COMPRESSED_RGB_PVRTC_4BPPV1_IMG";
    GL2[GL2["COMPRESSED_RGBA_PVRTC_4BPPV1_IMG"] = 35842] = "COMPRESSED_RGBA_PVRTC_4BPPV1_IMG";
    GL2[GL2["COMPRESSED_RGB_PVRTC_2BPPV1_IMG"] = 35841] = "COMPRESSED_RGB_PVRTC_2BPPV1_IMG";
    GL2[GL2["COMPRESSED_RGBA_PVRTC_2BPPV1_IMG"] = 35843] = "COMPRESSED_RGBA_PVRTC_2BPPV1_IMG";
    GL2[GL2["COMPRESSED_RGB_ETC1_WEBGL"] = 36196] = "COMPRESSED_RGB_ETC1_WEBGL";
    GL2[GL2["COMPRESSED_RGB_ATC_WEBGL"] = 35986] = "COMPRESSED_RGB_ATC_WEBGL";
    GL2[GL2["COMPRESSED_RGBA_ATC_EXPLICIT_ALPHA_WEBGL"] = 35986] = "COMPRESSED_RGBA_ATC_EXPLICIT_ALPHA_WEBGL";
    GL2[GL2["COMPRESSED_RGBA_ATC_INTERPOLATED_ALPHA_WEBGL"] = 34798] = "COMPRESSED_RGBA_ATC_INTERPOLATED_ALPHA_WEBGL";
    GL2[GL2["COMPRESSED_RGBA_ASTC_4x4_KHR"] = 37808] = "COMPRESSED_RGBA_ASTC_4x4_KHR";
    GL2[GL2["COMPRESSED_RGBA_ASTC_5x4_KHR"] = 37809] = "COMPRESSED_RGBA_ASTC_5x4_KHR";
    GL2[GL2["COMPRESSED_RGBA_ASTC_5x5_KHR"] = 37810] = "COMPRESSED_RGBA_ASTC_5x5_KHR";
    GL2[GL2["COMPRESSED_RGBA_ASTC_6x5_KHR"] = 37811] = "COMPRESSED_RGBA_ASTC_6x5_KHR";
    GL2[GL2["COMPRESSED_RGBA_ASTC_6x6_KHR"] = 37812] = "COMPRESSED_RGBA_ASTC_6x6_KHR";
    GL2[GL2["COMPRESSED_RGBA_ASTC_8x5_KHR"] = 37813] = "COMPRESSED_RGBA_ASTC_8x5_KHR";
    GL2[GL2["COMPRESSED_RGBA_ASTC_8x6_KHR"] = 37814] = "COMPRESSED_RGBA_ASTC_8x6_KHR";
    GL2[GL2["COMPRESSED_RGBA_ASTC_8x8_KHR"] = 37815] = "COMPRESSED_RGBA_ASTC_8x8_KHR";
    GL2[GL2["COMPRESSED_RGBA_ASTC_10x5_KHR"] = 37816] = "COMPRESSED_RGBA_ASTC_10x5_KHR";
    GL2[GL2["COMPRESSED_RGBA_ASTC_10x6_KHR"] = 37817] = "COMPRESSED_RGBA_ASTC_10x6_KHR";
    GL2[GL2["COMPRESSED_RGBA_ASTC_10x8_KHR"] = 37818] = "COMPRESSED_RGBA_ASTC_10x8_KHR";
    GL2[GL2["COMPRESSED_RGBA_ASTC_10x10_KHR"] = 37819] = "COMPRESSED_RGBA_ASTC_10x10_KHR";
    GL2[GL2["COMPRESSED_RGBA_ASTC_12x10_KHR"] = 37820] = "COMPRESSED_RGBA_ASTC_12x10_KHR";
    GL2[GL2["COMPRESSED_RGBA_ASTC_12x12_KHR"] = 37821] = "COMPRESSED_RGBA_ASTC_12x12_KHR";
    GL2[GL2["COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR"] = 37840] = "COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR";
    GL2[GL2["COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR"] = 37841] = "COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR";
    GL2[GL2["COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR"] = 37842] = "COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR";
    GL2[GL2["COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR"] = 37843] = "COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR";
    GL2[GL2["COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR"] = 37844] = "COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR";
    GL2[GL2["COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR"] = 37845] = "COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR";
    GL2[GL2["COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR"] = 37846] = "COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR";
    GL2[GL2["COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR"] = 37847] = "COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR";
    GL2[GL2["COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR"] = 37848] = "COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR";
    GL2[GL2["COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR"] = 37849] = "COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR";
    GL2[GL2["COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR"] = 37850] = "COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR";
    GL2[GL2["COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR"] = 37851] = "COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR";
    GL2[GL2["COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR"] = 37852] = "COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR";
    GL2[GL2["COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR"] = 37853] = "COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR";
    GL2[GL2["UNSIGNED_INT_24_8_WEBGL"] = 34042] = "UNSIGNED_INT_24_8_WEBGL";
    GL2[GL2["HALF_FLOAT_OES"] = 36193] = "HALF_FLOAT_OES";
    GL2[GL2["RGBA32F_EXT"] = 34836] = "RGBA32F_EXT";
    GL2[GL2["RGB32F_EXT"] = 34837] = "RGB32F_EXT";
    GL2[GL2["FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE_EXT"] = 33297] = "FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE_EXT";
    GL2[GL2["UNSIGNED_NORMALIZED_EXT"] = 35863] = "UNSIGNED_NORMALIZED_EXT";
    GL2[GL2["MIN_EXT"] = 32775] = "MIN_EXT";
    GL2[GL2["MAX_EXT"] = 32776] = "MAX_EXT";
    GL2[GL2["FRAGMENT_SHADER_DERIVATIVE_HINT_OES"] = 35723] = "FRAGMENT_SHADER_DERIVATIVE_HINT_OES";
    GL2[GL2["COLOR_ATTACHMENT0_WEBGL"] = 36064] = "COLOR_ATTACHMENT0_WEBGL";
    GL2[GL2["COLOR_ATTACHMENT1_WEBGL"] = 36065] = "COLOR_ATTACHMENT1_WEBGL";
    GL2[GL2["COLOR_ATTACHMENT2_WEBGL"] = 36066] = "COLOR_ATTACHMENT2_WEBGL";
    GL2[GL2["COLOR_ATTACHMENT3_WEBGL"] = 36067] = "COLOR_ATTACHMENT3_WEBGL";
    GL2[GL2["COLOR_ATTACHMENT4_WEBGL"] = 36068] = "COLOR_ATTACHMENT4_WEBGL";
    GL2[GL2["COLOR_ATTACHMENT5_WEBGL"] = 36069] = "COLOR_ATTACHMENT5_WEBGL";
    GL2[GL2["COLOR_ATTACHMENT6_WEBGL"] = 36070] = "COLOR_ATTACHMENT6_WEBGL";
    GL2[GL2["COLOR_ATTACHMENT7_WEBGL"] = 36071] = "COLOR_ATTACHMENT7_WEBGL";
    GL2[GL2["COLOR_ATTACHMENT8_WEBGL"] = 36072] = "COLOR_ATTACHMENT8_WEBGL";
    GL2[GL2["COLOR_ATTACHMENT9_WEBGL"] = 36073] = "COLOR_ATTACHMENT9_WEBGL";
    GL2[GL2["COLOR_ATTACHMENT10_WEBGL"] = 36074] = "COLOR_ATTACHMENT10_WEBGL";
    GL2[GL2["COLOR_ATTACHMENT11_WEBGL"] = 36075] = "COLOR_ATTACHMENT11_WEBGL";
    GL2[GL2["COLOR_ATTACHMENT12_WEBGL"] = 36076] = "COLOR_ATTACHMENT12_WEBGL";
    GL2[GL2["COLOR_ATTACHMENT13_WEBGL"] = 36077] = "COLOR_ATTACHMENT13_WEBGL";
    GL2[GL2["COLOR_ATTACHMENT14_WEBGL"] = 36078] = "COLOR_ATTACHMENT14_WEBGL";
    GL2[GL2["COLOR_ATTACHMENT15_WEBGL"] = 36079] = "COLOR_ATTACHMENT15_WEBGL";
    GL2[GL2["DRAW_BUFFER0_WEBGL"] = 34853] = "DRAW_BUFFER0_WEBGL";
    GL2[GL2["DRAW_BUFFER1_WEBGL"] = 34854] = "DRAW_BUFFER1_WEBGL";
    GL2[GL2["DRAW_BUFFER2_WEBGL"] = 34855] = "DRAW_BUFFER2_WEBGL";
    GL2[GL2["DRAW_BUFFER3_WEBGL"] = 34856] = "DRAW_BUFFER3_WEBGL";
    GL2[GL2["DRAW_BUFFER4_WEBGL"] = 34857] = "DRAW_BUFFER4_WEBGL";
    GL2[GL2["DRAW_BUFFER5_WEBGL"] = 34858] = "DRAW_BUFFER5_WEBGL";
    GL2[GL2["DRAW_BUFFER6_WEBGL"] = 34859] = "DRAW_BUFFER6_WEBGL";
    GL2[GL2["DRAW_BUFFER7_WEBGL"] = 34860] = "DRAW_BUFFER7_WEBGL";
    GL2[GL2["DRAW_BUFFER8_WEBGL"] = 34861] = "DRAW_BUFFER8_WEBGL";
    GL2[GL2["DRAW_BUFFER9_WEBGL"] = 34862] = "DRAW_BUFFER9_WEBGL";
    GL2[GL2["DRAW_BUFFER10_WEBGL"] = 34863] = "DRAW_BUFFER10_WEBGL";
    GL2[GL2["DRAW_BUFFER11_WEBGL"] = 34864] = "DRAW_BUFFER11_WEBGL";
    GL2[GL2["DRAW_BUFFER12_WEBGL"] = 34865] = "DRAW_BUFFER12_WEBGL";
    GL2[GL2["DRAW_BUFFER13_WEBGL"] = 34866] = "DRAW_BUFFER13_WEBGL";
    GL2[GL2["DRAW_BUFFER14_WEBGL"] = 34867] = "DRAW_BUFFER14_WEBGL";
    GL2[GL2["DRAW_BUFFER15_WEBGL"] = 34868] = "DRAW_BUFFER15_WEBGL";
    GL2[GL2["MAX_COLOR_ATTACHMENTS_WEBGL"] = 36063] = "MAX_COLOR_ATTACHMENTS_WEBGL";
    GL2[GL2["MAX_DRAW_BUFFERS_WEBGL"] = 34852] = "MAX_DRAW_BUFFERS_WEBGL";
    GL2[GL2["VERTEX_ARRAY_BINDING_OES"] = 34229] = "VERTEX_ARRAY_BINDING_OES";
    GL2[GL2["QUERY_COUNTER_BITS_EXT"] = 34916] = "QUERY_COUNTER_BITS_EXT";
    GL2[GL2["CURRENT_QUERY_EXT"] = 34917] = "CURRENT_QUERY_EXT";
    GL2[GL2["QUERY_RESULT_EXT"] = 34918] = "QUERY_RESULT_EXT";
    GL2[GL2["QUERY_RESULT_AVAILABLE_EXT"] = 34919] = "QUERY_RESULT_AVAILABLE_EXT";
    GL2[GL2["TIME_ELAPSED_EXT"] = 35007] = "TIME_ELAPSED_EXT";
    GL2[GL2["TIMESTAMP_EXT"] = 36392] = "TIMESTAMP_EXT";
    GL2[GL2["GPU_DISJOINT_EXT"] = 36795] = "GPU_DISJOINT_EXT";
    return GL2;
  }({});

  // ../../node_modules/@luma.gl/webgl/dist/context/context/webgl-checks.js
  var import_core4 = __toESM(require_core2(), 1);
  var ERR_CONTEXT = "Invalid WebGLRenderingContext";
  var ERR_WEBGL2 = "Requires WebGL2";
  function isWebGL(gl) {
    if (typeof WebGLRenderingContext !== "undefined" && gl instanceof WebGLRenderingContext) {
      return true;
    }
    if (typeof WebGL2RenderingContext !== "undefined" && gl instanceof WebGL2RenderingContext) {
      return true;
    }
    return Boolean(gl && Number.isFinite(gl._version));
  }
  function isWebGL2(gl) {
    if (typeof WebGL2RenderingContext !== "undefined" && gl instanceof WebGL2RenderingContext) {
      return true;
    }
    return Boolean(gl && gl._version === 2);
  }
  function getWebGL2Context(gl) {
    return isWebGL2(gl) ? gl : null;
  }
  function assertWebGLContext(gl) {
    (0, import_core4.assert)(isWebGL(gl), ERR_CONTEXT);
    return gl;
  }
  function assertWebGL2Context(gl) {
    (0, import_core4.assert)(isWebGL2(gl), ERR_WEBGL2);
    return gl;
  }

  // ../../node_modules/@luma.gl/webgl/dist/context/polyfill/get-parameter-polyfill.js
  var OES_element_index = "OES_element_index";
  var WEBGL_draw_buffers = "WEBGL_draw_buffers";
  var EXT_disjoint_timer_query = "EXT_disjoint_timer_query";
  var EXT_disjoint_timer_query_webgl2 = "EXT_disjoint_timer_query_webgl2";
  var EXT_texture_filter_anisotropic = "EXT_texture_filter_anisotropic";
  var WEBGL_debug_renderer_info = "WEBGL_debug_renderer_info";
  var GL_FRAGMENT_SHADER_DERIVATIVE_HINT = 35723;
  var GL_DONT_CARE = 4352;
  var GL_GPU_DISJOINT_EXT = 36795;
  var GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT = 34047;
  var GL_UNMASKED_VENDOR_WEBGL = 37445;
  var GL_UNMASKED_RENDERER_WEBGL = 37446;
  var getWebGL2ValueOrZero = (gl) => !isWebGL2(gl) ? 0 : void 0;
  var WEBGL_PARAMETERS = {
    [GL.READ_BUFFER]: (gl) => !isWebGL2(gl) ? GL.COLOR_ATTACHMENT0 : void 0,
    [GL_FRAGMENT_SHADER_DERIVATIVE_HINT]: (gl) => !isWebGL2(gl) ? GL_DONT_CARE : void 0,
    [GL.RASTERIZER_DISCARD]: getWebGL2ValueOrZero,
    [GL.SAMPLES]: getWebGL2ValueOrZero,
    [GL_GPU_DISJOINT_EXT]: (gl, getParameter) => {
      const ext = isWebGL2(gl) ? gl.getExtension(EXT_disjoint_timer_query_webgl2) : gl.getExtension(EXT_disjoint_timer_query);
      return ext && ext.GPU_DISJOINT_EXT ? getParameter(ext.GPU_DISJOINT_EXT) : 0;
    },
    [GL_UNMASKED_VENDOR_WEBGL]: (gl, getParameter) => {
      const ext = gl.getExtension(WEBGL_debug_renderer_info);
      return getParameter(ext && ext.UNMASKED_VENDOR_WEBGL || GL.VENDOR);
    },
    [GL_UNMASKED_RENDERER_WEBGL]: (gl, getParameter) => {
      const ext = gl.getExtension(WEBGL_debug_renderer_info);
      return getParameter(ext && ext.UNMASKED_RENDERER_WEBGL || GL.RENDERER);
    },
    [GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT]: (gl, getParameter) => {
      var _gl$luma;
      const ext = ((_gl$luma = gl.luma) === null || _gl$luma === void 0 || (_gl$luma = _gl$luma.extensions) === null || _gl$luma === void 0 ? void 0 : _gl$luma[EXT_texture_filter_anisotropic]) || gl.getExtension("EXT_texture_filter_anisotropic");
      return ext ? getParameter(ext.MAX_TEXTURE_MAX_ANISOTROPY_EXT) : 1;
    },
    [GL.MAX_3D_TEXTURE_SIZE]: getWebGL2ValueOrZero,
    [GL.MAX_ARRAY_TEXTURE_LAYERS]: getWebGL2ValueOrZero,
    [GL.MAX_CLIENT_WAIT_TIMEOUT_WEBGL]: getWebGL2ValueOrZero,
    [GL.MAX_COLOR_ATTACHMENTS]: (gl, getParameter) => {
      if (!isWebGL2(gl)) {
        const ext = gl.getExtension(WEBGL_draw_buffers);
        return ext ? getParameter(ext.MAX_COLOR_ATTACHMENTS_WEBGL) : 0;
      }
      return void 0;
    },
    [GL.MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS]: getWebGL2ValueOrZero,
    [GL.MAX_COMBINED_UNIFORM_BLOCKS]: getWebGL2ValueOrZero,
    [GL.MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS]: getWebGL2ValueOrZero,
    [GL.MAX_DRAW_BUFFERS]: (gl) => {
      if (!isWebGL2(gl)) {
        const ext = gl.getExtension(WEBGL_draw_buffers);
        return ext ? ext.MAX_DRAW_BUFFERS_WEBGL : 0;
      }
      return void 0;
    },
    [GL.MAX_ELEMENT_INDEX]: (gl) => gl.getExtension(OES_element_index) ? 2147483647 : 65535,
    [GL.MAX_ELEMENTS_INDICES]: (gl) => gl.getExtension(OES_element_index) ? 16777216 : 65535,
    [GL.MAX_ELEMENTS_VERTICES]: (gl) => 16777216,
    [GL.MAX_FRAGMENT_INPUT_COMPONENTS]: getWebGL2ValueOrZero,
    [GL.MAX_FRAGMENT_UNIFORM_BLOCKS]: getWebGL2ValueOrZero,
    [GL.MAX_FRAGMENT_UNIFORM_COMPONENTS]: getWebGL2ValueOrZero,
    [GL.MAX_SAMPLES]: getWebGL2ValueOrZero,
    [GL.MAX_SERVER_WAIT_TIMEOUT]: getWebGL2ValueOrZero,
    [GL.MAX_TEXTURE_LOD_BIAS]: getWebGL2ValueOrZero,
    [GL.MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS]: getWebGL2ValueOrZero,
    [GL.MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS]: getWebGL2ValueOrZero,
    [GL.MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS]: getWebGL2ValueOrZero,
    [GL.MAX_UNIFORM_BLOCK_SIZE]: getWebGL2ValueOrZero,
    [GL.MAX_UNIFORM_BUFFER_BINDINGS]: getWebGL2ValueOrZero,
    [GL.MAX_VARYING_COMPONENTS]: getWebGL2ValueOrZero,
    [GL.MAX_VERTEX_OUTPUT_COMPONENTS]: getWebGL2ValueOrZero,
    [GL.MAX_VERTEX_UNIFORM_BLOCKS]: getWebGL2ValueOrZero,
    [GL.MAX_VERTEX_UNIFORM_COMPONENTS]: getWebGL2ValueOrZero,
    [GL.MIN_PROGRAM_TEXEL_OFFSET]: getWebGL2ValueOrZero,
    [GL.MAX_PROGRAM_TEXEL_OFFSET]: getWebGL2ValueOrZero,
    [GL.UNIFORM_BUFFER_OFFSET_ALIGNMENT]: getWebGL2ValueOrZero
  };
  function getParameterPolyfill(gl, originalGetParameter, pname) {
    const limit = WEBGL_PARAMETERS[pname];
    const value = typeof limit === "function" ? limit(gl, originalGetParameter, pname) : limit;
    const result = value !== void 0 ? value : originalGetParameter(pname);
    return result;
  }

  // ../../node_modules/@luma.gl/webgl/dist/context/polyfill/context-data.js
  function getContextData(gl) {
    const luma = gl.luma;
    if (!luma) {
      const contextState = {
        _polyfilled: false,
        _extensions: {}
      };
      gl.luma = contextState;
    }
    return gl.luma;
  }

  // ../../node_modules/@luma.gl/webgl/dist/context/polyfill/polyfill-table.js
  var OES_vertex_array_object = "OES_vertex_array_object";
  var ANGLE_instanced_arrays = "ANGLE_instanced_arrays";
  var WEBGL_draw_buffers2 = "WEBGL_draw_buffers";
  var EXT_disjoint_timer_query2 = "EXT_disjoint_timer_query";
  var EXT_texture_filter_anisotropic2 = "EXT_texture_filter_anisotropic";
  var ERR_VAO_NOT_SUPPORTED = "VertexArray requires WebGL2 or OES_vertex_array_object extension";
  function getExtensionData(gl, extension) {
    return {
      webgl2: isWebGL2(gl),
      ext: gl.getExtension(extension)
    };
  }
  var WEBGL2_CONTEXT_POLYFILLS = {
    [OES_vertex_array_object]: {
      meta: {
        suffix: "OES"
      },
      createVertexArray: () => {
        (0, import_core5.assert)(false, ERR_VAO_NOT_SUPPORTED);
      },
      deleteVertexArray: () => {
      },
      bindVertexArray: () => {
      },
      isVertexArray: () => false
    },
    [ANGLE_instanced_arrays]: {
      meta: {
        suffix: "ANGLE"
      },
      vertexAttribDivisor(location, divisor) {
        (0, import_core5.assert)(divisor === 0, "WebGL instanced rendering not supported");
      },
      drawElementsInstanced: () => {
      },
      drawArraysInstanced: () => {
      }
    },
    [WEBGL_draw_buffers2]: {
      meta: {
        suffix: "WEBGL"
      },
      drawBuffers: () => {
        (0, import_core5.assert)(false);
      }
    },
    [EXT_disjoint_timer_query2]: {
      meta: {
        suffix: "EXT"
      },
      createQuery: () => {
        (0, import_core5.assert)(false);
      },
      deleteQuery: () => {
        (0, import_core5.assert)(false);
      },
      beginQuery: () => {
        (0, import_core5.assert)(false);
      },
      endQuery: () => {
      },
      getQuery(handle, pname) {
        return this.getQueryObject(handle, pname);
      },
      getQueryParameter(handle, pname) {
        return this.getQueryObject(handle, pname);
      },
      getQueryObject: (handle, pname) => {
      }
    }
  };
  var WEBGL2_CONTEXT_OVERRIDES = {
    readBuffer: (gl, originalFunc, attachment) => {
      if (isWebGL2(gl)) {
        originalFunc(attachment);
      } else {
      }
    },
    getVertexAttrib: (gl, originalFunc, location, pname) => {
      const {
        webgl2,
        ext
      } = getExtensionData(gl, ANGLE_instanced_arrays);
      let result;
      switch (pname) {
        case GL.VERTEX_ATTRIB_ARRAY_INTEGER:
          result = !webgl2 ? false : void 0;
          break;
        case GL.VERTEX_ATTRIB_ARRAY_DIVISOR:
          result = !webgl2 && !ext ? 0 : void 0;
          break;
        default:
      }
      return result !== void 0 ? result : originalFunc(location, pname);
    },
    getProgramParameter: (gl, originalFunc, program, pname) => {
      if (!isWebGL2(gl)) {
        switch (pname) {
          case GL.TRANSFORM_FEEDBACK_BUFFER_MODE:
            return GL.SEPARATE_ATTRIBS;
          case GL.TRANSFORM_FEEDBACK_VARYINGS:
            return 0;
          case GL.ACTIVE_UNIFORM_BLOCKS:
            return 0;
          default:
        }
      }
      return originalFunc(program, pname);
    },
    getInternalformatParameter: (gl, originalFunc, target, format, pname) => {
      if (!isWebGL2(gl)) {
        switch (pname) {
          case GL.SAMPLES:
            return new Int32Array([0]);
          default:
        }
      }
      const gl2 = gl;
      return gl2.getInternalformatParameter(target, format, pname);
    },
    getTexParameter(gl, originalFunc, target, pname) {
      switch (pname) {
        case GL.TEXTURE_MAX_ANISOTROPY_EXT:
          const contextData = getContextData(gl);
          const {
            _extensions
          } = contextData;
          const ext = _extensions[EXT_texture_filter_anisotropic2];
          pname = ext && ext.TEXTURE_MAX_ANISOTROPY_EXT || GL.TEXTURE_MAX_ANISOTROPY_EXT;
          break;
        default:
      }
      return originalFunc(target, pname);
    },
    getParameter: getParameterPolyfill,
    hint(gl, originalFunc, pname, value) {
      return originalFunc(pname, value);
    }
  };

  // ../../node_modules/@luma.gl/webgl/dist/context/polyfill/polyfill-context.js
  function polyfillContext(gl) {
    const contextState = getContextData(gl);
    if (!contextState._polyfilled) {
      polyfillVertexArrayObject(gl);
      initializeExtensions(gl);
      installPolyfills(gl, WEBGL2_CONTEXT_POLYFILLS);
      installOverrides(gl, {
        target: contextState,
        target2: gl
      });
      contextState._polyfilled = true;
    }
    return gl;
  }
  function initializeExtensions(gl) {
    const contextState = getContextData(gl);
    const EXTENSIONS = gl.getSupportedExtensions() || [];
    for (const extensionName of EXTENSIONS) {
      const extension = gl.getExtension(extensionName);
      contextState._extensions[extensionName] = extension;
    }
  }
  function installPolyfills(gl, polyfills) {
    const contextState = getContextData(gl);
    for (const extension of Object.getOwnPropertyNames(polyfills)) {
      if (extension !== "overrides") {
        polyfillExtension(gl, {
          extension,
          target: contextState,
          target2: gl
        });
      }
    }
  }
  function polyfillExtension(gl, _ref) {
    let {
      extension,
      target,
      target2
    } = _ref;
    const defaults = WEBGL2_CONTEXT_POLYFILLS[extension];
    (0, import_core6.assert)(defaults);
    const {
      meta = {}
    } = defaults;
    const {
      suffix = ""
    } = meta;
    const ext = gl.getExtension(extension);
    for (const key of Object.keys(defaults)) {
      const extKey = `${key}${suffix}`;
      let polyfill = null;
      if (key === "meta") {
      } else if (typeof gl[key] === "function") {
      } else if (ext && typeof ext[extKey] === "function") {
        polyfill = function() {
          return ext[extKey](...arguments);
        };
      } else if (typeof defaults[key] === "function") {
        polyfill = defaults[key].bind(target);
      }
      if (polyfill) {
        target[key] = polyfill;
        target2[key] = polyfill;
      }
    }
  }
  function installOverrides(gl, _ref2) {
    let {
      target,
      target2
    } = _ref2;
    Object.keys(WEBGL2_CONTEXT_OVERRIDES).forEach((key) => {
      if (typeof WEBGL2_CONTEXT_OVERRIDES[key] === "function") {
        const originalFunc = gl[key] ? gl[key].bind(gl) : () => {
        };
        const polyfill = WEBGL2_CONTEXT_OVERRIDES[key].bind(null, gl, originalFunc);
        target[key] = polyfill;
        target2[key] = polyfill;
      }
    });
  }

  // ../../node_modules/@luma.gl/webgl/dist/context/state-tracker/track-context-state.js
  var import_core7 = __toESM(require_core2(), 1);

  // ../../node_modules/@luma.gl/webgl/dist/context/parameters/webgl-parameter-tables.js
  var GL_PARAMETER_DEFAULTS = {
    [GL.BLEND]: false,
    [GL.BLEND_COLOR]: new Float32Array([0, 0, 0, 0]),
    [GL.BLEND_EQUATION_RGB]: GL.FUNC_ADD,
    [GL.BLEND_EQUATION_ALPHA]: GL.FUNC_ADD,
    [GL.BLEND_SRC_RGB]: GL.ONE,
    [GL.BLEND_DST_RGB]: GL.ZERO,
    [GL.BLEND_SRC_ALPHA]: GL.ONE,
    [GL.BLEND_DST_ALPHA]: GL.ZERO,
    [GL.COLOR_CLEAR_VALUE]: new Float32Array([0, 0, 0, 0]),
    [GL.COLOR_WRITEMASK]: [true, true, true, true],
    [GL.CULL_FACE]: false,
    [GL.CULL_FACE_MODE]: GL.BACK,
    [GL.DEPTH_TEST]: false,
    [GL.DEPTH_CLEAR_VALUE]: 1,
    [GL.DEPTH_FUNC]: GL.LESS,
    [GL.DEPTH_RANGE]: new Float32Array([0, 1]),
    [GL.DEPTH_WRITEMASK]: true,
    [GL.DITHER]: true,
    [GL.CURRENT_PROGRAM]: null,
    [GL.FRAMEBUFFER_BINDING]: null,
    [GL.RENDERBUFFER_BINDING]: null,
    [GL.VERTEX_ARRAY_BINDING]: null,
    [GL.ARRAY_BUFFER_BINDING]: null,
    [GL.FRONT_FACE]: GL.CCW,
    [GL.GENERATE_MIPMAP_HINT]: GL.DONT_CARE,
    [GL.LINE_WIDTH]: 1,
    [GL.POLYGON_OFFSET_FILL]: false,
    [GL.POLYGON_OFFSET_FACTOR]: 0,
    [GL.POLYGON_OFFSET_UNITS]: 0,
    [GL.SAMPLE_ALPHA_TO_COVERAGE]: false,
    [GL.SAMPLE_COVERAGE]: false,
    [GL.SAMPLE_COVERAGE_VALUE]: 1,
    [GL.SAMPLE_COVERAGE_INVERT]: false,
    [GL.SCISSOR_TEST]: false,
    [GL.SCISSOR_BOX]: new Int32Array([0, 0, 1024, 1024]),
    [GL.STENCIL_TEST]: false,
    [GL.STENCIL_CLEAR_VALUE]: 0,
    [GL.STENCIL_WRITEMASK]: 4294967295,
    [GL.STENCIL_BACK_WRITEMASK]: 4294967295,
    [GL.STENCIL_FUNC]: GL.ALWAYS,
    [GL.STENCIL_REF]: 0,
    [GL.STENCIL_VALUE_MASK]: 4294967295,
    [GL.STENCIL_BACK_FUNC]: GL.ALWAYS,
    [GL.STENCIL_BACK_REF]: 0,
    [GL.STENCIL_BACK_VALUE_MASK]: 4294967295,
    [GL.STENCIL_FAIL]: GL.KEEP,
    [GL.STENCIL_PASS_DEPTH_FAIL]: GL.KEEP,
    [GL.STENCIL_PASS_DEPTH_PASS]: GL.KEEP,
    [GL.STENCIL_BACK_FAIL]: GL.KEEP,
    [GL.STENCIL_BACK_PASS_DEPTH_FAIL]: GL.KEEP,
    [GL.STENCIL_BACK_PASS_DEPTH_PASS]: GL.KEEP,
    [GL.VIEWPORT]: [0, 0, 1024, 1024],
    [GL.PACK_ALIGNMENT]: 4,
    [GL.UNPACK_ALIGNMENT]: 4,
    [GL.UNPACK_FLIP_Y_WEBGL]: false,
    [GL.UNPACK_PREMULTIPLY_ALPHA_WEBGL]: false,
    [GL.UNPACK_COLORSPACE_CONVERSION_WEBGL]: GL.BROWSER_DEFAULT_WEBGL,
    [GL.TRANSFORM_FEEDBACK_BINDING]: null,
    [GL.COPY_READ_BUFFER_BINDING]: null,
    [GL.COPY_WRITE_BUFFER_BINDING]: null,
    [GL.PIXEL_PACK_BUFFER_BINDING]: null,
    [GL.PIXEL_UNPACK_BUFFER_BINDING]: null,
    [GL.FRAGMENT_SHADER_DERIVATIVE_HINT]: GL.DONT_CARE,
    [GL.READ_FRAMEBUFFER_BINDING]: null,
    [GL.RASTERIZER_DISCARD]: false,
    [GL.PACK_ROW_LENGTH]: 0,
    [GL.PACK_SKIP_PIXELS]: 0,
    [GL.PACK_SKIP_ROWS]: 0,
    [GL.UNPACK_ROW_LENGTH]: 0,
    [GL.UNPACK_IMAGE_HEIGHT]: 0,
    [GL.UNPACK_SKIP_PIXELS]: 0,
    [GL.UNPACK_SKIP_ROWS]: 0,
    [GL.UNPACK_SKIP_IMAGES]: 0
  };
  var enable = (gl, value, key) => value ? gl.enable(key) : gl.disable(key);
  var hint = (gl, value, key) => gl.hint(key, value);
  var pixelStorei = (gl, value, key) => gl.pixelStorei(key, value);
  var bindFramebuffer = (gl, value, key) => {
    let target;
    if (key === GL.FRAMEBUFFER_BINDING) {
      target = isWebGL2(gl) ? GL.DRAW_FRAMEBUFFER : GL.FRAMEBUFFER;
    } else {
      target = GL.READ_FRAMEBUFFER;
    }
    return gl.bindFramebuffer(target, value);
  };
  var bindBuffer = (gl, value, key) => {
    const bindingMap = {
      [GL.ARRAY_BUFFER_BINDING]: GL.ARRAY_BUFFER,
      [GL.COPY_READ_BUFFER_BINDING]: GL.COPY_READ_BUFFER,
      [GL.COPY_WRITE_BUFFER_BINDING]: GL.COPY_WRITE_BUFFER,
      [GL.PIXEL_PACK_BUFFER_BINDING]: GL.PIXEL_PACK_BUFFER,
      [GL.PIXEL_UNPACK_BUFFER_BINDING]: GL.PIXEL_UNPACK_BUFFER
    };
    const glTarget = bindingMap[key];
    gl.bindBuffer(glTarget, value);
  };
  function isArray(array) {
    return Array.isArray(array) || ArrayBuffer.isView(array) && !(array instanceof DataView);
  }
  var GL_PARAMETER_SETTERS = {
    [GL.BLEND]: enable,
    [GL.BLEND_COLOR]: (gl, value) => gl.blendColor(...value),
    [GL.BLEND_EQUATION_RGB]: "blendEquation",
    [GL.BLEND_EQUATION_ALPHA]: "blendEquation",
    [GL.BLEND_SRC_RGB]: "blendFunc",
    [GL.BLEND_DST_RGB]: "blendFunc",
    [GL.BLEND_SRC_ALPHA]: "blendFunc",
    [GL.BLEND_DST_ALPHA]: "blendFunc",
    [GL.COLOR_CLEAR_VALUE]: (gl, value) => gl.clearColor(...value),
    [GL.COLOR_WRITEMASK]: (gl, value) => gl.colorMask(...value),
    [GL.CULL_FACE]: enable,
    [GL.CULL_FACE_MODE]: (gl, value) => gl.cullFace(value),
    [GL.DEPTH_TEST]: enable,
    [GL.DEPTH_CLEAR_VALUE]: (gl, value) => gl.clearDepth(value),
    [GL.DEPTH_FUNC]: (gl, value) => gl.depthFunc(value),
    [GL.DEPTH_RANGE]: (gl, value) => gl.depthRange(...value),
    [GL.DEPTH_WRITEMASK]: (gl, value) => gl.depthMask(value),
    [GL.DITHER]: enable,
    [GL.FRAGMENT_SHADER_DERIVATIVE_HINT]: hint,
    [GL.CURRENT_PROGRAM]: (gl, value) => gl.useProgram(value),
    [GL.RENDERBUFFER_BINDING]: (gl, value) => gl.bindRenderbuffer(GL.RENDERBUFFER, value),
    [GL.TRANSFORM_FEEDBACK_BINDING]: (gl, value) => {
      var _bindTransformFeedbac, _ref;
      return (_bindTransformFeedbac = (_ref = gl).bindTransformFeedback) === null || _bindTransformFeedbac === void 0 ? void 0 : _bindTransformFeedbac.call(_ref, GL.TRANSFORM_FEEDBACK, value);
    },
    [GL.VERTEX_ARRAY_BINDING]: (gl, value) => gl.bindVertexArray(value),
    [GL.FRAMEBUFFER_BINDING]: bindFramebuffer,
    [GL.READ_FRAMEBUFFER_BINDING]: bindFramebuffer,
    [GL.ARRAY_BUFFER_BINDING]: bindBuffer,
    [GL.COPY_READ_BUFFER_BINDING]: bindBuffer,
    [GL.COPY_WRITE_BUFFER_BINDING]: bindBuffer,
    [GL.PIXEL_PACK_BUFFER_BINDING]: bindBuffer,
    [GL.PIXEL_UNPACK_BUFFER_BINDING]: bindBuffer,
    [GL.FRONT_FACE]: (gl, value) => gl.frontFace(value),
    [GL.GENERATE_MIPMAP_HINT]: hint,
    [GL.LINE_WIDTH]: (gl, value) => gl.lineWidth(value),
    [GL.POLYGON_OFFSET_FILL]: enable,
    [GL.POLYGON_OFFSET_FACTOR]: "polygonOffset",
    [GL.POLYGON_OFFSET_UNITS]: "polygonOffset",
    [GL.RASTERIZER_DISCARD]: enable,
    [GL.SAMPLE_ALPHA_TO_COVERAGE]: enable,
    [GL.SAMPLE_COVERAGE]: enable,
    [GL.SAMPLE_COVERAGE_VALUE]: "sampleCoverage",
    [GL.SAMPLE_COVERAGE_INVERT]: "sampleCoverage",
    [GL.SCISSOR_TEST]: enable,
    [GL.SCISSOR_BOX]: (gl, value) => gl.scissor(...value),
    [GL.STENCIL_TEST]: enable,
    [GL.STENCIL_CLEAR_VALUE]: (gl, value) => gl.clearStencil(value),
    [GL.STENCIL_WRITEMASK]: (gl, value) => gl.stencilMaskSeparate(GL.FRONT, value),
    [GL.STENCIL_BACK_WRITEMASK]: (gl, value) => gl.stencilMaskSeparate(GL.BACK, value),
    [GL.STENCIL_FUNC]: "stencilFuncFront",
    [GL.STENCIL_REF]: "stencilFuncFront",
    [GL.STENCIL_VALUE_MASK]: "stencilFuncFront",
    [GL.STENCIL_BACK_FUNC]: "stencilFuncBack",
    [GL.STENCIL_BACK_REF]: "stencilFuncBack",
    [GL.STENCIL_BACK_VALUE_MASK]: "stencilFuncBack",
    [GL.STENCIL_FAIL]: "stencilOpFront",
    [GL.STENCIL_PASS_DEPTH_FAIL]: "stencilOpFront",
    [GL.STENCIL_PASS_DEPTH_PASS]: "stencilOpFront",
    [GL.STENCIL_BACK_FAIL]: "stencilOpBack",
    [GL.STENCIL_BACK_PASS_DEPTH_FAIL]: "stencilOpBack",
    [GL.STENCIL_BACK_PASS_DEPTH_PASS]: "stencilOpBack",
    [GL.VIEWPORT]: (gl, value) => gl.viewport(...value),
    [GL.PACK_ALIGNMENT]: pixelStorei,
    [GL.UNPACK_ALIGNMENT]: pixelStorei,
    [GL.UNPACK_FLIP_Y_WEBGL]: pixelStorei,
    [GL.UNPACK_PREMULTIPLY_ALPHA_WEBGL]: pixelStorei,
    [GL.UNPACK_COLORSPACE_CONVERSION_WEBGL]: pixelStorei,
    [GL.PACK_ROW_LENGTH]: pixelStorei,
    [GL.PACK_SKIP_PIXELS]: pixelStorei,
    [GL.PACK_SKIP_ROWS]: pixelStorei,
    [GL.UNPACK_ROW_LENGTH]: pixelStorei,
    [GL.UNPACK_IMAGE_HEIGHT]: pixelStorei,
    [GL.UNPACK_SKIP_PIXELS]: pixelStorei,
    [GL.UNPACK_SKIP_ROWS]: pixelStorei,
    [GL.UNPACK_SKIP_IMAGES]: pixelStorei,
    framebuffer: (gl, framebuffer) => {
      const handle = framebuffer && "handle" in framebuffer ? framebuffer.handle : framebuffer;
      return gl.bindFramebuffer(GL.FRAMEBUFFER, handle);
    },
    blend: (gl, value) => value ? gl.enable(GL.BLEND) : gl.disable(GL.BLEND),
    blendColor: (gl, value) => gl.blendColor(...value),
    blendEquation: (gl, args) => {
      const separateModes = typeof args === "number" ? [args, args] : args;
      gl.blendEquationSeparate(...separateModes);
    },
    blendFunc: (gl, args) => {
      const separateFuncs = (args === null || args === void 0 ? void 0 : args.length) === 2 ? [...args, ...args] : args;
      gl.blendFuncSeparate(...separateFuncs);
    },
    clearColor: (gl, value) => gl.clearColor(...value),
    clearDepth: (gl, value) => gl.clearDepth(value),
    clearStencil: (gl, value) => gl.clearStencil(value),
    colorMask: (gl, value) => gl.colorMask(...value),
    cull: (gl, value) => value ? gl.enable(GL.CULL_FACE) : gl.disable(GL.CULL_FACE),
    cullFace: (gl, value) => gl.cullFace(value),
    depthTest: (gl, value) => value ? gl.enable(GL.DEPTH_TEST) : gl.disable(GL.DEPTH_TEST),
    depthFunc: (gl, value) => gl.depthFunc(value),
    depthMask: (gl, value) => gl.depthMask(value),
    depthRange: (gl, value) => gl.depthRange(...value),
    dither: (gl, value) => value ? gl.enable(GL.DITHER) : gl.disable(GL.DITHER),
    derivativeHint: (gl, value) => {
      gl.hint(GL.FRAGMENT_SHADER_DERIVATIVE_HINT, value);
    },
    frontFace: (gl, value) => gl.frontFace(value),
    mipmapHint: (gl, value) => gl.hint(GL.GENERATE_MIPMAP_HINT, value),
    lineWidth: (gl, value) => gl.lineWidth(value),
    polygonOffsetFill: (gl, value) => value ? gl.enable(GL.POLYGON_OFFSET_FILL) : gl.disable(GL.POLYGON_OFFSET_FILL),
    polygonOffset: (gl, value) => gl.polygonOffset(...value),
    sampleCoverage: (gl, value) => gl.sampleCoverage(...value),
    scissorTest: (gl, value) => value ? gl.enable(GL.SCISSOR_TEST) : gl.disable(GL.SCISSOR_TEST),
    scissor: (gl, value) => gl.scissor(...value),
    stencilTest: (gl, value) => value ? gl.enable(GL.STENCIL_TEST) : gl.disable(GL.STENCIL_TEST),
    stencilMask: (gl, value) => {
      value = isArray(value) ? value : [value, value];
      const [mask, backMask] = value;
      gl.stencilMaskSeparate(GL.FRONT, mask);
      gl.stencilMaskSeparate(GL.BACK, backMask);
    },
    stencilFunc: (gl, args) => {
      args = isArray(args) && args.length === 3 ? [...args, ...args] : args;
      const [func, ref, mask, backFunc, backRef, backMask] = args;
      gl.stencilFuncSeparate(GL.FRONT, func, ref, mask);
      gl.stencilFuncSeparate(GL.BACK, backFunc, backRef, backMask);
    },
    stencilOp: (gl, args) => {
      args = isArray(args) && args.length === 3 ? [...args, ...args] : args;
      const [sfail, dpfail, dppass, backSfail, backDpfail, backDppass] = args;
      gl.stencilOpSeparate(GL.FRONT, sfail, dpfail, dppass);
      gl.stencilOpSeparate(GL.BACK, backSfail, backDpfail, backDppass);
    },
    viewport: (gl, value) => gl.viewport(...value)
  };
  function getValue(glEnum, values, cache) {
    return values[glEnum] !== void 0 ? values[glEnum] : cache[glEnum];
  }
  var GL_COMPOSITE_PARAMETER_SETTERS = {
    blendEquation: (gl, values, cache) => gl.blendEquationSeparate(getValue(GL.BLEND_EQUATION_RGB, values, cache), getValue(GL.BLEND_EQUATION_ALPHA, values, cache)),
    blendFunc: (gl, values, cache) => gl.blendFuncSeparate(getValue(GL.BLEND_SRC_RGB, values, cache), getValue(GL.BLEND_DST_RGB, values, cache), getValue(GL.BLEND_SRC_ALPHA, values, cache), getValue(GL.BLEND_DST_ALPHA, values, cache)),
    polygonOffset: (gl, values, cache) => gl.polygonOffset(getValue(GL.POLYGON_OFFSET_FACTOR, values, cache), getValue(GL.POLYGON_OFFSET_UNITS, values, cache)),
    sampleCoverage: (gl, values, cache) => gl.sampleCoverage(getValue(GL.SAMPLE_COVERAGE_VALUE, values, cache), getValue(GL.SAMPLE_COVERAGE_INVERT, values, cache)),
    stencilFuncFront: (gl, values, cache) => gl.stencilFuncSeparate(GL.FRONT, getValue(GL.STENCIL_FUNC, values, cache), getValue(GL.STENCIL_REF, values, cache), getValue(GL.STENCIL_VALUE_MASK, values, cache)),
    stencilFuncBack: (gl, values, cache) => gl.stencilFuncSeparate(GL.BACK, getValue(GL.STENCIL_BACK_FUNC, values, cache), getValue(GL.STENCIL_BACK_REF, values, cache), getValue(GL.STENCIL_BACK_VALUE_MASK, values, cache)),
    stencilOpFront: (gl, values, cache) => gl.stencilOpSeparate(GL.FRONT, getValue(GL.STENCIL_FAIL, values, cache), getValue(GL.STENCIL_PASS_DEPTH_FAIL, values, cache), getValue(GL.STENCIL_PASS_DEPTH_PASS, values, cache)),
    stencilOpBack: (gl, values, cache) => gl.stencilOpSeparate(GL.BACK, getValue(GL.STENCIL_BACK_FAIL, values, cache), getValue(GL.STENCIL_BACK_PASS_DEPTH_FAIL, values, cache), getValue(GL.STENCIL_BACK_PASS_DEPTH_PASS, values, cache))
  };
  var GL_HOOKED_SETTERS = {
    enable: (update, capability) => update({
      [capability]: true
    }),
    disable: (update, capability) => update({
      [capability]: false
    }),
    pixelStorei: (update, pname, value) => update({
      [pname]: value
    }),
    hint: (update, pname, hint2) => update({
      [pname]: hint2
    }),
    useProgram: (update, value) => update({
      [GL.CURRENT_PROGRAM]: value
    }),
    bindRenderbuffer: (update, target, value) => update({
      [GL.RENDERBUFFER_BINDING]: value
    }),
    bindTransformFeedback: (update, target, value) => update({
      [GL.TRANSFORM_FEEDBACK_BINDING]: value
    }),
    bindVertexArray: (update, value) => update({
      [GL.VERTEX_ARRAY_BINDING]: value
    }),
    bindFramebuffer: (update, target, framebuffer) => {
      switch (target) {
        case GL.FRAMEBUFFER:
          return update({
            [GL.DRAW_FRAMEBUFFER_BINDING]: framebuffer,
            [GL.READ_FRAMEBUFFER_BINDING]: framebuffer
          });
        case GL.DRAW_FRAMEBUFFER:
          return update({
            [GL.DRAW_FRAMEBUFFER_BINDING]: framebuffer
          });
        case GL.READ_FRAMEBUFFER:
          return update({
            [GL.READ_FRAMEBUFFER_BINDING]: framebuffer
          });
        default:
          return null;
      }
    },
    bindBuffer: (update, target, buffer) => {
      const pname = {
        [GL.ARRAY_BUFFER]: [GL.ARRAY_BUFFER_BINDING],
        [GL.COPY_READ_BUFFER]: [GL.COPY_READ_BUFFER_BINDING],
        [GL.COPY_WRITE_BUFFER]: [GL.COPY_WRITE_BUFFER_BINDING],
        [GL.PIXEL_PACK_BUFFER]: [GL.PIXEL_PACK_BUFFER_BINDING],
        [GL.PIXEL_UNPACK_BUFFER]: [GL.PIXEL_UNPACK_BUFFER_BINDING]
      }[target];
      if (pname) {
        return update({
          [pname]: buffer
        });
      }
      return {
        valueChanged: true
      };
    },
    blendColor: (update, r, g, b, a) => update({
      [GL.BLEND_COLOR]: new Float32Array([r, g, b, a])
    }),
    blendEquation: (update, mode) => update({
      [GL.BLEND_EQUATION_RGB]: mode,
      [GL.BLEND_EQUATION_ALPHA]: mode
    }),
    blendEquationSeparate: (update, modeRGB, modeAlpha) => update({
      [GL.BLEND_EQUATION_RGB]: modeRGB,
      [GL.BLEND_EQUATION_ALPHA]: modeAlpha
    }),
    blendFunc: (update, src, dst) => update({
      [GL.BLEND_SRC_RGB]: src,
      [GL.BLEND_DST_RGB]: dst,
      [GL.BLEND_SRC_ALPHA]: src,
      [GL.BLEND_DST_ALPHA]: dst
    }),
    blendFuncSeparate: (update, srcRGB, dstRGB, srcAlpha, dstAlpha) => update({
      [GL.BLEND_SRC_RGB]: srcRGB,
      [GL.BLEND_DST_RGB]: dstRGB,
      [GL.BLEND_SRC_ALPHA]: srcAlpha,
      [GL.BLEND_DST_ALPHA]: dstAlpha
    }),
    clearColor: (update, r, g, b, a) => update({
      [GL.COLOR_CLEAR_VALUE]: new Float32Array([r, g, b, a])
    }),
    clearDepth: (update, depth) => update({
      [GL.DEPTH_CLEAR_VALUE]: depth
    }),
    clearStencil: (update, s) => update({
      [GL.STENCIL_CLEAR_VALUE]: s
    }),
    colorMask: (update, r, g, b, a) => update({
      [GL.COLOR_WRITEMASK]: [r, g, b, a]
    }),
    cullFace: (update, mode) => update({
      [GL.CULL_FACE_MODE]: mode
    }),
    depthFunc: (update, func) => update({
      [GL.DEPTH_FUNC]: func
    }),
    depthRange: (update, zNear, zFar) => update({
      [GL.DEPTH_RANGE]: new Float32Array([zNear, zFar])
    }),
    depthMask: (update, mask) => update({
      [GL.DEPTH_WRITEMASK]: mask
    }),
    frontFace: (update, face) => update({
      [GL.FRONT_FACE]: face
    }),
    lineWidth: (update, width) => update({
      [GL.LINE_WIDTH]: width
    }),
    polygonOffset: (update, factor, units) => update({
      [GL.POLYGON_OFFSET_FACTOR]: factor,
      [GL.POLYGON_OFFSET_UNITS]: units
    }),
    sampleCoverage: (update, value, invert) => update({
      [GL.SAMPLE_COVERAGE_VALUE]: value,
      [GL.SAMPLE_COVERAGE_INVERT]: invert
    }),
    scissor: (update, x, y, width, height) => update({
      [GL.SCISSOR_BOX]: new Int32Array([x, y, width, height])
    }),
    stencilMask: (update, mask) => update({
      [GL.STENCIL_WRITEMASK]: mask,
      [GL.STENCIL_BACK_WRITEMASK]: mask
    }),
    stencilMaskSeparate: (update, face, mask) => update({
      [face === GL.FRONT ? GL.STENCIL_WRITEMASK : GL.STENCIL_BACK_WRITEMASK]: mask
    }),
    stencilFunc: (update, func, ref, mask) => update({
      [GL.STENCIL_FUNC]: func,
      [GL.STENCIL_REF]: ref,
      [GL.STENCIL_VALUE_MASK]: mask,
      [GL.STENCIL_BACK_FUNC]: func,
      [GL.STENCIL_BACK_REF]: ref,
      [GL.STENCIL_BACK_VALUE_MASK]: mask
    }),
    stencilFuncSeparate: (update, face, func, ref, mask) => update({
      [face === GL.FRONT ? GL.STENCIL_FUNC : GL.STENCIL_BACK_FUNC]: func,
      [face === GL.FRONT ? GL.STENCIL_REF : GL.STENCIL_BACK_REF]: ref,
      [face === GL.FRONT ? GL.STENCIL_VALUE_MASK : GL.STENCIL_BACK_VALUE_MASK]: mask
    }),
    stencilOp: (update, fail, zfail, zpass) => update({
      [GL.STENCIL_FAIL]: fail,
      [GL.STENCIL_PASS_DEPTH_FAIL]: zfail,
      [GL.STENCIL_PASS_DEPTH_PASS]: zpass,
      [GL.STENCIL_BACK_FAIL]: fail,
      [GL.STENCIL_BACK_PASS_DEPTH_FAIL]: zfail,
      [GL.STENCIL_BACK_PASS_DEPTH_PASS]: zpass
    }),
    stencilOpSeparate: (update, face, fail, zfail, zpass) => update({
      [face === GL.FRONT ? GL.STENCIL_FAIL : GL.STENCIL_BACK_FAIL]: fail,
      [face === GL.FRONT ? GL.STENCIL_PASS_DEPTH_FAIL : GL.STENCIL_BACK_PASS_DEPTH_FAIL]: zfail,
      [face === GL.FRONT ? GL.STENCIL_PASS_DEPTH_PASS : GL.STENCIL_BACK_PASS_DEPTH_PASS]: zpass
    }),
    viewport: (update, x, y, width, height) => update({
      [GL.VIEWPORT]: [x, y, width, height]
    })
  };
  var isEnabled = (gl, key) => gl.isEnabled(key);
  var GL_PARAMETER_GETTERS = {
    [GL.BLEND]: isEnabled,
    [GL.CULL_FACE]: isEnabled,
    [GL.DEPTH_TEST]: isEnabled,
    [GL.DITHER]: isEnabled,
    [GL.POLYGON_OFFSET_FILL]: isEnabled,
    [GL.SAMPLE_ALPHA_TO_COVERAGE]: isEnabled,
    [GL.SAMPLE_COVERAGE]: isEnabled,
    [GL.SCISSOR_TEST]: isEnabled,
    [GL.STENCIL_TEST]: isEnabled,
    [GL.RASTERIZER_DISCARD]: isEnabled
  };
  var NON_CACHE_PARAMETERS = /* @__PURE__ */ new Set([GL.ACTIVE_TEXTURE, GL.TRANSFORM_FEEDBACK_ACTIVE, GL.TRANSFORM_FEEDBACK_PAUSED, GL.TRANSFORM_FEEDBACK_BUFFER_BINDING, GL.UNIFORM_BUFFER_BINDING, GL.ELEMENT_ARRAY_BUFFER_BINDING, GL.IMPLEMENTATION_COLOR_READ_FORMAT, GL.IMPLEMENTATION_COLOR_READ_TYPE, GL.READ_BUFFER, GL.DRAW_BUFFER0, GL.DRAW_BUFFER1, GL.DRAW_BUFFER2, GL.DRAW_BUFFER3, GL.DRAW_BUFFER4, GL.DRAW_BUFFER5, GL.DRAW_BUFFER6, GL.DRAW_BUFFER7, GL.DRAW_BUFFER8, GL.DRAW_BUFFER9, GL.DRAW_BUFFER10, GL.DRAW_BUFFER11, GL.DRAW_BUFFER12, GL.DRAW_BUFFER13, GL.DRAW_BUFFER14, GL.DRAW_BUFFER15, GL.SAMPLER_BINDING, GL.TEXTURE_BINDING_2D, GL.TEXTURE_BINDING_2D_ARRAY, GL.TEXTURE_BINDING_3D, GL.TEXTURE_BINDING_CUBE_MAP]);

  // ../../node_modules/@luma.gl/webgl/dist/context/parameters/unified-parameter-api.js
  function setGLParameters(device, parameters2) {
    const webglDevice = WebGLDevice.attach(device);
    const gl = webglDevice.gl;
    if (isObjectEmpty(parameters2)) {
      return;
    }
    const compositeSetters = {};
    for (const key in parameters2) {
      const glConstant = Number(key);
      const setter = GL_PARAMETER_SETTERS[key];
      if (setter) {
        if (typeof setter === "string") {
          compositeSetters[setter] = true;
        } else {
          setter(gl, parameters2[key], glConstant);
        }
      }
    }
    const cache = gl.state && gl.state.cache;
    if (cache) {
      for (const key in compositeSetters) {
        const compositeSetter = GL_COMPOSITE_PARAMETER_SETTERS[key];
        compositeSetter(gl, parameters2, cache);
      }
    }
  }
  function getGLParameters(device) {
    let parameters2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : GL_PARAMETER_DEFAULTS;
    const webglDevice = WebGLDevice.attach(device);
    const gl = webglDevice.gl;
    if (typeof parameters2 === "number") {
      const key = parameters2;
      const getter = GL_PARAMETER_GETTERS[key];
      return getter ? getter(gl, key) : gl.getParameter(key);
    }
    const parameterKeys = Array.isArray(parameters2) ? parameters2 : Object.keys(parameters2);
    const state = {};
    for (const key of parameterKeys) {
      const getter = GL_PARAMETER_GETTERS[key];
      state[key] = getter ? getter(gl, Number(key)) : gl.getParameter(Number(key));
    }
    return state;
  }
  function isObjectEmpty(object) {
    for (const key in object) {
      return false;
    }
    return true;
  }

  // ../../node_modules/@luma.gl/webgl/dist/context/state-tracker/deep-array-equal.js
  function deepArrayEqual(x, y) {
    if (x === y) {
      return true;
    }
    const isArrayX = Array.isArray(x) || ArrayBuffer.isView(x);
    const isArrayY = Array.isArray(y) || ArrayBuffer.isView(y);
    if (isArrayX && isArrayY && x.length === y.length) {
      for (let i = 0; i < x.length; ++i) {
        if (x[i] !== y[i]) {
          return false;
        }
      }
      return true;
    }
    return false;
  }

  // ../../node_modules/@luma.gl/webgl/dist/context/state-tracker/track-context-state.js
  var GLState = class {
    constructor(gl) {
      let {
        copyState = false,
        log: log13 = () => {
        }
      } = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
      this.gl = void 0;
      this.program = null;
      this.stateStack = [];
      this.enable = true;
      this.cache = void 0;
      this.log = void 0;
      this.gl = gl;
      this.cache = copyState ? getGLParameters(gl) : Object.assign({}, GL_PARAMETER_DEFAULTS);
      this.log = log13;
      this._updateCache = this._updateCache.bind(this);
      Object.seal(this);
    }
    push() {
      let values = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      this.stateStack.push({});
    }
    pop() {
      (0, import_core7.assert)(this.stateStack.length > 0);
      const oldValues = this.stateStack[this.stateStack.length - 1];
      setGLParameters(this.gl, oldValues);
      this.stateStack.pop();
    }
    _updateCache(values) {
      let valueChanged = false;
      let oldValue;
      const oldValues = this.stateStack.length > 0 ? this.stateStack[this.stateStack.length - 1] : null;
      for (const key in values) {
        (0, import_core7.assert)(key !== void 0);
        const value = values[key];
        const cached = this.cache[key];
        if (!deepArrayEqual(value, cached)) {
          valueChanged = true;
          oldValue = cached;
          if (oldValues && !(key in oldValues)) {
            oldValues[key] = cached;
          }
          this.cache[key] = value;
        }
      }
      return {
        valueChanged,
        oldValue
      };
    }
  };
  function getContextState(gl) {
    return gl.state;
  }
  function trackContextState(gl, options) {
    const {
      enable: enable2 = true,
      copyState
    } = options;
    (0, import_core7.assert)(copyState !== void 0);
    if (!gl.state) {
      gl.state = new GLState(gl, {
        copyState
      });
      installProgramSpy(gl);
      for (const key in GL_HOOKED_SETTERS) {
        const setter = GL_HOOKED_SETTERS[key];
        installSetterSpy(gl, key, setter);
      }
      installGetterOverride(gl, "getParameter");
      installGetterOverride(gl, "isEnabled");
    }
    const glState = getContextState(gl);
    glState.enable = enable2;
    return gl;
  }
  function pushContextState(gl) {
    let glState = getContextState(gl);
    if (!glState) {
      trackContextState(gl, {
        copyState: false
      });
      glState = getContextState(gl);
    }
    glState.push();
  }
  function popContextState(gl) {
    const glState = getContextState(gl);
    (0, import_core7.assert)(glState);
    glState.pop();
  }
  function installGetterOverride(gl, functionName) {
    const originalGetterFunc = gl[functionName].bind(gl);
    gl[functionName] = function get(pname) {
      if (pname === void 0 || NON_CACHE_PARAMETERS.has(pname)) {
        return originalGetterFunc(pname);
      }
      const glState = getContextState(gl);
      if (!(pname in glState.cache)) {
        glState.cache[pname] = originalGetterFunc(pname);
      }
      return glState.enable ? glState.cache[pname] : originalGetterFunc(pname);
    };
    Object.defineProperty(gl[functionName], "name", {
      value: `${functionName}-from-cache`,
      configurable: false
    });
  }
  function installSetterSpy(gl, functionName, setter) {
    if (!gl[functionName]) {
      return;
    }
    const originalSetterFunc = gl[functionName].bind(gl);
    gl[functionName] = function set2() {
      const glState = getContextState(gl);
      for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
        params[_key] = arguments[_key];
      }
      const {
        valueChanged,
        oldValue
      } = setter(glState._updateCache, ...params);
      if (valueChanged) {
        originalSetterFunc(...params);
      }
      return oldValue;
    };
    Object.defineProperty(gl[functionName], "name", {
      value: `${functionName}-to-cache`,
      configurable: false
    });
  }
  function installProgramSpy(gl) {
    const originalUseProgram = gl.useProgram.bind(gl);
    gl.useProgram = function useProgramLuma(handle) {
      const glState = getContextState(gl);
      if (glState.program !== handle) {
        originalUseProgram(handle);
        glState.program = handle;
      }
    };
  }

  // ../../node_modules/@luma.gl/webgl/dist/context/context/create-browser-context.js
  var DEFAULT_CONTEXT_PROPS = {
    webgl2: true,
    webgl1: true,
    powerPreference: "high-performance",
    onContextLost: () => console.error("WebGL context lost"),
    onContextRestored: () => console.info("WebGL context restored")
  };
  function createBrowserContext(canvas, props) {
    props = {
      ...DEFAULT_CONTEXT_PROPS,
      ...props
    };
    let errorMessage = null;
    const onCreateError = (error2) => errorMessage = error2.statusMessage || errorMessage;
    canvas.addEventListener("webglcontextcreationerror", onCreateError, false);
    let gl = null;
    if (props.type === "webgl2") {
      props = {
        ...props,
        webgl1: false
      };
    }
    if (props.type === "webgl1") {
      props = {
        ...props,
        webgl2: false
      };
    }
    if (!gl && props.webgl2) {
      gl = canvas.getContext("webgl2", props);
    }
    if (!gl && props.webgl1) {
      gl = canvas.getContext("webgl", props);
    }
    canvas.removeEventListener("webglcontextcreationerror", onCreateError, false);
    if (!gl) {
      throw new Error(`Failed to create ${props.webgl2 && !props.webgl1 ? "WebGL2" : "WebGL"} context: ${errorMessage || "Unknown error"}`);
    }
    if (props.onContextLost) {
      const {
        onContextLost
      } = props;
      canvas.addEventListener("webglcontextlost", (event) => onContextLost(event), false);
    }
    if (props.onContextRestored) {
      const {
        onContextRestored
      } = props;
      canvas.addEventListener("webglcontextrestored", (event) => onContextRestored(event), false);
    }
    return gl;
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/device-helpers/get-device-info.js
  function getDeviceInfo(gl) {
    const vendorMasked = gl.getParameter(GL.VENDOR);
    const rendererMasked = gl.getParameter(GL.RENDERER);
    const ext = gl.getExtension("WEBGL_debug_renderer_info");
    const vendorUnmasked = gl.getParameter(ext ? ext.UNMASKED_VENDOR_WEBGL : GL.VENDOR);
    const rendererUnmasked = gl.getParameter(ext ? ext.UNMASKED_RENDERER_WEBGL : GL.RENDERER);
    const vendor = vendorUnmasked || vendorMasked;
    const renderer = rendererUnmasked || rendererMasked;
    const gpu = identifyGPUVendor(vendor, renderer);
    return {
      type: isWebGL2(gl) ? "webgl2" : "webgl",
      gpu,
      vendor: vendorUnmasked || vendorMasked,
      renderer: rendererUnmasked || rendererMasked,
      version: gl.getParameter(GL.VERSION),
      shadingLanguages: ["glsl"],
      shadingLanguageVersions: {
        "glsl": gl.getParameter(GL.SHADING_LANGUAGE_VERSION)
      }
    };
  }
  function identifyGPUVendor(vendor, renderer) {
    if (/NVIDIA/i.exec(vendor) || /NVIDIA/i.exec(renderer)) {
      return "nvidia";
    }
    if (/INTEL/i.exec(vendor) || /INTEL/i.exec(renderer)) {
      return "intel";
    }
    if (/Apple/i.exec(vendor) || /Apple/i.exec(renderer)) {
      return "apple";
    }
    if (/AMD/i.exec(vendor) || /AMD/i.exec(renderer) || /ATI/i.exec(vendor) || /ATI/i.exec(renderer)) {
      return "amd";
    }
    if (/SwiftShader/i.exec(vendor) || /SwiftShader/i.exec(renderer)) {
      return "software";
    }
    return "unknown";
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/device-helpers/is-old-ie.js
  function isOldIE() {
    let opts = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    const navigator2 = typeof window !== "undefined" ? window.navigator || {} : {};
    const userAgent = opts.userAgent || navigator2.userAgent || "";
    const isMSIE = userAgent.indexOf("MSIE ") !== -1;
    const isTrident = userAgent.indexOf("Trident/") !== -1;
    return isMSIE || isTrident;
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/converters/texture-formats.js
  var import_core8 = __toESM(require_core2(), 1);

  // ../../node_modules/@luma.gl/webgl/dist/adapter/converters/vertex-formats.js
  function getGLFromVertexType(dataType) {
    switch (dataType) {
      case "uint8":
        return GL.UNSIGNED_BYTE;
      case "sint8":
        return GL.BYTE;
      case "unorm8":
        return GL.UNSIGNED_BYTE;
      case "snorm8":
        return GL.BYTE;
      case "uint16":
        return GL.UNSIGNED_SHORT;
      case "sint16":
        return GL.SHORT;
      case "unorm16":
        return GL.UNSIGNED_SHORT;
      case "snorm16":
        return GL.SHORT;
      case "uint32":
        return GL.UNSIGNED_INT;
      case "sint32":
        return GL.INT;
      case "float16":
        return GL.HALF_FLOAT;
      case "float32":
        return GL.FLOAT;
    }
    throw new Error(String(dataType));
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/converters/texture-formats.js
  var texture_compression_bc = "texture-compression-bc";
  var texture_compression_astc = "texture-compression-astc";
  var texture_compression_etc2 = "texture-compression-etc2";
  var texture_compression_etc1_webgl = "texture-compression-etc1-webgl";
  var texture_compression_pvrtc_webgl = "texture-compression-pvrtc-webgl";
  var texture_compression_atc_webgl = "texture-compression-atc-webgl";
  var X_S3TC = "WEBGL_compressed_texture_s3tc";
  var X_S3TC_SRGB = "WEBGL_compressed_texture_s3tc_srgb";
  var X_RGTC = "EXT_texture_compression_rgtc";
  var X_BPTC = "EXT_texture_compression_bptc";
  var X_ETC2 = "WEBGL_compressed_texture_etc";
  var X_ASTC = "WEBGL_compressed_texture_astc";
  var X_ETC1 = "WEBGL_compressed_texture_etc1";
  var X_PVRTC = "WEBGL_compressed_texture_pvrtc";
  var X_ATC = "WEBGL_compressed_texture_atc";
  var EXT_SRGB = "EXT_sRGB";
  var EXT_TEXTURE_NORM16 = "EXT_texture_norm16";
  var EXT_FLOAT_WEBGL1 = "WEBGL_color_buffer_float";
  var EXT_FLOAT_RENDER_WEBGL2 = "EXT_color_buffer_float";
  var checkExtension = (gl, extension) => gl.getExtension(extension);
  var checkExtensions = (gl, extensions) => extensions.every((extension) => gl.getExtension(extension));
  var TEXTURE_FEATURE_CHECKS = {
    "texture-blend-float-webgl1": (gl) => isWebGL2(gl) ? true : checkExtension(gl, "EXT_float_blend"),
    "texture-formats-srgb-webgl1": (gl) => isWebGL2(gl) ? true : checkExtension(gl, EXT_SRGB),
    "texture-formats-depth-webgl1": (gl) => isWebGL2(gl) ? true : checkExtension(gl, "WEBGL_depth_texture"),
    "texture-formats-float32-webgl1": (gl) => isWebGL2(gl) ? true : checkExtension(gl, "OES_texture_float"),
    "texture-formats-float16-webgl1": (gl) => isWebGL2(gl) ? true : checkExtension(gl, "OES_texture_half_float"),
    "texture-formats-norm16-webgl": (gl) => isWebGL2(gl) ? checkExtension(gl, EXT_TEXTURE_NORM16) : false,
    "texture-filter-linear-float32-webgl": (gl) => checkExtension(gl, "OES_texture_float_linear"),
    "texture-filter-linear-float16-webgl": (gl) => checkExtension(gl, "OES_texture_half_float_linear"),
    "texture-filter-anisotropic-webgl": (gl) => checkExtension(gl, "EXT_texture_filter_anisotropic"),
    "texture-renderable-float32-webgl": (gl) => checkExtension(gl, "EXT_color_buffer_float"),
    "texture-renderable-float16-webgl": (gl) => checkExtension(gl, "EXT_color_buffer_half_float"),
    "texture-compression-bc": (gl) => checkExtensions(gl, [X_S3TC, X_S3TC_SRGB, X_RGTC, X_BPTC]),
    "texture-compression-bc5-webgl": (gl) => checkExtensions(gl, [X_RGTC]),
    "texture-compression-etc2": (gl) => checkExtensions(gl, [X_ETC2]),
    "texture-compression-astc": (gl) => checkExtensions(gl, [X_ASTC]),
    "texture-compression-etc1-webgl": (gl) => checkExtensions(gl, [X_ETC1]),
    "texture-compression-pvrtc-webgl": (gl) => checkExtensions(gl, [X_PVRTC]),
    "texture-compression-atc-webgl": (gl) => checkExtensions(gl, [X_ATC])
  };
  function checkTextureFeature(gl, feature) {
    var _TEXTURE_FEATURE_CHEC;
    return ((_TEXTURE_FEATURE_CHEC = TEXTURE_FEATURE_CHECKS[feature]) === null || _TEXTURE_FEATURE_CHEC === void 0 ? void 0 : _TEXTURE_FEATURE_CHEC.call(TEXTURE_FEATURE_CHECKS, gl)) || false;
  }
  function getTextureFeatures(gl) {
    const textureFeatures = Object.keys(TEXTURE_FEATURE_CHECKS);
    return textureFeatures.filter((feature) => checkTextureFeature(gl, feature));
  }
  var TEXTURE_FORMATS = {
    "rgb8unorm-unsized": {
      gl: GL.RGB,
      gl1: GL.RGB,
      b: 4,
      c: 2,
      bpp: 4,
      dataFormat: GL.RGB,
      types: [GL.UNSIGNED_BYTE, GL.UNSIGNED_SHORT_5_6_5]
    },
    "rgba8unorm-unsized": {
      gl: GL.RGBA,
      gl1: GL.RGBA,
      b: 4,
      c: 2,
      bpp: 4,
      dataFormat: GL.RGBA,
      types: [GL.UNSIGNED_BYTE, GL.UNSIGNED_SHORT_4_4_4_4, GL.UNSIGNED_SHORT_5_5_5_1]
    },
    "r8unorm": {
      gl: GL.R8,
      b: 1,
      c: 1,
      renderbuffer: true
    },
    "r8snorm": {
      gl: GL.R8_SNORM,
      b: 1,
      c: 1
    },
    "r8uint": {
      gl: GL.R8UI,
      b: 1,
      c: 1,
      renderbuffer: true
    },
    "r8sint": {
      gl: GL.R8I,
      b: 1,
      c: 1,
      renderbuffer: true
    },
    "rg8unorm": {
      gl: GL.RG8,
      b: 2,
      c: 2,
      renderbuffer: true
    },
    "rg8snorm": {
      gl: GL.RG8_SNORM,
      b: 2,
      c: 2
    },
    "rg8uint": {
      gl: GL.RG8UI,
      b: 2,
      c: 2,
      renderbuffer: true
    },
    "rg8sint": {
      gl: GL.RG8I,
      b: 2,
      c: 2,
      renderbuffer: true
    },
    "r16uint": {
      gl: GL.R16UI,
      b: 2,
      c: 1,
      renderbuffer: true
    },
    "r16sint": {
      gl: GL.R16I,
      b: 2,
      c: 1,
      renderbuffer: true
    },
    "r16float": {
      gl: GL.R16F,
      b: 2,
      c: 1,
      render: "texture-renderable-float16-webgl",
      filter: "texture-filter-linear-float16-webgl",
      renderbuffer: true
    },
    "r16unorm-webgl": {
      gl: GL.R16_EXT,
      b: 2,
      c: 1,
      f: "texture-formats-norm16-webgl",
      renderbuffer: true,
      x: EXT_TEXTURE_NORM16
    },
    "r16snorm-webgl": {
      gl: GL.R16_SNORM_EXT,
      b: 2,
      c: 1,
      f: "texture-formats-norm16-webgl",
      x: EXT_TEXTURE_NORM16
    },
    "rgba4unorm-webgl": {
      gl: GL.RGBA4,
      b: 2,
      c: 4,
      wgpu: false,
      renderbuffer: true
    },
    "rgb565unorm-webgl": {
      gl: GL.RGB565,
      b: 2,
      c: 4,
      wgpu: false,
      renderbuffer: true
    },
    "rgb5a1unorm-webgl": {
      gl: GL.RGB5_A1,
      b: 2,
      c: 4,
      wgpu: false,
      renderbuffer: true
    },
    "rgb8unorm-webgl": {
      gl: GL.RGB8,
      b: 3,
      c: 3,
      wgpu: false
    },
    "rgb8snorm-webgl": {
      gl: GL.RGB8_SNORM,
      b: 3,
      c: 3,
      wgpu: false
    },
    "rgba8unorm": {
      gl: GL.RGBA8,
      gl1: GL.RGBA,
      b: 4,
      c: 2,
      bpp: 4
    },
    "rgba8unorm-srgb": {
      gl: GL.SRGB8_ALPHA8,
      gl1: GL.SRGB_ALPHA_EXT,
      b: 4,
      c: 4,
      gl1ext: EXT_SRGB,
      bpp: 4
    },
    "rgba8snorm": {
      gl: GL.RGBA8_SNORM,
      b: 4,
      c: 4
    },
    "rgba8uint": {
      gl: GL.RGBA8UI,
      b: 4,
      c: 4,
      bpp: 4
    },
    "rgba8sint": {
      gl: GL.RGBA8I,
      b: 4,
      c: 4,
      bpp: 4
    },
    "bgra8unorm": {
      b: 4,
      c: 4
    },
    "bgra8unorm-srgb": {
      b: 4,
      c: 4
    },
    "rg16uint": {
      gl: GL.RG16UI,
      b: 4,
      c: 1,
      bpp: 4
    },
    "rg16sint": {
      gl: GL.RG16I,
      b: 4,
      c: 2,
      bpp: 4
    },
    "rg16float": {
      gl: GL.RG16F,
      bpp: 4,
      b: 4,
      c: 2,
      render: "texture-renderable-float16-webgl",
      filter: "texture-filter-linear-float16-webgl",
      renderbuffer: true
    },
    "rg16unorm-webgl": {
      gl: GL.RG16_EXT,
      b: 2,
      c: 2,
      f: "texture-formats-norm16-webgl",
      x: EXT_TEXTURE_NORM16
    },
    "rg16snorm-webgl": {
      gl: GL.RG16_SNORM_EXT,
      b: 2,
      c: 2,
      f: "texture-formats-norm16-webgl",
      x: EXT_TEXTURE_NORM16
    },
    "r32uint": {
      gl: GL.R32UI,
      b: 4,
      c: 1,
      bpp: 4,
      renderbuffer: true
    },
    "r32sint": {
      gl: GL.R32I,
      b: 4,
      c: 1,
      bpp: 4,
      renderbuffer: true
    },
    "r32float": {
      gl: GL.R32F,
      bpp: 4,
      b: 4,
      c: 1,
      render: "texture-renderable-float32-webgl",
      filter: "texture-filter-linear-float32-webgl"
    },
    "rgb9e5ufloat": {
      gl: GL.RGB9_E5,
      b: 4,
      c: 3,
      p: 1,
      render: "texture-renderable-float16-webgl",
      filter: "texture-filter-linear-float16-webgl"
    },
    "rg11b10ufloat": {
      gl: GL.R11F_G11F_B10F,
      b: 4,
      c: 3,
      p: 1,
      render: "texture-renderable-float32-webgl",
      renderbuffer: true
    },
    "rgb10a2unorm": {
      gl: GL.RGB10_A2,
      b: 4,
      c: 4,
      p: 1,
      renderbuffer: true
    },
    "rgb10a2unorm-webgl": {
      b: 4,
      c: 4,
      gl: GL.RGB10_A2UI,
      p: 1,
      wgpu: false,
      bpp: 4,
      renderbuffer: true
    },
    "rgb16unorm-webgl": {
      gl: GL.RGB16_EXT,
      b: 2,
      c: 3,
      f: "texture-formats-norm16-webgl",
      x: EXT_TEXTURE_NORM16
    },
    "rgb16snorm-webgl": {
      gl: GL.RGB16_SNORM_EXT,
      b: 2,
      c: 3,
      f: "texture-formats-norm16-webgl",
      x: EXT_TEXTURE_NORM16
    },
    "rg32uint": {
      gl: GL.RG32UI,
      b: 8,
      c: 2,
      renderbuffer: true
    },
    "rg32sint": {
      gl: GL.RG32I,
      b: 8,
      c: 2,
      renderbuffer: true
    },
    "rg32float": {
      gl: GL.RG32F,
      b: 8,
      c: 2,
      render: "texture-renderable-float32-webgl",
      filter: "texture-filter-linear-float32-webgl",
      renderbuffer: true
    },
    "rgba16uint": {
      gl: GL.RGBA16UI,
      b: 8,
      c: 4,
      renderbuffer: true
    },
    "rgba16sint": {
      gl: GL.RGBA16I,
      b: 8,
      c: 4,
      renderbuffer: true
    },
    "rgba16float": {
      gl: GL.RGBA16F,
      gl1: GL.RGBA,
      b: 8,
      c: 4,
      render: "texture-renderable-float16-webgl",
      filter: "texture-filter-linear-float16-webgl"
    },
    "rgba16unorm-webgl": {
      gl: GL.RGBA16_EXT,
      b: 2,
      c: 4,
      f: "texture-formats-norm16-webgl",
      renderbuffer: true,
      x: EXT_TEXTURE_NORM16
    },
    "rgba16snorm-webgl": {
      gl: GL.RGBA16_SNORM_EXT,
      b: 2,
      c: 4,
      f: "texture-formats-norm16-webgl",
      x: EXT_TEXTURE_NORM16
    },
    "rgb32float-webgl": {
      gl: GL.RGB32F,
      gl1: GL.RGB,
      render: "texture-renderable-float32-webgl",
      filter: "texture-filter-linear-float32-webgl",
      gl2ext: EXT_FLOAT_RENDER_WEBGL2,
      gl1ext: EXT_FLOAT_WEBGL1,
      dataFormat: GL.RGB,
      types: [GL.FLOAT]
    },
    "rgba32uint": {
      gl: GL.RGBA32UI,
      b: 16,
      c: 4,
      renderbuffer: true
    },
    "rgba32sint": {
      gl: GL.RGBA32I,
      b: 16,
      c: 4,
      renderbuffer: true
    },
    "rgba32float": {
      gl: GL.RGBA32F,
      b: 16,
      c: 4,
      render: "texture-renderable-float32-webgl",
      filter: "texture-filter-linear-float32-webgl",
      renderbuffer: true
    },
    "stencil8": {
      gl: GL.STENCIL_INDEX8,
      gl1: GL.STENCIL_INDEX8,
      b: 1,
      c: 1,
      attachment: GL.STENCIL_ATTACHMENT,
      renderbuffer: true
    },
    "depth16unorm": {
      gl: GL.DEPTH_COMPONENT16,
      gl1: GL.DEPTH_COMPONENT16,
      b: 2,
      c: 1,
      attachment: GL.DEPTH_ATTACHMENT,
      renderbuffer: true
    },
    "depth24plus": {
      gl: GL.DEPTH_COMPONENT24,
      b: 3,
      c: 1,
      attachment: GL.DEPTH_ATTACHMENT
    },
    "depth32float": {
      gl: GL.DEPTH_COMPONENT32F,
      b: 4,
      c: 1,
      attachment: GL.DEPTH_ATTACHMENT,
      renderbuffer: true
    },
    "depth24plus-stencil8": {
      gl: GL.DEPTH_STENCIL,
      gl1: GL.DEPTH_STENCIL,
      b: 4,
      c: 2,
      p: 1,
      attachment: GL.DEPTH_STENCIL_ATTACHMENT,
      renderbuffer: true,
      depthTexture: true
    },
    "depth24unorm-stencil8": {
      gl: GL.DEPTH24_STENCIL8,
      b: 4,
      c: 2,
      p: 1,
      attachment: GL.DEPTH_STENCIL_ATTACHMENT,
      renderbuffer: true
    },
    "depth32float-stencil8": {
      gl: GL.DEPTH32F_STENCIL8,
      b: 5,
      c: 2,
      p: 1,
      attachment: GL.DEPTH_STENCIL_ATTACHMENT,
      renderbuffer: true
    },
    "bc1-rgb-unorm-webgl": {
      gl: GL.COMPRESSED_RGB_S3TC_DXT1_EXT,
      x: X_S3TC,
      f: texture_compression_bc
    },
    "bc1-rgb-unorm-srgb-webgl": {
      gl: GL.COMPRESSED_SRGB_S3TC_DXT1_EXT,
      x: X_S3TC_SRGB,
      f: texture_compression_bc
    },
    "bc1-rgba-unorm": {
      gl: GL.COMPRESSED_RGBA_S3TC_DXT1_EXT,
      x: X_S3TC,
      f: texture_compression_bc
    },
    "bc1-rgba-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB_S3TC_DXT1_EXT,
      x: X_S3TC_SRGB,
      f: texture_compression_bc
    },
    "bc2-rgba-unorm": {
      gl: GL.COMPRESSED_RGBA_S3TC_DXT3_EXT,
      x: X_S3TC,
      f: texture_compression_bc
    },
    "bc2-rgba-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT,
      x: X_S3TC_SRGB,
      f: texture_compression_bc
    },
    "bc3-rgba-unorm": {
      gl: GL.COMPRESSED_RGBA_S3TC_DXT5_EXT,
      x: X_S3TC,
      f: texture_compression_bc
    },
    "bc3-rgba-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT,
      x: X_S3TC_SRGB,
      f: texture_compression_bc
    },
    "bc4-r-unorm": {
      gl: GL.COMPRESSED_RED_RGTC1_EXT,
      x: X_RGTC,
      f: texture_compression_bc
    },
    "bc4-r-snorm": {
      gl: GL.COMPRESSED_SIGNED_RED_RGTC1_EXT,
      x: X_RGTC,
      f: texture_compression_bc
    },
    "bc5-rg-unorm": {
      gl: GL.COMPRESSED_RED_GREEN_RGTC2_EXT,
      x: X_RGTC,
      f: texture_compression_bc
    },
    "bc5-rg-snorm": {
      gl: GL.COMPRESSED_SIGNED_RED_GREEN_RGTC2_EXT,
      x: X_RGTC,
      f: texture_compression_bc
    },
    "bc6h-rgb-ufloat": {
      gl: GL.COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_EXT,
      x: X_BPTC,
      f: texture_compression_bc
    },
    "bc6h-rgb-float": {
      gl: GL.COMPRESSED_RGB_BPTC_SIGNED_FLOAT_EXT,
      x: X_BPTC,
      f: texture_compression_bc
    },
    "bc7-rgba-unorm": {
      gl: GL.COMPRESSED_RGBA_BPTC_UNORM_EXT,
      x: X_BPTC,
      f: texture_compression_bc
    },
    "bc7-rgba-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB_ALPHA_BPTC_UNORM_EXT,
      x: X_BPTC,
      f: texture_compression_bc
    },
    "etc2-rgb8unorm": {
      gl: GL.COMPRESSED_RGB8_ETC2,
      f: texture_compression_etc2
    },
    "etc2-rgb8unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_ETC2,
      f: texture_compression_etc2
    },
    "etc2-rgb8a1unorm": {
      gl: GL.COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2,
      f: texture_compression_etc2
    },
    "etc2-rgb8a1unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2,
      f: texture_compression_etc2
    },
    "etc2-rgba8unorm": {
      gl: GL.COMPRESSED_RGBA8_ETC2_EAC,
      f: texture_compression_etc2
    },
    "etc2-rgba8unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_ALPHA8_ETC2_EAC,
      f: texture_compression_etc2
    },
    "eac-r11unorm": {
      gl: GL.COMPRESSED_R11_EAC,
      f: texture_compression_etc2
    },
    "eac-r11snorm": {
      gl: GL.COMPRESSED_SIGNED_R11_EAC,
      f: texture_compression_etc2
    },
    "eac-rg11unorm": {
      gl: GL.COMPRESSED_RG11_EAC,
      f: texture_compression_etc2
    },
    "eac-rg11snorm": {
      gl: GL.COMPRESSED_SIGNED_RG11_EAC,
      f: texture_compression_etc2
    },
    "astc-4x4-unorm": {
      gl: GL.COMPRESSED_RGBA_ASTC_4x4_KHR,
      f: texture_compression_astc
    },
    "astc-4x4-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR,
      f: texture_compression_astc
    },
    "astc-5x4-unorm": {
      gl: GL.COMPRESSED_RGBA_ASTC_5x4_KHR,
      f: texture_compression_astc
    },
    "astc-5x4-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR,
      f: texture_compression_astc
    },
    "astc-5x5-unorm": {
      gl: GL.COMPRESSED_RGBA_ASTC_5x5_KHR,
      f: texture_compression_astc
    },
    "astc-5x5-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR,
      f: texture_compression_astc
    },
    "astc-6x5-unorm": {
      gl: GL.COMPRESSED_RGBA_ASTC_6x5_KHR,
      f: texture_compression_astc
    },
    "astc-6x5-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR,
      f: texture_compression_astc
    },
    "astc-6x6-unorm": {
      gl: GL.COMPRESSED_RGBA_ASTC_6x6_KHR,
      f: texture_compression_astc
    },
    "astc-6x6-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR,
      f: texture_compression_astc
    },
    "astc-8x5-unorm": {
      gl: GL.COMPRESSED_RGBA_ASTC_8x5_KHR,
      f: texture_compression_astc
    },
    "astc-8x5-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR,
      f: texture_compression_astc
    },
    "astc-8x6-unorm": {
      gl: GL.COMPRESSED_RGBA_ASTC_8x6_KHR,
      f: texture_compression_astc
    },
    "astc-8x6-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR,
      f: texture_compression_astc
    },
    "astc-8x8-unorm": {
      gl: GL.COMPRESSED_RGBA_ASTC_8x8_KHR,
      f: texture_compression_astc
    },
    "astc-8x8-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR,
      f: texture_compression_astc
    },
    "astc-10x5-unorm": {
      gl: GL.COMPRESSED_RGBA_ASTC_10x10_KHR,
      f: texture_compression_astc
    },
    "astc-10x5-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR,
      f: texture_compression_astc
    },
    "astc-10x6-unorm": {
      gl: GL.COMPRESSED_RGBA_ASTC_10x6_KHR,
      f: texture_compression_astc
    },
    "astc-10x6-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR,
      f: texture_compression_astc
    },
    "astc-10x8-unorm": {
      gl: GL.COMPRESSED_RGBA_ASTC_10x8_KHR,
      f: texture_compression_astc
    },
    "astc-10x8-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR,
      f: texture_compression_astc
    },
    "astc-10x10-unorm": {
      gl: GL.COMPRESSED_RGBA_ASTC_10x10_KHR,
      f: texture_compression_astc
    },
    "astc-10x10-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR,
      f: texture_compression_astc
    },
    "astc-12x10-unorm": {
      gl: GL.COMPRESSED_RGBA_ASTC_12x10_KHR,
      f: texture_compression_astc
    },
    "astc-12x10-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR,
      f: texture_compression_astc
    },
    "astc-12x12-unorm": {
      gl: GL.COMPRESSED_RGBA_ASTC_12x12_KHR,
      f: texture_compression_astc
    },
    "astc-12x12-unorm-srgb": {
      gl: GL.COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR,
      f: texture_compression_astc
    },
    "pvrtc-rgb4unorm-webgl": {
      gl: GL.COMPRESSED_RGB_PVRTC_4BPPV1_IMG,
      f: texture_compression_pvrtc_webgl
    },
    "pvrtc-rgba4unorm-webgl": {
      gl: GL.COMPRESSED_RGBA_PVRTC_4BPPV1_IMG,
      f: texture_compression_pvrtc_webgl
    },
    "pvrtc-rbg2unorm-webgl": {
      gl: GL.COMPRESSED_RGB_PVRTC_2BPPV1_IMG,
      f: texture_compression_pvrtc_webgl
    },
    "pvrtc-rgba2unorm-webgl": {
      gl: GL.COMPRESSED_RGBA_PVRTC_2BPPV1_IMG,
      f: texture_compression_pvrtc_webgl
    },
    "etc1-rbg-unorm-webgl": {
      gl: GL.COMPRESSED_RGB_ETC1_WEBGL,
      f: texture_compression_etc1_webgl
    },
    "atc-rgb-unorm-webgl": {
      gl: GL.COMPRESSED_RGB_ATC_WEBGL,
      f: texture_compression_atc_webgl
    },
    "atc-rgba-unorm-webgl": {
      gl: GL.COMPRESSED_RGBA_ATC_EXPLICIT_ALPHA_WEBGL,
      f: texture_compression_atc_webgl
    },
    "atc-rgbai-unorm-webgl": {
      gl: GL.COMPRESSED_RGBA_ATC_INTERPOLATED_ALPHA_WEBGL,
      f: texture_compression_atc_webgl
    }
  };
  var DATA_FORMAT_CHANNELS = {
    [GL.RED]: 1,
    [GL.RED_INTEGER]: 1,
    [GL.RG]: 2,
    [GL.RG_INTEGER]: 2,
    [GL.RGB]: 3,
    [GL.RGB_INTEGER]: 3,
    [GL.RGBA]: 4,
    [GL.RGBA_INTEGER]: 4,
    [GL.DEPTH_COMPONENT]: 1,
    [GL.DEPTH_STENCIL]: 1,
    [GL.ALPHA]: 1,
    [GL.LUMINANCE]: 1,
    [GL.LUMINANCE_ALPHA]: 2
  };
  var TYPE_SIZES = {
    [GL.FLOAT]: 4,
    [GL.UNSIGNED_INT]: 4,
    [GL.INT]: 4,
    [GL.UNSIGNED_SHORT]: 2,
    [GL.SHORT]: 2,
    [GL.HALF_FLOAT]: 2,
    [GL.BYTE]: 1,
    [GL.UNSIGNED_BYTE]: 1
  };
  function isTextureFormatSupported(gl, formatOrGL) {
    const format = convertGLToTextureFormat(formatOrGL);
    const info = TEXTURE_FORMATS[format];
    if (!info) {
      return false;
    }
    if (isWebGL2(gl) ? info.gl === void 0 : info.gl1 === void 0) {
      return false;
    }
    const extension = info.x || (isWebGL2(gl) ? info.gl2ext || info.gl1ext : info.gl1ext);
    if (extension) {
      return Boolean(gl.getExtension(extension));
    }
    return true;
  }
  function isRenderbufferFormatSupported(gl, format) {
    var _TEXTURE_FORMATS$form;
    return isTextureFormatSupported(gl, format) && ((_TEXTURE_FORMATS$form = TEXTURE_FORMATS[format]) === null || _TEXTURE_FORMATS$form === void 0 ? void 0 : _TEXTURE_FORMATS$form.renderbuffer);
  }
  function convertGLToTextureFormat(format) {
    if (typeof format === "string") {
      return format;
    }
    const entry = Object.entries(TEXTURE_FORMATS).find((_ref) => {
      let [, entry2] = _ref;
      return entry2.gl === format || entry2.gl1 === format;
    });
    if (!entry) {
      throw new Error(`Unknown texture format ${format}`);
    }
    return entry[0];
  }
  function convertTextureFormatToGL(format, isWebGL23) {
    const formatInfo = TEXTURE_FORMATS[format];
    const webglFormat = isWebGL23 ? formatInfo === null || formatInfo === void 0 ? void 0 : formatInfo.gl : formatInfo === null || formatInfo === void 0 ? void 0 : formatInfo.gl1;
    if (webglFormat === void 0) {
      throw new Error(`Unsupported texture format ${format}`);
    }
    return webglFormat;
  }
  function isTextureFormatFilterable(gl, formatOrGL) {
    const format = convertGLToTextureFormat(formatOrGL);
    if (!isTextureFormatSupported(gl, format)) {
      return false;
    }
    try {
      const decoded = (0, import_core8.decodeTextureFormat)(format);
      if (decoded.signed) {
        return false;
      }
    } catch {
      return false;
    }
    if (format.endsWith("32float")) {
      return Boolean(gl.getExtension("OES_texture_float_linear"));
    }
    if (format.endsWith("16float")) {
      return Boolean(gl.getExtension("OES_texture_half_float_linear"));
    }
    return true;
  }
  function isTextureFormatRenderable(gl, formatOrGL) {
    const format = convertGLToTextureFormat(formatOrGL);
    if (!isTextureFormatSupported(gl, format)) {
      return false;
    }
    if (typeof format === "number") {
      return false;
    }
    return true;
  }
  function getWebGLTextureParameters(formatOrGL, isWebGL23) {
    const format = convertGLToTextureFormat(formatOrGL);
    const webglFormat = convertTextureFormatToGL(format, isWebGL23);
    const decoded = (0, import_core8.decodeTextureFormat)(format);
    return {
      format: webglFormat,
      dataFormat: getWebGLPixelDataFormat(decoded.format, decoded.integer, decoded.normalized, webglFormat),
      type: decoded.dataType ? getGLFromVertexType(decoded.dataType) : GL.UNSIGNED_BYTE,
      compressed: decoded.compressed
    };
  }
  function getDepthStencilAttachmentWebGL(format) {
    const info = TEXTURE_FORMATS[format];
    if (!(info !== null && info !== void 0 && info.attachment)) {
      throw new Error(`${format} is not a depth stencil format`);
    }
    return info.attachment;
  }
  function _checkFloat32ColorAttachment(gl) {
    let internalFormat = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : gl.RGBA;
    let srcFormat = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : GL.RGBA;
    let srcType = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : GL.UNSIGNED_BYTE;
    let texture = null;
    let framebuffer = null;
    try {
      texture = gl.createTexture();
      gl.bindTexture(GL.TEXTURE_2D, texture);
      const level = 0;
      const width = 1;
      const height = 1;
      const border = 0;
      const pixel = new Uint8Array([0, 0, 255, 255]);
      gl.texImage2D(gl.TEXTURE_2D, level, internalFormat, width, height, border, srcFormat, srcType, pixel);
      framebuffer = gl.createFramebuffer();
      gl.bindFramebuffer(GL.FRAMEBUFFER, framebuffer);
      gl.framebufferTexture2D(GL.FRAMEBUFFER, GL.COLOR_ATTACHMENT0, GL.TEXTURE_2D, texture, 0);
      const status = gl.checkFramebufferStatus(GL.FRAMEBUFFER) === GL.FRAMEBUFFER_COMPLETE;
      gl.bindTexture(GL.TEXTURE_2D, null);
      return status;
    } finally {
      gl.deleteTexture(texture);
      gl.deleteFramebuffer(framebuffer);
    }
  }
  function getTextureFormatBytesPerPixel(formatOrGL, isWebGL23) {
    const format = convertGLToTextureFormat(formatOrGL);
    const params = getWebGLTextureParameters(format, isWebGL23);
    const channels = DATA_FORMAT_CHANNELS[params.dataFormat] || 4;
    const channelSize = TYPE_SIZES[params.type] || 1;
    return channels * channelSize;
  }
  function getWebGLPixelDataFormat(dataFormat, integer, normalized, format) {
    if (format === GL.RGBA || format === GL.RGB) {
      return format;
    }
    switch (dataFormat) {
      case "r":
        return integer && !normalized ? GL.RED_INTEGER : GL.RED;
      case "rg":
        return integer && !normalized ? GL.RG_INTEGER : GL.RG;
      case "rgb":
        return integer && !normalized ? GL.RGB_INTEGER : GL.RGB;
      case "rgba":
        return integer && !normalized ? GL.RGBA_INTEGER : GL.RGBA;
      default:
        return GL.RGBA;
    }
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/device-helpers/device-features.js
  function getDeviceFeatures(gl) {
    const features = getWebGLFeatures(gl);
    for (const textureFeature of getTextureFeatures(gl)) {
      features.add(textureFeature);
    }
    return features;
  }
  function getWebGLFeatures(gl) {
    gl.getExtension("EXT_color_buffer_float");
    gl.getExtension("WEBGL_color_buffer_float");
    gl.getExtension("EXT_float_blend");
    const features = /* @__PURE__ */ new Set();
    for (const feature of Object.keys(WEBGL_FEATURES)) {
      if (isFeatureSupported(gl, feature)) {
        features.add(feature);
      }
    }
    return features;
  }
  function isFeatureSupported(gl, feature) {
    const featureInfo = WEBGL_FEATURES[feature];
    if (!featureInfo) {
      return false;
    }
    const [webgl1Feature, webgl2Feature] = featureInfo || [];
    const featureDefinition = isWebGL2(gl) ? webgl2Feature : webgl1Feature;
    if (typeof featureDefinition === "boolean") {
      return featureDefinition;
    }
    switch (feature) {
      case "texture-renderable-rgba32float-webgl":
        return isWebGL2(gl) ? Boolean(gl.getExtension(featureDefinition)) : _checkFloat32ColorAttachment(gl);
      case "glsl-derivatives":
        return canCompileGLSLExtension(gl, featureDefinition);
      case "glsl-frag-data":
        return canCompileGLSLExtension(gl, featureDefinition, {
          behavior: "require"
        });
      case "glsl-frag-depth":
        return canCompileGLSLExtension(gl, featureDefinition);
      default:
        return Boolean(gl.getExtension(featureDefinition));
    }
  }
  var compiledGLSLExtensions = {};
  function canCompileGLSLExtension(gl, extensionName) {
    let opts = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
    if (!isOldIE(opts)) {
      return true;
    }
    if (extensionName in compiledGLSLExtensions) {
      return compiledGLSLExtensions[extensionName];
    }
    const behavior = opts.behavior || "enable";
    const source = `#extension GL_${extensionName} : ${behavior}
void main(void) {}`;
    const shader = gl.createShader(gl.VERTEX_SHADER);
    if (!shader) {
      throw new Error("shader");
    }
    gl.shaderSource(shader, source);
    gl.compileShader(shader);
    const canCompile = gl.getShaderParameter(shader, gl.COMPILE_STATUS);
    gl.deleteShader(shader);
    compiledGLSLExtensions[extensionName] = canCompile;
    return canCompile;
  }
  var WEBGL_FEATURES = {
    "webgl": [true, true],
    "webgl2": [false, true],
    "timer-query-webgl": ["EXT_disjoint_timer_query", "EXT_disjoint_timer_query_webgl2"],
    "vertex-array-object-webgl1": ["OES_vertex_array_object", true],
    "instanced-rendering-webgl1": ["ANGLE_instanced_arrays", true],
    "multiple-render-targets-webgl1": ["WEBGL_draw_buffers", true],
    "index-uint32-webgl1": ["OES_element_index_uint", true],
    "blend-minmax-webgl1": ["EXT_blend_minmax", true],
    "texture-blend-float-webgl1": ["EXT_float_blend", "EXT_float_blend"],
    "texture-formats-srgb-webgl1": ["EXT_sRGB", true],
    "texture-formats-depth-webgl1": ["WEBGL_depth_texture", true],
    "texture-formats-float32-webgl1": ["OES_texture_float", true],
    "texture-formats-float16-webgl1": ["OES_texture_half_float", true],
    "texture-filter-linear-float32-webgl": ["OES_texture_float_linear", "OES_texture_float_linear"],
    "texture-filter-linear-float16-webgl": ["OES_texture_half_float_linear", "OES_texture_half_float_linear"],
    "texture-filter-anisotropic-webgl": ["EXT_texture_filter_anisotropic", "EXT_texture_filter_anisotropic"],
    "texture-renderable-rgba32float-webgl": ["WEBGL_color_buffer_float", "EXT_color_buffer_float"],
    "texture-renderable-float32-webgl": [false, "EXT_color_buffer_float"],
    "texture-renderable-float16-webgl": ["EXT_color_buffer_half_float", "EXT_color_buffer_half_float"],
    "glsl-frag-data": ["WEBGL_draw_buffers", true],
    "glsl-frag-depth": ["EXT_frag_depth", true],
    "glsl-derivatives": ["OES_standard_derivatives", true],
    "glsl-texture-lod": ["EXT_shader_texture_lod", true]
  };

  // ../../node_modules/@luma.gl/webgl/dist/adapter/device-helpers/device-limits.js
  function getDeviceLimits(gl) {
    const gl2 = getWebGL2Context(gl);
    return {
      maxTextureDimension1D: 0,
      maxTextureDimension2D: gl.getParameter(GL.MAX_TEXTURE_SIZE),
      maxTextureDimension3D: gl2 ? gl2.getParameter(GL.MAX_3D_TEXTURE_SIZE) : 0,
      maxTextureArrayLayers: gl2 ? gl2.getParameter(GL.MAX_ARRAY_TEXTURE_LAYERS) : 0,
      maxBindGroups: 1,
      maxDynamicUniformBuffersPerPipelineLayout: 0,
      maxDynamicStorageBuffersPerPipelineLayout: 0,
      maxSampledTexturesPerShaderStage: gl.getParameter(GL.MAX_VERTEX_TEXTURE_IMAGE_UNITS),
      maxSamplersPerShaderStage: gl.getParameter(GL.MAX_COMBINED_TEXTURE_IMAGE_UNITS),
      maxStorageBuffersPerShaderStage: 0,
      maxStorageTexturesPerShaderStage: 0,
      maxUniformBuffersPerShaderStage: gl2 ? gl2.getParameter(GL.MAX_UNIFORM_BUFFER_BINDINGS) : 0,
      maxUniformBufferBindingSize: gl2 ? gl2.getParameter(GL.MAX_UNIFORM_BLOCK_SIZE) : 0,
      maxStorageBufferBindingSize: 0,
      minUniformBufferOffsetAlignment: gl2 ? gl2.getParameter(GL.UNIFORM_BUFFER_OFFSET_ALIGNMENT) : 0,
      minStorageBufferOffsetAlignment: 0,
      maxVertexBuffers: 0,
      maxVertexAttributes: gl.getParameter(GL.MAX_VERTEX_ATTRIBS),
      maxVertexBufferArrayStride: 2048,
      maxInterStageShaderComponents: gl2 ? gl2.getParameter(GL.MAX_VARYING_COMPONENTS) : 0,
      maxComputeWorkgroupStorageSize: 0,
      maxComputeInvocationsPerWorkgroup: 0,
      maxComputeWorkgroupSizeX: 0,
      maxComputeWorkgroupSizeY: 0,
      maxComputeWorkgroupSizeZ: 0,
      maxComputeWorkgroupsPerDimension: 0
    };
  }
  function getWebGLLimits(gl) {
    const gl2 = getWebGL2Context(gl);
    function get(pname) {
      return gl.getParameter(pname);
    }
    function get2(pname, defaultValue) {
      return gl2 ? gl2.getParameter(pname) : defaultValue || 0;
    }
    return {
      [GL.ALIASED_LINE_WIDTH_RANGE]: get(GL.ALIASED_LINE_WIDTH_RANGE),
      [GL.ALIASED_POINT_SIZE_RANGE]: get(GL.ALIASED_POINT_SIZE_RANGE),
      [GL.MAX_TEXTURE_SIZE]: get(GL.MAX_TEXTURE_SIZE),
      [GL.MAX_CUBE_MAP_TEXTURE_SIZE]: get(GL.MAX_CUBE_MAP_TEXTURE_SIZE),
      [GL.MAX_TEXTURE_IMAGE_UNITS]: get(GL.MAX_TEXTURE_IMAGE_UNITS),
      [GL.MAX_COMBINED_TEXTURE_IMAGE_UNITS]: get(GL.MAX_COMBINED_TEXTURE_IMAGE_UNITS),
      [GL.MAX_VERTEX_TEXTURE_IMAGE_UNITS]: get(GL.MAX_VERTEX_TEXTURE_IMAGE_UNITS),
      [GL.MAX_RENDERBUFFER_SIZE]: get(GL.MAX_RENDERBUFFER_SIZE),
      [GL.MAX_VARYING_VECTORS]: get(GL.MAX_VARYING_VECTORS),
      [GL.MAX_VERTEX_ATTRIBS]: get(GL.MAX_VERTEX_ATTRIBS),
      [GL.MAX_VERTEX_UNIFORM_VECTORS]: get(GL.MAX_VERTEX_UNIFORM_VECTORS),
      [GL.MAX_FRAGMENT_UNIFORM_VECTORS]: get(GL.MAX_FRAGMENT_UNIFORM_VECTORS),
      [GL.MAX_VIEWPORT_DIMS]: get(GL.MAX_VIEWPORT_DIMS),
      [GL.MAX_TEXTURE_MAX_ANISOTROPY_EXT]: get(GL.MAX_TEXTURE_MAX_ANISOTROPY_EXT),
      [GL.MAX_3D_TEXTURE_SIZE]: get2(GL.MAX_3D_TEXTURE_SIZE),
      [GL.MAX_ARRAY_TEXTURE_LAYERS]: get2(GL.MAX_ARRAY_TEXTURE_LAYERS),
      [GL.MAX_CLIENT_WAIT_TIMEOUT_WEBGL]: get2(GL.MAX_CLIENT_WAIT_TIMEOUT_WEBGL),
      [GL.MAX_COLOR_ATTACHMENTS]: get2(GL.MAX_COLOR_ATTACHMENTS),
      [GL.MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS]: get2(GL.MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS),
      [GL.MAX_COMBINED_UNIFORM_BLOCKS]: get2(GL.MAX_COMBINED_UNIFORM_BLOCKS),
      [GL.MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS]: get2(GL.MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS),
      [GL.MAX_DRAW_BUFFERS]: get2(GL.MAX_DRAW_BUFFERS),
      [GL.MAX_ELEMENT_INDEX]: get2(GL.MAX_ELEMENT_INDEX),
      [GL.MAX_ELEMENTS_INDICES]: get2(GL.MAX_ELEMENTS_INDICES),
      [GL.MAX_ELEMENTS_VERTICES]: get2(GL.MAX_ELEMENTS_VERTICES),
      [GL.MAX_FRAGMENT_INPUT_COMPONENTS]: get2(GL.MAX_FRAGMENT_INPUT_COMPONENTS),
      [GL.MAX_FRAGMENT_UNIFORM_BLOCKS]: get2(GL.MAX_FRAGMENT_UNIFORM_BLOCKS),
      [GL.MAX_FRAGMENT_UNIFORM_COMPONENTS]: get2(GL.MAX_FRAGMENT_UNIFORM_COMPONENTS),
      [GL.MAX_SAMPLES]: get2(GL.MAX_SAMPLES),
      [GL.MAX_SERVER_WAIT_TIMEOUT]: get2(GL.MAX_SERVER_WAIT_TIMEOUT),
      [GL.MAX_TEXTURE_LOD_BIAS]: get2(GL.MAX_TEXTURE_LOD_BIAS),
      [GL.MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS]: get2(GL.MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS),
      [GL.MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS]: get2(GL.MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS),
      [GL.MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS]: get2(GL.MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS),
      [GL.MAX_UNIFORM_BLOCK_SIZE]: get2(GL.MAX_UNIFORM_BLOCK_SIZE),
      [GL.MAX_UNIFORM_BUFFER_BINDINGS]: get2(GL.MAX_UNIFORM_BUFFER_BINDINGS),
      [GL.MAX_VARYING_COMPONENTS]: get2(GL.MAX_VARYING_COMPONENTS),
      [GL.MAX_VERTEX_OUTPUT_COMPONENTS]: get2(GL.MAX_VERTEX_OUTPUT_COMPONENTS),
      [GL.MAX_VERTEX_UNIFORM_BLOCKS]: get2(GL.MAX_VERTEX_UNIFORM_BLOCKS),
      [GL.MAX_VERTEX_UNIFORM_COMPONENTS]: get2(GL.MAX_VERTEX_UNIFORM_COMPONENTS),
      [GL.MIN_PROGRAM_TEXEL_OFFSET]: get2(GL.MIN_PROGRAM_TEXEL_OFFSET),
      [GL.MAX_PROGRAM_TEXEL_OFFSET]: get2(GL.MAX_PROGRAM_TEXEL_OFFSET),
      [GL.UNIFORM_BUFFER_OFFSET_ALIGNMENT]: get2(GL.UNIFORM_BUFFER_OFFSET_ALIGNMENT)
    };
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/webgl-canvas-context.js
  var import_core18 = __toESM(require_core2(), 1);

  // ../../node_modules/@luma.gl/webgl/dist/adapter/resources/webgl-framebuffer.js
  var import_core17 = __toESM(require_core2(), 1);

  // ../../node_modules/@luma.gl/webgl/dist/adapter/resources/webgl-texture.js
  var import_core12 = __toESM(require_core2(), 1);
  var import_core13 = __toESM(require_core2(), 1);

  // ../../node_modules/@luma.gl/webgl/dist/context/state-tracker/with-parameters.js
  function withGLParameters(device, parameters2, func) {
    const webglDevice = WebGLDevice.attach(device);
    const gl = webglDevice.gl;
    if (isObjectEmpty2(parameters2)) {
      return func(device);
    }
    const {
      nocatch = true
    } = parameters2;
    pushContextState(gl);
    setGLParameters(gl, parameters2);
    let value;
    if (nocatch) {
      value = func(gl);
      popContextState(gl);
    } else {
      try {
        value = func(gl);
      } finally {
        popContextState(gl);
      }
    }
    return value;
  }
  function isObjectEmpty2(object) {
    for (const key in object) {
      return false;
    }
    return true;
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/converters/device-parameters.js
  var import_core9 = __toESM(require_core2(), 1);
  function withDeviceAndGLParameters(device, parameters2, glParameters, func) {
    if ((0, import_core9.isObjectEmpty)(parameters2)) {
      return func(device);
    }
    pushContextState(device.gl);
    try {
      setDeviceParameters(device, parameters2);
      setGLParameters(device, glParameters);
      return func(device);
    } finally {
      popContextState(device.gl);
    }
  }
  function setDeviceParameters(device, parameters2) {
    const webglDevice = WebGLDevice.attach(device);
    const {
      gl
    } = webglDevice;
    if (parameters2.cullMode) {
      switch (parameters2.cullMode) {
        case "none":
          gl.disable(GL.CULL_FACE);
          break;
        case "front":
          gl.enable(GL.CULL_FACE);
          gl.cullFace(GL.FRONT);
          break;
        case "back":
          gl.enable(GL.CULL_FACE);
          gl.cullFace(GL.BACK);
          break;
      }
    }
    if (parameters2.frontFace) {
      gl.frontFace(map("frontFace", parameters2.frontFace, {
        ccw: GL.CCW,
        cw: GL.CW
      }));
    }
    if (parameters2.depthBias !== void 0) {
      gl.polygonOffset(parameters2.depthBias, parameters2.depthBiasSlopeScale || 0);
    }
    if (parameters2.depthWriteEnabled !== void 0) {
      gl.depthMask(mapBoolean("depthWriteEnabled", parameters2.depthWriteEnabled));
    }
    if (parameters2.depthCompare) {
      parameters2.depthCompare !== "always" ? gl.enable(GL.DEPTH_TEST) : gl.disable(GL.DEPTH_TEST);
      gl.depthFunc(convertCompareFunction("depthCompare", parameters2.depthCompare));
    }
    if (parameters2.stencilWriteMask) {
      const mask = parameters2.stencilWriteMask;
      gl.stencilMaskSeparate(GL.FRONT, mask);
      gl.stencilMaskSeparate(GL.BACK, mask);
    }
    if (parameters2.stencilReadMask) {
      import_core9.log.warn("stencilReadMask not supported under WebGL");
    }
    if (parameters2.stencilCompare) {
      const mask = parameters2.stencilReadMask || 4294967295;
      const glValue = convertCompareFunction("depthCompare", parameters2.stencilCompare);
      parameters2.stencilCompare !== "always" ? gl.enable(GL.STENCIL_TEST) : gl.disable(GL.STENCIL_TEST);
      gl.stencilFuncSeparate(GL.FRONT, glValue, 0, mask);
      gl.stencilFuncSeparate(GL.BACK, glValue, 0, mask);
    }
    if (parameters2.stencilPassOperation && parameters2.stencilFailOperation && parameters2.stencilDepthFailOperation) {
      const dppass = convertStencilOperation("stencilPassOperation", parameters2.stencilPassOperation);
      const sfail = convertStencilOperation("stencilFailOperation", parameters2.stencilFailOperation);
      const dpfail = convertStencilOperation("stencilDepthFailOperation", parameters2.stencilDepthFailOperation);
      gl.stencilOpSeparate(GL.FRONT, sfail, dpfail, dppass);
      gl.stencilOpSeparate(GL.BACK, sfail, dpfail, dppass);
    }
  }
  function convertCompareFunction(parameter, value) {
    return map(parameter, value, {
      never: GL.NEVER,
      less: GL.LESS,
      equal: GL.EQUAL,
      "less-equal": GL.LEQUAL,
      greater: GL.GREATER,
      "not-equal": GL.NOTEQUAL,
      "greater-equal": GL.GEQUAL,
      always: GL.ALWAYS
    });
  }
  function convertStencilOperation(parameter, value) {
    return map(parameter, value, {
      keep: GL.KEEP,
      zero: GL.ZERO,
      replace: GL.REPLACE,
      invert: GL.INVERT,
      "increment-clamp": GL.INCR,
      "decrement-clamp": GL.DECR,
      "increment-wrap": GL.INCR_WRAP,
      "decrement-wrap": GL.DECR_WRAP
    });
  }
  function message(parameter, value) {
    return `Illegal parameter ${value} for ${parameter}`;
  }
  function map(parameter, value, valueMap) {
    if (!(value in valueMap)) {
      throw new Error(message(parameter, value));
    }
    return valueMap[value];
  }
  function mapBoolean(parameter, value) {
    return value;
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/converters/sampler-parameters.js
  function convertSamplerParametersToWebGL(props) {
    const params = {};
    if (props.addressModeU) {
      params[GL.TEXTURE_WRAP_S] = convertAddressMode(props.addressModeU);
    }
    if (props.addressModeV) {
      params[GL.TEXTURE_WRAP_T] = convertAddressMode(props.addressModeV);
    }
    if (props.addressModeW) {
      params[GL.TEXTURE_WRAP_R] = convertAddressMode(props.addressModeW);
    }
    if (props.magFilter) {
      params[GL.TEXTURE_MAG_FILTER] = convertMaxFilterMode(props.magFilter);
    }
    if (props.minFilter || props.mipmapFilter) {
      params[GL.TEXTURE_MIN_FILTER] = convertMinFilterMode(props.minFilter || "linear", props.mipmapFilter);
    }
    if (props.lodMinClamp !== void 0) {
      params[GL.TEXTURE_MIN_LOD] = props.lodMinClamp;
    }
    if (props.lodMaxClamp !== void 0) {
      params[GL.TEXTURE_MAX_LOD] = props.lodMaxClamp;
    }
    if (props.type === "comparison-sampler") {
      params[GL.TEXTURE_COMPARE_MODE] = GL.COMPARE_REF_TO_TEXTURE;
    }
    if (props.compare) {
      params[GL.TEXTURE_COMPARE_FUNC] = convertCompareFunction("compare", props.compare);
    }
    if (props.maxAnisotropy) {
      params[GL.TEXTURE_MAX_ANISOTROPY_EXT] = props.maxAnisotropy;
    }
    return params;
  }
  function convertAddressMode(addressMode) {
    switch (addressMode) {
      case "clamp-to-edge":
        return GL.CLAMP_TO_EDGE;
      case "repeat":
        return GL.REPEAT;
      case "mirror-repeat":
        return GL.MIRRORED_REPEAT;
    }
  }
  function convertMaxFilterMode(maxFilter) {
    switch (maxFilter) {
      case "nearest":
        return GL.NEAREST;
      case "linear":
        return GL.LINEAR;
    }
  }
  function convertMinFilterMode(minFilter, mipmapFilter) {
    if (!mipmapFilter) {
      return convertMaxFilterMode(minFilter);
    }
    switch (minFilter) {
      case "nearest":
        return mipmapFilter === "nearest" ? GL.NEAREST_MIPMAP_NEAREST : GL.NEAREST_MIPMAP_LINEAR;
      case "linear":
        return mipmapFilter === "nearest" ? GL.LINEAR_MIPMAP_NEAREST : GL.LINEAR_MIPMAP_LINEAR;
    }
  }
  function updateSamplerParametersForNPOT(parameters2) {
    const newParameters = {
      ...parameters2
    };
    if (parameters2[GL.TEXTURE_MIN_FILTER] !== GL.NEAREST) {
      newParameters[GL.TEXTURE_MIN_FILTER] = GL.LINEAR;
    }
    newParameters[GL.TEXTURE_WRAP_S] = GL.CLAMP_TO_EDGE;
    newParameters[GL.TEXTURE_WRAP_T] = GL.CLAMP_TO_EDGE;
    return newParameters;
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/resources/webgl-buffer.js
  var import_core10 = __toESM(require_core2(), 1);
  var DEBUG_DATA_LENGTH = 10;
  var WEBGLBuffer = class extends import_core10.Buffer {
    constructor(device) {
      let props = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
      super(device, props);
      this.device = void 0;
      this.gl = void 0;
      this.gl2 = void 0;
      this.handle = void 0;
      this.glTarget = void 0;
      this.glUsage = void 0;
      this.glIndexType = GL.UNSIGNED_SHORT;
      this.byteLength = void 0;
      this.bytesUsed = void 0;
      this.debugData = null;
      this.device = device;
      this.gl = this.device.gl;
      this.gl2 = this.device.gl2;
      const handle = typeof props === "object" ? props.handle : void 0;
      this.handle = handle || this.gl.createBuffer();
      device.setSpectorMetadata(this.handle, {
        ...this.props,
        data: typeof this.props.data
      });
      this.glTarget = getWebGLTarget(this.props.usage);
      this.glUsage = getWebGLUsage(this.props.usage);
      this.glIndexType = this.props.indexType === "uint32" ? GL.UNSIGNED_INT : GL.UNSIGNED_SHORT;
      this.debugData = null;
      if (props.data) {
        this._initWithData(props.data, props.byteOffset, props.byteLength);
      } else {
        this._initWithByteLength(props.byteLength || 0);
      }
    }
    _initWithData(data) {
      let byteOffset = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
      let byteLength = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : data.byteLength + byteOffset;
      (0, import_core10.assert)(ArrayBuffer.isView(data));
      const glTarget = this._getWriteTarget();
      this.gl.bindBuffer(glTarget, this.handle);
      this.gl.bufferData(glTarget, byteLength, this.glUsage);
      this.gl.bufferSubData(glTarget, byteOffset, data);
      this.gl.bindBuffer(glTarget, null);
      this.debugData = data.slice(0, DEBUG_DATA_LENGTH);
      this.bytesUsed = byteLength;
      this.byteLength = byteLength;
      this.trackAllocatedMemory(byteLength);
      return this;
    }
    _initWithByteLength(byteLength) {
      (0, import_core10.assert)(byteLength >= 0);
      let data = byteLength;
      if (byteLength === 0) {
        data = new Float32Array(0);
      }
      const glTarget = this._getWriteTarget();
      this.gl.bindBuffer(glTarget, this.handle);
      this.gl.bufferData(glTarget, data, this.glUsage);
      this.gl.bindBuffer(glTarget, null);
      this.debugData = null;
      this.bytesUsed = byteLength;
      this.byteLength = byteLength;
      return this;
    }
    destroy() {
      if (!this.destroyed && this.handle) {
        this.removeStats();
        this.trackDeallocatedMemory();
        this.gl.deleteBuffer(this.handle);
        this.destroyed = true;
        this.handle = null;
      }
    }
    write(data) {
      let byteOffset = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
      const srcOffset = 0;
      const byteLength = void 0;
      const glTarget = this.device.isWebGL2 ? GL.COPY_WRITE_BUFFER : this.glTarget;
      this.gl.bindBuffer(glTarget, this.handle);
      if (srcOffset !== 0 || byteLength !== void 0) {
        this.device.assertWebGL2();
        this.gl2.bufferSubData(glTarget, byteOffset, data, srcOffset, byteLength);
      } else {
        this.gl.bufferSubData(glTarget, byteOffset, data);
      }
      this.gl.bindBuffer(glTarget, null);
    }
    async readAsync() {
      let byteOffset = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
      let byteLength = arguments.length > 1 ? arguments[1] : void 0;
      this.device.assertWebGL2();
      const data = new Uint8Array(byteLength);
      const dstOffset = 0;
      this.gl.bindBuffer(GL.COPY_READ_BUFFER, this.handle);
      this.gl2.getBufferSubData(GL.COPY_READ_BUFFER, byteOffset, data, dstOffset, byteLength);
      this.gl.bindBuffer(GL.COPY_READ_BUFFER, null);
      return data;
    }
    _invalidateDebugData() {
      this.debugData = null;
    }
    _getWriteTarget() {
      return this.glTarget;
    }
    _getReadTarget() {
      return this.glTarget;
    }
  };
  function getWebGLTarget(usage) {
    if (usage & import_core10.Buffer.INDEX) {
      return GL.ELEMENT_ARRAY_BUFFER;
    }
    if (usage & import_core10.Buffer.VERTEX) {
      return GL.ARRAY_BUFFER;
    }
    if (usage & import_core10.Buffer.UNIFORM) {
      return GL.UNIFORM_BUFFER;
    }
    return GL.ARRAY_BUFFER;
  }
  function getWebGLUsage(usage) {
    if (usage & import_core10.Buffer.INDEX) {
      return GL.STATIC_DRAW;
    }
    if (usage & import_core10.Buffer.VERTEX) {
      return GL.STATIC_DRAW;
    }
    if (usage & import_core10.Buffer.UNIFORM) {
      return GL.DYNAMIC_DRAW;
    }
    return GL.STATIC_DRAW;
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/resources/webgl-sampler.js
  var import_core11 = __toESM(require_core2(), 1);
  var WEBGLSampler = class extends import_core11.Sampler {
    constructor(device, props) {
      super(device, props);
      this.device = void 0;
      this.handle = void 0;
      this.parameters = void 0;
      this.device = device;
      this.parameters = convertSamplerParametersToWebGL(props);
      if (this.device.isWebGL2) {
        this.handle = this.handle || this.device.gl2.createSampler();
        this._setSamplerParameters(this.parameters);
      }
    }
    destroy() {
      if (this.handle) {
        this.device.gl2.deleteSampler(this.handle);
        this.handle = void 0;
      }
    }
    toString() {
      return `Sampler(${this.id},${JSON.stringify(this.props)})`;
    }
    _setSamplerParameters(parameters2) {
      for (const [pname, value] of Object.entries(parameters2)) {
        const param = Number(pname);
        switch (param) {
          case GL.TEXTURE_MIN_LOD:
          case GL.TEXTURE_MAX_LOD:
            this.device.gl2.samplerParameterf(this.handle, param, value);
            break;
          default:
            this.device.gl2.samplerParameteri(this.handle, param, value);
            break;
        }
      }
    }
  };

  // ../../node_modules/@luma.gl/webgl/dist/adapter/resources/webgl-texture.js
  var DEFAULT_WEBGL_TEXTURE_PROPS = {
    parameters: {},
    pixelStore: {},
    pixels: null,
    border: 0,
    dataFormat: void 0,
    textureUnit: void 0,
    target: void 0
  };
  var WEBGLTexture = class extends import_core13.Texture {
    constructor(device, props) {
      var _this$props;
      super(device, {
        ...DEFAULT_WEBGL_TEXTURE_PROPS,
        format: "rgba8unorm",
        ...props
      });
      this.MAX_ATTRIBUTES = void 0;
      this.device = void 0;
      this.gl = void 0;
      this.gl2 = void 0;
      this.handle = void 0;
      this.sampler = void 0;
      this.glFormat = void 0;
      this.type = void 0;
      this.dataFormat = void 0;
      this.mipmaps = void 0;
      this.target = void 0;
      this.textureUnit = void 0;
      this.loaded = false;
      this._video = void 0;
      this.device = (0, import_core13.cast)(device);
      this.gl = this.device.gl;
      this.gl2 = this.device.gl2;
      this.handle = this.props.handle || this.gl.createTexture();
      this.device.setSpectorMetadata(this.handle, {
        ...this.props,
        data: typeof this.props.data
      });
      this.glFormat = GL.RGBA;
      this.target = getWebGLTextureTarget(this.props);
      this.loaded = false;
      if (typeof ((_this$props = this.props) === null || _this$props === void 0 ? void 0 : _this$props.data) === "string") {
        Object.assign(this.props, {
          data: (0, import_core13.loadImage)(this.props.data)
        });
      }
      this.initialize(this.props);
      Object.seal(this);
    }
    destroy() {
      if (this.handle) {
        this.gl.deleteTexture(this.handle);
        this.removeStats();
        this.trackDeallocatedMemory("Texture");
        this.destroyed = true;
      }
    }
    toString() {
      return `Texture(${this.id},${this.width}x${this.height})`;
    }
    initialize() {
      let props = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      if (this.props.dimension === "cube") {
        return this.initializeCube(props);
      }
      let data = props.data;
      if (data instanceof Promise) {
        data.then((resolvedImageData) => this.initialize(Object.assign({}, props, {
          pixels: resolvedImageData,
          data: resolvedImageData
        })));
        return this;
      }
      const isVideo = typeof HTMLVideoElement !== "undefined" && data instanceof HTMLVideoElement;
      if (isVideo && data.readyState < HTMLVideoElement.HAVE_METADATA) {
        this._video = null;
        data.addEventListener("loadeddata", () => this.initialize(props));
        return this;
      }
      const {
        parameters: parameters2 = {}
      } = props;
      const {
        pixels = null,
        pixelStore = {},
        textureUnit = void 0
      } = props;
      if (!data) {
        data = pixels;
      }
      let {
        width,
        height,
        dataFormat,
        type,
        compressed = false,
        mipmaps = true
      } = props;
      const {
        depth = 0
      } = props;
      const glFormat = convertTextureFormatToGL(props.format, this.device.isWebGL2);
      ({
        width,
        height,
        compressed,
        dataFormat,
        type
      } = this._deduceParameters({
        format: props.format,
        type,
        dataFormat,
        compressed,
        data,
        width,
        height
      }));
      this.width = width;
      this.height = height;
      this.glFormat = glFormat;
      this.type = type;
      this.dataFormat = dataFormat;
      this.textureUnit = textureUnit;
      if (Number.isFinite(this.textureUnit)) {
        this.gl.activeTexture(GL.TEXTURE0 + this.textureUnit);
        this.gl.bindTexture(this.target, this.handle);
      }
      if (mipmaps && this.device.isWebGL1 && isNPOT(this.width, this.height)) {
        import_core13.log.warn(`texture: ${this} is Non-Power-Of-Two, disabling mipmaps`)();
        mipmaps = false;
      }
      this.mipmaps = mipmaps;
      this.setImageData({
        data,
        width,
        height,
        depth,
        format: glFormat,
        type,
        dataFormat,
        parameters: pixelStore,
        compressed
      });
      this.setSampler(props.sampler);
      this._setSamplerParameters(parameters2);
      if (mipmaps) {
        this.generateMipmap();
      }
      if (isVideo) {
        this._video = {
          video: data,
          parameters: parameters2,
          lastTime: data.readyState >= HTMLVideoElement.HAVE_CURRENT_DATA ? data.currentTime : -1
        };
      }
      return this;
    }
    initializeCube(props) {
      const {
        mipmaps = true,
        parameters: parameters2 = {}
      } = props;
      this.setCubeMapImageData(props).then(() => {
        this.loaded = true;
        if (mipmaps) {
          this.generateMipmap(props);
        }
        this.setSampler(props.sampler);
        this._setSamplerParameters(parameters2);
      });
      return this;
    }
    setSampler() {
      let sampler = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      let samplerProps;
      if (sampler instanceof WEBGLSampler) {
        this.sampler = sampler;
        samplerProps = sampler.props;
      } else {
        this.sampler = new WEBGLSampler(this.device, sampler);
        samplerProps = sampler;
      }
      const parameters2 = convertSamplerParametersToWebGL(samplerProps);
      this._setSamplerParameters(parameters2);
      return this;
    }
    resize(options) {
      const {
        height,
        width,
        mipmaps = false
      } = options;
      if (width !== this.width || height !== this.height) {
        return this.initialize({
          width,
          height,
          format: this.format,
          type: this.type,
          dataFormat: this.dataFormat,
          mipmaps
        });
      }
      return this;
    }
    update() {
      if (this._video) {
        const {
          video,
          parameters: parameters2,
          lastTime
        } = this._video;
        if (lastTime === video.currentTime || video.readyState < HTMLVideoElement.HAVE_CURRENT_DATA) {
          return;
        }
        this.setSubImageData({
          data: video,
          parameters: parameters2
        });
        if (this.mipmaps) {
          this.generateMipmap();
        }
        this._video.lastTime = video.currentTime;
      }
    }
    generateMipmap() {
      let params = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      if (this.device.isWebGL1 && isNPOT(this.width, this.height)) {
        import_core13.log.warn(`texture: ${this} is Non-Power-Of-Two, disabling mipmaping`)();
        return this;
      }
      this.mipmaps = true;
      this.gl.bindTexture(this.target, this.handle);
      withGLParameters(this.gl, params, () => {
        this.gl.generateMipmap(this.target);
      });
      this.gl.bindTexture(this.target, null);
      return this;
    }
    setImageData(options) {
      if (this.props.dimension === "3d" || this.props.dimension === "2d-array") {
        return this.setImageData3D(options);
      }
      this.trackDeallocatedMemory("Texture");
      const {
        target = this.target,
        pixels = null,
        level = 0,
        glFormat = this.glFormat,
        offset = 0,
        parameters: parameters2 = {}
      } = options;
      let {
        data = null,
        type = this.type,
        width = this.width,
        height = this.height,
        dataFormat = this.dataFormat,
        compressed = false
      } = options;
      if (!data) {
        data = pixels;
      }
      ({
        type,
        dataFormat,
        compressed,
        width,
        height
      } = this._deduceParameters({
        format: this.props.format,
        type,
        dataFormat,
        compressed,
        data,
        width,
        height
      }));
      const {
        gl
      } = this;
      gl.bindTexture(this.target, this.handle);
      let dataType = null;
      ({
        data,
        dataType
      } = this._getDataType({
        data,
        compressed
      }));
      let gl2;
      withGLParameters(this.gl, parameters2, () => {
        switch (dataType) {
          case "null":
            gl.texImage2D(target, level, glFormat, width, height, 0, dataFormat, type, data);
            break;
          case "typed-array":
            gl.texImage2D(target, level, glFormat, width, height, 0, dataFormat, type, data, offset);
            break;
          case "buffer":
            gl2 = this.device.assertWebGL2();
            gl2.bindBuffer(GL.PIXEL_UNPACK_BUFFER, data.handle || data);
            gl2.texImage2D(target, level, glFormat, width, height, 0, dataFormat, type, offset);
            gl2.bindBuffer(GL.PIXEL_UNPACK_BUFFER, null);
            break;
          case "browser-object":
            if (this.device.isWebGL2) {
              gl.texImage2D(target, level, glFormat, width, height, 0, dataFormat, type, data);
            } else {
              gl.texImage2D(target, level, glFormat, dataFormat, type, data);
            }
            break;
          case "compressed":
            for (const [levelIndex, levelData] of data.entries()) {
              gl.compressedTexImage2D(target, levelIndex, levelData.format, levelData.width, levelData.height, 0, levelData.data);
            }
            break;
          default:
            (0, import_core13.assert)(false, "Unknown image data type");
        }
      });
      if (data && data.byteLength) {
        this.trackAllocatedMemory(data.byteLength, "Texture");
      } else {
        const bytesPerPixel = getTextureFormatBytesPerPixel(this.props.format, this.device.isWebGL2);
        this.trackAllocatedMemory(this.width * this.height * bytesPerPixel, "Texture");
      }
      this.loaded = true;
      return this;
    }
    setSubImageData(_ref) {
      let {
        target = this.target,
        pixels = null,
        data = null,
        x = 0,
        y = 0,
        width = this.width,
        height = this.height,
        level = 0,
        glFormat = this.glFormat,
        type = this.type,
        dataFormat = this.dataFormat,
        compressed = false,
        offset = 0,
        parameters: parameters2 = {}
      } = _ref;
      ({
        type,
        dataFormat,
        compressed,
        width,
        height
      } = this._deduceParameters({
        format: this.props.format,
        type,
        dataFormat,
        compressed,
        data,
        width,
        height
      }));
      (0, import_core13.assert)(this.depth === 1, "texSubImage not supported for 3D textures");
      if (!data) {
        data = pixels;
      }
      if (data && data.data) {
        const ndarray = data;
        data = ndarray.data;
        width = ndarray.shape[0];
        height = ndarray.shape[1];
      }
      if (data instanceof WEBGLBuffer) {
        data = data.handle;
      }
      this.gl.bindTexture(this.target, this.handle);
      withGLParameters(this.gl, parameters2, () => {
        if (compressed) {
          this.gl.compressedTexSubImage2D(target, level, x, y, width, height, glFormat, data);
        } else if (data === null) {
          this.gl.texSubImage2D(target, level, x, y, width, height, dataFormat, type, null);
        } else if (ArrayBuffer.isView(data)) {
          this.gl.texSubImage2D(target, level, x, y, width, height, dataFormat, type, data, offset);
        } else if (typeof WebGLBuffer !== "undefined" && data instanceof WebGLBuffer) {
          const gl2 = this.device.assertWebGL2();
          gl2.bindBuffer(GL.PIXEL_UNPACK_BUFFER, data);
          gl2.texSubImage2D(target, level, x, y, width, height, dataFormat, type, offset);
          gl2.bindBuffer(GL.PIXEL_UNPACK_BUFFER, null);
        } else if (this.device.isWebGL2) {
          const gl2 = this.device.assertWebGL2();
          gl2.texSubImage2D(target, level, x, y, width, height, dataFormat, type, data);
        } else {
          this.gl.texSubImage2D(target, level, x, y, dataFormat, type, data);
        }
      });
      this.gl.bindTexture(this.target, null);
    }
    copyFramebuffer() {
      let opts = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      import_core13.log.error("Texture.copyFramebuffer({...}) is no logner supported, use copyToTexture(source, target, opts})")();
      return null;
    }
    getActiveUnit() {
      return this.gl.getParameter(GL.ACTIVE_TEXTURE) - GL.TEXTURE0;
    }
    bind() {
      let textureUnit = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.textureUnit;
      const {
        gl
      } = this;
      if (textureUnit !== void 0) {
        this.textureUnit = textureUnit;
        gl.activeTexture(gl.TEXTURE0 + textureUnit);
      }
      gl.bindTexture(this.target, this.handle);
      return textureUnit;
    }
    unbind() {
      let textureUnit = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.textureUnit;
      const {
        gl
      } = this;
      if (textureUnit !== void 0) {
        this.textureUnit = textureUnit;
        gl.activeTexture(gl.TEXTURE0 + textureUnit);
      }
      gl.bindTexture(this.target, null);
      return textureUnit;
    }
    _getDataType(_ref2) {
      let {
        data,
        compressed = false
      } = _ref2;
      if (compressed) {
        return {
          data,
          dataType: "compressed"
        };
      }
      if (data === null) {
        return {
          data,
          dataType: "null"
        };
      }
      if (ArrayBuffer.isView(data)) {
        return {
          data,
          dataType: "typed-array"
        };
      }
      if (data instanceof WEBGLBuffer) {
        return {
          data: data.handle,
          dataType: "buffer"
        };
      }
      if (typeof WebGLBuffer !== "undefined" && data instanceof WebGLBuffer) {
        return {
          data,
          dataType: "buffer"
        };
      }
      return {
        data,
        dataType: "browser-object"
      };
    }
    _deduceParameters(opts) {
      const {
        format,
        data
      } = opts;
      let {
        width,
        height,
        dataFormat,
        type,
        compressed
      } = opts;
      const parameters2 = getWebGLTextureParameters(format, this.device.isWebGL2);
      dataFormat = dataFormat || parameters2.dataFormat;
      type = type || parameters2.type;
      compressed = compressed || parameters2.compressed;
      ({
        width,
        height
      } = this._deduceImageSize(data, width, height));
      return {
        dataFormat,
        type,
        compressed,
        width,
        height,
        format,
        data
      };
    }
    _deduceImageSize(data, width, height) {
      let size;
      if (typeof ImageData !== "undefined" && data instanceof ImageData) {
        size = {
          width: data.width,
          height: data.height
        };
      } else if (typeof HTMLImageElement !== "undefined" && data instanceof HTMLImageElement) {
        size = {
          width: data.naturalWidth,
          height: data.naturalHeight
        };
      } else if (typeof HTMLCanvasElement !== "undefined" && data instanceof HTMLCanvasElement) {
        size = {
          width: data.width,
          height: data.height
        };
      } else if (typeof ImageBitmap !== "undefined" && data instanceof ImageBitmap) {
        size = {
          width: data.width,
          height: data.height
        };
      } else if (typeof HTMLVideoElement !== "undefined" && data instanceof HTMLVideoElement) {
        size = {
          width: data.videoWidth,
          height: data.videoHeight
        };
      } else if (!data) {
        size = {
          width: width >= 0 ? width : 1,
          height: height >= 0 ? height : 1
        };
      } else {
        size = {
          width,
          height
        };
      }
      (0, import_core13.assert)(size, "Could not deduced texture size");
      (0, import_core13.assert)(width === void 0 || size.width === width, "Deduced texture width does not match supplied width");
      (0, import_core13.assert)(height === void 0 || size.height === height, "Deduced texture height does not match supplied height");
      return size;
    }
    async setCubeMapImageData(options) {
      const {
        gl
      } = this;
      const {
        width,
        height,
        pixels,
        data,
        format = GL.RGBA,
        type = GL.UNSIGNED_BYTE
      } = options;
      const imageDataMap = pixels || data;
      const resolvedFaces = await Promise.all(WEBGLTexture.FACES.map((face) => {
        const facePixels = imageDataMap[face];
        return Promise.all(Array.isArray(facePixels) ? facePixels : [facePixels]);
      }));
      this.bind();
      WEBGLTexture.FACES.forEach((face, index) => {
        if (resolvedFaces[index].length > 1 && this.props.mipmaps !== false) {
          import_core13.log.warn(`${this.id} has mipmap and multiple LODs.`)();
        }
        resolvedFaces[index].forEach((image, lodLevel) => {
          if (width && height) {
            gl.texImage2D(face, lodLevel, format, width, height, 0, format, type, image);
          } else {
            gl.texImage2D(face, lodLevel, format, format, type, image);
          }
        });
      });
      this.unbind();
    }
    setImageDataForFace(options) {
      const {
        face,
        width,
        height,
        pixels,
        data,
        format = GL.RGBA,
        type = GL.UNSIGNED_BYTE
      } = options;
      const {
        gl
      } = this;
      const imageData = pixels || data;
      this.bind();
      if (imageData instanceof Promise) {
        imageData.then((resolvedImageData) => this.setImageDataForFace(Object.assign({}, options, {
          face,
          data: resolvedImageData,
          pixels: resolvedImageData
        })));
      } else if (this.width || this.height) {
        gl.texImage2D(face, 0, format, width, height, 0, format, type, imageData);
      } else {
        gl.texImage2D(face, 0, format, format, type, imageData);
      }
      return this;
    }
    setImageData3D(options) {
      const {
        level = 0,
        dataFormat,
        format,
        type,
        width,
        height,
        depth = 1,
        offset = 0,
        data,
        parameters: parameters2 = {}
      } = options;
      this.trackDeallocatedMemory("Texture");
      this.gl.bindTexture(this.target, this.handle);
      const webglTextureFormat = getWebGLTextureParameters(format, this.device.isWebGL2);
      withGLParameters(this.gl, parameters2, () => {
        if (ArrayBuffer.isView(data)) {
          this.gl.texImage3D(this.target, level, webglTextureFormat.format, width, height, depth, 0, webglTextureFormat.dataFormat, webglTextureFormat.type, data);
        }
        if (data instanceof WEBGLBuffer) {
          this.gl.bindBuffer(GL.PIXEL_UNPACK_BUFFER, data.handle);
          this.gl.texImage3D(this.target, level, dataFormat, width, height, depth, 0, format, type, offset);
        }
      });
      if (data && data.byteLength) {
        this.trackAllocatedMemory(data.byteLength, "Texture");
      } else {
        const bytesPerPixel = getTextureFormatBytesPerPixel(this.props.format, this.device.isWebGL2);
        this.trackAllocatedMemory(this.width * this.height * this.depth * bytesPerPixel, "Texture");
      }
      this.loaded = true;
      return this;
    }
    _setSamplerParameters(parameters2) {
      if (this.device.isWebGL1 && isNPOT(this.width, this.height)) {
        parameters2 = updateSamplerParametersForNPOT(parameters2);
      }
      if ((0, import_core12.isObjectEmpty)(parameters2)) {
        return;
      }
      logParameters(parameters2);
      this.gl.bindTexture(this.target, this.handle);
      for (const [pname, pvalue] of Object.entries(parameters2)) {
        const param = Number(pname);
        const value = pvalue;
        switch (param) {
          case GL.TEXTURE_MIN_LOD:
          case GL.TEXTURE_MAX_LOD:
            this.gl.texParameterf(this.target, param, value);
            break;
          default:
            this.gl.texParameteri(this.target, param, value);
            break;
        }
      }
      this.gl.bindTexture(this.target, null);
      return;
    }
    _getWebGL1NPOTParameterOverride(pname, value) {
      const npot = this.device.isWebGL1 && isNPOT(this.width, this.height);
      if (npot) {
        switch (pname) {
          case GL.TEXTURE_MIN_FILTER:
            if (value !== GL.LINEAR && value !== GL.NEAREST) {
              return GL.LINEAR;
            }
            break;
          case GL.TEXTURE_WRAP_S:
          case GL.TEXTURE_WRAP_T:
            return GL.CLAMP_TO_EDGE;
          default:
            break;
        }
      }
      return value;
    }
  };
  WEBGLTexture.FACES = [GL.TEXTURE_CUBE_MAP_POSITIVE_X, GL.TEXTURE_CUBE_MAP_NEGATIVE_X, GL.TEXTURE_CUBE_MAP_POSITIVE_Y, GL.TEXTURE_CUBE_MAP_NEGATIVE_Y, GL.TEXTURE_CUBE_MAP_POSITIVE_Z, GL.TEXTURE_CUBE_MAP_NEGATIVE_Z];
  function getWebGLTextureTarget(props) {
    switch (props.dimension) {
      case "2d":
        return GL.TEXTURE_2D;
      case "cube":
        return GL.TEXTURE_CUBE_MAP;
      case "2d-array":
        return GL.TEXTURE_2D_ARRAY;
      case "3d":
        return GL.TEXTURE_3D;
      case "1d":
      case "cube-array":
      default:
        throw new Error(props.dimension);
    }
  }
  function isNPOT(width, height) {
    if (!width || !height) {
      return false;
    }
    return !(0, import_core13.isPowerOfTwo)(width) || !(0, import_core13.isPowerOfTwo)(height);
  }
  function logParameters(parameters2) {
    import_core13.log.log(1, "texture sampler parameters", parameters2)();
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/objects/webgl-renderbuffer.js
  var import_core16 = __toESM(require_core2(), 1);

  // ../../node_modules/@luma.gl/webgl/dist/adapter/objects/webgl-resource.js
  var import_core15 = __toESM(require_core2(), 1);

  // ../../node_modules/@luma.gl/webgl/dist/adapter/objects/constants-to-keys.js
  var import_core14 = __toESM(require_core2(), 1);
  function getKeyValue(gl, name) {
    if (typeof name !== "string") {
      return name;
    }
    const number = Number(name);
    if (!isNaN(number)) {
      return number;
    }
    name = name.replace(/^.*\./, "");
    const value = gl[name];
    (0, import_core14.assert)(value !== void 0, `Accessing undefined constant GL.${name}`);
    return value;
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/objects/webgl-resource.js
  var ERR_RESOURCE_METHOD_UNDEFINED = "Resource subclass must define virtual methods";
  var WebGLResource = class extends import_core15.Resource {
    constructor(device, props, defaultProps9) {
      super(device, props, defaultProps9);
      this.device = void 0;
      this.gl = void 0;
      this.gl2 = void 0;
      this._handle = void 0;
      this._bound = false;
      this.byteLength = 0;
      this.device = WebGLDevice.attach(device);
      const gl = this.device.gl;
      assertWebGLContext(gl);
      const {
        id
      } = props || {};
      this.gl = gl;
      this.gl2 = gl;
      this.id = id || (0, import_core15.uid)(this.constructor.name);
      this._handle = props === null || props === void 0 ? void 0 : props.handle;
      if (this._handle === void 0) {
        this._handle = this._createHandle();
      }
      this.byteLength = 0;
    }
    toString() {
      return `${this.constructor.name}(${this.id})`;
    }
    get handle() {
      return this._handle;
    }
    delete() {
      let {
        deleteChildren = false
      } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      const children = this._handle && this._deleteHandle(this._handle);
      if (this._handle) {
        this.removeStats();
      }
      this._handle = null;
      if (children && deleteChildren) {
        children.filter(Boolean).forEach((child) => child.destroy());
      }
      return this;
    }
    bind() {
      let funcOrHandle = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.handle;
      if (typeof funcOrHandle !== "function") {
        this._bindHandle(funcOrHandle);
        return this;
      }
      let value;
      if (!this._bound) {
        this._bindHandle(this.handle);
        this._bound = true;
        value = funcOrHandle();
        this._bound = false;
        this._bindHandle(null);
      } else {
        value = funcOrHandle();
      }
      return value;
    }
    unbind() {
      this.bind(null);
    }
    getParameter(pname) {
      let props = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
      pname = getKeyValue(this.gl, pname);
      (0, import_core15.assert)(pname);
      const parameters2 = this.constructor.PARAMETERS || {};
      const parameter = parameters2[pname];
      if (parameter) {
        const isWebgl2 = isWebGL2(this.gl);
        const parameterAvailable = (!("webgl2" in parameter) || isWebgl2) && (!("extension" in parameter) || this.gl.getExtension(parameter.extension));
        if (!parameterAvailable) {
          const webgl1Default = parameter.webgl1;
          const webgl2Default = "webgl2" in parameter ? parameter.webgl2 : parameter.webgl1;
          const defaultValue = isWebgl2 ? webgl2Default : webgl1Default;
          return defaultValue;
        }
      }
      return this._getParameter(pname, props);
    }
    getParameters() {
      let options = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      const {
        parameters: parameters2,
        keys
      } = options;
      const PARAMETERS = this.constructor.PARAMETERS || {};
      const isWebgl2 = isWebGL2(this.gl);
      const values = {};
      const parameterKeys = parameters2 || Object.keys(PARAMETERS);
      for (const pname of parameterKeys) {
        const parameter = PARAMETERS[pname];
        const parameterAvailable = parameter && (!("webgl2" in parameter) || isWebgl2) && (!("extension" in parameter) || this.gl.getExtension(parameter.extension));
        if (parameterAvailable) {
          const key = keys ? this.device.getGLKey(pname) : pname;
          values[key] = this.getParameter(pname, options);
          if (keys && parameter.type === "GLenum") {
            values[key] = this.device.getGLKey(values[key]);
          }
        }
      }
      return values;
    }
    setParameter(pname, value) {
      pname = getKeyValue(this.gl, pname);
      (0, import_core15.assert)(pname);
      const parameters2 = this.constructor.PARAMETERS || {};
      const parameter = parameters2[pname];
      if (parameter) {
        const isWebgl2 = isWebGL2(this.gl);
        const parameterAvailable = (!("webgl2" in parameter) || isWebgl2) && (!("extension" in parameter) || this.gl.getExtension(parameter.extension));
        if (!parameterAvailable) {
          throw new Error("Parameter not available on this platform");
        }
        if (parameter.type === "GLenum") {
          value = getKeyValue(value);
        }
      }
      this._setParameter(pname, value);
      return this;
    }
    setParameters(parameters2) {
      for (const pname in parameters2) {
        this.setParameter(pname, parameters2[pname]);
      }
      return this;
    }
    stubRemovedMethods(className, version, methodNames) {
      return (0, import_core15.stubRemovedMethods)(this, className, version, methodNames);
    }
    initialize(props) {
    }
    _createHandle() {
      throw new Error(ERR_RESOURCE_METHOD_UNDEFINED);
    }
    _deleteHandle() {
      throw new Error(ERR_RESOURCE_METHOD_UNDEFINED);
    }
    _bindHandle(handle) {
      throw new Error(ERR_RESOURCE_METHOD_UNDEFINED);
    }
    _getOptsFromHandle() {
      throw new Error(ERR_RESOURCE_METHOD_UNDEFINED);
    }
    _getParameter(pname, props) {
      throw new Error(ERR_RESOURCE_METHOD_UNDEFINED);
    }
    _setParameter(pname, value) {
      throw new Error(ERR_RESOURCE_METHOD_UNDEFINED);
    }
  };

  // ../../node_modules/@luma.gl/webgl/dist/adapter/objects/webgl-renderbuffer.js
  var _Symbol$toStringTag;
  _Symbol$toStringTag = Symbol.toStringTag;
  var WEBGLRenderbuffer = class extends WebGLResource {
    get [_Symbol$toStringTag]() {
      return "Renderbuffer";
    }
    get width() {
      return this.props.width;
    }
    get height() {
      return this.props.height;
    }
    get format() {
      return this.props.format;
    }
    get samples() {
      return this.props.samples;
    }
    get attachment() {
      return;
    }
    static isTextureFormatSupported(device, format) {
      return isRenderbufferFormatSupported(device.gl, format);
    }
    constructor(device, props) {
      if (typeof props.format === "number") {
        throw new Error("Renderbuffer");
      }
      super(device, props, WEBGLRenderbuffer.defaultProps);
      this.glFormat = void 0;
      this.glFormat = convertTextureFormatToGL(this.props.format, device.isWebGL2);
      this._initialize(this.props);
    }
    resize(size) {
      if (size.width !== this.width || size.height !== this.height) {
        Object.assign(this.props, {
          ...size,
          format: this.format,
          samples: this.samples
        });
        this._initialize(this.props);
      }
    }
    _initialize(props) {
      const {
        format,
        width,
        height,
        samples
      } = props;
      (0, import_core16.assert)(format, "Needs format");
      this.trackDeallocatedMemory();
      this.gl.bindRenderbuffer(GL.RENDERBUFFER, this.handle);
      if (samples !== 0 && this.device.isWebGL2) {
        this.gl2.renderbufferStorageMultisample(GL.RENDERBUFFER, samples, this.glFormat, width, height);
      } else {
        this.gl.renderbufferStorage(GL.RENDERBUFFER, this.glFormat, width, height);
      }
      this.gl.bindRenderbuffer(GL.RENDERBUFFER, null);
      this.trackAllocatedMemory(width * height * (samples || 1) * getTextureFormatBytesPerPixel(this.glFormat, this.device.isWebGL2));
    }
    _createHandle() {
      return this.gl.createRenderbuffer();
    }
    _deleteHandle() {
      this.gl.deleteRenderbuffer(this.handle);
      this.trackDeallocatedMemory();
    }
    _bindHandle(handle) {
      this.gl.bindRenderbuffer(GL.RENDERBUFFER, handle);
    }
  };
  WEBGLRenderbuffer.defaultProps = {
    id: void 0,
    handle: void 0,
    userData: void 0,
    format: void 0,
    width: 1,
    height: 1,
    samples: 0
  };

  // ../../node_modules/@luma.gl/webgl/dist/adapter/resources/webgl-framebuffer.js
  var WEBGLFramebuffer = class extends import_core17.Framebuffer {
    get texture() {
      return this.colorAttachments[0];
    }
    constructor(device, props) {
      super(device, props);
      this.device = void 0;
      this.gl = void 0;
      this.handle = void 0;
      const isDefaultFramebuffer = props.handle === null;
      this.device = device;
      this.gl = device.gl;
      this.handle = this.props.handle || isDefaultFramebuffer ? this.props.handle : this.gl.createFramebuffer();
      if (!isDefaultFramebuffer) {
        device.setSpectorMetadata(this.handle, {
          id: this.props.id,
          props: this.props
        });
        this.autoCreateAttachmentTextures();
        this.gl.bindFramebuffer(GL.FRAMEBUFFER, this.handle);
        for (let i = 0; i < this.colorAttachments.length; ++i) {
          const attachment = this.colorAttachments[i];
          const attachmentPoint = GL.COLOR_ATTACHMENT0 + i;
          if (attachment) {
            this._attachOne(attachmentPoint, attachment);
          }
        }
        if (this.depthStencilAttachment) {
          this._attachOne(getDepthStencilAttachmentWebGL(this.depthStencilAttachment.format), this.depthStencilAttachment);
        }
        this.gl.bindFramebuffer(GL.FRAMEBUFFER, null);
      }
      if (props.check !== false) {
        this._checkStatus();
      }
    }
    destroy() {
      super.destroy();
      if (!this.destroyed && this.handle !== null) {
        this.gl.deleteFramebuffer(this.handle);
      }
    }
    _checkStatus() {
      const {
        gl
      } = this;
      const prevHandle = gl.bindFramebuffer(GL.FRAMEBUFFER, this.handle);
      const status = gl.checkFramebufferStatus(GL.FRAMEBUFFER);
      gl.bindFramebuffer(GL.FRAMEBUFFER, prevHandle || null);
      if (status !== gl.FRAMEBUFFER_COMPLETE) {
        throw new Error(`Framebuffer ${_getFrameBufferStatus(status)}`);
      }
    }
    createDepthStencilTexture(format) {
      return new WEBGLRenderbuffer(this.device, {
        id: `${this.id}-depth-stencil`,
        format,
        width: this.width,
        height: this.height
      });
    }
    resizeAttachments(width, height) {
      if (this.handle === null) {
        this.width = this.gl.drawingBufferWidth;
        this.height = this.gl.drawingBufferHeight;
        return this;
      }
      if (width === void 0) {
        width = this.gl.drawingBufferWidth;
      }
      if (height === void 0) {
        height = this.gl.drawingBufferHeight;
      }
      for (const colorAttachment of this.colorAttachments) {
        colorAttachment.resize({
          width,
          height
        });
      }
      if (this.depthStencilAttachment) {
        this.depthStencilAttachment.resize({
          width,
          height
        });
      }
      return this;
    }
    _attachOne(attachmentPoint, attachment) {
      if (attachment instanceof WEBGLRenderbuffer) {
        this._attachWEBGLRenderbuffer(attachmentPoint, attachment);
        return attachment;
      } else if (Array.isArray(attachment)) {
        const [texture, layer = 0, level = 0] = attachment;
        this._attachTexture(attachmentPoint, texture, layer, level);
        return texture;
      } else if (attachment instanceof WEBGLTexture) {
        this._attachTexture(attachmentPoint, attachment, 0, 0);
        return attachment;
      }
      throw new Error("attach");
    }
    _attachWEBGLRenderbuffer(attachment, renderbuffer) {
      this.gl.framebufferRenderbuffer(GL.FRAMEBUFFER, attachment, GL.RENDERBUFFER, renderbuffer.handle);
    }
    _attachTexture(attachment, texture, layer, level) {
      const {
        gl,
        gl2
      } = this.device;
      gl.bindTexture(texture.target, texture.handle);
      switch (texture.target) {
        case GL.TEXTURE_2D_ARRAY:
        case GL.TEXTURE_3D:
          this.device.assertWebGL2();
          gl2 === null || gl2 === void 0 ? void 0 : gl2.framebufferTextureLayer(GL.FRAMEBUFFER, attachment, texture.target, level, layer);
          break;
        case GL.TEXTURE_CUBE_MAP:
          const face = mapIndexToCubeMapFace(layer);
          gl.framebufferTexture2D(GL.FRAMEBUFFER, attachment, face, texture.handle, level);
          break;
        case GL.TEXTURE_2D:
          gl.framebufferTexture2D(GL.FRAMEBUFFER, attachment, GL.TEXTURE_2D, texture.handle, level);
          break;
        default:
          (0, import_core17.assert)(false, "Illegal texture type");
      }
      gl.bindTexture(texture.target, null);
    }
  };
  function mapIndexToCubeMapFace(layer) {
    return layer < GL.TEXTURE_CUBE_MAP_POSITIVE_X ? layer + GL.TEXTURE_CUBE_MAP_POSITIVE_X : layer;
  }
  function _getFrameBufferStatus(status) {
    switch (status) {
      case GL.FRAMEBUFFER_COMPLETE:
        return "success";
      case GL.FRAMEBUFFER_INCOMPLETE_ATTACHMENT:
        return "Mismatched attachments";
      case GL.FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT:
        return "No attachments";
      case GL.FRAMEBUFFER_INCOMPLETE_DIMENSIONS:
        return "Height/width mismatch";
      case GL.FRAMEBUFFER_UNSUPPORTED:
        return "Unsupported or split attachments";
      case GL.FRAMEBUFFER_INCOMPLETE_MULTISAMPLE:
        return "Samples mismatch";
      default:
        return `${status}`;
    }
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/webgl-canvas-context.js
  var WebGLCanvasContext = class extends import_core18.CanvasContext {
    constructor(device, props) {
      super(props);
      this.device = void 0;
      this.presentationSize = void 0;
      this._framebuffer = null;
      this.device = device;
      this.presentationSize = [-1, -1];
      this._setAutoCreatedCanvasId(`${this.device.id}-canvas`);
      this.update();
    }
    getCurrentFramebuffer() {
      this.update();
      this._framebuffer = this._framebuffer || new WEBGLFramebuffer(this.device, {
        handle: null
      });
      return this._framebuffer;
    }
    update() {
      const size = this.getPixelSize();
      const sizeChanged = size[0] !== this.presentationSize[0] || size[1] !== this.presentationSize[1];
      if (sizeChanged) {
        this.presentationSize = size;
      }
    }
    resize(options) {
      if (this.canvas) {
        const devicePixelRatio = this.getDevicePixelRatio(options === null || options === void 0 ? void 0 : options.useDevicePixels);
        this.setDevicePixelRatio(devicePixelRatio, options);
        return;
      }
      const ext = this.device.gl.getExtension("STACKGL_resize_drawingbuffer");
      if (ext && options && "width" in options && "height" in options) {
        ext.resize(options.width, options.height);
      }
    }
    commit() {
    }
  };

  // ../../node_modules/@luma.gl/webgl/dist/context/debug/spector.js
  var import_core19 = __toESM(require_core2(), 1);
  var DEFAULT_SPECTOR_PROPS = {
    spector: import_core19.log.get("spector") || import_core19.log.get("inspect")
  };
  var SPECTOR_CDN_URL = "https://spectorcdn.babylonjs.com/spector.bundle.js";
  var LOG_LEVEL = 1;
  var spector = null;
  var initialized = false;
  async function loadSpectorJS(props) {
    if (!globalThis.SPECTOR) {
      try {
        await (0, import_core19.loadScript)(SPECTOR_CDN_URL);
      } catch (error2) {
        import_core19.log.warn(String(error2));
      }
    }
  }
  function initializeSpectorJS(props) {
    var _props, _props2;
    props = {
      ...DEFAULT_SPECTOR_PROPS,
      ...props
    };
    if (!((_props = props) !== null && _props !== void 0 && _props.spector)) {
      return null;
    }
    if (!spector && globalThis.SPECTOR) {
      import_core19.log.probe(LOG_LEVEL, "SPECTOR found and initialized")();
      spector = new globalThis.SPECTOR.Spector();
      if (globalThis.luma) {
        globalThis.luma.spector = spector;
      }
    }
    if (!spector) {
      return null;
    }
    if (!initialized) {
      var _spector, _spector2;
      initialized = true;
      spector.spyCanvases();
      (_spector = spector) === null || _spector === void 0 ? void 0 : _spector.onCaptureStarted.add((capture) => import_core19.log.info("Spector capture started:", capture)());
      (_spector2 = spector) === null || _spector2 === void 0 ? void 0 : _spector2.onCapture.add((capture) => {
        var _spector3, _spector4, _spector5;
        import_core19.log.info("Spector capture complete:", capture)();
        (_spector3 = spector) === null || _spector3 === void 0 ? void 0 : _spector3.getResultUI();
        (_spector4 = spector) === null || _spector4 === void 0 ? void 0 : _spector4.resultView.display();
        (_spector5 = spector) === null || _spector5 === void 0 ? void 0 : _spector5.resultView.addCapture(capture);
      });
    }
    if ((_props2 = props) !== null && _props2 !== void 0 && _props2.canvas) {
      var _spector6, _props3;
      if (typeof props.spector === "string" && props.spector !== props.canvas.id) {
        return spector;
      }
      (_spector6 = spector) === null || _spector6 === void 0 ? void 0 : _spector6.startCapture((_props3 = props) === null || _props3 === void 0 ? void 0 : _props3.canvas, 500);
      new Promise((resolve) => setTimeout(resolve, 2e3)).then((_) => {
        var _spector7;
        import_core19.log.info("Spector capture stopped after 2 seconds")();
        (_spector7 = spector) === null || _spector7 === void 0 ? void 0 : _spector7.stopCapture();
      });
    }
    return spector;
  }

  // ../../node_modules/@luma.gl/webgl/dist/context/debug/webgl-developer-tools.js
  var import_core20 = __toESM(require_core2(), 1);
  var WEBGL_DEBUG_CDN_URL = "https://unpkg.com/webgl-debug@2.0.1/index.js";
  function getContextData2(gl) {
    gl.luma = gl.luma || {};
    return gl.luma;
  }
  async function loadWebGLDeveloperTools() {
    if (isBrowser() && !globalThis.WebGLDebugUtils) {
      globalThis.global = globalThis.global || globalThis;
      globalThis.global.module = {};
      await (0, import_core20.loadScript)(WEBGL_DEBUG_CDN_URL);
    }
  }
  function makeDebugContext(gl) {
    let props = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    if (!gl) {
      return null;
    }
    return props.debug ? getDebugContext(gl, props) : getRealContext(gl);
  }
  function getRealContext(gl) {
    const data = getContextData2(gl);
    return data.realContext ? data.realContext : gl;
  }
  function getDebugContext(gl, props) {
    if (!globalThis.WebGLDebugUtils) {
      import_core20.log.warn("webgl-debug not loaded")();
      return gl;
    }
    const data = getContextData2(gl);
    if (data.debugContext) {
      return data.debugContext;
    }
    globalThis.WebGLDebugUtils.init({
      ...GL,
      ...gl
    });
    const glDebug = globalThis.WebGLDebugUtils.makeDebugContext(gl, onGLError.bind(null, props), onValidateGLFunc.bind(null, props));
    for (const key in GL) {
      if (!(key in glDebug) && typeof GL[key] === "number") {
        glDebug[key] = GL[key];
      }
    }
    class WebGLDebugContext {
    }
    Object.setPrototypeOf(glDebug, Object.getPrototypeOf(gl));
    Object.setPrototypeOf(WebGLDebugContext, glDebug);
    const debugContext = Object.create(WebGLDebugContext);
    data.realContext = gl;
    data.debugContext = debugContext;
    debugContext.debug = true;
    return debugContext;
  }
  function getFunctionString(functionName, functionArgs) {
    functionArgs = Array.from(functionArgs).map((arg) => arg === void 0 ? "undefined" : arg);
    let args = globalThis.WebGLDebugUtils.glFunctionArgsToString(functionName, functionArgs);
    args = `${args.slice(0, 100)}${args.length > 100 ? "..." : ""}`;
    return `gl.${functionName}(${args})`;
  }
  function onGLError(props, err, functionName, args) {
    args = Array.from(args).map((arg) => arg === void 0 ? "undefined" : arg);
    const errorMessage = globalThis.WebGLDebugUtils.glEnumToString(err);
    const functionArgs = globalThis.WebGLDebugUtils.glFunctionArgsToString(functionName, args);
    const glName = props.webgl2 ? "gl2" : "gl1";
    const message2 = `${errorMessage} in ${glName}.${functionName}(${functionArgs})`;
    import_core20.log.error(message2)();
    debugger;
    if (props.throwOnError) {
      throw new Error(message2);
    }
  }
  function onValidateGLFunc(props, functionName, functionArgs) {
    let functionString = "";
    if (import_core20.log.level >= 1) {
      functionString = getFunctionString(functionName, functionArgs);
      import_core20.log.log(1, functionString)();
    }
    if (props.break && props.break.length > 0) {
      functionString = functionString || getFunctionString(functionName, functionArgs);
      const isBreakpoint = props.break.every((breakOn) => functionString.indexOf(breakOn) !== -1);
      if (isBreakpoint) {
        debugger;
      }
    }
    for (const arg of functionArgs) {
      if (arg === void 0) {
        functionString = functionString || getFunctionString(functionName, functionArgs);
        if (props.throwOnError) {
          throw new Error(`Undefined argument: ${functionString}`);
        } else {
          import_core20.log.error(`Undefined argument: ${functionString}`)();
          debugger;
        }
      }
    }
  }

  // ../../node_modules/@luma.gl/webgl/dist/classic/buffer-with-accessor.js
  var import_core22 = __toESM(require_core2(), 1);

  // ../../node_modules/@luma.gl/webgl/dist/classic/accessor.js
  var import_core21 = __toESM(require_core2(), 1);

  // ../../node_modules/@luma.gl/webgl/dist/classic/typed-array-utils.js
  var ERR_TYPE_DEDUCTION = "Failed to deduce GL constant from typed array";
  function getGLTypeFromTypedArray(arrayOrType) {
    const type = ArrayBuffer.isView(arrayOrType) ? arrayOrType.constructor : arrayOrType;
    switch (type) {
      case Float32Array:
        return GL.FLOAT;
      case Uint16Array:
        return GL.UNSIGNED_SHORT;
      case Uint32Array:
        return GL.UNSIGNED_INT;
      case Uint8Array:
        return GL.UNSIGNED_BYTE;
      case Uint8ClampedArray:
        return GL.UNSIGNED_BYTE;
      case Int8Array:
        return GL.BYTE;
      case Int16Array:
        return GL.SHORT;
      case Int32Array:
        return GL.INT;
      default:
        throw new Error(ERR_TYPE_DEDUCTION);
    }
  }
  function getTypedArrayFromGLType(glType, options) {
    const {
      clamped = true
    } = options || {};
    switch (glType) {
      case GL.FLOAT:
        return Float32Array;
      case GL.UNSIGNED_SHORT:
      case GL.UNSIGNED_SHORT_5_6_5:
      case GL.UNSIGNED_SHORT_4_4_4_4:
      case GL.UNSIGNED_SHORT_5_5_5_1:
        return Uint16Array;
      case GL.UNSIGNED_INT:
        return Uint32Array;
      case GL.UNSIGNED_BYTE:
        return clamped ? Uint8ClampedArray : Uint8Array;
      case GL.BYTE:
        return Int8Array;
      case GL.SHORT:
        return Int16Array;
      case GL.INT:
        return Int32Array;
      default:
        throw new Error("Failed to deduce typed array type from GL constant");
    }
  }

  // ../../node_modules/@luma.gl/webgl/dist/classic/accessor.js
  var DEFAULT_ACCESSOR_VALUES = {
    offset: 0,
    stride: 0,
    type: GL.FLOAT,
    size: 1,
    divisor: 0,
    normalized: false,
    integer: false
  };
  var PROP_CHECKS = {
    deprecatedProps: {
      instanced: "divisor",
      isInstanced: "divisor"
    }
  };
  var Accessor = class {
    static getBytesPerElement(accessor) {
      const ArrayType = getTypedArrayFromGLType(accessor.type || GL.FLOAT);
      return ArrayType.BYTES_PER_ELEMENT;
    }
    static getBytesPerVertex(accessor) {
      (0, import_core21.assert)(accessor.size);
      const ArrayType = getTypedArrayFromGLType(accessor.type || GL.FLOAT);
      return ArrayType.BYTES_PER_ELEMENT * accessor.size;
    }
    static resolve() {
      for (var _len = arguments.length, accessors = new Array(_len), _key = 0; _key < _len; _key++) {
        accessors[_key] = arguments[_key];
      }
      return new Accessor(...[DEFAULT_ACCESSOR_VALUES, ...accessors]);
    }
    constructor() {
      this.offset = void 0;
      this.stride = void 0;
      this.type = void 0;
      this.size = void 0;
      this.divisor = void 0;
      this.normalized = void 0;
      this.integer = void 0;
      this.buffer = void 0;
      this.index = void 0;
      for (var _len2 = arguments.length, accessors = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        accessors[_key2] = arguments[_key2];
      }
      accessors.forEach((accessor) => this._assign(accessor));
      Object.freeze(this);
    }
    toString() {
      return JSON.stringify(this);
    }
    get BYTES_PER_ELEMENT() {
      return Accessor.getBytesPerElement(this);
    }
    get BYTES_PER_VERTEX() {
      return Accessor.getBytesPerVertex(this);
    }
    _assign() {
      let props = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      props = (0, import_core21.checkProps)("Accessor", props, PROP_CHECKS);
      if (props.type !== void 0) {
        this.type = props.type;
        if (props.type === GL.INT || props.type === GL.UNSIGNED_INT) {
          this.integer = true;
        }
      }
      if (props.size !== void 0) {
        this.size = props.size;
      }
      if (props.offset !== void 0) {
        this.offset = props.offset;
      }
      if (props.stride !== void 0) {
        this.stride = props.stride;
      }
      if (props.normalize !== void 0) {
        this.normalized = props.normalize;
      }
      if (props.normalized !== void 0) {
        this.normalized = props.normalized;
      }
      if (props.integer !== void 0) {
        this.integer = props.integer;
      }
      if (props.divisor !== void 0) {
        this.divisor = props.divisor;
      }
      if (props.buffer !== void 0) {
        this.buffer = props.buffer;
      }
      if (props.index !== void 0) {
        if (typeof props.index === "boolean") {
          this.index = props.index ? 1 : 0;
        } else {
          this.index = props.index;
        }
      }
      if (props.instanced !== void 0) {
        this.divisor = props.instanced ? 1 : 0;
      }
      if (props.isInstanced !== void 0) {
        this.divisor = props.isInstanced ? 1 : 0;
      }
      if (this.offset === void 0)
        delete this.offset;
      if (this.stride === void 0)
        delete this.stride;
      if (this.type === void 0)
        delete this.type;
      if (this.size === void 0)
        delete this.size;
      if (this.divisor === void 0)
        delete this.divisor;
      if (this.normalized === void 0)
        delete this.normalized;
      if (this.integer === void 0)
        delete this.integer;
      if (this.buffer === void 0)
        delete this.buffer;
      if (this.index === void 0)
        delete this.index;
      return this;
    }
  };

  // ../../node_modules/@luma.gl/webgl/dist/classic/buffer-with-accessor.js
  var DEBUG_DATA_LENGTH2 = 10;
  var DEPRECATED_PROPS = {
    offset: "accessor.offset",
    stride: "accessor.stride",
    type: "accessor.type",
    size: "accessor.size",
    divisor: "accessor.divisor",
    normalized: "accessor.normalized",
    integer: "accessor.integer",
    instanced: "accessor.divisor",
    isInstanced: "accessor.divisor"
  };
  var PROP_CHECKS_INITIALIZE = {
    removedProps: {},
    replacedProps: {
      bytes: "byteLength"
    },
    deprecatedProps: DEPRECATED_PROPS
  };
  var PROP_CHECKS_SET_PROPS = {
    removedProps: DEPRECATED_PROPS
  };
  function getWEBGLBufferProps(props) {
    if (ArrayBuffer.isView(props)) {
      return {
        data: props
      };
    } else if (typeof props === "number") {
      return {
        byteLength: props
      };
    }
    props = (0, import_core22.checkProps)("Buffer", props, PROP_CHECKS_INITIALIZE);
    const bufferProps = {
      ...props
    };
    return bufferProps;
  }
  var BufferWithAccessor = class extends WEBGLBuffer {
    constructor(device) {
      let props = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
      super(WebGLDevice.attach(device), getWEBGLBufferProps(props));
      this.accessor = void 0;
      this.setAccessor(Object.assign({}, props, props.accessor));
      if (this.props.data) {
        const type = getGLTypeFromTypedArray(this.props.data);
        (0, import_core22.assert)(type);
        this.setAccessor(new Accessor(this.accessor, {
          type
        }));
      }
      Object.seal(this);
    }
    getElementCount() {
      let accessor = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.accessor;
      return Math.round(this.byteLength / Accessor.getBytesPerElement(accessor));
    }
    getVertexCount() {
      let accessor = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.accessor;
      return Math.round(this.byteLength / Accessor.getBytesPerVertex(accessor));
    }
    initialize() {
      let props = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      if (ArrayBuffer.isView(props)) {
        props = {
          data: props
        };
      }
      if (Number.isFinite(props)) {
        props = {
          byteLength: props
        };
      }
      props = (0, import_core22.checkProps)("Buffer", props, PROP_CHECKS_INITIALIZE);
      this.glUsage = props.glUsage || GL.STATIC_DRAW;
      this.debugData = null;
      this.setAccessor(Object.assign({}, props, props.accessor));
      if (props.data) {
        this._setData(props.data, props.byteOffset, props.byteLength);
      } else {
        this._setByteLength(props.byteLength || 0);
      }
      return this;
    }
    setProps(props) {
      props = (0, import_core22.checkProps)("Buffer", props, PROP_CHECKS_SET_PROPS);
      if ("accessor" in props) {
        this.setAccessor(props.accessor);
      }
      return this;
    }
    setAccessor(accessor) {
      accessor = Object.assign({}, accessor);
      delete accessor.buffer;
      this.accessor = new Accessor(accessor);
      return this;
    }
    reallocate(byteLength) {
      if (byteLength > this.byteLength) {
        this._setByteLength(byteLength);
        return true;
      }
      this.bytesUsed = byteLength;
      return false;
    }
    setData(props) {
      return this.initialize(props);
    }
    subData(options) {
      if (ArrayBuffer.isView(options)) {
        options = {
          data: options
        };
      }
      const {
        data,
        offset = 0,
        srcOffset = 0
      } = options;
      const byteLength = options.byteLength || options.length;
      (0, import_core22.assert)(data);
      const glTarget = this.gl.webgl2 ? GL.COPY_WRITE_BUFFER : this.glTarget;
      this.gl.bindBuffer(glTarget, this.handle);
      if (srcOffset !== 0 || byteLength !== void 0) {
        assertWebGL2Context(this.gl);
        this.gl.bufferSubData(this.glTarget, offset, data, srcOffset, byteLength);
      } else {
        this.gl.bufferSubData(glTarget, offset, data);
      }
      this.gl.bindBuffer(glTarget, null);
      this.debugData = null;
      this._inferType(data);
      return this;
    }
    copyData(options) {
      const {
        sourceBuffer,
        readOffset = 0,
        writeOffset = 0,
        size
      } = options;
      const {
        gl,
        gl2
      } = this;
      assertWebGL2Context(gl);
      gl.bindBuffer(GL.COPY_READ_BUFFER, sourceBuffer.handle);
      gl.bindBuffer(GL.COPY_WRITE_BUFFER, this.handle);
      gl2 === null || gl2 === void 0 ? void 0 : gl2.copyBufferSubData(GL.COPY_READ_BUFFER, GL.COPY_WRITE_BUFFER, readOffset, writeOffset, size);
      gl.bindBuffer(GL.COPY_READ_BUFFER, null);
      gl.bindBuffer(GL.COPY_WRITE_BUFFER, null);
      this.debugData = null;
      return this;
    }
    getData(options) {
      var _this$gl;
      let {
        dstData = null,
        length: length2 = 0
      } = options || {};
      const {
        srcByteOffset = 0,
        dstOffset = 0
      } = options || {};
      assertWebGL2Context(this.gl);
      const ArrayType = getTypedArrayFromGLType(this.accessor.type || GL.FLOAT, {
        clamped: false
      });
      const sourceAvailableElementCount = this._getAvailableElementCount(srcByteOffset);
      const dstElementOffset = dstOffset;
      let dstAvailableElementCount;
      let dstElementCount;
      if (dstData) {
        dstElementCount = dstData.length;
        dstAvailableElementCount = dstElementCount - dstElementOffset;
      } else {
        dstAvailableElementCount = Math.min(sourceAvailableElementCount, length2 || sourceAvailableElementCount);
        dstElementCount = dstElementOffset + dstAvailableElementCount;
      }
      const copyElementCount = Math.min(sourceAvailableElementCount, dstAvailableElementCount);
      length2 = length2 || copyElementCount;
      (0, import_core22.assert)(length2 <= copyElementCount);
      dstData = dstData || new ArrayType(dstElementCount);
      this.gl.bindBuffer(GL.COPY_READ_BUFFER, this.handle);
      (_this$gl = this.gl2) === null || _this$gl === void 0 ? void 0 : _this$gl.getBufferSubData(GL.COPY_READ_BUFFER, srcByteOffset, dstData, dstOffset, length2);
      this.gl.bindBuffer(GL.COPY_READ_BUFFER, null);
      return dstData;
    }
    bind(options) {
      const {
        glTarget = this.glTarget,
        index = this.accessor && this.accessor.index,
        offset = 0,
        size
      } = options || {};
      if (glTarget === GL.UNIFORM_BUFFER || glTarget === GL.TRANSFORM_FEEDBACK_BUFFER) {
        if (size !== void 0) {
          var _this$gl2;
          (_this$gl2 = this.gl2) === null || _this$gl2 === void 0 ? void 0 : _this$gl2.bindBufferRange(glTarget, index, this.handle, offset, size);
        } else {
          var _this$gl3;
          (0, import_core22.assert)(offset === 0);
          (_this$gl3 = this.gl2) === null || _this$gl3 === void 0 ? void 0 : _this$gl3.bindBufferBase(glTarget, index, this.handle);
        }
      } else {
        this.gl.bindBuffer(glTarget, this.handle);
      }
      return this;
    }
    unbind(options) {
      const {
        glTarget = this.glTarget,
        index = this.accessor && this.accessor.index
      } = options || {};
      const isIndexedBuffer = glTarget === GL.UNIFORM_BUFFER || glTarget === GL.TRANSFORM_FEEDBACK_BUFFER;
      if (isIndexedBuffer) {
        var _this$gl4;
        (_this$gl4 = this.gl2) === null || _this$gl4 === void 0 ? void 0 : _this$gl4.bindBufferBase(glTarget, index, null);
      } else {
        this.gl.bindBuffer(glTarget, null);
      }
      return this;
    }
    getDebugData() {
      if (!this.debugData) {
        this.debugData = this.getData({
          length: Math.min(DEBUG_DATA_LENGTH2, this.byteLength)
        });
        return {
          data: this.debugData,
          changed: true
        };
      }
      return {
        data: this.debugData,
        changed: false
      };
    }
    invalidateDebugData() {
      this.debugData = null;
    }
    _setData(data) {
      let offset = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
      let byteLength = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : data.byteLength + offset;
      (0, import_core22.assert)(ArrayBuffer.isView(data));
      this.trackDeallocatedMemory();
      const target = this._getTarget();
      this.gl.bindBuffer(target, this.handle);
      this.gl.bufferData(target, byteLength, this.glUsage);
      this.gl.bufferSubData(target, offset, data);
      this.gl.bindBuffer(target, null);
      this.debugData = data.slice(0, DEBUG_DATA_LENGTH2);
      this.bytesUsed = byteLength;
      this.byteLength = byteLength;
      this.trackAllocatedMemory(byteLength);
      const type = getGLTypeFromTypedArray(data);
      (0, import_core22.assert)(type);
      this.setAccessor(new Accessor(this.accessor, {
        type
      }));
      return this;
    }
    _setByteLength(byteLength) {
      (0, import_core22.assert)(byteLength >= 0);
      this.trackDeallocatedMemory();
      let data = byteLength;
      if (byteLength === 0) {
        data = new Float32Array(0);
      }
      const glTarget = this._getTarget();
      this.gl.bindBuffer(glTarget, this.handle);
      this.gl.bufferData(glTarget, data, this.glUsage);
      this.gl.bindBuffer(glTarget, null);
      this.debugData = null;
      this.bytesUsed = byteLength;
      this.byteLength = byteLength;
      this.trackAllocatedMemory(byteLength);
      return this;
    }
    _getTarget() {
      return this.gl.webgl2 ? GL.COPY_WRITE_BUFFER : this.glTarget;
    }
    _getAvailableElementCount(srcByteOffset) {
      const ArrayType = getTypedArrayFromGLType(this.accessor.type || GL.FLOAT, {
        clamped: false
      });
      const sourceElementOffset = srcByteOffset / ArrayType.BYTES_PER_ELEMENT;
      return this.getElementCount() - sourceElementOffset;
    }
    _inferType(data) {
      if (!this.accessor.type) {
        this.setAccessor(new Accessor(this.accessor, {
          type: getGLTypeFromTypedArray(data)
        }));
      }
    }
    getParameter(pname) {
      this.gl.bindBuffer(this.glTarget, this.handle);
      const value = this.gl.getBufferParameter(this.glTarget, pname);
      this.gl.bindBuffer(this.glTarget, null);
      return value;
    }
    get type() {
      return this.accessor.type;
    }
  };

  // ../../node_modules/@luma.gl/webgl/dist/adapter/resources/webgl-shader.js
  var import_core23 = __toESM(require_core2(), 1);

  // ../../node_modules/@luma.gl/webgl/dist/adapter/helpers/get-shader-info.js
  function getShaderInfo(source, defaultName) {
    return {
      name: getShaderName(source, defaultName),
      language: "glsl",
      version: getShaderVersion(source)
    };
  }
  function getShaderName(shader) {
    let defaultName = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "unnamed";
    const SHADER_NAME_REGEXP = /#define[\s*]SHADER_NAME[\s*]([A-Za-z0-9_-]+)[\s*]/;
    const match = SHADER_NAME_REGEXP.exec(shader);
    return match ? match[1] : defaultName;
  }
  function getShaderVersion(source) {
    let version = 100;
    const words = source.match(/[^\s]+/g);
    if (words && words.length >= 2 && words[0] === "#version") {
      const v = parseInt(words[1], 10);
      if (Number.isFinite(v)) {
        version = v;
      }
    }
    return version;
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/helpers/parse-shader-compiler-log.js
  var MESSAGE_TYPES = ["warning", "error", "info"];
  function parseShaderCompilerLog(errLog) {
    const lines = errLog.split(/\r?\n/);
    const messages = [];
    for (const line of lines) {
      if (line.length <= 1) {
        continue;
      }
      const segments = line.split(":");
      const [messageType, linePosition, lineNumber, ...rest] = segments;
      let lineNum = parseInt(lineNumber, 10);
      if (isNaN(lineNum)) {
        lineNum = 0;
      }
      let linePos = parseInt(linePosition, 10);
      if (isNaN(linePos)) {
        linePos = 0;
      }
      const lowerCaseType = messageType.toLowerCase();
      const type = MESSAGE_TYPES.includes(lowerCaseType) ? lowerCaseType : "info";
      messages.push({
        message: rest.join(":").trim(),
        type,
        lineNum,
        linePos
      });
    }
    return messages;
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/resources/webgl-shader.js
  var WEBGLShader = class extends import_core23.Shader {
    constructor(device, props) {
      super(device, {
        id: getShaderIdFromProps(props),
        ...props
      });
      this.device = void 0;
      this.handle = void 0;
      this.device = device;
      switch (this.props.stage) {
        case "vertex":
          this.handle = this.props.handle || this.device.gl.createShader(GL.VERTEX_SHADER);
          break;
        case "fragment":
          this.handle = this.props.handle || this.device.gl.createShader(GL.FRAGMENT_SHADER);
          break;
        default:
          throw new Error(this.props.stage);
      }
      this._compile(this.source);
    }
    destroy() {
      if (this.handle) {
        this.removeStats();
        this.device.gl.deleteShader(this.handle);
        this.destroyed = true;
      }
    }
    async compilationInfo() {
      const log13 = this.device.gl.getShaderInfoLog(this.handle);
      return log13 ? parseShaderCompilerLog(log13) : [];
    }
    _compile(source) {
      const addGLSLVersion = (source2) => source2.startsWith("#version ") ? source2 : `#version 100
${source2}`;
      source = addGLSLVersion(source);
      const {
        gl
      } = this.device;
      gl.shaderSource(this.handle, source);
      gl.compileShader(this.handle);
      const compileStatus = gl.getShaderParameter(this.handle, GL.COMPILE_STATUS);
      if (!compileStatus) {
        const shaderLog = gl.getShaderInfoLog(this.handle);
        const parsedLog = shaderLog ? parseShaderCompilerLog(shaderLog) : [];
        const messages = parsedLog.filter((message2) => message2.type === "error");
        const formattedLog = (0, import_core23.formatCompilerLog)(messages, source, {
          showSourceCode: true
        });
        const shaderName = getShaderInfo(source).name;
        const shaderDescription = `${this.stage} shader ${shaderName}`;
        import_core23.log.error(`GLSL compilation errors in ${shaderDescription}
${formattedLog}`)();
        throw new Error(`GLSL compilation errors in ${shaderName}`);
      }
    }
  };
  function getShaderIdFromProps(props) {
    return getShaderInfo(props.source).name || props.id || (0, import_core23.uid)(`unnamed ${props.stage}-shader`);
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/resources/webgl-render-pass.js
  var import_core24 = __toESM(require_core2(), 1);
  var GL_DEPTH_BUFFER_BIT = 256;
  var GL_STENCIL_BUFFER_BIT = 1024;
  var GL_COLOR_BUFFER_BIT = 16384;
  var GL_COLOR = 6144;
  var WEBGLRenderPass = class extends import_core24.RenderPass {
    constructor(device, props) {
      super(device, props);
      this.device = void 0;
      this.glParameters = void 0;
      this.device = device;
      this.setParameters(this.props.parameters);
      this.clear();
    }
    end() {
    }
    pushDebugGroup(groupLabel) {
    }
    popDebugGroup() {
    }
    insertDebugMarker(markerLabel) {
    }
    setParameters() {
      let parameters2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      const glParameters = {};
      if (this.props.framebuffer) {
        glParameters.framebuffer = this.props.framebuffer;
      }
      if (this.props.depthReadOnly) {
        glParameters.depthMask = !this.props.depthReadOnly;
      }
      glParameters.stencilMask = this.props.stencilReadOnly ? 0 : 1;
      glParameters[GL.RASTERIZER_DISCARD] = this.props.discard;
      if (parameters2.viewport) {
        if (parameters2.viewport.length >= 6) {
          glParameters.viewport = parameters2.viewport.slice(0, 4);
          glParameters.depthRange = [parameters2.viewport[4], parameters2.viewport[5]];
        } else {
          glParameters.viewport = parameters2.viewport;
        }
      }
      glParameters.scissorTest = Boolean(parameters2.scissorRect);
      if (parameters2.scissorRect) {
        glParameters.scissor = parameters2.scissorRect;
      }
      if (parameters2.blendConstant) {
        glParameters.blendColor = parameters2.blendConstant;
      }
      if (parameters2.stencilReference) {
        console.warn("RenderPassParameters.stencilReference not yet implemented in WebGL");
        parameters2[GL.STENCIL_REF] = parameters2.stencilReference;
      }
      this.glParameters = glParameters;
      setGLParameters(this.device, glParameters);
    }
    clear() {
      const glParameters = {
        ...this.glParameters
      };
      let clearMask = 0;
      if (this.props.clearColor !== false) {
        clearMask |= GL_COLOR_BUFFER_BIT;
        glParameters.clearColor = this.props.clearColor;
      }
      if (this.props.clearDepth !== false) {
        clearMask |= GL_DEPTH_BUFFER_BIT;
        glParameters.clearDepth = this.props.clearDepth;
      }
      if (this.props.clearStencil !== false) {
        clearMask |= GL_STENCIL_BUFFER_BIT;
        glParameters.clearStencil = this.props.clearStencil;
      }
      if (clearMask !== 0) {
        withGLParameters(this.device, glParameters, () => {
          this.device.gl.clear(clearMask);
        });
      }
    }
    clearColorBuffer() {
      let drawBuffer = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
      let value = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : [0, 0, 0, 0];
      withGLParameters(this.device.gl2, {
        framebuffer: this.props.framebuffer
      }, () => {
        switch (value.constructor) {
          case Int32Array:
            this.device.gl2.clearBufferiv(GL_COLOR, drawBuffer, value);
            break;
          case Uint32Array:
            this.device.gl2.clearBufferuiv(GL_COLOR, drawBuffer, value);
            break;
          case Float32Array:
          default:
            this.device.gl2.clearBufferfv(GL_COLOR, drawBuffer, value);
            break;
        }
      });
    }
  };

  // ../../node_modules/@luma.gl/webgl/dist/adapter/resources/webgl-render-pipeline.js
  var import_core25 = __toESM(require_core2(), 1);
  var import_core26 = __toESM(require_core2(), 1);

  // ../../node_modules/@luma.gl/webgl/dist/adapter/helpers/decode-webgl-types.js
  function isSamplerUniform(type) {
    return SAMPLER_TYPES.includes(type);
  }
  var SAMPLER_TYPES = [GL.SAMPLER_2D, GL.SAMPLER_CUBE, GL.SAMPLER_3D, GL.SAMPLER_2D_SHADOW, GL.SAMPLER_2D_ARRAY, GL.SAMPLER_2D_ARRAY_SHADOW, GL.SAMPLER_CUBE_SHADOW, GL.INT_SAMPLER_2D, GL.INT_SAMPLER_3D, GL.INT_SAMPLER_CUBE, GL.INT_SAMPLER_2D_ARRAY, GL.UNSIGNED_INT_SAMPLER_2D, GL.UNSIGNED_INT_SAMPLER_3D, GL.UNSIGNED_INT_SAMPLER_CUBE, GL.UNSIGNED_INT_SAMPLER_2D_ARRAY];
  var COMPOSITE_GL_TYPES = {
    [GL.FLOAT]: [GL.FLOAT, 1, "float", "f32", "float32"],
    [GL.FLOAT_VEC2]: [GL.FLOAT, 2, "vec2", "vec2<f32>", "float32x2"],
    [GL.FLOAT_VEC3]: [GL.FLOAT, 3, "vec3", "vec3<f32>", "float32x3"],
    [GL.FLOAT_VEC4]: [GL.FLOAT, 4, "vec4", "vec4<f32>", "float32x4"],
    [GL.INT]: [GL.INT, 1, "int", "i32", "sint32"],
    [GL.INT_VEC2]: [GL.INT, 2, "ivec2", "vec2<i32>", "sint32x2"],
    [GL.INT_VEC3]: [GL.INT, 3, "ivec3", "vec3<i32>", "sint32x3"],
    [GL.INT_VEC4]: [GL.INT, 4, "ivec4", "vec4<i32>", "sint32x4"],
    [GL.UNSIGNED_INT]: [GL.UNSIGNED_INT, 1, "uint", "u32", "uint32"],
    [GL.UNSIGNED_INT_VEC2]: [GL.UNSIGNED_INT, 2, "uvec2", "vec2<u32>", "uint32x2"],
    [GL.UNSIGNED_INT_VEC3]: [GL.UNSIGNED_INT, 3, "uvec3", "vec3<u32>", "uint32x3"],
    [GL.UNSIGNED_INT_VEC4]: [GL.UNSIGNED_INT, 4, "uvec4", "vec4<u32>", "uint32x4"],
    [GL.BOOL]: [GL.FLOAT, 1, "bool", "f32", "float32"],
    [GL.BOOL_VEC2]: [GL.FLOAT, 2, "bvec2", "vec2<f32>", "float32x2"],
    [GL.BOOL_VEC3]: [GL.FLOAT, 3, "bvec3", "vec3<f32>", "float32x3"],
    [GL.BOOL_VEC4]: [GL.FLOAT, 4, "bvec4", "vec4<f32>", "float32x4"],
    [GL.FLOAT_MAT2]: [GL.FLOAT, 8, "mat2", "mat2x2<f32>"],
    [GL.FLOAT_MAT2x3]: [GL.FLOAT, 8, "mat2x3", "mat2x3<f32>"],
    [GL.FLOAT_MAT2x4]: [GL.FLOAT, 8, "mat2x4", "mat2x4<f32>"],
    [GL.FLOAT_MAT3x2]: [GL.FLOAT, 12, "mat3x2", "mat3x2<f32>"],
    [GL.FLOAT_MAT3]: [GL.FLOAT, 12, "mat3", "mat3x3<f32>"],
    [GL.FLOAT_MAT3x4]: [GL.FLOAT, 12, "mat3x4", "mat3x4<f32>"],
    [GL.FLOAT_MAT4x2]: [GL.FLOAT, 16, "mat4x2", "mat4x2<f32>"],
    [GL.FLOAT_MAT4x3]: [GL.FLOAT, 16, "mat4x3", "mat4x3<f32>"],
    [GL.FLOAT_MAT4]: [GL.FLOAT, 16, "mat4", "mat4x4<f32>"]
  };
  function decodeGLUniformType(glUniformType) {
    const typeAndSize = COMPOSITE_GL_TYPES[glUniformType];
    if (!typeAndSize) {
      throw new Error("uniform");
    }
    const [glType, components, , format] = typeAndSize;
    return {
      format,
      components,
      glType
    };
  }
  function decodeGLAttributeType(glAttributeType) {
    const typeAndSize = COMPOSITE_GL_TYPES[glAttributeType];
    if (!typeAndSize) {
      throw new Error("attribute");
    }
    const [, components, , shaderType, vertexFormat] = typeAndSize;
    const attributeType = shaderType;
    return {
      attributeType,
      vertexFormat,
      components
    };
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/helpers/get-shader-layout.js
  function getShaderLayout(gl, program) {
    const shaderLayout = {
      attributes: [],
      bindings: []
    };
    shaderLayout.attributes = readAttributeDeclarations(gl, program);
    const uniformBlocks = readUniformBlocks(gl, program);
    for (const uniformBlock of uniformBlocks) {
      const uniforms2 = uniformBlock.uniforms.map((uniform) => ({
        name: uniform.name,
        format: uniform.format,
        byteOffset: uniform.byteOffset,
        byteStride: uniform.byteStride,
        arrayLength: uniform.arrayLength
      }));
      shaderLayout.bindings.push({
        type: "uniform",
        name: uniformBlock.name,
        location: uniformBlock.location,
        visibility: (uniformBlock.vertex ? 1 : 0) & (uniformBlock.fragment ? 2 : 0),
        minBindingSize: uniformBlock.byteLength,
        uniforms: uniforms2
      });
    }
    const uniforms = readUniformBindings(gl, program);
    let textureUnit = 0;
    for (const uniform of uniforms) {
      if (isSamplerUniform(uniform.type)) {
        const {
          viewDimension,
          sampleType
        } = getSamplerInfo(uniform.type);
        shaderLayout.bindings.push({
          type: "texture",
          name: uniform.name,
          location: textureUnit,
          viewDimension,
          sampleType
        });
        uniform.textureUnit = textureUnit;
        textureUnit += 1;
      }
    }
    if (uniforms.length) {
      shaderLayout.uniforms = uniforms;
    }
    const varyings = readVaryings(gl, program);
    if (varyings !== null && varyings !== void 0 && varyings.length) {
      shaderLayout.varyings = varyings;
    }
    return shaderLayout;
  }
  function readAttributeDeclarations(gl, program) {
    const attributes = [];
    const count = gl.getProgramParameter(program, gl.ACTIVE_ATTRIBUTES);
    for (let index = 0; index < count; index++) {
      const activeInfo = gl.getActiveAttrib(program, index);
      if (!activeInfo) {
        throw new Error("activeInfo");
      }
      const {
        name,
        type: compositeType
      } = activeInfo;
      const location = gl.getAttribLocation(program, name);
      if (location >= 0) {
        const {
          attributeType
        } = decodeGLAttributeType(compositeType);
        const stepMode = /instance/i.test(name) ? "instance" : "vertex";
        attributes.push({
          name,
          location,
          stepMode,
          type: attributeType
        });
      }
    }
    attributes.sort((a, b) => a.location - b.location);
    return attributes;
  }
  function readVaryings(gl, program) {
    if (!isWebGL2(gl)) {
      return [];
    }
    const gl2 = gl;
    const varyings = [];
    const count = gl.getProgramParameter(program, GL.TRANSFORM_FEEDBACK_VARYINGS);
    for (let location = 0; location < count; location++) {
      const activeInfo = gl2.getTransformFeedbackVarying(program, location);
      if (!activeInfo) {
        throw new Error("activeInfo");
      }
      const {
        name,
        type: compositeType,
        size
      } = activeInfo;
      const {
        glType,
        components
      } = decodeGLUniformType(compositeType);
      const accessor = new Accessor({
        type: glType,
        size: size * components
      });
      const varying = {
        location,
        name,
        accessor
      };
      varyings.push(varying);
    }
    varyings.sort((a, b) => a.location - b.location);
    return varyings;
  }
  function readUniformBindings(gl, program) {
    const uniforms = [];
    const uniformCount = gl.getProgramParameter(program, GL.ACTIVE_UNIFORMS);
    for (let i = 0; i < uniformCount; i++) {
      const activeInfo = gl.getActiveUniform(program, i);
      if (!activeInfo) {
        throw new Error("activeInfo");
      }
      const {
        name: rawName,
        size,
        type
      } = activeInfo;
      const {
        name,
        isArray: isArray3
      } = parseUniformName(rawName);
      let webglLocation = gl.getUniformLocation(program, name);
      const uniformInfo = {
        location: webglLocation,
        name,
        size,
        type,
        isArray: isArray3
      };
      uniforms.push(uniformInfo);
      if (uniformInfo.size > 1) {
        for (let j = 0; j < uniformInfo.size; j++) {
          const elementName = `${name}[${j}]`;
          webglLocation = gl.getUniformLocation(program, elementName);
          const arrayElementUniformInfo = {
            ...uniformInfo,
            name: elementName,
            location: webglLocation
          };
          uniforms.push(arrayElementUniformInfo);
        }
      }
    }
    return uniforms;
  }
  function readUniformBlocks(gl, program) {
    if (!isWebGL2(gl)) {
      return [];
    }
    const gl2 = gl;
    const getBlockParameter = (blockIndex, pname) => gl2.getActiveUniformBlockParameter(program, blockIndex, pname);
    const uniformBlocks = [];
    const blockCount = gl2.getProgramParameter(program, GL.ACTIVE_UNIFORM_BLOCKS);
    for (let blockIndex = 0; blockIndex < blockCount; blockIndex++) {
      const blockInfo = {
        name: gl2.getActiveUniformBlockName(program, blockIndex) || "",
        location: getBlockParameter(blockIndex, GL.UNIFORM_BLOCK_BINDING),
        byteLength: getBlockParameter(blockIndex, GL.UNIFORM_BLOCK_DATA_SIZE),
        vertex: getBlockParameter(blockIndex, GL.UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER),
        fragment: getBlockParameter(blockIndex, GL.UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER),
        uniformCount: getBlockParameter(blockIndex, GL.UNIFORM_BLOCK_ACTIVE_UNIFORMS),
        uniforms: []
      };
      const uniformIndices = getBlockParameter(blockIndex, GL.UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES) || [];
      const uniformType = gl2.getActiveUniforms(program, uniformIndices, GL.UNIFORM_TYPE);
      const uniformArrayLength = gl2.getActiveUniforms(program, uniformIndices, GL.UNIFORM_SIZE);
      const uniformOffset = gl2.getActiveUniforms(program, uniformIndices, GL.UNIFORM_OFFSET);
      const uniformStride = gl2.getActiveUniforms(program, uniformIndices, GL.UNIFORM_ARRAY_STRIDE);
      for (let i = 0; i < blockInfo.uniformCount; ++i) {
        const activeInfo = gl2.getActiveUniform(program, uniformIndices[i]);
        if (!activeInfo) {
          throw new Error("activeInfo");
        }
        blockInfo.uniforms.push({
          name: activeInfo.name,
          format: decodeGLUniformType(uniformType[i]).format,
          type: uniformType[i],
          arrayLength: uniformArrayLength[i],
          byteOffset: uniformOffset[i],
          byteStride: uniformStride[i]
        });
      }
      uniformBlocks.push(blockInfo);
    }
    uniformBlocks.sort((a, b) => a.location - b.location);
    return uniformBlocks;
  }
  var SAMPLER_UNIFORMS_GL_TO_GPU = {
    [GL.SAMPLER_2D]: ["2d", "float"],
    [GL.SAMPLER_CUBE]: ["cube", "float"],
    [GL.SAMPLER_3D]: ["3d", "float"],
    [GL.SAMPLER_2D_SHADOW]: ["3d", "depth"],
    [GL.SAMPLER_2D_ARRAY]: ["2d-array", "float"],
    [GL.SAMPLER_2D_ARRAY_SHADOW]: ["2d-array", "depth"],
    [GL.SAMPLER_CUBE_SHADOW]: ["cube", "float"],
    [GL.INT_SAMPLER_2D]: ["2d", "sint"],
    [GL.INT_SAMPLER_3D]: ["3d", "sint"],
    [GL.INT_SAMPLER_CUBE]: ["cube", "sint"],
    [GL.INT_SAMPLER_2D_ARRAY]: ["2d-array", "uint"],
    [GL.UNSIGNED_INT_SAMPLER_2D]: ["2d", "uint"],
    [GL.UNSIGNED_INT_SAMPLER_3D]: ["3d", "uint"],
    [GL.UNSIGNED_INT_SAMPLER_CUBE]: ["cube", "uint"],
    [GL.UNSIGNED_INT_SAMPLER_2D_ARRAY]: ["2d-array", "uint"]
  };
  function getSamplerInfo(type) {
    const sampler = SAMPLER_UNIFORMS_GL_TO_GPU[type];
    if (!sampler) {
      throw new Error("sampler");
    }
    const [viewDimension, sampleType] = sampler;
    return {
      viewDimension,
      sampleType
    };
  }
  function parseUniformName(name) {
    if (name[name.length - 1] !== "]") {
      return {
        name,
        length: 1,
        isArray: false
      };
    }
    const UNIFORM_NAME_REGEXP = /([^[]*)(\[[0-9]+\])?/;
    const matches = UNIFORM_NAME_REGEXP.exec(name);
    if (!matches || matches.length < 2) {
      throw new Error(`Failed to parse GLSL uniform name ${name}`);
    }
    return {
      name: matches[1],
      length: matches[2] ? 1 : 0,
      isArray: Boolean(matches[2])
    };
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/helpers/set-uniform.js
  function setUniform(gl, location, type, value) {
    const gl2 = gl;
    let uniformValue = value;
    if (uniformValue === true) {
      uniformValue = 1;
    }
    if (uniformValue === false) {
      uniformValue = 0;
    }
    const arrayValue = typeof uniformValue === "number" ? [uniformValue] : uniformValue;
    switch (type) {
      case GL.SAMPLER_2D:
      case GL.SAMPLER_CUBE:
      case GL.SAMPLER_3D:
      case GL.SAMPLER_2D_SHADOW:
      case GL.SAMPLER_2D_ARRAY:
      case GL.SAMPLER_2D_ARRAY_SHADOW:
      case GL.SAMPLER_CUBE_SHADOW:
      case GL.INT_SAMPLER_2D:
      case GL.INT_SAMPLER_3D:
      case GL.INT_SAMPLER_CUBE:
      case GL.INT_SAMPLER_2D_ARRAY:
      case GL.UNSIGNED_INT_SAMPLER_2D:
      case GL.UNSIGNED_INT_SAMPLER_3D:
      case GL.UNSIGNED_INT_SAMPLER_CUBE:
      case GL.UNSIGNED_INT_SAMPLER_2D_ARRAY:
        if (typeof value !== "number") {
          throw new Error("samplers must be set to integers");
        }
        return gl.uniform1i(location, value);
      case GL.FLOAT:
        return gl.uniform1fv(location, arrayValue);
      case GL.FLOAT_VEC2:
        return gl.uniform2fv(location, arrayValue);
      case GL.FLOAT_VEC3:
        return gl.uniform3fv(location, arrayValue);
      case GL.FLOAT_VEC4:
        return gl.uniform4fv(location, arrayValue);
      case GL.INT:
        return gl.uniform1iv(location, arrayValue);
      case GL.INT_VEC2:
        return gl.uniform2iv(location, arrayValue);
      case GL.INT_VEC3:
        return gl.uniform3iv(location, arrayValue);
      case GL.INT_VEC4:
        return gl.uniform4iv(location, arrayValue);
      case GL.BOOL:
        return gl.uniform1iv(location, arrayValue);
      case GL.BOOL_VEC2:
        return gl.uniform2iv(location, arrayValue);
      case GL.BOOL_VEC3:
        return gl.uniform3iv(location, arrayValue);
      case GL.BOOL_VEC4:
        return gl.uniform4iv(location, arrayValue);
      case GL.UNSIGNED_INT:
        return gl2.uniform1uiv(location, arrayValue, 1);
      case GL.UNSIGNED_INT_VEC2:
        return gl2.uniform2uiv(location, arrayValue, 2);
      case GL.UNSIGNED_INT_VEC3:
        return gl2.uniform3uiv(location, arrayValue, 3);
      case GL.UNSIGNED_INT_VEC4:
        return gl2.uniform4uiv(location, arrayValue, 4);
      case GL.FLOAT_MAT2:
        return gl.uniformMatrix2fv(location, false, arrayValue);
      case GL.FLOAT_MAT3:
        return gl.uniformMatrix3fv(location, false, arrayValue);
      case GL.FLOAT_MAT4:
        return gl.uniformMatrix4fv(location, false, arrayValue);
      case GL.FLOAT_MAT2x3:
        return gl2.uniformMatrix2x3fv(location, false, arrayValue);
      case GL.FLOAT_MAT2x4:
        return gl2.uniformMatrix2x4fv(location, false, arrayValue);
      case GL.FLOAT_MAT3x2:
        return gl2.uniformMatrix3x2fv(location, false, arrayValue);
      case GL.FLOAT_MAT3x4:
        return gl2.uniformMatrix3x4fv(location, false, arrayValue);
      case GL.FLOAT_MAT4x2:
        return gl2.uniformMatrix4x2fv(location, false, arrayValue);
      case GL.FLOAT_MAT4x3:
        return gl2.uniformMatrix4x3fv(location, false, arrayValue);
    }
    throw new Error("Illegal uniform");
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/resources/webgl-render-pipeline.js
  var LOG_PROGRAM_PERF_PRIORITY = 4;
  var WEBGLRenderPipeline = class extends import_core25.RenderPipeline {
    constructor(device, props) {
      super(device, props);
      this.device = void 0;
      this.handle = void 0;
      this.vs = void 0;
      this.fs = void 0;
      this.introspectedLayout = void 0;
      this.uniforms = {};
      this.bindings = {};
      this.varyings = null;
      this._textureUniforms = {};
      this._textureIndexCounter = 0;
      this._uniformCount = 0;
      this._uniformSetters = {};
      this.device = device;
      this.handle = this.props.handle || this.device.gl.createProgram();
      this.device.setSpectorMetadata(this.handle, {
        id: this.props.id
      });
      this.vs = (0, import_core25.cast)(props.vs);
      this.fs = (0, import_core25.cast)(props.fs);
      const {
        varyings,
        bufferMode = GL.SEPARATE_ATTRIBS
      } = props;
      if (varyings && varyings.length > 0) {
        var _this$device$gl;
        this.device.assertWebGL2();
        this.varyings = varyings;
        (_this$device$gl = this.device.gl2) === null || _this$device$gl === void 0 ? void 0 : _this$device$gl.transformFeedbackVaryings(this.handle, varyings, bufferMode);
      }
      this._compileAndLink();
      this.introspectedLayout = getShaderLayout(this.device.gl, this.handle);
      this.shaderLayout = (0, import_core26.mergeShaderLayout)(this.introspectedLayout, props.shaderLayout);
    }
    destroy() {
      if (this.handle) {
        this.device.gl.deleteProgram(this.handle);
        this.destroyed = true;
      }
    }
    setBindings(bindings) {
      for (const [name, value] of Object.entries(bindings)) {
        const binding = this.shaderLayout.bindings.find((binding2) => binding2.name === name);
        if (!binding) {
          const validBindings = this.shaderLayout.bindings.map((binding2) => `"${binding2.name}"`).join(", ");
          import_core25.log.warn(`Unknown binding "${name}" in render pipeline "${this.id}", expected one of ${validBindings}`)();
          continue;
        }
        if (!value) {
          import_core25.log.warn(`Unsetting binding "${name}" in render pipeline "${this.id}"`)();
        }
        switch (binding.type) {
          case "uniform":
            if (!(value instanceof WEBGLBuffer) && !(value.buffer instanceof WEBGLBuffer)) {
              throw new Error("buffer value");
            }
            break;
          case "texture":
            if (!(value instanceof WEBGLTexture || value instanceof WEBGLFramebuffer)) {
              throw new Error("texture value");
            }
            break;
          case "sampler":
            import_core25.log.warn(`Ignoring sampler ${name}`)();
            break;
          default:
            throw new Error(binding.type);
        }
        this.bindings[name] = value;
      }
    }
    setUniforms(uniforms) {
      Object.assign(this.uniforms, uniforms);
    }
    draw(options) {
      var _vertexArray$indexBuf;
      const {
        renderPass,
        vertexArray,
        vertexCount,
        instanceCount,
        firstVertex = 0
      } = options;
      const glDrawMode = getGLDrawMode(this.props.topology);
      const isIndexed = Boolean(vertexArray.indexBuffer);
      const glIndexType = (_vertexArray$indexBuf = vertexArray.indexBuffer) === null || _vertexArray$indexBuf === void 0 ? void 0 : _vertexArray$indexBuf.glIndexType;
      const isInstanced = Number(instanceCount) > 0;
      if (!this._areTexturesRenderable() || vertexCount === 0) {
        return false;
      }
      this.device.gl.useProgram(this.handle);
      vertexArray.bindBeforeRender(renderPass);
      const primitiveMode = getGLPrimitive(this.props.topology);
      const transformFeedback = null;
      if (transformFeedback) {
        transformFeedback.begin(primitiveMode);
      }
      this._applyBindings();
      this._applyUniforms();
      const webglRenderPass = renderPass;
      withDeviceAndGLParameters(this.device, this.props.parameters, webglRenderPass.glParameters, () => {
        if (isIndexed && isInstanced) {
          var _this$device$gl2;
          (_this$device$gl2 = this.device.gl2) === null || _this$device$gl2 === void 0 ? void 0 : _this$device$gl2.drawElementsInstanced(glDrawMode, vertexCount || 0, glIndexType, firstVertex, instanceCount || 0);
        } else if (isIndexed) {
          this.device.gl.drawElements(glDrawMode, vertexCount || 0, glIndexType, firstVertex);
        } else if (isInstanced) {
          var _this$device$gl3;
          (_this$device$gl3 = this.device.gl2) === null || _this$device$gl3 === void 0 ? void 0 : _this$device$gl3.drawArraysInstanced(glDrawMode, firstVertex, vertexCount || 0, instanceCount || 0);
        } else {
          this.device.gl.drawArrays(glDrawMode, firstVertex, vertexCount || 0);
        }
        if (transformFeedback) {
          transformFeedback.end();
        }
      });
      vertexArray.unbindAfterRender(renderPass);
      return true;
    }
    _compileAndLink() {
      const {
        gl
      } = this.device;
      gl.attachShader(this.handle, this.vs.handle);
      gl.attachShader(this.handle, this.fs.handle);
      import_core25.log.time(LOG_PROGRAM_PERF_PRIORITY, `linkProgram for ${this.id}`)();
      gl.linkProgram(this.handle);
      import_core25.log.timeEnd(LOG_PROGRAM_PERF_PRIORITY, `linkProgram for ${this.id}`)();
      if (!gl.debug && import_core25.log.level === 0) {
      }
      const linked = gl.getProgramParameter(this.handle, gl.LINK_STATUS);
      if (!linked) {
        throw new Error(`Error linking: ${gl.getProgramInfoLog(this.handle)}`);
      }
      gl.validateProgram(this.handle);
      const validated = gl.getProgramParameter(this.handle, gl.VALIDATE_STATUS);
      if (!validated) {
        throw new Error(`Error validating: ${gl.getProgramInfoLog(this.handle)}`);
      }
    }
    _areTexturesRenderable() {
      let texturesRenderable = true;
      for (const [, texture] of Object.entries(this._textureUniforms)) {
        texture.update();
        texturesRenderable = texturesRenderable && texture.loaded;
      }
      for (const [, texture] of Object.entries(this.bindings)) {
        if (texture.loaded !== void 0) {
          texturesRenderable = texturesRenderable && texture.loaded;
        }
      }
      return texturesRenderable;
    }
    _applyBindings() {
      this.device.gl.useProgram(this.handle);
      const {
        gl2
      } = this.device;
      if (!gl2) {
        throw new Error("bindings");
      }
      let textureUnit = 0;
      let uniformBufferIndex = 0;
      for (const binding of this.shaderLayout.bindings) {
        const value = this.bindings[binding.name];
        if (!value) {
          throw new Error(`No value for binding ${binding.name} in ${this.id}`);
        }
        switch (binding.type) {
          case "uniform":
            const {
              name
            } = binding;
            const location = gl2.getUniformBlockIndex(this.handle, name);
            if (location === GL.INVALID_INDEX) {
              throw new Error(`Invalid uniform block name ${name}`);
            }
            gl2.uniformBlockBinding(this.handle, uniformBufferIndex, location);
            if (value instanceof WEBGLBuffer) {
              gl2.bindBufferBase(GL.UNIFORM_BUFFER, uniformBufferIndex, value.handle);
            } else {
              gl2.bindBufferRange(GL.UNIFORM_BUFFER, uniformBufferIndex, value.buffer.handle, value.offset || 0, value.size || value.buffer.byteLength - value.offset);
            }
            uniformBufferIndex += 1;
            break;
          case "texture":
            if (!(value instanceof WEBGLTexture || value instanceof WEBGLFramebuffer)) {
              throw new Error("texture");
            }
            let texture;
            if (value instanceof WEBGLTexture) {
              texture = value;
            } else if (value instanceof WEBGLFramebuffer && value.colorAttachments[0] instanceof WEBGLTexture) {
              import_core25.log.warn("Passing framebuffer in texture binding may be deprecated. Use fbo.colorAttachments[0] instead")();
              texture = value.colorAttachments[0];
            } else {
              throw new Error("No texture");
            }
            gl2.activeTexture(GL.TEXTURE0 + textureUnit);
            gl2.bindTexture(texture.target, texture.handle);
            textureUnit += 1;
            break;
          case "sampler":
            break;
          case "storage":
          case "read-only-storage":
            throw new Error(`binding type '${binding.type}' not supported in WebGL`);
        }
      }
    }
    _applyUniforms() {
      for (const uniformLayout of this.shaderLayout.uniforms || []) {
        var _this$uniforms$name;
        const {
          name,
          location,
          type,
          textureUnit
        } = uniformLayout;
        const value = (_this$uniforms$name = this.uniforms[name]) !== null && _this$uniforms$name !== void 0 ? _this$uniforms$name : textureUnit;
        if (value !== void 0) {
          setUniform(this.device.gl, location, type, value);
        }
      }
    }
  };
  function getGLDrawMode(topology) {
    switch (topology) {
      case "point-list":
        return GL.POINTS;
      case "line-list":
        return GL.LINES;
      case "line-strip":
        return GL.LINE_STRIP;
      case "line-loop-webgl":
        return GL.LINE_LOOP;
      case "triangle-list":
        return GL.TRIANGLES;
      case "triangle-strip":
        return GL.TRIANGLE_STRIP;
      case "triangle-fan-webgl":
        return GL.TRIANGLE_FAN;
      default:
        throw new Error(topology);
    }
  }
  function getGLPrimitive(topology) {
    switch (topology) {
      case "point-list":
        return GL.POINTS;
      case "line-list":
        return GL.LINES;
      case "line-strip":
        return GL.LINES;
      case "line-loop-webgl":
        return GL.LINES;
      case "triangle-list":
        return GL.TRIANGLES;
      case "triangle-strip":
        return GL.TRIANGLES;
      case "triangle-fan-webgl":
        return GL.TRIANGLES;
      default:
        throw new Error(topology);
    }
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/resources/webgl-command-encoder.js
  var import_core28 = __toESM(require_core2(), 1);

  // ../../node_modules/@luma.gl/webgl/dist/adapter/resources/webgl-command-buffer.js
  var import_core27 = __toESM(require_core2(), 1);
  function cast3(value) {
    return value;
  }
  var WEBGLCommandBuffer = class extends import_core27.CommandBuffer {
    constructor(device) {
      super({});
      this.device = void 0;
      this.commands = [];
      this.device = device;
    }
    submitCommands() {
      let commands = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.commands;
      for (const command of commands) {
        switch (command.name) {
          case "copy-buffer-to-buffer":
            _copyBufferToBuffer(this.device, command.options);
            break;
          case "copy-buffer-to-texture":
            _copyBufferToTexture(this.device, command.options);
            break;
          case "copy-texture-to-buffer":
            _copyTextureToBuffer(this.device, command.options);
            break;
          case "copy-texture-to-texture":
            _copyTextureToTexture(this.device, command.options);
            break;
        }
      }
    }
  };
  function _copyBufferToBuffer(device, options) {
    const source = cast3(options.source);
    const destination = cast3(options.destination);
    const gl2 = device.assertWebGL2();
    if (gl2) {
      var _options$sourceOffset, _options$destinationO;
      gl2.bindBuffer(GL.COPY_READ_BUFFER, source.handle);
      gl2.bindBuffer(GL.COPY_WRITE_BUFFER, destination.handle);
      gl2.copyBufferSubData(GL.COPY_READ_BUFFER, GL.COPY_WRITE_BUFFER, (_options$sourceOffset = options.sourceOffset) !== null && _options$sourceOffset !== void 0 ? _options$sourceOffset : 0, (_options$destinationO = options.destinationOffset) !== null && _options$destinationO !== void 0 ? _options$destinationO : 0, options.size);
      gl2.bindBuffer(GL.COPY_READ_BUFFER, null);
      gl2.bindBuffer(GL.COPY_WRITE_BUFFER, null);
    } else {
      throw new Error("copyBufferToBuffer not implemented in WebGL1");
    }
  }
  function _copyBufferToTexture(device, options) {
    throw new Error("Not implemented");
  }
  function _copyTextureToBuffer(device, options) {
    const {
      source,
      mipLevel = 0,
      aspect = "all",
      width = options.source.width,
      height = options.source.height,
      depthOrArrayLayers = 0,
      origin = [0, 0],
      destination,
      byteOffset = 0,
      bytesPerRow,
      rowsPerImage
    } = options;
    if (aspect !== "all") {
      throw new Error("not supported");
    }
    if (mipLevel !== 0 || depthOrArrayLayers !== void 0 || bytesPerRow || rowsPerImage) {
      throw new Error("not implemented");
    }
    const gl2 = device.assertWebGL2();
    const {
      framebuffer,
      destroyFramebuffer
    } = getFramebuffer(source);
    try {
      const webglBuffer = destination;
      const sourceWidth = width || framebuffer.width;
      const sourceHeight = height || framebuffer.height;
      const sourceFormat = GL.RGBA;
      const sourceType = GL.UNSIGNED_BYTE;
      gl2.bindBuffer(GL.PIXEL_PACK_BUFFER, webglBuffer.handle);
      gl2.bindFramebuffer(GL.FRAMEBUFFER, framebuffer.handle);
      gl2.readPixels(origin[0], origin[1], sourceWidth, sourceHeight, sourceFormat, sourceType, byteOffset);
    } finally {
      gl2.bindBuffer(GL.PIXEL_PACK_BUFFER, null);
      gl2.bindFramebuffer(GL.FRAMEBUFFER, null);
      if (destroyFramebuffer) {
        framebuffer.destroy();
      }
    }
  }
  function _copyTextureToTexture(device, options) {
    const {
      source,
      origin = [0, 0],
      destination
    } = options;
    let {
      width = options.destination.width,
      height = options.destination.width
    } = options;
    const destinationMipmaplevel = 0;
    const destinationInternalFormat = GL.RGBA;
    const {
      framebuffer,
      destroyFramebuffer
    } = getFramebuffer(source);
    const [sourceX, sourceY] = origin;
    const isSubCopy = false;
    device.gl.bindFramebuffer(GL.FRAMEBUFFER, framebuffer.handle);
    let texture = null;
    let textureTarget;
    if (destination instanceof WEBGLTexture) {
      texture = destination;
      width = Number.isFinite(width) ? width : texture.width;
      height = Number.isFinite(height) ? height : texture.height;
      texture.bind(0);
      textureTarget = texture.destination;
    } else {
      throw new Error("whoops");
    }
    if (!isSubCopy) {
      device.gl.copyTexImage2D(textureTarget, destinationMipmaplevel, destinationInternalFormat, sourceX, sourceY, width, height, 0);
    } else {
    }
    if (texture) {
      texture.unbind();
    }
    if (destroyFramebuffer) {
      framebuffer.destroy();
    }
    return texture;
  }
  function getFramebuffer(source) {
    if (source instanceof import_core27.Texture) {
      const {
        width,
        height,
        id
      } = source;
      const framebuffer = source.device.createFramebuffer({
        id: `framebuffer-for-${id}`,
        width,
        height,
        colorAttachments: [source]
      });
      return {
        framebuffer,
        destroyFramebuffer: true
      };
    }
    return {
      framebuffer: source,
      destroyFramebuffer: false
    };
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/resources/webgl-command-encoder.js
  var WEBGLCommandEncoder = class extends import_core28.CommandEncoder {
    constructor(device, props) {
      super(device, props);
      this.device = void 0;
      this.commandBuffer = void 0;
      this.device = device;
      this.commandBuffer = new WEBGLCommandBuffer(device);
    }
    destroy() {
    }
    finish() {
      this.commandBuffer.submitCommands();
    }
    copyBufferToBuffer(options) {
      this.commandBuffer.commands.push({
        name: "copy-buffer-to-buffer",
        options
      });
    }
    copyBufferToTexture(options) {
      this.commandBuffer.commands.push({
        name: "copy-buffer-to-texture",
        options
      });
    }
    copyTextureToBuffer(options) {
      this.commandBuffer.commands.push({
        name: "copy-texture-to-buffer",
        options
      });
    }
    copyTextureToTexture(options) {
      this.commandBuffer.commands.push({
        name: "copy-texture-to-texture",
        options
      });
    }
    pushDebugGroup(groupLabel) {
    }
    popDebugGroup() {
    }
    insertDebugMarker(markerLabel) {
    }
  };

  // ../../node_modules/@luma.gl/webgl/dist/adapter/resources/webgl-vertex-array.js
  var import_core29 = __toESM(require_core2(), 1);
  var _Symbol$toStringTag2;
  _Symbol$toStringTag2 = Symbol.toStringTag;
  var WEBGLVertexArray = class extends import_core29.VertexArray {
    get [_Symbol$toStringTag2]() {
      return "VertexArray";
    }
    static isConstantAttributeZeroSupported(device) {
      return device.info.type === "webgl2" || getBrowser() === "Chrome";
    }
    constructor(device, props) {
      super(device, props);
      this.device = void 0;
      this.handle = void 0;
      this.buffer = null;
      this.bufferValue = null;
      this.init = false;
      this.device = device;
      this.handle = this.device.gl2.createVertexArray();
    }
    destroy() {
      super.destroy();
      if (this.buffer) {
        var _this$buffer;
        (_this$buffer = this.buffer) === null || _this$buffer === void 0 ? void 0 : _this$buffer.destroy();
      }
      if (this.handle) {
        this.device.gl2.deleteVertexArray(this.handle);
        this.handle = void 0;
      }
    }
    setIndexBuffer(indexBuffer) {
      const buffer = indexBuffer;
      if (buffer && buffer.glTarget !== GL.ELEMENT_ARRAY_BUFFER) {
        throw new Error("Use .setBuffer()");
      }
      this.device.gl2.bindVertexArray(this.handle);
      this.device.gl2.bindBuffer(GL.ELEMENT_ARRAY_BUFFER, buffer ? buffer.handle : null);
      this.indexBuffer = buffer;
    }
    setBuffer(location, attributeBuffer) {
      const buffer = attributeBuffer;
      if (buffer.glTarget === GL.ELEMENT_ARRAY_BUFFER) {
        throw new Error("Use .setIndexBuffer()");
      }
      const {
        size,
        type,
        stride,
        offset,
        normalized,
        integer,
        divisor
      } = this._getAccessor(location);
      this.device.gl2.bindVertexArray(this.handle);
      this.device.gl.bindBuffer(GL.ARRAY_BUFFER, buffer.handle);
      if (integer) {
        this.device.assertWebGL2();
        this.device.gl2.vertexAttribIPointer(location, size, type, stride, offset);
      } else {
        this.device.gl.vertexAttribPointer(location, size, type, normalized, stride, offset);
      }
      this.device.gl.enableVertexAttribArray(location);
      this.device.gl2.vertexAttribDivisor(location, divisor || 0);
      this.attributes[location] = buffer;
    }
    setConstant(location, value) {
      this._enable(location, false);
      this.attributes[location] = value;
    }
    bindBeforeRender() {
      this.device.gl2.bindVertexArray(this.handle);
      if (!this.init) {
        const webglBuffer = this.indexBuffer;
        this.device.gl2.bindBuffer(GL.ELEMENT_ARRAY_BUFFER, (webglBuffer === null || webglBuffer === void 0 ? void 0 : webglBuffer.handle) || null);
        this.init = true;
      }
      this._applyConstantAttributes();
    }
    unbindAfterRender() {
      this.device.gl2.bindVertexArray(null);
    }
    _applyConstantAttributes() {
      for (let location = 0; location < this.maxVertexAttributes; ++location) {
        const constant = this.attributes[location];
        if (ArrayBuffer.isView(constant)) {
          this.device.setConstantAttribute(location, constant);
        }
      }
    }
    _getAccessor(location) {
      const attributeInfo = this.attributeInfos[location];
      if (!attributeInfo) {
        throw new Error(`Unknown attribute location ${location}`);
      }
      const glType = getGLFromVertexType(attributeInfo.bufferDataType);
      return {
        size: attributeInfo.bufferComponents,
        type: glType,
        stride: attributeInfo.byteStride,
        offset: attributeInfo.byteOffset,
        normalized: attributeInfo.normalized,
        integer: attributeInfo.integer,
        divisor: attributeInfo.stepMode === "instance" ? 1 : 0
      };
    }
    _enable(location) {
      let enable2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
      const canDisableAttributeZero = WEBGLVertexArray.isConstantAttributeZeroSupported(this.device);
      const canDisableAttribute = canDisableAttributeZero || location !== 0;
      if (enable2 || canDisableAttribute) {
        location = Number(location);
        this.device.gl2.bindVertexArray(this.handle);
        if (enable2) {
          this.device.gl.enableVertexAttribArray(location);
        } else {
          this.device.gl.disableVertexAttribArray(location);
        }
        this.device.gl2.bindVertexArray(null);
      }
    }
    getConstantBuffer(elementCount, value) {
      const constantValue = normalizeConstantArrayValue(value);
      const byteLength = constantValue.byteLength * elementCount;
      const length2 = constantValue.length * elementCount;
      let updateNeeded = !this.buffer;
      this.buffer = this.buffer || this.device.createBuffer({
        byteLength
      });
      updateNeeded = updateNeeded || this.buffer.reallocate(byteLength);
      updateNeeded = updateNeeded || !compareConstantArrayValues(constantValue, this.bufferValue);
      if (updateNeeded) {
        const typedArray = (0, import_core29.getScratchArray)(value.constructor, length2);
        (0, import_core29.fillArray)({
          target: typedArray,
          source: constantValue,
          start: 0,
          count: length2
        });
        this.buffer.subData(typedArray);
        this.bufferValue = value;
      }
      return this.buffer;
    }
  };
  function normalizeConstantArrayValue(arrayValue) {
    if (Array.isArray(arrayValue)) {
      return new Float32Array(arrayValue);
    }
    return arrayValue;
  }
  function compareConstantArrayValues(v1, v2) {
    if (!v1 || !v2 || v1.length !== v2.length || v1.constructor !== v2.constructor) {
      return false;
    }
    for (let i = 0; i < v1.length; ++i) {
      if (v1[i] !== v2[i]) {
        return false;
      }
    }
    return true;
  }

  // ../../node_modules/@luma.gl/webgl/dist/adapter/webgl-device.js
  var LOG_LEVEL2 = 1;
  var WebGLDevice = class extends import_core30.Device {
    static isSupported() {
      return typeof WebGLRenderingContext !== "undefined" || isHeadlessGLRegistered();
    }
    get features() {
      this._features = this._features || getDeviceFeatures(this.gl);
      return this._features;
    }
    get limits() {
      this._limits = this._limits || getDeviceLimits(this.gl);
      return this._limits;
    }
    static attach(gl) {
      if (gl instanceof WebGLDevice) {
        return gl;
      }
      if ((gl === null || gl === void 0 ? void 0 : gl.device) instanceof import_core30.Device) {
        return gl.device;
      }
      if (!isWebGL3(gl)) {
        throw new Error("Invalid WebGLRenderingContext");
      }
      return new WebGLDevice({
        gl
      });
    }
    static async create() {
      let props = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      import_core30.log.groupCollapsed(LOG_LEVEL2, "WebGLDevice created");
      if (typeof props.canvas === "string") {
        await import_core30.CanvasContext.pageLoaded;
      }
      if (import_core30.log.get("debug") || props.debug) {
        await loadWebGLDeveloperTools();
      }
      const {
        spector: spector2
      } = props;
      if (import_core30.log.get("spector") || spector2) {
        await loadSpectorJS();
      }
      import_core30.log.probe(LOG_LEVEL2 + 1, "DOM is loaded")();
      if (props.gl && props.gl.device) {
        return WebGLDevice.attach(props.gl);
      }
      return new WebGLDevice(props);
    }
    constructor(props) {
      var _props$gl;
      super({
        ...props,
        id: props.id || (0, import_core30.uid)("webgl-device")
      });
      this.info = void 0;
      this.canvasContext = void 0;
      this.handle = void 0;
      this.lost = void 0;
      this._resolveContextLost = void 0;
      this._features = void 0;
      this._limits = void 0;
      this.renderPass = null;
      this.gl = void 0;
      this.gl2 = null;
      this.debug = false;
      this.isWebGL1 = void 0;
      this.isWebGL2 = void 0;
      this._canvasSizeInfo = {
        clientWidth: 0,
        clientHeight: 0,
        devicePixelRatio: 1
      };
      this._extensions = {};
      this._polyfilled = false;
      this.spector = void 0;
      this._webglLimits = void 0;
      this._constants = void 0;
      const device = (_props$gl = props.gl) === null || _props$gl === void 0 ? void 0 : _props$gl.device;
      if (device) {
        throw new Error(`WebGL context already attached to device ${device.id}`);
      }
      this.canvasContext = new WebGLCanvasContext(this, props);
      this.lost = new Promise((resolve) => {
        this._resolveContextLost = resolve;
      });
      const onContextLost = (event) => {
        var _this$_resolveContext;
        return (_this$_resolveContext = this._resolveContextLost) === null || _this$_resolveContext === void 0 ? void 0 : _this$_resolveContext.call(this, {
          reason: "destroyed",
          message: "Computer entered sleep mode, or too many apps or browser tabs are using the GPU."
        });
      };
      let gl = props.gl || null;
      gl = gl || (isBrowser() ? createBrowserContext(this.canvasContext.canvas, {
        ...props,
        onContextLost
      }) : null);
      gl = gl || (!isBrowser() ? createHeadlessContext({
        ...props,
        onContextLost
      }) : null);
      if (!gl) {
        throw new Error("WebGL context creation failed");
      }
      this.handle = gl;
      this.gl = this.handle;
      this.gl2 = this.gl;
      this.isWebGL2 = isWebGL22(this.gl);
      this.isWebGL1 = !this.isWebGL2;
      this.info = getDeviceInfo(this.gl);
      this.gl.device = this;
      this.gl._version = this.isWebGL2 ? 2 : 1;
      polyfillContext(this.gl);
      const {
        enable: enable2 = true,
        copyState = false
      } = props;
      trackContextState(this.gl, {
        enable: enable2,
        copyState,
        log: function() {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }
          return import_core30.log.log(1, ...args)();
        }
      });
      if (isBrowser() && props.debug) {
        this.gl = makeDebugContext(this.gl, {
          ...props,
          webgl2: this.isWebGL2,
          throwOnError: true
        });
        this.gl2 = this.gl;
        this.debug = true;
        import_core30.log.level = Math.max(import_core30.log.level, 1);
        import_core30.log.warn("WebGL debug mode activated. Performance reduced.")();
      }
      if (isBrowser() && props.spector) {
        const canvas = this.handle.canvas || props.canvas;
        this.spector = initializeSpectorJS({
          ...this.props,
          canvas
        });
      }
      const message2 = `Created ${this.info.type}${this.debug ? " debug" : ""} context: ${this.info.vendor}, ${this.info.renderer} for canvas: ${this.canvasContext.id}`;
      import_core30.log.probe(LOG_LEVEL2, message2)();
      import_core30.log.groupEnd(LOG_LEVEL2)();
    }
    destroy() {
      const ext = this.gl.getExtension("STACKGL_destroy_context");
      if (ext) {
        ext.destroy();
      }
    }
    get isLost() {
      return this.gl.isContextLost();
    }
    getSize() {
      return [this.gl.drawingBufferWidth, this.gl.drawingBufferHeight];
    }
    isTextureFormatSupported(format) {
      return isTextureFormatSupported(this.gl, format);
    }
    isTextureFormatFilterable(format) {
      return isTextureFormatFilterable(this.gl, format);
    }
    isTextureFormatRenderable(format) {
      return isTextureFormatRenderable(this.gl, format);
    }
    assertWebGL2() {
      if (!this.gl2) {
        throw new Error("Requires WebGL2");
      }
      return this.gl2;
    }
    createCanvasContext(props) {
      throw new Error("WebGL only supports a single canvas");
    }
    createBuffer(props) {
      const newProps = this._getBufferProps(props);
      return new BufferWithAccessor(this, newProps);
    }
    _createTexture(props) {
      return new WEBGLTexture(this, props);
    }
    createExternalTexture(props) {
      throw new Error("createExternalTexture() not implemented");
    }
    createSampler(props) {
      return new WEBGLSampler(this, props);
    }
    createShader(props) {
      return new WEBGLShader(this, props);
    }
    createFramebuffer(props) {
      return new WEBGLFramebuffer(this, props);
    }
    createRenderPipeline(props) {
      return new WEBGLRenderPipeline(this, props);
    }
    createVertexArray(props) {
      return new WEBGLVertexArray(this, props);
    }
    beginRenderPass(props) {
      return new WEBGLRenderPass(this, props);
    }
    createComputePipeline(props) {
      throw new Error("ComputePipeline not supported in WebGL");
    }
    beginComputePass(props) {
      throw new Error("compute shaders not supported in WebGL");
    }
    getDefaultRenderPass() {
      this.renderPass = this.renderPass || this.beginRenderPass({
        framebuffer: this.canvasContext.getCurrentFramebuffer()
      });
      return this.renderPass;
    }
    createCommandEncoder(props) {
      return new WEBGLCommandEncoder(this, props);
    }
    submit() {
      var _this$renderPass;
      (_this$renderPass = this.renderPass) === null || _this$renderPass === void 0 ? void 0 : _this$renderPass.end();
      this.renderPass = null;
    }
    get webglLimits() {
      this._webglLimits = this._webglLimits || getWebGLLimits(this.gl);
      return this._webglLimits;
    }
    loseDevice() {
      var _this$_resolveContext2;
      let deviceLossTriggered = false;
      const ext = this.gl.getExtension("WEBGL_lose_context");
      if (ext) {
        deviceLossTriggered = true;
        ext.loseContext();
      }
      (_this$_resolveContext2 = this._resolveContextLost) === null || _this$_resolveContext2 === void 0 ? void 0 : _this$_resolveContext2.call(this, {
        reason: "destroyed",
        message: "Application triggered context loss"
      });
      return deviceLossTriggered;
    }
    pushState() {
      pushContextState(this.gl);
    }
    popState() {
      popContextState(this.gl);
    }
    setSpectorMetadata(handle, props) {
      handle.__SPECTOR_Metadata = props;
    }
    getGLKey(value, gl) {
      gl = gl || this.gl2 || this.gl;
      const number = Number(value);
      for (const key in gl) {
        if (gl[key] === number) {
          return `GL.${key}`;
        }
      }
      return String(value);
    }
    setConstantAttribute(location, constant) {
      this._constants = this._constants || new Array(this.limits.maxVertexAttributes).fill(null);
      const currentConstant = this._constants[location];
      if (currentConstant && compareConstantArrayValues2(currentConstant, constant)) {
        import_core30.log.info(1, `setConstantAttribute(${location}) could have been skipped, value unchanged`)();
      }
      this._constants[location] = constant;
      switch (constant.constructor) {
        case Float32Array:
          setConstantFloatArray(this, location, constant);
          break;
        case Int32Array:
          setConstantIntArray(this, location, constant);
          break;
        case Uint32Array:
          setConstantUintArray(this, location, constant);
          break;
        default:
          (0, import_core30.assert)(false);
      }
    }
  };
  WebGLDevice.type = "webgl";
  function isWebGL3(gl) {
    if (typeof WebGLRenderingContext !== "undefined" && gl instanceof WebGLRenderingContext) {
      return true;
    }
    if (typeof WebGL2RenderingContext !== "undefined" && gl instanceof WebGL2RenderingContext) {
      return true;
    }
    return Boolean(gl && Number.isFinite(gl._version));
  }
  function isWebGL22(gl) {
    if (typeof WebGL2RenderingContext !== "undefined" && gl instanceof WebGL2RenderingContext) {
      return true;
    }
    return Boolean(gl && gl._version === 2);
  }
  function setConstantFloatArray(device, location, array) {
    switch (array.length) {
      case 1:
        device.gl.vertexAttrib1fv(location, array);
        break;
      case 2:
        device.gl.vertexAttrib2fv(location, array);
        break;
      case 3:
        device.gl.vertexAttrib3fv(location, array);
        break;
      case 4:
        device.gl.vertexAttrib4fv(location, array);
        break;
      default:
        (0, import_core30.assert)(false);
    }
  }
  function setConstantIntArray(device, location, array) {
    var _device$gl;
    device.assertWebGL2();
    (_device$gl = device.gl2) === null || _device$gl === void 0 ? void 0 : _device$gl.vertexAttribI4iv(location, array);
  }
  function setConstantUintArray(device, location, array) {
    var _device$gl2;
    device.assertWebGL2();
    (_device$gl2 = device.gl2) === null || _device$gl2 === void 0 ? void 0 : _device$gl2.vertexAttribI4uiv(location, array);
  }
  function compareConstantArrayValues2(v1, v2) {
    if (!v1 || !v2 || v1.length !== v2.length || v1.constructor !== v2.constructor) {
      return false;
    }
    for (let i = 0; i < v1.length; ++i) {
      if (v1[i] !== v2[i]) {
        return false;
      }
    }
    return true;
  }

  // ../../node_modules/@luma.gl/webgl/dist/classic/clear.js
  var import_core31 = __toESM(require_core2(), 1);
  var GL_DEPTH_BUFFER_BIT2 = 256;
  var GL_STENCIL_BUFFER_BIT2 = 1024;
  var GL_COLOR_BUFFER_BIT2 = 16384;
  var ERR_ARGUMENTS = "clear: bad arguments";
  function clear(gl, options) {
    const device = WebGLDevice.attach(gl);
    const {
      framebuffer = null,
      color = null,
      depth = null,
      stencil = null
    } = options || {};
    const parameters2 = {};
    if (framebuffer) {
      parameters2.framebuffer = framebuffer;
    }
    let clearFlags = 0;
    if (color) {
      clearFlags |= GL_COLOR_BUFFER_BIT2;
      if (color !== true) {
        parameters2.clearColor = color;
      }
    }
    if (depth) {
      clearFlags |= GL_DEPTH_BUFFER_BIT2;
      if (depth !== true) {
        parameters2.clearDepth = depth;
      }
    }
    if (stencil) {
      clearFlags |= GL_STENCIL_BUFFER_BIT2;
      if (depth !== true) {
        parameters2.clearStencil = depth;
      }
    }
    (0, import_core31.assert)(clearFlags !== 0, ERR_ARGUMENTS);
    withGLParameters(device.gl, parameters2, () => {
      device.gl.clear(clearFlags);
    });
  }

  // ../../node_modules/@luma.gl/webgl/dist/classic/copy-and-blit.js
  var import_core33 = __toESM(require_core2(), 1);

  // ../../node_modules/@luma.gl/webgl/dist/classic/format-utils.js
  var import_core32 = __toESM(require_core2(), 1);
  function glFormatToComponents(format) {
    switch (format) {
      case GL.ALPHA:
      case GL.R32F:
      case GL.RED:
        return 1;
      case GL.RG32F:
      case GL.RG:
        return 2;
      case GL.RGB:
      case GL.RGB32F:
        return 3;
      case GL.RGBA:
      case GL.RGBA32F:
        return 4;
      default:
        (0, import_core32.assert)(false);
        return 0;
    }
  }

  // ../../node_modules/@luma.gl/webgl/dist/classic/copy-and-blit.js
  function readPixelsToArray(source, options) {
    var _framebuffer$colorAtt;
    const {
      sourceX = 0,
      sourceY = 0,
      sourceFormat = GL.RGBA,
      sourceAttachment = GL.COLOR_ATTACHMENT0
    } = options || {};
    let {
      target = null,
      sourceWidth,
      sourceHeight,
      sourceType
    } = options || {};
    const {
      framebuffer,
      deleteFramebuffer
    } = getFramebuffer2(source);
    (0, import_core33.assert)(framebuffer);
    const {
      gl,
      handle
    } = framebuffer;
    sourceWidth = sourceWidth || framebuffer.width;
    sourceHeight = sourceHeight || framebuffer.height;
    const attachment = sourceAttachment - GL.COLOR_ATTACHMENT0;
    sourceType = sourceType || ((_framebuffer$colorAtt = framebuffer.colorAttachments[attachment]) === null || _framebuffer$colorAtt === void 0 ? void 0 : _framebuffer$colorAtt.type) || GL.UNSIGNED_BYTE;
    target = getPixelArray(target, sourceType, sourceFormat, sourceWidth, sourceHeight);
    sourceType = sourceType || getGLTypeFromTypedArray(target);
    const prevHandle = gl.bindFramebuffer(GL.FRAMEBUFFER, handle);
    gl.readPixels(sourceX, sourceY, sourceWidth, sourceHeight, sourceFormat, sourceType, target);
    gl.bindFramebuffer(GL.FRAMEBUFFER, prevHandle || null);
    if (deleteFramebuffer) {
      framebuffer.destroy();
    }
    return target;
  }
  function getFramebuffer2(source) {
    if (!(source instanceof import_core33.Framebuffer)) {
      return {
        framebuffer: toFramebuffer(source),
        deleteFramebuffer: true
      };
    }
    return {
      framebuffer: source,
      deleteFramebuffer: false
    };
  }
  function toFramebuffer(texture, props) {
    const {
      device,
      width,
      height,
      id
    } = texture;
    const framebuffer = device.createFramebuffer({
      ...props,
      id: `framebuffer-for-${id}`,
      width,
      height,
      colorAttachments: [texture]
    });
    return framebuffer;
  }
  function getPixelArray(pixelArray, type, format, width, height) {
    if (pixelArray) {
      return pixelArray;
    }
    type = type || GL.UNSIGNED_BYTE;
    const ArrayType = getTypedArrayFromGLType(type, {
      clamped: false
    });
    const components = glFormatToComponents(format);
    return new ArrayType(width * height * components);
  }

  // src/data-filter/data-filter-extension.ts
  var import_core38 = __toESM(require_core());

  // src/data-filter/shader-module.ts
  var vs2 = `
uniform DATAFILTER_TYPE filter_min;
uniform DATAFILTER_TYPE filter_softMin;
uniform DATAFILTER_TYPE filter_softMax;
uniform DATAFILTER_TYPE filter_max;
uniform bool filter_useSoftMargin;
uniform bool filter_enabled;
uniform bool filter_transformSize;

#ifdef NON_INSTANCED_MODEL
  #define DATAFILTER_ATTRIB filterValues
  #define DATAFILTER_ATTRIB_64LOW filterValues64Low
#else
  #define DATAFILTER_ATTRIB instanceFilterValues
  #define DATAFILTER_ATTRIB_64LOW instanceFilterValues64Low
#endif

attribute DATAFILTER_TYPE DATAFILTER_ATTRIB;
#ifdef DATAFILTER_DOUBLE
  attribute DATAFILTER_TYPE DATAFILTER_ATTRIB_64LOW;

  uniform DATAFILTER_TYPE filter_min64High;
  uniform DATAFILTER_TYPE filter_max64High;
#endif

varying float dataFilter_value;

float dataFilter_reduceValue(float value) {
  return value;
}
float dataFilter_reduceValue(vec2 value) {
  return min(value.x, value.y);
}
float dataFilter_reduceValue(vec3 value) {
  return min(min(value.x, value.y), value.z);
}
float dataFilter_reduceValue(vec4 value) {
  return min(min(value.x, value.y), min(value.z, value.w));
}
void dataFilter_setValue(DATAFILTER_TYPE valueFromMin, DATAFILTER_TYPE valueFromMax) {
  if (filter_enabled) {
    if (filter_useSoftMargin) {
      dataFilter_value = dataFilter_reduceValue(
        smoothstep(filter_min, filter_softMin, valueFromMin) *
        (1.0 - smoothstep(filter_softMax, filter_max, valueFromMax))
      );
    } else {
      dataFilter_value = dataFilter_reduceValue(
        step(filter_min, valueFromMin) * step(valueFromMax, filter_max)
      );
    }
  } else {
    dataFilter_value = 1.0;
  }
}
`;
  var fs2 = `
uniform bool filter_transformColor;
varying float dataFilter_value;
`;
  function getUniforms(opts) {
    if (!opts || !("extensions" in opts)) {
      return {};
    }
    const {
      filterRange = [-1, 1],
      filterEnabled = true,
      filterTransformSize = true,
      filterTransformColor = true
    } = opts;
    const filterSoftRange = opts.filterSoftRange || filterRange;
    return {
      ...Number.isFinite(filterRange[0]) ? {
        filter_min: filterRange[0],
        filter_softMin: filterSoftRange[0],
        filter_softMax: filterSoftRange[1],
        filter_max: filterRange[1]
      } : {
        filter_min: filterRange.map((r) => r[0]),
        filter_softMin: filterSoftRange.map((r) => r[0]),
        filter_softMax: filterSoftRange.map((r) => r[1]),
        filter_max: filterRange.map((r) => r[1])
      },
      filter_enabled: filterEnabled,
      filter_useSoftMargin: Boolean(opts.filterSoftRange),
      filter_transformSize: filterEnabled && filterTransformSize,
      filter_transformColor: filterEnabled && filterTransformColor
    };
  }
  function getUniforms64(opts) {
    if (!opts || !("extensions" in opts)) {
      return {};
    }
    const uniforms = getUniforms(opts);
    if (Number.isFinite(uniforms.filter_min)) {
      const min64High = Math.fround(uniforms.filter_min);
      uniforms.filter_min -= min64High;
      uniforms.filter_softMin -= min64High;
      uniforms.filter_min64High = min64High;
      const max64High = Math.fround(uniforms.filter_max);
      uniforms.filter_max -= max64High;
      uniforms.filter_softMax -= max64High;
      uniforms.filter_max64High = max64High;
    } else {
      const min64High = uniforms.filter_min.map(Math.fround);
      uniforms.filter_min = uniforms.filter_min.map((x, i) => x - min64High[i]);
      uniforms.filter_softMin = uniforms.filter_softMin.map((x, i) => x - min64High[i]);
      uniforms.filter_min64High = min64High;
      const max64High = uniforms.filter_max.map(Math.fround);
      uniforms.filter_max = uniforms.filter_max.map((x, i) => x - max64High[i]);
      uniforms.filter_softMax = uniforms.filter_softMax.map((x, i) => x - max64High[i]);
      uniforms.filter_max64High = max64High;
    }
    return uniforms;
  }
  var inject2 = {
    "vs:#main-start": `
    #ifdef DATAFILTER_DOUBLE
      dataFilter_setValue(
        DATAFILTER_ATTRIB - filter_min64High + DATAFILTER_ATTRIB_64LOW,
        DATAFILTER_ATTRIB - filter_max64High + DATAFILTER_ATTRIB_64LOW
      );
    #else
      dataFilter_setValue(DATAFILTER_ATTRIB, DATAFILTER_ATTRIB);
    #endif
  `,
    "vs:#main-end": `
    if (dataFilter_value == 0.0) {
      gl_Position = vec4(0.);
    }
  `,
    "vs:DECKGL_FILTER_SIZE": `
    if (filter_transformSize) {
      size = size * dataFilter_value;
    }
  `,
    "fs:DECKGL_FILTER_COLOR": `
    if (dataFilter_value == 0.0) discard;
    if (filter_transformColor) {
      color.a *= dataFilter_value;
    }
  `
  };
  var shaderModule = {
    name: "data-filter",
    vs: vs2,
    fs: fs2,
    inject: inject2,
    getUniforms
  };
  var shaderModule64 = {
    name: "data-filter-fp64",
    vs: vs2,
    fs: fs2,
    inject: inject2,
    getUniforms: getUniforms64
  };

  // ../../../luma.gl/modules/engine/dist/model/model.js
  var import_core36 = __toESM(require_core2(), 1);
  var import_core37 = __toESM(require_core2(), 1);

  // ../../../luma.gl/modules/shadertools/dist/lib/glsl-utils/highlight.js
  var glsl = (x) => `${x}`;

  // ../../../luma.gl/modules/shadertools/dist/lib/utils/assert.js
  function assert17(condition, message2) {
    if (!condition) {
      throw new Error(message2 || "shadertools: assertion failed.");
    }
  }

  // ../../../luma.gl/modules/shadertools/dist/lib/filters/prop-types.js
  var DEFAULT_PROP_VALIDATORS = {
    number: {
      type: "number",
      validate(value, propType) {
        return Number.isFinite(value) && typeof propType === "object" && (propType.max === void 0 || value <= propType.max) && (propType.min === void 0 || value >= propType.min);
      }
    },
    array: {
      type: "array",
      validate(value, propType) {
        return Array.isArray(value) || ArrayBuffer.isView(value);
      }
    }
  };
  function makePropValidators(propTypes) {
    const propValidators = {};
    for (const [name, propType] of Object.entries(propTypes)) {
      propValidators[name] = makePropValidator(propType);
    }
    return propValidators;
  }
  function getValidatedProperties(properties, propValidators, errorMessage) {
    const validated = {};
    for (const [key, propsValidator] of Object.entries(propValidators)) {
      if (properties && key in properties && !propsValidator.private) {
        if (propsValidator.validate) {
          assert17(propsValidator.validate(properties[key], propsValidator), `${errorMessage}: invalid ${key}`);
        }
        validated[key] = properties[key];
      } else {
        validated[key] = propsValidator.value;
      }
    }
    return validated;
  }
  function makePropValidator(propType) {
    let type = getTypeOf(propType);
    if (type !== "object") {
      return {
        value: propType,
        ...DEFAULT_PROP_VALIDATORS[type],
        type
      };
    }
    if (typeof propType === "object") {
      if (!propType) {
        return {
          type: "object",
          value: null
        };
      }
      if (propType.type !== void 0) {
        return {
          ...propType,
          ...DEFAULT_PROP_VALIDATORS[propType.type],
          type: propType.type
        };
      }
      if (propType.value === void 0) {
        return {
          type: "object",
          value: propType
        };
      }
      type = getTypeOf(propType.value);
      return {
        ...propType,
        ...DEFAULT_PROP_VALIDATORS[type],
        type
      };
    }
    throw new Error("props");
  }
  function getTypeOf(value) {
    if (Array.isArray(value) || ArrayBuffer.isView(value)) {
      return "array";
    }
    return typeof value;
  }

  // ../../../luma.gl/modules/shadertools/dist/module-injectors.js
  var MODULE_INJECTORS_VS = glsl`\
#ifdef MODULE_LOGDEPTH
  logdepth_adjustPosition(gl_Position);
#endif
`;
  var MODULE_INJECTORS_FS = glsl`\
#ifdef MODULE_MATERIAL
  gl_FragColor = material_filterColor(gl_FragColor);
#endif

#ifdef MODULE_LIGHTING
  gl_FragColor = lighting_filterColor(gl_FragColor);
#endif

#ifdef MODULE_FOG
  gl_FragColor = fog_filterColor(gl_FragColor);
#endif

#ifdef MODULE_PICKING
  gl_FragColor = picking_filterHighlightColor(gl_FragColor);
  gl_FragColor = picking_filterPickingColor(gl_FragColor);
#endif

#ifdef MODULE_LOGDEPTH
  logdepth_setFragDepth();
#endif
`;

  // ../../../luma.gl/modules/shadertools/dist/lib/shader-assembly/shader-injections.js
  var MODULE_INJECTORS = {
    vertex: MODULE_INJECTORS_VS,
    fragment: MODULE_INJECTORS_FS
  };
  var REGEX_START_OF_MAIN = /void\s+main\s*\([^)]*\)\s*\{\n?/;
  var REGEX_END_OF_MAIN = /}\n?[^{}]*$/;
  var fragments = [];
  var DECLARATION_INJECT_MARKER = "__LUMA_INJECT_DECLARATIONS__";
  function normalizeInjections(injections) {
    const result = {
      vertex: {},
      fragment: {}
    };
    for (const hook in injections) {
      let injection = injections[hook];
      const stage = getHookStage(hook);
      if (typeof injection === "string") {
        injection = {
          order: 0,
          injection
        };
      }
      result[stage][hook] = injection;
    }
    return result;
  }
  function getHookStage(hook) {
    const type = hook.slice(0, 2);
    switch (type) {
      case "vs":
        return "vertex";
      case "fs":
        return "fragment";
      default:
        throw new Error(type);
    }
  }
  function injectShader(source, stage, inject6) {
    let injectStandardStubs = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
    const isVertex = stage === "vertex";
    for (const key in inject6) {
      const fragmentData = inject6[key];
      fragmentData.sort((a, b) => a.order - b.order);
      fragments.length = fragmentData.length;
      for (let i = 0, len2 = fragmentData.length; i < len2; ++i) {
        fragments[i] = fragmentData[i].injection;
      }
      const fragmentString = `${fragments.join("\n")}
`;
      switch (key) {
        case "vs:#decl":
          if (isVertex) {
            source = source.replace(DECLARATION_INJECT_MARKER, fragmentString);
          }
          break;
        case "vs:#main-start":
          if (isVertex) {
            source = source.replace(REGEX_START_OF_MAIN, (match) => match + fragmentString);
          }
          break;
        case "vs:#main-end":
          if (isVertex) {
            source = source.replace(REGEX_END_OF_MAIN, (match) => fragmentString + match);
          }
          break;
        case "fs:#decl":
          if (!isVertex) {
            source = source.replace(DECLARATION_INJECT_MARKER, fragmentString);
          }
          break;
        case "fs:#main-start":
          if (!isVertex) {
            source = source.replace(REGEX_START_OF_MAIN, (match) => match + fragmentString);
          }
          break;
        case "fs:#main-end":
          if (!isVertex) {
            source = source.replace(REGEX_END_OF_MAIN, (match) => fragmentString + match);
          }
          break;
        default:
          source = source.replace(key, (match) => match + fragmentString);
      }
    }
    source = source.replace(DECLARATION_INJECT_MARKER, "");
    if (injectStandardStubs) {
      source = source.replace(/\}\s*$/, (match) => match + MODULE_INJECTORS[stage]);
    }
    return source;
  }

  // ../../../luma.gl/modules/shadertools/dist/lib/shader-module/shader-module-instance.js
  var ShaderModuleInstance = class {
    static instantiateModules(modules) {
      return modules.map((module) => {
        if (module instanceof ShaderModuleInstance) {
          return module;
        }
        assert17(typeof module !== "string", `Shader module use by name is deprecated. Import shader module '${module}' and use it directly.`);
        assert17(module.name, "shader module has no name");
        const moduleObject = new ShaderModuleInstance(module);
        moduleObject.dependencies = ShaderModuleInstance.instantiateModules(module.dependencies || []);
        return moduleObject;
      });
    }
    constructor(props) {
      this.name = void 0;
      this.vs = void 0;
      this.fs = void 0;
      this.getModuleUniforms = void 0;
      this.dependencies = void 0;
      this.deprecations = void 0;
      this.defines = void 0;
      this.injections = void 0;
      this.uniforms = {};
      this.uniformTypes = {};
      const {
        name,
        vs: vs5,
        fs: fs4,
        dependencies = [],
        uniformPropTypes = {},
        getUniforms: getUniforms4,
        deprecations = [],
        defines = {},
        inject: inject6 = {}
      } = props;
      assert17(typeof name === "string");
      this.name = name;
      this.vs = vs5;
      this.fs = fs4;
      this.getModuleUniforms = getUniforms4;
      this.dependencies = ShaderModuleInstance.instantiateModules(dependencies);
      this.deprecations = this._parseDeprecationDefinitions(deprecations);
      this.defines = defines;
      this.injections = normalizeInjections(inject6);
      if (uniformPropTypes) {
        this.uniforms = makePropValidators(uniformPropTypes);
      }
    }
    getModuleSource(stage) {
      let moduleSource;
      switch (stage) {
        case "vertex":
          moduleSource = this.vs || "";
          break;
        case "fragment":
          moduleSource = this.fs || "";
          break;
        default:
          assert17(false);
      }
      return `#define MODULE_${this.name.toUpperCase().replace(/[^0-9a-z]/gi, "_")}
${moduleSource}// END MODULE_${this.name}

`;
    }
    getUniforms(userProps, uniforms) {
      if (this.getModuleUniforms) {
        return this.getModuleUniforms(userProps, uniforms);
      }
      return getValidatedProperties(userProps, this.uniforms, this.name);
    }
    getDefines() {
      return this.defines;
    }
    checkDeprecations(shaderSource, log13) {
      this.deprecations.forEach((def) => {
        var _def$regex;
        if ((_def$regex = def.regex) !== null && _def$regex !== void 0 && _def$regex.test(shaderSource)) {
          if (def.deprecated) {
            log13.deprecated(def.old, def.new)();
          } else {
            log13.removed(def.old, def.new)();
          }
        }
      });
    }
    _parseDeprecationDefinitions(deprecations) {
      deprecations.forEach((def) => {
        switch (def.type) {
          case "function":
            def.regex = new RegExp(`\\b${def.old}\\(`);
            break;
          default:
            def.regex = new RegExp(`${def.type} ${def.old};`);
        }
      });
      return deprecations;
    }
    _defaultGetUniforms() {
      let opts = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      const uniforms = {};
      const propTypes = this.uniforms;
      for (const key in propTypes) {
        const propDef = propTypes[key];
        if (key in opts && !propDef.private) {
          if (propDef.validate) {
            assert17(propDef.validate(opts[key], propDef), `${this.name}: invalid ${key}`);
          }
          uniforms[key] = opts[key];
        } else {
          uniforms[key] = propDef.value;
        }
      }
      return uniforms;
    }
  };

  // ../../../luma.gl/modules/shadertools/dist/lib/shader-assembly/resolve-modules.js
  function resolveModules(modules) {
    const instances = ShaderModuleInstance.instantiateModules(modules);
    return getShaderDependencies(instances);
  }
  function getShaderDependencies(modules) {
    const moduleMap = {};
    const moduleDepth = {};
    getDependencyGraph({
      modules,
      level: 0,
      moduleMap,
      moduleDepth
    });
    return Object.keys(moduleDepth).sort((a, b) => moduleDepth[b] - moduleDepth[a]).map((name) => moduleMap[name]);
  }
  function getDependencyGraph(options) {
    const {
      modules,
      level,
      moduleMap,
      moduleDepth
    } = options;
    if (level >= 5) {
      throw new Error("Possible loop in shader dependency graph");
    }
    for (const module of modules) {
      moduleMap[module.name] = module;
      if (moduleDepth[module.name] === void 0 || moduleDepth[module.name] < level) {
        moduleDepth[module.name] = level;
      }
    }
    for (const module of modules) {
      if (module.dependencies) {
        getDependencyGraph({
          modules: module.dependencies,
          level: level + 1,
          moduleMap,
          moduleDepth
        });
      }
    }
  }

  // ../../../luma.gl/modules/shadertools/dist/lib/shader-assembly/platform-defines.js
  function getPlatformShaderDefines(platformInfo) {
    switch (platformInfo === null || platformInfo === void 0 ? void 0 : platformInfo.gpu.toLowerCase()) {
      case "apple":
        return glsl`\
#define APPLE_GPU
// Apple optimizes away the calculation necessary for emulated fp64
#define LUMA_FP64_CODE_ELIMINATION_WORKAROUND 1
#define LUMA_FP32_TAN_PRECISION_WORKAROUND 1
// Intel GPU doesn't have full 32 bits precision in same cases, causes overflow
#define LUMA_FP64_HIGH_BITS_OVERFLOW_WORKAROUND 1
`;
      case "nvidia":
        return glsl`\
#define NVIDIA_GPU
// Nvidia optimizes away the calculation necessary for emulated fp64
#define LUMA_FP64_CODE_ELIMINATION_WORKAROUND 1
`;
      case "intel":
        return glsl`\
#define INTEL_GPU
// Intel optimizes away the calculation necessary for emulated fp64
#define LUMA_FP64_CODE_ELIMINATION_WORKAROUND 1
// Intel's built-in 'tan' function doesn't have acceptable precision
#define LUMA_FP32_TAN_PRECISION_WORKAROUND 1
// Intel GPU doesn't have full 32 bits precision in same cases, causes overflow
#define LUMA_FP64_HIGH_BITS_OVERFLOW_WORKAROUND 1
`;
      case "amd":
        return glsl`\
#define AMD_GPU
`;
      default:
        return glsl`\
#define DEFAULT_GPU
// Prevent driver from optimizing away the calculation necessary for emulated fp64
#define LUMA_FP64_CODE_ELIMINATION_WORKAROUND 1
// Headless Chrome's software shader 'tan' function doesn't have acceptable precision
#define LUMA_FP32_TAN_PRECISION_WORKAROUND 1
// If the GPU doesn't have full 32 bits precision, will causes overflow
#define LUMA_FP64_HIGH_BITS_OVERFLOW_WORKAROUND 1
`;
    }
  }
  function getVersionDefines(platformInfo) {
    let versionDefines = glsl`\
#if (__VERSION__ > 120)
# define FEATURE_GLSL_DERIVATIVES
# define FEATURE_GLSL_DRAW_BUFFERS
# define FEATURE_GLSL_FRAG_DEPTH
# define FEATURE_GLSL_TEXTURE_LOD
#endif // __VERSION
`;
    if (!platformInfo.features.has("webgl2") && platformInfo.features.has("glsl-frag-depth")) {
      versionDefines += glsl`\

// FRAG_DEPTH => gl_FragDepth is available
#ifdef GL_EXT_frag_depth
# extension GL_EXT_frag_depth : enable
# define FEATURE_GLSL_FRAG_DEPTH
# define FRAG_DEPTH
# define gl_FragDepth gl_FragDepthEXT
#endif
`;
    }
    if (!platformInfo.features.has("webgl2") && platformInfo !== null && platformInfo !== void 0 && platformInfo.features.has("glsl-derivatives")) {
      versionDefines += glsl`\

// DERIVATIVES => dxdF, dxdY and fwidth are available
#if defined(GL_OES_standard_derivatives) || defined(FEATURE_GLSL_DERIVATIVES)
# extension GL_OES_standard_derivatives : enable
# define FEATURE_GLSL_DERIVATIVES
# define DERIVATIVES
#endif
`;
    }
    if (!platformInfo.features.has("webgl2") && platformInfo !== null && platformInfo !== void 0 && platformInfo.features.has("glsl-frag-data")) {
      versionDefines += glsl`\

// DRAW_BUFFERS => gl_FragData[] is available
#ifdef GL_EXT_draw_buffers
# extension GL_EXT_draw_buffers : require
# define FEATURE_GLSL_DRAW_BUFFERS
# define DRAW_BUFFERS
#endif
`;
    }
    if (!platformInfo.features.has("webgl2") && platformInfo !== null && platformInfo !== void 0 && platformInfo.features.has("glsl-texture-lod")) {
      versionDefines += glsl`\
// TEXTURE_LOD => texture2DLod etc are available
#ifdef GL_EXT_shader_texture_lod
# extension GL_EXT_shader_texture_lod : enable
# define FEATURE_GLSL_TEXTURE_LOD
# define TEXTURE_LOD
#endif
`;
    }
    return versionDefines;
  }

  // ../../../luma.gl/modules/shadertools/dist/lib/shader-transpiler/transpile-glsl-shader.js
  function transpileGLSLShader(source, targetGLSLVersion, stage) {
    switch (targetGLSLVersion) {
      case 300:
        switch (stage) {
          case "vertex":
            return convertShader(source, ES300_VERTEX_REPLACEMENTS);
          case "fragment":
            return convertFragmentShaderTo300(source);
          default:
            throw new Error(`unknown shader stage ${stage}`);
        }
      case 100:
        switch (stage) {
          case "vertex":
            return convertShader(source, ES100_VERTEX_REPLACEMENTS);
          case "fragment":
            return convertFragmentShaderTo100(source);
          default:
            throw new Error(`unknown shader stage ${stage}`);
        }
      default:
        throw new Error(`unknown GLSL version ${targetGLSLVersion}`);
    }
  }
  var ES300_REPLACEMENTS = [[/^(#version[ \t]+(100|300[ \t]+es))?[ \t]*\n/, "#version 300 es\n"], [/\btexture(2D|2DProj|Cube)Lod(EXT)?\(/g, "textureLod("], [/\btexture(2D|2DProj|Cube)(EXT)?\(/g, "texture("]];
  var ES300_VERTEX_REPLACEMENTS = [...ES300_REPLACEMENTS, [makeVariableTextRegExp("attribute"), "in $1"], [makeVariableTextRegExp("varying"), "out $1"]];
  var ES300_FRAGMENT_REPLACEMENTS = [...ES300_REPLACEMENTS, [makeVariableTextRegExp("varying"), "in $1"]];
  var ES100_REPLACEMENTS = [[/^#version[ \t]+300[ \t]+es/, "#version 100"], [/\btexture(2D|2DProj|Cube)Lod\(/g, "texture$1LodEXT("], [/\btexture\(/g, "texture2D("], [/\btextureLod\(/g, "texture2DLodEXT("]];
  var ES100_VERTEX_REPLACEMENTS = [...ES100_REPLACEMENTS, [makeVariableTextRegExp("in"), "attribute $1"], [makeVariableTextRegExp("out"), "varying $1"]];
  var ES100_FRAGMENT_REPLACEMENTS = [...ES100_REPLACEMENTS, [makeVariableTextRegExp("in"), "varying $1"]];
  var ES100_FRAGMENT_OUTPUT_NAME = "gl_FragColor";
  var ES300_FRAGMENT_OUTPUT_REGEX = /\bout[ \t]+vec4[ \t]+(\w+)[ \t]*;\n?/;
  var REGEX_START_OF_MAIN2 = /void\s+main\s*\([^)]*\)\s*\{\n?/;
  function convertShader(source, replacements) {
    for (const [pattern, replacement] of replacements) {
      source = source.replace(pattern, replacement);
    }
    return source;
  }
  function convertFragmentShaderTo300(source) {
    source = convertShader(source, ES300_FRAGMENT_REPLACEMENTS);
    const outputMatch = ES300_FRAGMENT_OUTPUT_REGEX.exec(source);
    if (outputMatch) {
      const outputName = outputMatch[1];
      source = source.replace(new RegExp(`\\b${ES100_FRAGMENT_OUTPUT_NAME}\\b`, "g"), outputName);
    } else {
      const outputName = "fragmentColor";
      source = source.replace(REGEX_START_OF_MAIN2, (match) => `out vec4 ${outputName};
${match}`).replace(new RegExp(`\\b${ES100_FRAGMENT_OUTPUT_NAME}\\b`, "g"), outputName);
    }
    return source;
  }
  function convertFragmentShaderTo100(source) {
    source = convertShader(source, ES100_FRAGMENT_REPLACEMENTS);
    const outputMatch = ES300_FRAGMENT_OUTPUT_REGEX.exec(source);
    if (outputMatch) {
      const outputName = outputMatch[1];
      source = source.replace(ES300_FRAGMENT_OUTPUT_REGEX, "").replace(new RegExp(`\\b${outputName}\\b`, "g"), ES100_FRAGMENT_OUTPUT_NAME);
    }
    return source;
  }
  function makeVariableTextRegExp(qualifier) {
    return new RegExp(`\\b${qualifier}[ \\t]+(\\w+[ \\t]+\\w+(\\[\\w+\\])?;)`, "g");
  }

  // ../../../luma.gl/modules/shadertools/dist/lib/shader-assembly/shader-hooks.js
  function getShaderHooks(hookFunctions, hookInjections) {
    let result = "";
    for (const hookName in hookFunctions) {
      const hookFunction = hookFunctions[hookName];
      result += `void ${hookFunction.signature} {
`;
      if (hookFunction.header) {
        result += `  ${hookFunction.header}`;
      }
      if (hookInjections[hookName]) {
        const injections = hookInjections[hookName];
        injections.sort((a, b) => a.order - b.order);
        for (const injection of injections) {
          result += `  ${injection.injection}
`;
        }
      }
      if (hookFunction.footer) {
        result += `  ${hookFunction.footer}`;
      }
      result += "}\n";
    }
    return result;
  }
  function normalizeShaderHooks(hookFunctions) {
    const result = {
      vertex: {},
      fragment: {}
    };
    for (const hookFunction of hookFunctions) {
      let opts;
      let hook;
      if (typeof hookFunction !== "string") {
        opts = hookFunction;
        hook = opts.hook;
      } else {
        opts = {};
        hook = hookFunction;
      }
      hook = hook.trim();
      const [shaderStage, signature] = hook.split(":");
      const name = hook.replace(/\(.+/, "");
      const normalizedHook = Object.assign(opts, {
        signature
      });
      switch (shaderStage) {
        case "vs":
          result.vertex[name] = normalizedHook;
          break;
        case "fs":
          result.fragment[name] = normalizedHook;
          break;
        default:
          throw new Error(shaderStage);
      }
    }
    return result;
  }

  // ../../../luma.gl/modules/shadertools/dist/lib/shader-assembly/assemble-shaders.js
  var INJECT_SHADER_DECLARATIONS = `

${DECLARATION_INJECT_MARKER}

`;
  var FRAGMENT_SHADER_PROLOGUE = glsl`\
precision highp float;

`;
  function assembleShaders(platformInfo, options) {
    const {
      vs: vs5,
      fs: fs4
    } = options;
    const modules = resolveModules(options.modules || []);
    switch (platformInfo.shaderLanguage) {
      case "glsl":
        return {
          vs: assembleGLSLShader(platformInfo, {
            ...options,
            source: vs5,
            stage: "vertex",
            modules
          }),
          fs: assembleGLSLShader(platformInfo, {
            ...options,
            source: fs4,
            stage: "fragment",
            modules
          }),
          getUniforms: assembleGetUniforms(modules)
        };
      case "wgsl":
        return {
          vs: assembleWGSLShader(platformInfo, {
            ...options,
            source: vs5,
            stage: "vertex",
            modules
          }),
          fs: assembleWGSLShader(platformInfo, {
            ...options,
            source: fs4,
            stage: "fragment",
            modules
          }),
          getUniforms: assembleGetUniforms(modules)
        };
    }
  }
  function assembleWGSLShader(platformInfo, options) {
    const {
      source,
      stage,
      modules,
      defines = {},
      hookFunctions = [],
      inject: inject6 = {},
      log: log13
    } = options;
    assert17(typeof source === "string", "shader source must be a string");
    const coreSource = source;
    const allDefines = {};
    modules.forEach((module) => {
      Object.assign(allDefines, module.getDefines());
    });
    Object.assign(allDefines, defines);
    let assembledSource = "";
    const hookFunctionMap = normalizeShaderHooks(hookFunctions);
    const hookInjections = {};
    const declInjections = {};
    const mainInjections = {};
    for (const key in inject6) {
      const injection = typeof inject6[key] === "string" ? {
        injection: inject6[key],
        order: 0
      } : inject6[key];
      const match = /^(v|f)s:(#)?([\w-]+)$/.exec(key);
      if (match) {
        const hash = match[2];
        const name = match[3];
        if (hash) {
          if (name === "decl") {
            declInjections[key] = [injection];
          } else {
            mainInjections[key] = [injection];
          }
        } else {
          hookInjections[key] = [injection];
        }
      } else {
        mainInjections[key] = [injection];
      }
    }
    for (const module of modules) {
      if (log13) {
        module.checkDeprecations(coreSource, log13);
      }
      const moduleSource = module.getModuleSource(stage, "wgsl");
      assembledSource += moduleSource;
      const injections = module.injections[stage];
      for (const key in injections) {
        const match = /^(v|f)s:#([\w-]+)$/.exec(key);
        if (match) {
          const name = match[2];
          const injectionType = name === "decl" ? declInjections : mainInjections;
          injectionType[key] = injectionType[key] || [];
          injectionType[key].push(injections[key]);
        } else {
          hookInjections[key] = hookInjections[key] || [];
          hookInjections[key].push(injections[key]);
        }
      }
    }
    assembledSource += INJECT_SHADER_DECLARATIONS;
    assembledSource = injectShader(assembledSource, stage, declInjections);
    assembledSource += getShaderHooks(hookFunctionMap[stage], hookInjections);
    assembledSource += coreSource;
    assembledSource = injectShader(assembledSource, stage, mainInjections);
    return assembledSource;
  }
  function assembleGLSLShader(platformInfo, options) {
    const isWGSL = options.source.includes("->");
    const {
      id,
      source,
      stage,
      language = isWGSL ? "wgsl" : "glsl",
      modules,
      defines = {},
      hookFunctions = [],
      inject: inject6 = {},
      transpileToGLSL100 = false,
      prologue = !isWGSL,
      log: log13
    } = options;
    assert17(typeof source === "string", "shader source must be a string");
    const sourceLines = source.split("\n");
    let glslVersion = 100;
    let versionLine = "";
    let coreSource = source;
    if (sourceLines[0].indexOf("#version ") === 0) {
      glslVersion = 300;
      versionLine = sourceLines[0];
      coreSource = sourceLines.slice(1).join("\n");
    } else {
      versionLine = `#version ${glslVersion}`;
    }
    const targetVersion = transpileToGLSL100 ? 100 : glslVersion;
    const allDefines = {};
    modules.forEach((module) => {
      Object.assign(allDefines, module.getDefines());
    });
    Object.assign(allDefines, defines);
    let assembledSource = "";
    switch (language) {
      case "wgsl":
        break;
      case "glsl":
        assembledSource = prologue ? `${versionLine}
${getShaderNameDefine({
          id,
          source,
          stage
        })}
${`#define SHADER_TYPE_${stage.toUpperCase()}`}
${getPlatformShaderDefines(platformInfo)}
${getVersionDefines(platformInfo)}
${getApplicationDefines(allDefines)}
${stage === "fragment" ? FRAGMENT_SHADER_PROLOGUE : ""}
` : `${versionLine}
`;
        break;
    }
    const hookFunctionMap = normalizeShaderHooks(hookFunctions);
    const hookInjections = {};
    const declInjections = {};
    const mainInjections = {};
    for (const key in inject6) {
      const injection = typeof inject6[key] === "string" ? {
        injection: inject6[key],
        order: 0
      } : inject6[key];
      const match = /^(v|f)s:(#)?([\w-]+)$/.exec(key);
      if (match) {
        const hash = match[2];
        const name = match[3];
        if (hash) {
          if (name === "decl") {
            declInjections[key] = [injection];
          } else {
            mainInjections[key] = [injection];
          }
        } else {
          hookInjections[key] = [injection];
        }
      } else {
        mainInjections[key] = [injection];
      }
    }
    for (const module of modules) {
      if (log13) {
        module.checkDeprecations(coreSource, log13);
      }
      const moduleSource = module.getModuleSource(stage);
      assembledSource += moduleSource;
      const injections = module.injections[stage];
      for (const key in injections) {
        const match = /^(v|f)s:#([\w-]+)$/.exec(key);
        if (match) {
          const name = match[2];
          const injectionType = name === "decl" ? declInjections : mainInjections;
          injectionType[key] = injectionType[key] || [];
          injectionType[key].push(injections[key]);
        } else {
          hookInjections[key] = hookInjections[key] || [];
          hookInjections[key].push(injections[key]);
        }
      }
    }
    assembledSource += INJECT_SHADER_DECLARATIONS;
    assembledSource = injectShader(assembledSource, stage, declInjections);
    assembledSource += getShaderHooks(hookFunctionMap[stage], hookInjections);
    assembledSource += coreSource;
    assembledSource = injectShader(assembledSource, stage, mainInjections);
    assembledSource = transpileGLSLShader(assembledSource, targetVersion, stage);
    return assembledSource.trim();
  }
  function assembleGetUniforms(modules) {
    return function getUniforms4(opts) {
      const uniforms = {};
      for (const module of modules) {
        const moduleUniforms = module.getUniforms(opts, uniforms);
        Object.assign(uniforms, moduleUniforms);
      }
      return uniforms;
    };
  }
  function getShaderNameDefine(options) {
    const {
      id,
      source,
      stage
    } = options;
    const injectShaderName = id && source.indexOf("SHADER_NAME") === -1;
    return injectShaderName ? `
#define SHADER_NAME ${id}_${stage}

` : "";
  }
  function getApplicationDefines() {
    let defines = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    let count = 0;
    let sourceText = "";
    for (const define in defines) {
      if (count === 0) {
        sourceText += "\n// APPLICATION DEFINES\n";
      }
      count++;
      const value = defines[define];
      if (value || Number.isFinite(value)) {
        sourceText += `#define ${define.toUpperCase()} ${defines[define]}
`;
      }
    }
    if (count === 0) {
      sourceText += "\n";
    }
    return sourceText;
  }

  // ../../../luma.gl/modules/shadertools/dist/lib/shader-assembly/select-shaders.js
  function selectShaders(platformInfo, props) {
    if (!props.vs) {
      throw new Error("no vertex shader");
    }
    const vs5 = getShaderSource(platformInfo, props.vs);
    let fs4;
    if (props.fs) {
      fs4 = getShaderSource(platformInfo, props.fs);
    }
    return {
      ...props,
      vs: vs5,
      fs: fs4
    };
  }
  function getShaderSource(platformInfo, shader) {
    if (typeof shader === "string") {
      return shader;
    }
    switch (platformInfo.type) {
      case "webgpu":
        if (shader !== null && shader !== void 0 && shader.wgsl) {
          return shader.wgsl;
        }
        throw new Error("WebGPU does not support GLSL shaders");
      default:
        if (shader !== null && shader !== void 0 && shader.glsl) {
          return shader.glsl;
        }
        throw new Error("WebGL does not support WGSL shaders");
    }
  }

  // ../../../luma.gl/modules/shadertools/dist/lib/shader-assembler.js
  var ShaderAssembler = class {
    constructor() {
      this._hookFunctions = [];
      this._defaultModules = [];
    }
    static getDefaultShaderAssembler() {
      ShaderAssembler.defaultShaderAssembler = ShaderAssembler.defaultShaderAssembler || new ShaderAssembler();
      return ShaderAssembler.defaultShaderAssembler;
    }
    addDefaultModule(module) {
      if (!this._defaultModules.find((m) => m.name === (typeof module === "string" ? module : module.name))) {
        this._defaultModules.push(module);
      }
    }
    removeDefaultModule(module) {
      const moduleName = typeof module === "string" ? module : module.name;
      this._defaultModules = this._defaultModules.filter((m) => m.name !== moduleName);
    }
    addShaderHook(hook, opts) {
      if (opts) {
        hook = Object.assign(opts, {
          hook
        });
      }
      this._hookFunctions.push(hook);
    }
    assembleShaders(platformInfo, props) {
      const modules = this._getModuleList(props.modules);
      const hookFunctions = this._hookFunctions;
      const options = selectShaders(platformInfo, props);
      const assembled = assembleShaders(platformInfo, {
        ...options,
        modules,
        hookFunctions
      });
      return assembled;
    }
    _getModuleList() {
      let appModules = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : [];
      const modules = new Array(this._defaultModules.length + appModules.length);
      const seen = {};
      let count = 0;
      for (let i = 0, len2 = this._defaultModules.length; i < len2; ++i) {
        const module = this._defaultModules[i];
        const name = module.name;
        modules[count++] = module;
        seen[name] = true;
      }
      for (let i = 0, len2 = appModules.length; i < len2; ++i) {
        const module = appModules[i];
        const name = module.name;
        if (!seen[name]) {
          modules[count++] = module;
          seen[name] = true;
        }
      }
      modules.length = count;
      return modules;
    }
  };
  ShaderAssembler.defaultShaderAssembler = void 0;

  // ../../../luma.gl/modules/engine/dist/geometry/gpu-geometry.js
  var import_core34 = __toESM(require_core2(), 1);
  var GPUGeometry = class {
    constructor(props) {
      this.id = void 0;
      this.userData = {};
      this.topology = void 0;
      this.bufferLayout = [];
      this.vertexCount = void 0;
      this.indices = void 0;
      this.attributes = void 0;
      this.id = props.id || (0, import_core34.uid)("geometry");
      this.topology = props.topology;
      this.indices = props.indices || null;
      this.attributes = props.attributes;
      this.vertexCount = props.vertexCount;
      this.bufferLayout = props.bufferLayout || [];
      if (this.indices) {
        (0, import_core34.assert)(this.indices.usage === import_core34.Buffer.INDEX);
      }
    }
    destroy() {
      var _this$attributes$colo;
      this.indices.destroy();
      this.attributes.positions.destroy();
      this.attributes.normals.destroy();
      this.attributes.texCoords.destroy();
      (_this$attributes$colo = this.attributes.colors) === null || _this$attributes$colo === void 0 ? void 0 : _this$attributes$colo.destroy();
    }
    getVertexCount() {
      return this.vertexCount;
    }
    getAttributes() {
      return this.attributes;
    }
    getIndexes() {
      return this.indices;
    }
    _calculateVertexCount(positions) {
      const vertexCount = positions.byteLength / 12;
      return vertexCount;
    }
  };
  function makeGPUGeometry(device, geometry) {
    if (geometry instanceof GPUGeometry) {
      return geometry;
    }
    const indices = getIndexBufferFromGeometry(device, geometry);
    const {
      attributes,
      bufferLayout
    } = getAttributeBuffersFromGeometry(device, geometry);
    return new GPUGeometry({
      topology: geometry.topology || "triangle-list",
      bufferLayout,
      vertexCount: geometry.vertexCount,
      indices,
      attributes
    });
  }
  function getIndexBufferFromGeometry(device, geometry) {
    if (!geometry.indices) {
      return void 0;
    }
    const data = geometry.indices.value;
    return device.createBuffer({
      usage: import_core34.Buffer.INDEX,
      data
    });
  }
  function getAttributeBuffersFromGeometry(device, geometry) {
    const bufferLayout = [];
    const attributes = {};
    for (const [attributeName, attribute] of Object.entries(geometry.attributes)) {
      let name = attributeName;
      switch (attributeName) {
        case "POSITION":
          name = "positions";
          break;
        case "NORMAL":
          name = "normals";
          break;
        case "TEXCOORD_0":
          name = "texCoords";
          break;
      }
      attributes[name] = device.createBuffer({
        data: attribute.value,
        id: `${attributeName}-buffer`
      });
      bufferLayout.push({
        name,
        format: `float32x${attribute.size}`
      });
    }
    const vertexCount = geometry._calculateVertexCount(geometry.attributes, geometry.indices);
    return {
      attributes,
      bufferLayout,
      vertexCount
    };
  }

  // ../../../luma.gl/modules/engine/dist/lib/pipeline-factory.js
  var import_core35 = __toESM(require_core2(), 1);
  var PipelineFactory = class {
    static getDefaultPipelineFactory(device) {
      device._lumaData.defaultPipelineFactory = device._lumaData.defaultPipelineFactory || new PipelineFactory(device);
      return device._lumaData.defaultPipelineFactory;
    }
    constructor(device) {
      this.device = void 0;
      this._hashCounter = 0;
      this._hashes = {};
      this._useCounts = {};
      this._pipelineCache = {};
      this.device = device;
    }
    createRenderPipeline(options) {
      const props = {
        ...PipelineFactory.defaultProps,
        ...options
      };
      const hash = this._hashRenderPipeline({
        ...props
      });
      if (!this._pipelineCache[hash]) {
        const pipeline = this.device.createRenderPipeline({
          ...props,
          vs: this.device.createShader({
            stage: "vertex",
            source: props.vs
          }),
          fs: props.fs ? this.device.createShader({
            stage: "fragment",
            source: props.fs
          }) : null
        });
        pipeline.hash = hash;
        this._pipelineCache[hash] = pipeline;
        this._useCounts[hash] = 0;
      }
      this._useCounts[hash]++;
      return this._pipelineCache[hash];
    }
    release(pipeline) {
      const hash = pipeline.hash;
      this._useCounts[hash]--;
      if (this._useCounts[hash] === 0) {
        this._pipelineCache[hash].destroy();
        delete this._pipelineCache[hash];
        delete this._useCounts[hash];
      }
    }
    _createRenderPipeline(props) {
      if (!props.fs) {
        throw new Error("fs");
      }
      const pipeline = this.device.createRenderPipeline({
        ...props,
        vs: this.device.createShader({
          stage: "vertex",
          source: props.vs
        }),
        fs: props.fs ? this.device.createShader({
          stage: "fragment",
          source: props.fs
        }) : null
      });
      return pipeline;
    }
    _hashRenderPipeline(props) {
      const vsHash = this._getHash(props.vs);
      const fsHash = props.fs ? this._getHash(props.fs) : 0;
      const varyingHash = "-";
      switch (this.device.info.type) {
        case "webgpu":
          const parameterHash = this._getHash(JSON.stringify(props.parameters));
          const bufferLayoutHash = this._getHash(JSON.stringify(props.bufferLayout));
          return `${vsHash}/${fsHash}V${varyingHash}T${props.topology}P${parameterHash}BL${bufferLayoutHash}}`;
        default:
          return `${vsHash}/${fsHash}V${varyingHash}`;
      }
    }
    _getHash(key) {
      if (this._hashes[key] === void 0) {
        this._hashes[key] = this._hashCounter++;
      }
      return this._hashes[key];
    }
  };
  PipelineFactory.defaultProps = {
    ...import_core35.RenderPipeline.defaultProps,
    vs: void 0,
    fs: void 0
  };

  // ../../../luma.gl/modules/engine/dist/model/model.js
  var Model = class {
    constructor(device, props) {
      this.device = void 0;
      this.id = void 0;
      this.vs = void 0;
      this.fs = void 0;
      this.pipelineFactory = void 0;
      this.userData = {};
      this.parameters = void 0;
      this.topology = void 0;
      this.bufferLayout = void 0;
      this.vertexCount = void 0;
      this.instanceCount = 0;
      this.indexBuffer = null;
      this.bufferAttributes = {};
      this.constantAttributes = {};
      this.bindings = {};
      this.uniforms = {};
      this.pipeline = void 0;
      this.vertexArray = void 0;
      this._pipelineNeedsUpdate = "newly created";
      this._attributeInfos = {};
      this._gpuGeometry = null;
      this._getModuleUniforms = void 0;
      this.props = void 0;
      this.props = {
        ...Model.defaultProps,
        ...props
      };
      props = this.props;
      this.id = props.id || (0, import_core36.uid)("model");
      this.device = device;
      Object.assign(this.userData, props.userData);
      const platformInfo = {
        type: device.info.type,
        shaderLanguage: device.info.shadingLanguages[0],
        gpu: device.info.gpu,
        features: device.features
      };
      const {
        vs: vs5,
        fs: fs4,
        getUniforms: getUniforms4
      } = this.props.shaderAssembler.assembleShaders(platformInfo, this.props);
      this.vs = vs5;
      this.fs = fs4;
      this._getModuleUniforms = getUniforms4;
      this.vertexCount = this.props.vertexCount;
      this.instanceCount = this.props.instanceCount;
      this.topology = this.props.topology;
      this.bufferLayout = this.props.bufferLayout;
      this.parameters = this.props.parameters;
      if (props.geometry) {
        this._gpuGeometry = this.setGeometry(props.geometry);
      }
      this.pipelineFactory = props.pipelineFactory || PipelineFactory.getDefaultPipelineFactory(this.device);
      this.pipeline = this._updatePipeline();
      this.vertexArray = device.createVertexArray({
        renderPipeline: this.pipeline
      });
      if (this._gpuGeometry) {
        this._setGeometryAttributes(this._gpuGeometry);
      }
      if (props.vertexCount) {
        this.setVertexCount(props.vertexCount);
      }
      if (props.instanceCount) {
        this.setInstanceCount(props.instanceCount);
      }
      if (props.indices) {
        throw new Error("Model.props.indices removed. Use props.indexBuffer");
      }
      if (props.indexBuffer) {
        this.setIndexBuffer(props.indexBuffer);
      }
      if (props.attributes) {
        this.setAttributes(props.attributes);
      }
      if (props.constantAttributes) {
        this.setConstantAttributes(props.constantAttributes);
      }
      if (props.bindings) {
        this.setBindings(props.bindings);
      }
      if (props.uniforms) {
        this.setUniforms(props.uniforms);
      }
      if (props.moduleSettings) {
        this.updateModuleSettings(props.moduleSettings);
      }
      this.setUniforms(this._getModuleUniforms());
      Object.seal(this);
    }
    destroy() {
      this.pipelineFactory.release(this.pipeline);
    }
    draw(renderPass) {
      this.pipeline = this._updatePipeline();
      this.pipeline.setBindings(this.bindings);
      this.pipeline.setUniforms(this.uniforms);
      this.pipeline.draw({
        renderPass,
        vertexArray: this.vertexArray,
        vertexCount: this.vertexCount,
        instanceCount: this.instanceCount
      });
    }
    setGeometry(geometry) {
      const gpuGeometry = geometry && makeGPUGeometry(this.device, geometry);
      this.setTopology(gpuGeometry.topology || "triangle-list");
      this.bufferLayout = mergeBufferLayouts(this.bufferLayout, gpuGeometry.bufferLayout);
      if (this.vertexArray) {
        this._setGeometryAttributes(gpuGeometry);
      }
      return gpuGeometry;
    }
    _setGeometryAttributes(gpuGeometry) {
      this.vertexCount = gpuGeometry.vertexCount;
      this.setAttributes(gpuGeometry.attributes);
      this.setIndexBuffer(gpuGeometry.indices);
    }
    setTopology(topology) {
      if (topology !== this.topology) {
        this.topology = topology;
        this._setPipelineNeedsUpdate("topology");
      }
    }
    setBufferLayout(bufferLayout) {
      this.bufferLayout = this._gpuGeometry ? mergeBufferLayouts(bufferLayout, this._gpuGeometry.bufferLayout) : bufferLayout;
      this._setPipelineNeedsUpdate("bufferLayout");
      this.pipeline = this._updatePipeline();
      this.vertexArray = this.device.createVertexArray({
        renderPipeline: this.pipeline
      });
      if (this._gpuGeometry) {
        this._setGeometryAttributes(this._gpuGeometry);
      }
    }
    setParameters(parameters2) {
      if (!(0, import_core36.deepEqual)(parameters2, this.parameters, 2)) {
        this.parameters = parameters2;
        this._setPipelineNeedsUpdate("parameters");
      }
    }
    setVertexCount(vertexCount) {
      this.vertexCount = vertexCount;
    }
    setInstanceCount(instanceCount) {
      this.instanceCount = instanceCount;
    }
    setShaderModuleProps(props) {
      const uniforms = this._getModuleUniforms(props);
      const keys = Object.keys(uniforms).filter((k) => {
        const uniform = uniforms[k];
        return !(0, import_core36.isNumberArray)(uniform) && typeof uniform !== "number" && typeof uniform !== "boolean";
      });
      const bindings = {};
      for (const k of keys) {
        bindings[k] = uniforms[k];
        delete uniforms[k];
      }
      Object.assign(this.uniforms, uniforms);
      Object.assign(this.bindings, bindings);
    }
    updateModuleSettings(props) {
      this.setShaderModuleProps(props);
    }
    setBindings(bindings) {
      Object.assign(this.bindings, bindings);
    }
    setUniforms(uniforms) {
      this.pipeline.setUniforms(uniforms);
      Object.assign(this.uniforms, uniforms);
    }
    setIndexBuffer(indexBuffer) {
      this.vertexArray.setIndexBuffer(indexBuffer);
    }
    setAttributes(buffers) {
      if (buffers.indices) {
        import_core36.log.warn(`Model:${this.id} setAttributes() - indexBuffer should be set using setIndexBuffer()`);
      }
      for (const [bufferName, buffer] of Object.entries(buffers)) {
        var _bufferLayout$attribu;
        const bufferLayout = this.bufferLayout.find((layout) => layout.name === bufferName);
        if (!bufferLayout) {
          continue;
        }
        const attributeNames = bufferLayout.attributes ? (_bufferLayout$attribu = bufferLayout.attributes) === null || _bufferLayout$attribu === void 0 ? void 0 : _bufferLayout$attribu.map((layout) => layout.attribute) : [bufferLayout.name];
        let set2 = false;
        for (const attributeName of attributeNames) {
          const attributeInfo = this._attributeInfos[attributeName];
          if (attributeInfo) {
            this.vertexArray.setBuffer(attributeInfo.location, buffer);
            set2 = true;
          }
        }
        if (!set2) {
          import_core36.log.warn(`Model(${this.id}): Ignoring buffer "${buffer.id}" for unknown attribute "${bufferName}"`)();
        }
      }
    }
    setConstantAttributes(attributes) {
      for (const [attributeName, value] of Object.entries(attributes)) {
        const attributeInfo = this._attributeInfos[attributeName];
        if (attributeInfo) {
          this.vertexArray.setConstant(attributeInfo.location, value);
        } else {
          import_core36.log.warn(`Model "${this.id}: Ignoring constant supplied for unknown attribute "${attributeName}"`)();
        }
      }
    }
    _setPipelineNeedsUpdate(reason) {
      this._pipelineNeedsUpdate = this._pipelineNeedsUpdate || reason;
    }
    _updatePipeline() {
      if (this._pipelineNeedsUpdate) {
        if (this.pipeline) {
          import_core36.log.log(1, `Model ${this.id}: Recreating pipeline because "${this._pipelineNeedsUpdate}".`)();
        }
        this._pipelineNeedsUpdate = false;
        this.pipeline = this.device.createRenderPipeline({
          ...this.props,
          bufferLayout: this.bufferLayout,
          topology: this.topology,
          parameters: this.parameters,
          vs: this.device.createShader({
            id: "{$this.id}-vertex",
            stage: "vertex",
            source: this.vs
          }),
          fs: this.fs ? this.device.createShader({
            id: "{$this.id}-fragment",
            stage: "fragment",
            source: this.fs
          }) : null
        });
        this._attributeInfos = (0, import_core37.getAttributeInfosFromLayouts)(this.pipeline.shaderLayout, this.bufferLayout);
      }
      return this.pipeline;
    }
  };
  Model.defaultProps = {
    ...import_core36.RenderPipeline.defaultProps,
    vs: null,
    fs: null,
    id: "unnamed",
    handle: void 0,
    userData: {},
    defines: {},
    modules: [],
    moduleSettings: {},
    geometry: null,
    indexBuffer: null,
    attributes: {},
    constantAttributes: {},
    pipelineFactory: void 0,
    shaderAssembler: ShaderAssembler.getDefaultShaderAssembler()
  };
  function mergeBufferLayouts(layouts1, layouts2) {
    const layouts = [...layouts1];
    for (const attribute of layouts2) {
      const index = layouts.findIndex((attribute2) => attribute2.name === attribute.name);
      if (index < 0) {
        layouts.push(attribute);
      } else {
        layouts[index] = attribute;
      }
    }
    return layouts;
  }

  // src/data-filter/aggregator.ts
  var AGGREGATE_VS = `#define SHADER_NAME data-filter-vertex-shader

#ifdef FLOAT_TARGET
  attribute float filterIndices;
  attribute float filterPrevIndices;
#else
  attribute vec2 filterIndices;
  attribute vec2 filterPrevIndices;
#endif

varying vec4 vColor;
const float component = 1.0 / 255.0;

void main() {
  #ifdef FLOAT_TARGET
    dataFilter_value *= float(filterIndices != filterPrevIndices);
    gl_Position = vec4(0.0, 0.0, 0.0, 1.0);
    vColor = vec4(0.0, 0.0, 0.0, 1.0);
  #else
    // Float texture is not supported: pack result into 4 channels x 256 px x 64px
    dataFilter_value *= float(filterIndices.x != filterPrevIndices.x);
    float col = filterIndices.x;
    float row = filterIndices.y * 4.0;
    float channel = floor(row);
    row = fract(row);
    vColor = component * vec4(bvec4(channel == 0.0, channel == 1.0, channel == 2.0, channel == 3.0));
    gl_Position = vec4(col * 2.0 - 1.0, row * 2.0 - 1.0, 0.0, 1.0);
  #endif
  gl_PointSize = 1.0;
}
`;
  var AGGREGATE_FS = `#define SHADER_NAME data-filter-fragment-shader
precision highp float;

varying vec4 vColor;

void main() {
  if (dataFilter_value < 0.5) {
    discard;
  }
  gl_FragColor = vColor;
}
`;
  function supportsFloatTarget(device) {
    const gl = device.gl;
    return Boolean(gl.getExtension("EXT_float_blend") && (gl.getExtension("EXT_color_buffer_float") || gl.getExtension("WEBGL_color_buffer_float")));
  }
  function getFramebuffer3(device, useFloatTarget) {
    if (useFloatTarget) {
      return device.createFramebuffer({
        width: 1,
        height: 1,
        colorAttachments: [device.createTexture({
          format: device.info.type === "webgl2" ? "rgba32float" : "rgba8unorm",
          type: 5126,
          mipmaps: false
        })]
      });
    }
    return device.createFramebuffer({
      width: 256,
      height: 64,
      colorAttachments: [device.createTexture({
        format: "rgba8unorm",
        type: 5126,
        mipmaps: false
      })]
    });
  }
  function getModel(device, shaderOptions, useFloatTarget) {
    shaderOptions.defines.NON_INSTANCED_MODEL = 1;
    if (useFloatTarget) {
      shaderOptions.defines.FLOAT_TARGET = 1;
    }
    return new Model(device, {
      id: "data-filter-aggregation-model",
      vertexCount: 1,
      isInstanced: false,
      drawMode: 0,
      vs: AGGREGATE_VS,
      fs: AGGREGATE_FS,
      ...shaderOptions
    });
  }
  var parameters = {
    blend: true,
    blendFunc: [1, 1, 1, 1],
    blendEquation: [32774, 32774],
    depthTest: false
  };

  // src/data-filter/data-filter-extension.ts
  var defaultProps2 = {
    getFilterValue: {
      type: "accessor",
      value: 0
    },
    onFilteredItemsChange: {
      type: "function",
      value: null,
      optional: true
    },
    filterEnabled: true,
    filterRange: [-1, 1],
    filterSoftRange: null,
    filterTransformSize: true,
    filterTransformColor: true
  };
  var DATA_TYPE_FROM_SIZE = {
    1: "float",
    2: "vec2",
    3: "vec3",
    4: "vec4"
  };
  var DataFilterExtension = class extends import_core38.LayerExtension {
    constructor({
      filterSize = 1,
      fp64: fp642 = false,
      countItems = false
    } = {}) {
      if (!DATA_TYPE_FROM_SIZE[filterSize]) {
        throw new Error("filterSize out of range");
      }
      super({
        filterSize,
        fp64: fp642,
        countItems
      });
    }
    getShaders(extension) {
      const {
        filterSize,
        fp64: fp642
      } = extension.opts;
      return {
        modules: [fp642 ? shaderModule64 : shaderModule],
        defines: {
          DATAFILTER_TYPE: DATA_TYPE_FROM_SIZE[filterSize],
          DATAFILTER_DOUBLE: Boolean(fp642)
        }
      };
    }
    initializeState(context, extension) {
      const attributeManager = this.getAttributeManager();
      if (attributeManager) {
        attributeManager.add({
          filterValues: {
            size: extension.opts.filterSize,
            type: extension.opts.fp64 ? 5130 : 5126,
            accessor: "getFilterValue",
            shaderAttributes: {
              filterValues: {
                divisor: 0
              },
              instanceFilterValues: {
                divisor: 1
              }
            }
          }
        });
      }
      const {
        device
      } = this.context;
      if (attributeManager && extension.opts.countItems) {
        const useFloatTarget = supportsFloatTarget(device);
        attributeManager.add({
          filterIndices: {
            size: useFloatTarget ? 1 : 2,
            vertexOffset: 1,
            type: 5121,
            normalized: true,
            accessor: (object, {
              index
            }) => {
              const i = object && object.__source ? object.__source.index : index;
              return useFloatTarget ? (i + 1) % 255 : [(i + 1) % 255, Math.floor(i / 255) % 255];
            },
            shaderAttributes: {
              filterPrevIndices: {
                vertexOffset: 0
              },
              filterIndices: {
                vertexOffset: 1
              }
            }
          }
        });
        const filterFBO = getFramebuffer3(device, useFloatTarget);
        const filterModel = getModel(device, extension.getShaders.call(this, extension), useFloatTarget);
        this.setState({
          filterFBO,
          filterModel
        });
      }
    }
    updateState({
      props,
      oldProps
    }) {
      if (this.state.filterModel) {
        const attributeManager = this.getAttributeManager();
        const filterNeedsUpdate = attributeManager.attributes.filterValues.needsUpdate() || props.filterEnabled !== oldProps.filterEnabled || props.filterRange !== oldProps.filterRange || props.filterSoftRange !== oldProps.filterSoftRange;
        if (filterNeedsUpdate) {
          this.setState({
            filterNeedsUpdate
          });
        }
      }
    }
    draw(params, extension) {
      const filterFBO = this.state.filterFBO;
      const filterModel = this.state.filterModel;
      const filterNeedsUpdate = this.state.filterNeedsUpdate;
      const {
        onFilteredItemsChange
      } = this.props;
      if (filterNeedsUpdate && onFilteredItemsChange && filterModel) {
        const {
          attributes: {
            filterValues,
            filterIndices
          }
        } = this.getAttributeManager();
        filterModel.setVertexCount(this.getNumInstances());
        clear(this.context.device, {
          framebuffer: filterFBO,
          color: [0, 0, 0, 0]
        });
        filterModel.updateModuleSettings(params.moduleParameters);
        filterModel.setAttributes({
          ...filterValues.getValue(),
          ...filterIndices?.getValue()
        });
        withGLParameters(filterModel.device, {
          framebuffer: filterFBO,
          ...parameters,
          viewport: [0, 0, filterFBO.width, filterFBO.height]
        }, () => {
          filterModel.draw(this.context.renderPass);
        });
        const color = readPixelsToArray(filterFBO);
        let count = 0;
        for (let i = 0; i < color.length; i++) {
          count += color[i];
        }
        onFilteredItemsChange({
          id: this.id,
          count
        });
        this.state.filterNeedsUpdate = false;
      }
    }
    finalizeState() {
      const filterFBO = this.state.filterFBO;
      const filterModel = this.state.filterModel;
      filterFBO?.destroy();
      filterModel?.destroy();
    }
  };
  __publicField(DataFilterExtension, "defaultProps", defaultProps2);
  __publicField(DataFilterExtension, "extensionName", "DataFilterExtension");

  // src/fp64/fp64-extension.ts
  var import_core40 = __toESM(require_core());

  // ../../node_modules/@luma.gl/shadertools/dist/lib/glsl-utils/highlight.js
  var glsl2 = (x) => `${x}`;

  // ../../node_modules/@luma.gl/shadertools/dist/modules-webgl1/math/fp64/fp64-utils.js
  function fp64ify(a) {
    let out = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : [];
    let startIndex = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0;
    const hiPart = Math.fround(a);
    const loPart = a - hiPart;
    out[startIndex] = hiPart;
    out[startIndex + 1] = loPart;
    return out;
  }
  function fp64LowPart(a) {
    return a - Math.fround(a);
  }
  function fp64ifyMatrix4(matrix) {
    const matrixFP64 = new Float32Array(32);
    for (let i = 0; i < 4; ++i) {
      for (let j = 0; j < 4; ++j) {
        const index = i * 4 + j;
        fp64ify(matrix[j * 4 + i], matrixFP64, index * 2);
      }
    }
    return matrixFP64;
  }

  // ../../node_modules/@luma.gl/shadertools/dist/modules-webgl1/math/fp64/fp64-arithmetic.glsl.js
  var fp64arithmeticShader = glsl2`\
uniform float ONE;

/*
About LUMA_FP64_CODE_ELIMINATION_WORKAROUND

The purpose of this workaround is to prevent shader compilers from
optimizing away necessary arithmetic operations by swapping their sequences
or transform the equation to some 'equivalent' from.

The method is to multiply an artifical variable, ONE, which will be known to
the compiler to be 1 only at runtime. The whole expression is then represented
as a polynomial with respective to ONE. In the coefficients of all terms, only one a
and one b should appear

err = (a + b) * ONE^6 - a * ONE^5 - (a + b) * ONE^4 + a * ONE^3 - b - (a + b) * ONE^2 + a * ONE
*/

// Divide float number to high and low floats to extend fraction bits
vec2 split(float a) {
  const float SPLIT = 4097.0;
  float t = a * SPLIT;
#if defined(LUMA_FP64_CODE_ELIMINATION_WORKAROUND)
  float a_hi = t * ONE - (t - a);
  float a_lo = a * ONE - a_hi;
#else
  float a_hi = t - (t - a);
  float a_lo = a - a_hi;
#endif
  return vec2(a_hi, a_lo);
}

// Divide float number again when high float uses too many fraction bits
vec2 split2(vec2 a) {
  vec2 b = split(a.x);
  b.y += a.y;
  return b;
}

// Special sum operation when a > b
vec2 quickTwoSum(float a, float b) {
#if defined(LUMA_FP64_CODE_ELIMINATION_WORKAROUND)
  float sum = (a + b) * ONE;
  float err = b - (sum - a) * ONE;
#else
  float sum = a + b;
  float err = b - (sum - a);
#endif
  return vec2(sum, err);
}

// General sum operation
vec2 twoSum(float a, float b) {
  float s = (a + b);
#if defined(LUMA_FP64_CODE_ELIMINATION_WORKAROUND)
  float v = (s * ONE - a) * ONE;
  float err = (a - (s - v) * ONE) * ONE * ONE * ONE + (b - v);
#else
  float v = s - a;
  float err = (a - (s - v)) + (b - v);
#endif
  return vec2(s, err);
}

vec2 twoSub(float a, float b) {
  float s = (a - b);
#if defined(LUMA_FP64_CODE_ELIMINATION_WORKAROUND)
  float v = (s * ONE - a) * ONE;
  float err = (a - (s - v) * ONE) * ONE * ONE * ONE - (b + v);
#else
  float v = s - a;
  float err = (a - (s - v)) - (b + v);
#endif
  return vec2(s, err);
}

vec2 twoSqr(float a) {
  float prod = a * a;
  vec2 a_fp64 = split(a);
#if defined(LUMA_FP64_CODE_ELIMINATION_WORKAROUND)
  float err = ((a_fp64.x * a_fp64.x - prod) * ONE + 2.0 * a_fp64.x *
    a_fp64.y * ONE * ONE) + a_fp64.y * a_fp64.y * ONE * ONE * ONE;
#else
  float err = ((a_fp64.x * a_fp64.x - prod) + 2.0 * a_fp64.x * a_fp64.y) + a_fp64.y * a_fp64.y;
#endif
  return vec2(prod, err);
}

vec2 twoProd(float a, float b) {
  float prod = a * b;
  vec2 a_fp64 = split(a);
  vec2 b_fp64 = split(b);
  float err = ((a_fp64.x * b_fp64.x - prod) + a_fp64.x * b_fp64.y +
    a_fp64.y * b_fp64.x) + a_fp64.y * b_fp64.y;
  return vec2(prod, err);
}

vec2 sum_fp64(vec2 a, vec2 b) {
  vec2 s, t;
  s = twoSum(a.x, b.x);
  t = twoSum(a.y, b.y);
  s.y += t.x;
  s = quickTwoSum(s.x, s.y);
  s.y += t.y;
  s = quickTwoSum(s.x, s.y);
  return s;
}

vec2 sub_fp64(vec2 a, vec2 b) {
  vec2 s, t;
  s = twoSub(a.x, b.x);
  t = twoSub(a.y, b.y);
  s.y += t.x;
  s = quickTwoSum(s.x, s.y);
  s.y += t.y;
  s = quickTwoSum(s.x, s.y);
  return s;
}

vec2 mul_fp64(vec2 a, vec2 b) {
  vec2 prod = twoProd(a.x, b.x);
  // y component is for the error
  prod.y += a.x * b.y;
#if defined(LUMA_FP64_HIGH_BITS_OVERFLOW_WORKAROUND)
  prod = split2(prod);
#endif
  prod = quickTwoSum(prod.x, prod.y);
  prod.y += a.y * b.x;
#if defined(LUMA_FP64_HIGH_BITS_OVERFLOW_WORKAROUND)
  prod = split2(prod);
#endif
  prod = quickTwoSum(prod.x, prod.y);
  return prod;
}

vec2 div_fp64(vec2 a, vec2 b) {
  float xn = 1.0 / b.x;
#if defined(LUMA_FP64_HIGH_BITS_OVERFLOW_WORKAROUND)
  vec2 yn = mul_fp64(a, vec2(xn, 0));
#else
  vec2 yn = a * xn;
#endif
  float diff = (sub_fp64(a, mul_fp64(b, yn))).x;
  vec2 prod = twoProd(xn, diff);
  return sum_fp64(yn, prod);
}

vec2 sqrt_fp64(vec2 a) {
  if (a.x == 0.0 && a.y == 0.0) return vec2(0.0, 0.0);
  if (a.x < 0.0) return vec2(0.0 / 0.0, 0.0 / 0.0);

  float x = 1.0 / sqrt(a.x);
  float yn = a.x * x;
#if defined(LUMA_FP64_CODE_ELIMINATION_WORKAROUND)
  vec2 yn_sqr = twoSqr(yn) * ONE;
#else
  vec2 yn_sqr = twoSqr(yn);
#endif
  float diff = sub_fp64(a, yn_sqr).x;
  vec2 prod = twoProd(x * 0.5, diff);
#if defined(LUMA_FP64_HIGH_BITS_OVERFLOW_WORKAROUND)
  return sum_fp64(split(yn), prod);
#else
  return sum_fp64(vec2(yn, 0.0), prod);
#endif
}
`;

  // ../../node_modules/@luma.gl/shadertools/dist/modules-webgl1/math/fp64/fp64-functions.glsl.js
  var fp64functionShader = glsl2`\
const vec2 E_FP64 = vec2(2.7182817459106445e+00, 8.254840366817007e-08);
const vec2 LOG2_FP64 = vec2(0.6931471824645996e+00, -1.9046542121259336e-09);
const vec2 PI_FP64 = vec2(3.1415927410125732, -8.742278012618954e-8);
const vec2 TWO_PI_FP64 = vec2(6.2831854820251465, -1.7484556025237907e-7);
const vec2 PI_2_FP64 = vec2(1.5707963705062866, -4.371139006309477e-8);
const vec2 PI_4_FP64 = vec2(0.7853981852531433, -2.1855695031547384e-8);
const vec2 PI_16_FP64 = vec2(0.19634954631328583, -5.463923757886846e-9);
const vec2 PI_16_2_FP64 = vec2(0.39269909262657166, -1.0927847515773692e-8);
const vec2 PI_16_3_FP64 = vec2(0.5890486240386963, -1.4906100798128818e-9);
const vec2 PI_180_FP64 = vec2(0.01745329238474369, 1.3519960498364902e-10);

const vec2 SIN_TABLE_0_FP64 = vec2(0.19509032368659973, -1.6704714833615242e-9);
const vec2 SIN_TABLE_1_FP64 = vec2(0.3826834261417389, 6.22335089017767e-9);
const vec2 SIN_TABLE_2_FP64 = vec2(0.5555702447891235, -1.1769521357507529e-8);
const vec2 SIN_TABLE_3_FP64 = vec2(0.7071067690849304, 1.2101617041793133e-8);

const vec2 COS_TABLE_0_FP64 = vec2(0.9807852506637573, 2.9739473106360492e-8);
const vec2 COS_TABLE_1_FP64 = vec2(0.9238795042037964, 2.8307490351764386e-8);
const vec2 COS_TABLE_2_FP64 = vec2(0.8314695954322815, 1.6870263741530778e-8);
const vec2 COS_TABLE_3_FP64 = vec2(0.7071067690849304, 1.2101617152815436e-8);

const vec2 INVERSE_FACTORIAL_3_FP64 = vec2(1.666666716337204e-01, -4.967053879312289e-09); // 1/3!
const vec2 INVERSE_FACTORIAL_4_FP64 = vec2(4.16666679084301e-02, -1.2417634698280722e-09); // 1/4!
const vec2 INVERSE_FACTORIAL_5_FP64 = vec2(8.333333767950535e-03, -4.34617203337595e-10); // 1/5!
const vec2 INVERSE_FACTORIAL_6_FP64 = vec2(1.3888889225199819e-03, -3.3631094437103215e-11); // 1/6!
const vec2 INVERSE_FACTORIAL_7_FP64 = vec2(1.9841270113829523e-04,  -2.725596874933456e-12); // 1/7!
const vec2 INVERSE_FACTORIAL_8_FP64 = vec2(2.4801587642286904e-05, -3.406996025904184e-13); // 1/8!
const vec2 INVERSE_FACTORIAL_9_FP64 = vec2(2.75573188446287533e-06, 3.7935713937038186e-14); // 1/9!
const vec2 INVERSE_FACTORIAL_10_FP64 = vec2(2.755731998149713e-07, -7.575112367869873e-15); // 1/10!

float nint(float d) {
    if (d == floor(d)) return d;
    return floor(d + 0.5);
}

vec2 nint_fp64(vec2 a) {
    float hi = nint(a.x);
    float lo;
    vec2 tmp;
    if (hi == a.x) {
        lo = nint(a.y);
        tmp = quickTwoSum(hi, lo);
    } else {
        lo = 0.0;
        if (abs(hi - a.x) == 0.5 && a.y < 0.0) {
            hi -= 1.0;
        }
        tmp = vec2(hi, lo);
    }
    return tmp;
}

/* k_power controls how much range reduction we would like to have
Range reduction uses the following method:
assume a = k_power * r + m * log(2), k and m being integers.
Set k_power = 4 (we can choose other k to trade accuracy with performance.
we only need to calculate exp(r) and using exp(a) = 2^m * exp(r)^k_power;
*/

vec2 exp_fp64(vec2 a) {
  // We need to make sure these two numbers match
  // as bit-wise shift is not available in GLSL 1.0
  const int k_power = 4;
  const float k = 16.0;

  const float inv_k = 1.0 / k;

  if (a.x <= -88.0) return vec2(0.0, 0.0);
  if (a.x >= 88.0) return vec2(1.0 / 0.0, 1.0 / 0.0);
  if (a.x == 0.0 && a.y == 0.0) return vec2(1.0, 0.0);
  if (a.x == 1.0 && a.y == 0.0) return E_FP64;

  float m = floor(a.x / LOG2_FP64.x + 0.5);
  vec2 r = sub_fp64(a, mul_fp64(LOG2_FP64, vec2(m, 0.0))) * inv_k;
  vec2 s, t, p;

  p = mul_fp64(r, r);
  s = sum_fp64(r, p * 0.5);
  p = mul_fp64(p, r);
  t = mul_fp64(p, INVERSE_FACTORIAL_3_FP64);

  s = sum_fp64(s, t);
  p = mul_fp64(p, r);
  t = mul_fp64(p, INVERSE_FACTORIAL_4_FP64);

  s = sum_fp64(s, t);
  p = mul_fp64(p, r);
  t = mul_fp64(p, INVERSE_FACTORIAL_5_FP64);

  // s = sum_fp64(s, t);
  // p = mul_fp64(p, r);
  // t = mul_fp64(p, INVERSE_FACTORIAL_6_FP64);

  // s = sum_fp64(s, t);
  // p = mul_fp64(p, r);
  // t = mul_fp64(p, INVERSE_FACTORIAL_7_FP64);

  s = sum_fp64(s, t);


  // At this point, s = exp(r) - 1; but after following 4 recursions, we will get exp(r) ^ 512 - 1.
  for (int i = 0; i < k_power; i++) {
    s = sum_fp64(s * 2.0, mul_fp64(s, s));
  }

#if defined(NVIDIA_FP64_WORKAROUND) || defined(INTEL_FP64_WORKAROUND)
  s = sum_fp64(s, vec2(ONE, 0.0));
#else
  s = sum_fp64(s, vec2(1.0, 0.0));
#endif

  return s * pow(2.0, m);
//   return r;
}

vec2 log_fp64(vec2 a)
{
  if (a.x == 1.0 && a.y == 0.0) return vec2(0.0, 0.0);
  if (a.x <= 0.0) return vec2(0.0 / 0.0, 0.0 / 0.0);
  vec2 x = vec2(log(a.x), 0.0);
  vec2 s;
#if defined(NVIDIA_FP64_WORKAROUND) || defined(INTEL_FP64_WORKAROUND)
  s = vec2(ONE, 0.0);
#else
  s = vec2(1.0, 0.0);
#endif

  x = sub_fp64(sum_fp64(x, mul_fp64(a, exp_fp64(-x))), s);
  return x;
}

vec2 sin_taylor_fp64(vec2 a) {
  vec2 r, s, t, x;

  if (a.x == 0.0 && a.y == 0.0) {
    return vec2(0.0, 0.0);
  }

  x = -mul_fp64(a, a);
  s = a;
  r = a;

  r = mul_fp64(r, x);
  t = mul_fp64(r, INVERSE_FACTORIAL_3_FP64);
  s = sum_fp64(s, t);

  r = mul_fp64(r, x);
  t = mul_fp64(r, INVERSE_FACTORIAL_5_FP64);
  s = sum_fp64(s, t);

  /* keep the following commented code in case we need them
  for extra accuracy from the Taylor expansion*/

  // r = mul_fp64(r, x);
  // t = mul_fp64(r, INVERSE_FACTORIAL_7_FP64);
  // s = sum_fp64(s, t);

  // r = mul_fp64(r, x);
  // t = mul_fp64(r, INVERSE_FACTORIAL_9_FP64);
  // s = sum_fp64(s, t);

  return s;
}

vec2 cos_taylor_fp64(vec2 a) {
  vec2 r, s, t, x;

  if (a.x == 0.0 && a.y == 0.0) {
    return vec2(1.0, 0.0);
  }

  x = -mul_fp64(a, a);
  r = x;
  s = sum_fp64(vec2(1.0, 0.0), r * 0.5);

  r = mul_fp64(r, x);
  t = mul_fp64(r, INVERSE_FACTORIAL_4_FP64);
  s = sum_fp64(s, t);

  r = mul_fp64(r, x);
  t = mul_fp64(r, INVERSE_FACTORIAL_6_FP64);
  s = sum_fp64(s, t);

  /* keep the following commented code in case we need them
  for extra accuracy from the Taylor expansion*/

  // r = mul_fp64(r, x);
  // t = mul_fp64(r, INVERSE_FACTORIAL_8_FP64);
  // s = sum_fp64(s, t);

  // r = mul_fp64(r, x);
  // t = mul_fp64(r, INVERSE_FACTORIAL_10_FP64);
  // s = sum_fp64(s, t);

  return s;
}

void sincos_taylor_fp64(vec2 a, out vec2 sin_t, out vec2 cos_t) {
  if (a.x == 0.0 && a.y == 0.0) {
    sin_t = vec2(0.0, 0.0);
    cos_t = vec2(1.0, 0.0);
  }

  sin_t = sin_taylor_fp64(a);
  cos_t = sqrt_fp64(sub_fp64(vec2(1.0, 0.0), mul_fp64(sin_t, sin_t)));
}

vec2 sin_fp64(vec2 a) {
    if (a.x == 0.0 && a.y == 0.0) {
        return vec2(0.0, 0.0);
    }

    // 2pi range reduction
    vec2 z = nint_fp64(div_fp64(a, TWO_PI_FP64));
    vec2 r = sub_fp64(a, mul_fp64(TWO_PI_FP64, z));

    vec2 t;
    float q = floor(r.x / PI_2_FP64.x + 0.5);
    int j = int(q);

    if (j < -2 || j > 2) {
        return vec2(0.0 / 0.0, 0.0 / 0.0);
    }

    t = sub_fp64(r, mul_fp64(PI_2_FP64, vec2(q, 0.0)));

    q = floor(t.x / PI_16_FP64.x + 0.5);
    int k = int(q);

    if (k == 0) {
        if (j == 0) {
            return sin_taylor_fp64(t);
        } else if (j == 1) {
            return cos_taylor_fp64(t);
        } else if (j == -1) {
            return -cos_taylor_fp64(t);
        } else {
            return -sin_taylor_fp64(t);
        }
    }

    int abs_k = int(abs(float(k)));

    if (abs_k > 4) {
        return vec2(0.0 / 0.0, 0.0 / 0.0);
    } else {
        t = sub_fp64(t, mul_fp64(PI_16_FP64, vec2(q, 0.0)));
    }

    vec2 u = vec2(0.0, 0.0);
    vec2 v = vec2(0.0, 0.0);

#if defined(NVIDIA_FP64_WORKAROUND) || defined(INTEL_FP64_WORKAROUND)
    if (abs(float(abs_k) - 1.0) < 0.5) {
        u = COS_TABLE_0_FP64;
        v = SIN_TABLE_0_FP64;
    } else if (abs(float(abs_k) - 2.0) < 0.5) {
        u = COS_TABLE_1_FP64;
        v = SIN_TABLE_1_FP64;
    } else if (abs(float(abs_k) - 3.0) < 0.5) {
        u = COS_TABLE_2_FP64;
        v = SIN_TABLE_2_FP64;
    } else if (abs(float(abs_k) - 4.0) < 0.5) {
        u = COS_TABLE_3_FP64;
        v = SIN_TABLE_3_FP64;
    }
#else
    if (abs_k == 1) {
        u = COS_TABLE_0_FP64;
        v = SIN_TABLE_0_FP64;
    } else if (abs_k == 2) {
        u = COS_TABLE_1_FP64;
        v = SIN_TABLE_1_FP64;
    } else if (abs_k == 3) {
        u = COS_TABLE_2_FP64;
        v = SIN_TABLE_2_FP64;
    } else if (abs_k == 4) {
        u = COS_TABLE_3_FP64;
        v = SIN_TABLE_3_FP64;
    }
#endif

    vec2 sin_t, cos_t;
    sincos_taylor_fp64(t, sin_t, cos_t);



    vec2 result = vec2(0.0, 0.0);
    if (j == 0) {
        if (k > 0) {
            result = sum_fp64(mul_fp64(u, sin_t), mul_fp64(v, cos_t));
        } else {
            result = sub_fp64(mul_fp64(u, sin_t), mul_fp64(v, cos_t));
        }
    } else if (j == 1) {
        if (k > 0) {
            result = sub_fp64(mul_fp64(u, cos_t), mul_fp64(v, sin_t));
        } else {
            result = sum_fp64(mul_fp64(u, cos_t), mul_fp64(v, sin_t));
        }
    } else if (j == -1) {
        if (k > 0) {
            result = sub_fp64(mul_fp64(v, sin_t), mul_fp64(u, cos_t));
        } else {
            result = -sum_fp64(mul_fp64(v, sin_t), mul_fp64(u, cos_t));
        }
    } else {
        if (k > 0) {
            result = -sum_fp64(mul_fp64(u, sin_t), mul_fp64(v, cos_t));
        } else {
            result = sub_fp64(mul_fp64(v, cos_t), mul_fp64(u, sin_t));
        }
    }

    return result;
}

vec2 cos_fp64(vec2 a) {
    if (a.x == 0.0 && a.y == 0.0) {
        return vec2(1.0, 0.0);
    }

    // 2pi range reduction
    vec2 z = nint_fp64(div_fp64(a, TWO_PI_FP64));
    vec2 r = sub_fp64(a, mul_fp64(TWO_PI_FP64, z));

    vec2 t;
    float q = floor(r.x / PI_2_FP64.x + 0.5);
    int j = int(q);

    if (j < -2 || j > 2) {
        return vec2(0.0 / 0.0, 0.0 / 0.0);
    }

    t = sub_fp64(r, mul_fp64(PI_2_FP64, vec2(q, 0.0)));

    q = floor(t.x / PI_16_FP64.x + 0.5);
    int k = int(q);

    if (k == 0) {
        if (j == 0) {
            return cos_taylor_fp64(t);
        } else if (j == 1) {
            return -sin_taylor_fp64(t);
        } else if (j == -1) {
            return sin_taylor_fp64(t);
        } else {
            return -cos_taylor_fp64(t);
        }
    }

    int abs_k = int(abs(float(k)));

    if (abs_k > 4) {
        return vec2(0.0 / 0.0, 0.0 / 0.0);
    } else {
        t = sub_fp64(t, mul_fp64(PI_16_FP64, vec2(q, 0.0)));
    }

    vec2 u = vec2(0.0, 0.0);
    vec2 v = vec2(0.0, 0.0);

#if defined(NVIDIA_FP64_WORKAROUND) || defined(INTEL_FP64_WORKAROUND)
    if (abs(float(abs_k) - 1.0) < 0.5) {
        u = COS_TABLE_0_FP64;
        v = SIN_TABLE_0_FP64;
    } else if (abs(float(abs_k) - 2.0) < 0.5) {
        u = COS_TABLE_1_FP64;
        v = SIN_TABLE_1_FP64;
    } else if (abs(float(abs_k) - 3.0) < 0.5) {
        u = COS_TABLE_2_FP64;
        v = SIN_TABLE_2_FP64;
    } else if (abs(float(abs_k) - 4.0) < 0.5) {
        u = COS_TABLE_3_FP64;
        v = SIN_TABLE_3_FP64;
    }
#else
    if (abs_k == 1) {
        u = COS_TABLE_0_FP64;
        v = SIN_TABLE_0_FP64;
    } else if (abs_k == 2) {
        u = COS_TABLE_1_FP64;
        v = SIN_TABLE_1_FP64;
    } else if (abs_k == 3) {
        u = COS_TABLE_2_FP64;
        v = SIN_TABLE_2_FP64;
    } else if (abs_k == 4) {
        u = COS_TABLE_3_FP64;
        v = SIN_TABLE_3_FP64;
    }
#endif

    vec2 sin_t, cos_t;
    sincos_taylor_fp64(t, sin_t, cos_t);

    vec2 result = vec2(0.0, 0.0);
    if (j == 0) {
        if (k > 0) {
            result = sub_fp64(mul_fp64(u, cos_t), mul_fp64(v, sin_t));
        } else {
            result = sum_fp64(mul_fp64(u, cos_t), mul_fp64(v, sin_t));
        }
    } else if (j == 1) {
        if (k > 0) {
            result = -sum_fp64(mul_fp64(u, sin_t), mul_fp64(v, cos_t));
        } else {
            result = sub_fp64(mul_fp64(v, cos_t), mul_fp64(u, sin_t));
        }
    } else if (j == -1) {
        if (k > 0) {
            result = sum_fp64(mul_fp64(u, sin_t), mul_fp64(v, cos_t));
        } else {
            result = sub_fp64(mul_fp64(u, sin_t), mul_fp64(v, cos_t));
        }
    } else {
        if (k > 0) {
            result = sub_fp64(mul_fp64(v, sin_t), mul_fp64(u, cos_t));
        } else {
            result = -sum_fp64(mul_fp64(u, cos_t), mul_fp64(v, sin_t));
        }
    }

    return result;
}

vec2 tan_fp64(vec2 a) {
    vec2 sin_a;
    vec2 cos_a;

    if (a.x == 0.0 && a.y == 0.0) {
        return vec2(0.0, 0.0);
    }

    // 2pi range reduction
    vec2 z = nint_fp64(div_fp64(a, TWO_PI_FP64));
    vec2 r = sub_fp64(a, mul_fp64(TWO_PI_FP64, z));

    vec2 t;
    float q = floor(r.x / PI_2_FP64.x + 0.5);
    int j = int(q);


    if (j < -2 || j > 2) {
        return vec2(0.0 / 0.0, 0.0 / 0.0);
    }

    t = sub_fp64(r, mul_fp64(PI_2_FP64, vec2(q, 0.0)));

    q = floor(t.x / PI_16_FP64.x + 0.5);
    int k = int(q);
    int abs_k = int(abs(float(k)));

    // We just can't get PI/16 * 3.0 very accurately.
    // so let's just store it
    if (abs_k > 4) {
        return vec2(0.0 / 0.0, 0.0 / 0.0);
    } else {
        t = sub_fp64(t, mul_fp64(PI_16_FP64, vec2(q, 0.0)));
    }


    vec2 u = vec2(0.0, 0.0);
    vec2 v = vec2(0.0, 0.0);

    vec2 sin_t, cos_t;
    vec2 s, c;
    sincos_taylor_fp64(t, sin_t, cos_t);

    if (k == 0) {
        s = sin_t;
        c = cos_t;
    } else {
#if defined(NVIDIA_FP64_WORKAROUND) || defined(INTEL_FP64_WORKAROUND)
        if (abs(float(abs_k) - 1.0) < 0.5) {
            u = COS_TABLE_0_FP64;
            v = SIN_TABLE_0_FP64;
        } else if (abs(float(abs_k) - 2.0) < 0.5) {
            u = COS_TABLE_1_FP64;
            v = SIN_TABLE_1_FP64;
        } else if (abs(float(abs_k) - 3.0) < 0.5) {
            u = COS_TABLE_2_FP64;
            v = SIN_TABLE_2_FP64;
        } else if (abs(float(abs_k) - 4.0) < 0.5) {
            u = COS_TABLE_3_FP64;
            v = SIN_TABLE_3_FP64;
        }
#else
        if (abs_k == 1) {
            u = COS_TABLE_0_FP64;
            v = SIN_TABLE_0_FP64;
        } else if (abs_k == 2) {
            u = COS_TABLE_1_FP64;
            v = SIN_TABLE_1_FP64;
        } else if (abs_k == 3) {
            u = COS_TABLE_2_FP64;
            v = SIN_TABLE_2_FP64;
        } else if (abs_k == 4) {
            u = COS_TABLE_3_FP64;
            v = SIN_TABLE_3_FP64;
        }
#endif
        if (k > 0) {
            s = sum_fp64(mul_fp64(u, sin_t), mul_fp64(v, cos_t));
            c = sub_fp64(mul_fp64(u, cos_t), mul_fp64(v, sin_t));
        } else {
            s = sub_fp64(mul_fp64(u, sin_t), mul_fp64(v, cos_t));
            c = sum_fp64(mul_fp64(u, cos_t), mul_fp64(v, sin_t));
        }
    }

    if (j == 0) {
        sin_a = s;
        cos_a = c;
    } else if (j == 1) {
        sin_a = c;
        cos_a = -s;
    } else if (j == -1) {
        sin_a = -c;
        cos_a = s;
    } else {
        sin_a = -s;
        cos_a = -c;
    }
    return div_fp64(sin_a, cos_a);
}

vec2 radians_fp64(vec2 degree) {
  return mul_fp64(degree, PI_180_FP64);
}

vec2 mix_fp64(vec2 a, vec2 b, float x) {
  vec2 range = sub_fp64(b, a);
  return sum_fp64(a, mul_fp64(range, vec2(x, 0.0)));
}

// Vector functions
// vec2 functions
void vec2_sum_fp64(vec2 a[2], vec2 b[2], out vec2 out_val[2]) {
    out_val[0] = sum_fp64(a[0], b[0]);
    out_val[1] = sum_fp64(a[1], b[1]);
}

void vec2_sub_fp64(vec2 a[2], vec2 b[2], out vec2 out_val[2]) {
    out_val[0] = sub_fp64(a[0], b[0]);
    out_val[1] = sub_fp64(a[1], b[1]);
}

void vec2_mul_fp64(vec2 a[2], vec2 b[2], out vec2 out_val[2]) {
    out_val[0] = mul_fp64(a[0], b[0]);
    out_val[1] = mul_fp64(a[1], b[1]);
}

void vec2_div_fp64(vec2 a[2], vec2 b[2], out vec2 out_val[2]) {
    out_val[0] = div_fp64(a[0], b[0]);
    out_val[1] = div_fp64(a[1], b[1]);
}

void vec2_mix_fp64(vec2 x[2], vec2 y[2], float a, out vec2 out_val[2]) {
  vec2 range[2];
  vec2_sub_fp64(y, x, range);
  vec2 portion[2];
  portion[0] = range[0] * a;
  portion[1] = range[1] * a;
  vec2_sum_fp64(x, portion, out_val);
}

vec2 vec2_length_fp64(vec2 x[2]) {
  return sqrt_fp64(sum_fp64(mul_fp64(x[0], x[0]), mul_fp64(x[1], x[1])));
}

void vec2_normalize_fp64(vec2 x[2], out vec2 out_val[2]) {
  vec2 length = vec2_length_fp64(x);
  vec2 length_vec2[2];
  length_vec2[0] = length;
  length_vec2[1] = length;

  vec2_div_fp64(x, length_vec2, out_val);
}

vec2 vec2_distance_fp64(vec2 x[2], vec2 y[2]) {
  vec2 diff[2];
  vec2_sub_fp64(x, y, diff);
  return vec2_length_fp64(diff);
}

vec2 vec2_dot_fp64(vec2 a[2], vec2 b[2]) {
  vec2 v[2];

  v[0] = mul_fp64(a[0], b[0]);
  v[1] = mul_fp64(a[1], b[1]);

  return sum_fp64(v[0], v[1]);
}

// vec3 functions
void vec3_sub_fp64(vec2 a[3], vec2 b[3], out vec2 out_val[3]) {
  for (int i = 0; i < 3; i++) {
    out_val[i] = sum_fp64(a[i], b[i]);
  }
}

void vec3_sum_fp64(vec2 a[3], vec2 b[3], out vec2 out_val[3]) {
  for (int i = 0; i < 3; i++) {
    out_val[i] = sum_fp64(a[i], b[i]);
  }
}

vec2 vec3_length_fp64(vec2 x[3]) {
  return sqrt_fp64(sum_fp64(sum_fp64(mul_fp64(x[0], x[0]), mul_fp64(x[1], x[1])),
    mul_fp64(x[2], x[2])));
}

vec2 vec3_distance_fp64(vec2 x[3], vec2 y[3]) {
  vec2 diff[3];
  vec3_sub_fp64(x, y, diff);
  return vec3_length_fp64(diff);
}

// vec4 functions
void vec4_fp64(vec4 a, out vec2 out_val[4]) {
  out_val[0].x = a[0];
  out_val[0].y = 0.0;

  out_val[1].x = a[1];
  out_val[1].y = 0.0;

  out_val[2].x = a[2];
  out_val[2].y = 0.0;

  out_val[3].x = a[3];
  out_val[3].y = 0.0;
}

void vec4_scalar_mul_fp64(vec2 a[4], vec2 b, out vec2 out_val[4]) {
  out_val[0] = mul_fp64(a[0], b);
  out_val[1] = mul_fp64(a[1], b);
  out_val[2] = mul_fp64(a[2], b);
  out_val[3] = mul_fp64(a[3], b);
}

void vec4_sum_fp64(vec2 a[4], vec2 b[4], out vec2 out_val[4]) {
  for (int i = 0; i < 4; i++) {
    out_val[i] = sum_fp64(a[i], b[i]);
  }
}

void vec4_dot_fp64(vec2 a[4], vec2 b[4], out vec2 out_val) {
  vec2 v[4];

  v[0] = mul_fp64(a[0], b[0]);
  v[1] = mul_fp64(a[1], b[1]);
  v[2] = mul_fp64(a[2], b[2]);
  v[3] = mul_fp64(a[3], b[3]);

  out_val = sum_fp64(sum_fp64(v[0], v[1]), sum_fp64(v[2], v[3]));
}

void mat4_vec4_mul_fp64(vec2 b[16], vec2 a[4], out vec2 out_val[4]) {
  vec2 tmp[4];

  for (int i = 0; i < 4; i++)
  {
    for (int j = 0; j < 4; j++)
    {
      tmp[j] = b[j + i * 4];
    }
    vec4_dot_fp64(a, tmp, out_val[i]);
  }
}
`;

  // ../../node_modules/@luma.gl/shadertools/dist/modules-webgl1/math/fp64/fp64.js
  var CONST_UNIFORMS = {
    ONE: 1
  };
  function getUniforms2() {
    return CONST_UNIFORMS;
  }
  var fp64arithmetic = {
    name: "fp64-arithmetic",
    vs: fp64arithmeticShader,
    getUniforms: getUniforms2,
    fp64ify,
    fp64LowPart,
    fp64ifyMatrix4
  };
  var fp64 = {
    name: "fp64",
    vs: fp64functionShader,
    dependencies: [fp64arithmetic],
    fp64ify,
    fp64LowPart,
    fp64ifyMatrix4
  };

  // ../../node_modules/@math.gl/core/dist/lib/common.js
  var RADIANS_TO_DEGREES = 1 / Math.PI * 180;
  var DEGREES_TO_RADIANS = 1 / 180 * Math.PI;
  var DEFAULT_CONFIG = {
    EPSILON: 1e-12,
    debug: false,
    precision: 4,
    printTypes: false,
    printDegrees: false,
    printRowMajor: true,
    _cartographicRadians: false
  };
  globalThis.mathgl = globalThis.mathgl || {
    config: {
      ...DEFAULT_CONFIG
    }
  };
  var config = globalThis.mathgl.config;
  function isArray2(value) {
    return Array.isArray(value) || ArrayBuffer.isView(value) && !(value instanceof DataView);
  }
  function equals(a, b, epsilon) {
    const oldEpsilon = config.EPSILON;
    if (epsilon) {
      config.EPSILON = epsilon;
    }
    try {
      if (a === b) {
        return true;
      }
      if (isArray2(a) && isArray2(b)) {
        if (a.length !== b.length) {
          return false;
        }
        for (let i = 0; i < a.length; ++i) {
          if (!equals(a[i], b[i])) {
            return false;
          }
        }
        return true;
      }
      if (a && a.equals) {
        return a.equals(b);
      }
      if (b && b.equals) {
        return b.equals(a);
      }
      if (typeof a === "number" && typeof b === "number") {
        return Math.abs(a - b) <= config.EPSILON * Math.max(1, Math.abs(a), Math.abs(b));
      }
      return false;
    } finally {
      config.EPSILON = oldEpsilon;
    }
  }

  // ../../node_modules/@math.gl/core/dist/gl-matrix/common.js
  var EPSILON = 1e-6;
  var ARRAY_TYPE = typeof Float32Array !== "undefined" ? Float32Array : Array;
  var RANDOM = Math.random;
  function round(a) {
    if (a >= 0)
      return Math.round(a);
    return a % 0.5 === 0 ? Math.floor(a) : Math.round(a);
  }
  var degree = Math.PI / 180;

  // ../../node_modules/@math.gl/core/dist/gl-matrix/vec3.js
  var vec3_exports = {};
  __export(vec3_exports, {
    add: () => add,
    angle: () => angle,
    bezier: () => bezier,
    ceil: () => ceil,
    clone: () => clone,
    copy: () => copy,
    create: () => create,
    cross: () => cross,
    dist: () => dist,
    distance: () => distance,
    div: () => div,
    divide: () => divide,
    dot: () => dot,
    equals: () => equals2,
    exactEquals: () => exactEquals,
    floor: () => floor,
    forEach: () => forEach,
    fromValues: () => fromValues,
    hermite: () => hermite,
    inverse: () => inverse,
    len: () => len,
    length: () => length,
    lerp: () => lerp,
    max: () => max,
    min: () => min,
    mul: () => mul,
    multiply: () => multiply,
    negate: () => negate,
    normalize: () => normalize,
    random: () => random,
    rotateX: () => rotateX,
    rotateY: () => rotateY,
    rotateZ: () => rotateZ,
    round: () => round2,
    scale: () => scale,
    scaleAndAdd: () => scaleAndAdd,
    set: () => set,
    slerp: () => slerp,
    sqrDist: () => sqrDist,
    sqrLen: () => sqrLen,
    squaredDistance: () => squaredDistance,
    squaredLength: () => squaredLength,
    str: () => str,
    sub: () => sub,
    subtract: () => subtract,
    transformMat3: () => transformMat3,
    transformMat4: () => transformMat4,
    transformQuat: () => transformQuat,
    zero: () => zero
  });
  function create() {
    const out = new ARRAY_TYPE(3);
    if (ARRAY_TYPE != Float32Array) {
      out[0] = 0;
      out[1] = 0;
      out[2] = 0;
    }
    return out;
  }
  function clone(a) {
    const out = new ARRAY_TYPE(3);
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    return out;
  }
  function length(a) {
    const x = a[0];
    const y = a[1];
    const z = a[2];
    return Math.sqrt(x * x + y * y + z * z);
  }
  function fromValues(x, y, z) {
    const out = new ARRAY_TYPE(3);
    out[0] = x;
    out[1] = y;
    out[2] = z;
    return out;
  }
  function copy(out, a) {
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    return out;
  }
  function set(out, x, y, z) {
    out[0] = x;
    out[1] = y;
    out[2] = z;
    return out;
  }
  function add(out, a, b) {
    out[0] = a[0] + b[0];
    out[1] = a[1] + b[1];
    out[2] = a[2] + b[2];
    return out;
  }
  function subtract(out, a, b) {
    out[0] = a[0] - b[0];
    out[1] = a[1] - b[1];
    out[2] = a[2] - b[2];
    return out;
  }
  function multiply(out, a, b) {
    out[0] = a[0] * b[0];
    out[1] = a[1] * b[1];
    out[2] = a[2] * b[2];
    return out;
  }
  function divide(out, a, b) {
    out[0] = a[0] / b[0];
    out[1] = a[1] / b[1];
    out[2] = a[2] / b[2];
    return out;
  }
  function ceil(out, a) {
    out[0] = Math.ceil(a[0]);
    out[1] = Math.ceil(a[1]);
    out[2] = Math.ceil(a[2]);
    return out;
  }
  function floor(out, a) {
    out[0] = Math.floor(a[0]);
    out[1] = Math.floor(a[1]);
    out[2] = Math.floor(a[2]);
    return out;
  }
  function min(out, a, b) {
    out[0] = Math.min(a[0], b[0]);
    out[1] = Math.min(a[1], b[1]);
    out[2] = Math.min(a[2], b[2]);
    return out;
  }
  function max(out, a, b) {
    out[0] = Math.max(a[0], b[0]);
    out[1] = Math.max(a[1], b[1]);
    out[2] = Math.max(a[2], b[2]);
    return out;
  }
  function round2(out, a) {
    out[0] = round(a[0]);
    out[1] = round(a[1]);
    out[2] = round(a[2]);
    return out;
  }
  function scale(out, a, b) {
    out[0] = a[0] * b;
    out[1] = a[1] * b;
    out[2] = a[2] * b;
    return out;
  }
  function scaleAndAdd(out, a, b, scale2) {
    out[0] = a[0] + b[0] * scale2;
    out[1] = a[1] + b[1] * scale2;
    out[2] = a[2] + b[2] * scale2;
    return out;
  }
  function distance(a, b) {
    const x = b[0] - a[0];
    const y = b[1] - a[1];
    const z = b[2] - a[2];
    return Math.sqrt(x * x + y * y + z * z);
  }
  function squaredDistance(a, b) {
    const x = b[0] - a[0];
    const y = b[1] - a[1];
    const z = b[2] - a[2];
    return x * x + y * y + z * z;
  }
  function squaredLength(a) {
    const x = a[0];
    const y = a[1];
    const z = a[2];
    return x * x + y * y + z * z;
  }
  function negate(out, a) {
    out[0] = -a[0];
    out[1] = -a[1];
    out[2] = -a[2];
    return out;
  }
  function inverse(out, a) {
    out[0] = 1 / a[0];
    out[1] = 1 / a[1];
    out[2] = 1 / a[2];
    return out;
  }
  function normalize(out, a) {
    const x = a[0];
    const y = a[1];
    const z = a[2];
    let len2 = x * x + y * y + z * z;
    if (len2 > 0) {
      len2 = 1 / Math.sqrt(len2);
    }
    out[0] = a[0] * len2;
    out[1] = a[1] * len2;
    out[2] = a[2] * len2;
    return out;
  }
  function dot(a, b) {
    return a[0] * b[0] + a[1] * b[1] + a[2] * b[2];
  }
  function cross(out, a, b) {
    const ax = a[0];
    const ay = a[1];
    const az = a[2];
    const bx = b[0];
    const by = b[1];
    const bz = b[2];
    out[0] = ay * bz - az * by;
    out[1] = az * bx - ax * bz;
    out[2] = ax * by - ay * bx;
    return out;
  }
  function lerp(out, a, b, t) {
    const ax = a[0];
    const ay = a[1];
    const az = a[2];
    out[0] = ax + t * (b[0] - ax);
    out[1] = ay + t * (b[1] - ay);
    out[2] = az + t * (b[2] - az);
    return out;
  }
  function slerp(out, a, b, t) {
    const angle2 = Math.acos(Math.min(Math.max(dot(a, b), -1), 1));
    const sinTotal = Math.sin(angle2);
    const ratioA = Math.sin((1 - t) * angle2) / sinTotal;
    const ratioB = Math.sin(t * angle2) / sinTotal;
    out[0] = ratioA * a[0] + ratioB * b[0];
    out[1] = ratioA * a[1] + ratioB * b[1];
    out[2] = ratioA * a[2] + ratioB * b[2];
    return out;
  }
  function hermite(out, a, b, c, d, t) {
    const factorTimes2 = t * t;
    const factor1 = factorTimes2 * (2 * t - 3) + 1;
    const factor2 = factorTimes2 * (t - 2) + t;
    const factor3 = factorTimes2 * (t - 1);
    const factor4 = factorTimes2 * (3 - 2 * t);
    out[0] = a[0] * factor1 + b[0] * factor2 + c[0] * factor3 + d[0] * factor4;
    out[1] = a[1] * factor1 + b[1] * factor2 + c[1] * factor3 + d[1] * factor4;
    out[2] = a[2] * factor1 + b[2] * factor2 + c[2] * factor3 + d[2] * factor4;
    return out;
  }
  function bezier(out, a, b, c, d, t) {
    const inverseFactor = 1 - t;
    const inverseFactorTimesTwo = inverseFactor * inverseFactor;
    const factorTimes2 = t * t;
    const factor1 = inverseFactorTimesTwo * inverseFactor;
    const factor2 = 3 * t * inverseFactorTimesTwo;
    const factor3 = 3 * factorTimes2 * inverseFactor;
    const factor4 = factorTimes2 * t;
    out[0] = a[0] * factor1 + b[0] * factor2 + c[0] * factor3 + d[0] * factor4;
    out[1] = a[1] * factor1 + b[1] * factor2 + c[1] * factor3 + d[1] * factor4;
    out[2] = a[2] * factor1 + b[2] * factor2 + c[2] * factor3 + d[2] * factor4;
    return out;
  }
  function random(out, scale2) {
    scale2 = scale2 === void 0 ? 1 : scale2;
    const r = RANDOM() * 2 * Math.PI;
    const z = RANDOM() * 2 - 1;
    const zScale = Math.sqrt(1 - z * z) * scale2;
    out[0] = Math.cos(r) * zScale;
    out[1] = Math.sin(r) * zScale;
    out[2] = z * scale2;
    return out;
  }
  function transformMat4(out, a, m) {
    const x = a[0];
    const y = a[1];
    const z = a[2];
    let w = m[3] * x + m[7] * y + m[11] * z + m[15];
    w = w || 1;
    out[0] = (m[0] * x + m[4] * y + m[8] * z + m[12]) / w;
    out[1] = (m[1] * x + m[5] * y + m[9] * z + m[13]) / w;
    out[2] = (m[2] * x + m[6] * y + m[10] * z + m[14]) / w;
    return out;
  }
  function transformMat3(out, a, m) {
    const x = a[0];
    const y = a[1];
    const z = a[2];
    out[0] = x * m[0] + y * m[3] + z * m[6];
    out[1] = x * m[1] + y * m[4] + z * m[7];
    out[2] = x * m[2] + y * m[5] + z * m[8];
    return out;
  }
  function transformQuat(out, a, q) {
    const qx = q[0];
    const qy = q[1];
    const qz = q[2];
    const qw = q[3];
    const x = a[0];
    const y = a[1];
    const z = a[2];
    let uvx = qy * z - qz * y;
    let uvy = qz * x - qx * z;
    let uvz = qx * y - qy * x;
    let uuvx = qy * uvz - qz * uvy;
    let uuvy = qz * uvx - qx * uvz;
    let uuvz = qx * uvy - qy * uvx;
    const w2 = qw * 2;
    uvx *= w2;
    uvy *= w2;
    uvz *= w2;
    uuvx *= 2;
    uuvy *= 2;
    uuvz *= 2;
    out[0] = x + uvx + uuvx;
    out[1] = y + uvy + uuvy;
    out[2] = z + uvz + uuvz;
    return out;
  }
  function rotateX(out, a, b, rad) {
    const p = [];
    const r = [];
    p[0] = a[0] - b[0];
    p[1] = a[1] - b[1];
    p[2] = a[2] - b[2];
    r[0] = p[0];
    r[1] = p[1] * Math.cos(rad) - p[2] * Math.sin(rad);
    r[2] = p[1] * Math.sin(rad) + p[2] * Math.cos(rad);
    out[0] = r[0] + b[0];
    out[1] = r[1] + b[1];
    out[2] = r[2] + b[2];
    return out;
  }
  function rotateY(out, a, b, rad) {
    const p = [];
    const r = [];
    p[0] = a[0] - b[0];
    p[1] = a[1] - b[1];
    p[2] = a[2] - b[2];
    r[0] = p[2] * Math.sin(rad) + p[0] * Math.cos(rad);
    r[1] = p[1];
    r[2] = p[2] * Math.cos(rad) - p[0] * Math.sin(rad);
    out[0] = r[0] + b[0];
    out[1] = r[1] + b[1];
    out[2] = r[2] + b[2];
    return out;
  }
  function rotateZ(out, a, b, rad) {
    const p = [];
    const r = [];
    p[0] = a[0] - b[0];
    p[1] = a[1] - b[1];
    p[2] = a[2] - b[2];
    r[0] = p[0] * Math.cos(rad) - p[1] * Math.sin(rad);
    r[1] = p[0] * Math.sin(rad) + p[1] * Math.cos(rad);
    r[2] = p[2];
    out[0] = r[0] + b[0];
    out[1] = r[1] + b[1];
    out[2] = r[2] + b[2];
    return out;
  }
  function angle(a, b) {
    const ax = a[0];
    const ay = a[1];
    const az = a[2];
    const bx = b[0];
    const by = b[1];
    const bz = b[2];
    const mag = Math.sqrt((ax * ax + ay * ay + az * az) * (bx * bx + by * by + bz * bz));
    const cosine = mag && dot(a, b) / mag;
    return Math.acos(Math.min(Math.max(cosine, -1), 1));
  }
  function zero(out) {
    out[0] = 0;
    out[1] = 0;
    out[2] = 0;
    return out;
  }
  function str(a) {
    return "vec3(".concat(a[0], ", ").concat(a[1], ", ").concat(a[2], ")");
  }
  function exactEquals(a, b) {
    return a[0] === b[0] && a[1] === b[1] && a[2] === b[2];
  }
  function equals2(a, b) {
    const a0 = a[0];
    const a1 = a[1];
    const a2 = a[2];
    const b0 = b[0];
    const b1 = b[1];
    const b2 = b[2];
    return Math.abs(a0 - b0) <= EPSILON * Math.max(1, Math.abs(a0), Math.abs(b0)) && Math.abs(a1 - b1) <= EPSILON * Math.max(1, Math.abs(a1), Math.abs(b1)) && Math.abs(a2 - b2) <= EPSILON * Math.max(1, Math.abs(a2), Math.abs(b2));
  }
  var sub = subtract;
  var mul = multiply;
  var div = divide;
  var dist = distance;
  var sqrDist = squaredDistance;
  var len = length;
  var sqrLen = squaredLength;
  var forEach = function() {
    const vec = create();
    return function(a, stride, offset, count, fn, arg) {
      let i;
      let l;
      if (!stride) {
        stride = 3;
      }
      if (!offset) {
        offset = 0;
      }
      if (count) {
        l = Math.min(count * stride + offset, a.length);
      } else {
        l = a.length;
      }
      for (i = offset; i < l; i += stride) {
        vec[0] = a[i];
        vec[1] = a[i + 1];
        vec[2] = a[i + 2];
        fn(vec, vec, arg);
        a[i] = vec[0];
        a[i + 1] = vec[1];
        a[i + 2] = vec[2];
      }
      return a;
    };
  }();

  // src/fp64/project64.ts
  var import_core39 = __toESM(require_core());

  // src/fp64/project64.glsl.ts
  var project64_glsl_default = `
const vec2 WORLD_SCALE_FP64 = vec2(81.4873275756836, 0.0000032873668232014097);

uniform vec2 project_uViewProjectionMatrixFP64[16];

// longitude: lnglat_fp64.xy; latitude: lnglat_fp64.zw
void mercatorProject_fp64(vec4 lnglat_fp64, out vec2 out_val[2]) {

#if defined(NVIDIA_FP64_WORKAROUND)
  out_val[0] = sum_fp64(radians_fp64(lnglat_fp64.xy), PI_FP64 * ONE);
#else
  out_val[0] = sum_fp64(radians_fp64(lnglat_fp64.xy), PI_FP64);
#endif
  out_val[1] = sum_fp64(PI_FP64,
    log_fp64(tan_fp64(sum_fp64(PI_4_FP64, radians_fp64(lnglat_fp64.zw) / 2.0))));
  return;
}

void project_position_fp64(vec4 position_fp64, out vec2 out_val[2]) {
  vec2 pos_fp64[2];
  mercatorProject_fp64(position_fp64, pos_fp64);
  out_val[0] = mul_fp64(pos_fp64[0], WORLD_SCALE_FP64);
  out_val[1] = mul_fp64(pos_fp64[1], WORLD_SCALE_FP64);

  return;
}

void project_position_fp64(vec2 position, vec2 position64xyLow, out vec2 out_val[2]) {
  vec4 position64xy = vec4(
    position.x, position64xyLow.x,
    position.y, position64xyLow.y);

  project_position_fp64(position64xy, out_val);
}

vec4 project_common_position_to_clipspace_fp64(vec2 vertex_pos_modelspace[4]) {
  vec2 vertex_pos_clipspace[4];
  mat4_vec4_mul_fp64(project_uViewProjectionMatrixFP64, vertex_pos_modelspace,
    vertex_pos_clipspace);
  return vec4(
    vertex_pos_clipspace[0].x,
    vertex_pos_clipspace[1].x,
    vertex_pos_clipspace[2].x,
    vertex_pos_clipspace[3].x
    );
}

vec4 project_position_to_clipspace(
  vec3 position, vec3 position64xyLow, vec3 offset, out vec4 commonPosition
) {
  // This is the local offset to the instance position
  vec2 offset64[4];
  vec4_fp64(vec4(offset, 0.0), offset64);

  float z = project_size(position.z);

  // Apply web mercator projection (depends on coordinate system imn use)
  vec2 projectedPosition64xy[2];
  project_position_fp64(position.xy, position64xyLow.xy, projectedPosition64xy);

  vec2 commonPosition64[4];
  commonPosition64[0] = sum_fp64(offset64[0], projectedPosition64xy[0]);
  commonPosition64[1] = sum_fp64(offset64[1], projectedPosition64xy[1]);
  commonPosition64[2] = sum_fp64(offset64[2], vec2(z, 0.0));
  commonPosition64[3] = vec2(1.0, 0.0);

  commonPosition = vec4(projectedPosition64xy[0].x, projectedPosition64xy[1].x, z, 1.0);

  return project_common_position_to_clipspace_fp64(commonPosition64);
}

vec4 project_position_to_clipspace(
  vec3 position, vec3 position64xyLow, vec3 offset
) {
  vec4 commonPosition;
  return project_position_to_clipspace(
    position, position64xyLow, offset, commonPosition
  );
}
`;

  // src/fp64/project64.ts
  var {
    fp64ify: fp64ify2,
    fp64ifyMatrix4: fp64ifyMatrix42
  } = fp64;
  var project64_default = {
    name: "project64",
    dependencies: [import_core39.project, fp64],
    vs: project64_glsl_default,
    getUniforms: getUniforms3
  };
  var getMemoizedUniforms = (0, import_core39._memoize)(calculateUniforms);
  function getUniforms3(opts) {
    if (opts && "viewport" in opts) {
      const {
        viewProjectionMatrix,
        scale: scale2
      } = opts.viewport;
      return getMemoizedUniforms({
        viewProjectionMatrix,
        scale: scale2
      });
    }
    return {};
  }
  function calculateUniforms({
    viewProjectionMatrix,
    scale: scale2
  }) {
    const glViewProjectionMatrixFP64 = fp64ifyMatrix42(viewProjectionMatrix);
    const scaleFP64 = fp64ify2(scale2);
    return {
      project_uViewProjectionMatrixFP64: glViewProjectionMatrixFP64,
      project64_uViewProjectionMatrix: glViewProjectionMatrixFP64,
      project64_uScale: scaleFP64
    };
  }

  // src/fp64/fp64-extension.ts
  var Fp64Extension = class extends import_core40.LayerExtension {
    getShaders() {
      const {
        coordinateSystem
      } = this.props;
      if (coordinateSystem !== import_core40.COORDINATE_SYSTEM.LNGLAT && coordinateSystem !== import_core40.COORDINATE_SYSTEM.DEFAULT) {
        throw new Error("fp64: coordinateSystem must be LNGLAT");
      }
      return {
        modules: [project64_default]
      };
    }
  };
  __publicField(Fp64Extension, "extensionName", "Fp64Extension");

  // src/path-style/path-style-extension.ts
  var import_core41 = __toESM(require_core());

  // src/path-style/shaders.glsl.ts
  var dashShaders = {
    inject: {
      "vs:#decl": `
attribute vec2 instanceDashArrays;
attribute float instanceDashOffsets;
varying vec2 vDashArray;
varying float vDashOffset;
`,
      "vs:#main-end": `
vDashArray = instanceDashArrays;
vDashOffset = instanceDashOffsets / width.x;
`,
      "fs:#decl": `
uniform float dashAlignMode;
uniform float capType;
uniform bool dashGapPickable;
varying vec2 vDashArray;
varying float vDashOffset;

float round(float x) {
  return floor(x + 0.5);
}
`,
      "fs:#main-start": `
  float solidLength = vDashArray.x;
  float gapLength = vDashArray.y;
  float unitLength = solidLength + gapLength;

  float offset;

  if (unitLength > 0.0) {
    if (dashAlignMode == 0.0) {
      offset = vDashOffset;
    } else {
      unitLength = vPathLength / round(vPathLength / unitLength);
      offset = solidLength / 2.0;
    }

    float unitOffset = mod(vPathPosition.y + offset, unitLength);

    if (gapLength > 0.0 && unitOffset > solidLength) {
      if (capType <= 0.5) {
        if (!(dashGapPickable && picking_uActive)) {
          discard;
        }
      } else {
        // caps are rounded, test the distance to solid ends
        float distToEnd = length(vec2(
          min(unitOffset - solidLength, unitLength - unitOffset),
          vPathPosition.x
        ));
        if (distToEnd > 1.0) {
          if (!(dashGapPickable && picking_uActive)) {
            discard;
          }
        }
      }
    }
  }
`
    }
  };
  var offsetShaders = {
    inject: {
      "vs:#decl": `
attribute float instanceOffsets;
`,
      "vs:DECKGL_FILTER_SIZE": `
  float offsetWidth = abs(instanceOffsets * 2.0) + 1.0;
  size *= offsetWidth;
`,
      "vs:#main-end": `
  float offsetWidth = abs(instanceOffsets * 2.0) + 1.0;
  float offsetDir = sign(instanceOffsets);
  vPathPosition.x = (vPathPosition.x + offsetDir) * offsetWidth - offsetDir;
  vPathPosition.y *= offsetWidth;
  vPathLength *= offsetWidth;
`,
      "fs:#main-start": `
  float isInside;
  isInside = step(-1.0, vPathPosition.x) * step(vPathPosition.x, 1.0);
  if (isInside == 0.0) {
    discard;
  }
`
    }
  };

  // src/path-style/path-style-extension.ts
  var defaultProps3 = {
    getDashArray: {
      type: "accessor",
      value: [0, 0]
    },
    getOffset: {
      type: "accessor",
      value: 0
    },
    dashJustified: false,
    dashGapPickable: false
  };
  var PathStyleExtension = class extends import_core41.LayerExtension {
    constructor({
      dash = false,
      offset = false,
      highPrecisionDash = false
    } = {}) {
      super({
        dash: dash || highPrecisionDash,
        offset,
        highPrecisionDash
      });
    }
    isEnabled(layer) {
      return "pathTesselator" in layer.state;
    }
    getShaders(extension) {
      if (!extension.isEnabled(this)) {
        return null;
      }
      let result = {};
      if (extension.opts.dash) {
        result = (0, import_core41._mergeShaders)(result, dashShaders);
      }
      if (extension.opts.offset) {
        result = (0, import_core41._mergeShaders)(result, offsetShaders);
      }
      return result;
    }
    initializeState(context, extension) {
      const attributeManager = this.getAttributeManager();
      if (!attributeManager || !extension.isEnabled(this)) {
        return;
      }
      if (extension.opts.dash) {
        attributeManager.addInstanced({
          instanceDashArrays: {
            size: 2,
            accessor: "getDashArray"
          },
          instanceDashOffsets: extension.opts.highPrecisionDash ? {
            size: 1,
            accessor: "getPath",
            transform: extension.getDashOffsets.bind(this)
          } : {
            size: 1,
            update: (attribute) => {
              attribute.constant = true;
              attribute.value = [0];
            }
          }
        });
      }
      if (extension.opts.offset) {
        attributeManager.addInstanced({
          instanceOffsets: {
            size: 1,
            accessor: "getOffset"
          }
        });
      }
    }
    updateState(params, extension) {
      if (!extension.isEnabled(this)) {
        return;
      }
      const uniforms = {};
      if (extension.opts.dash) {
        uniforms.dashAlignMode = this.props.dashJustified ? 1 : 0;
        uniforms.dashGapPickable = Boolean(this.props.dashGapPickable);
      }
      this.state.model?.setUniforms(uniforms);
    }
    getDashOffsets(path) {
      const result = [0];
      const positionSize = this.props.positionFormat === "XY" ? 2 : 3;
      const isNested = Array.isArray(path[0]);
      const geometrySize = isNested ? path.length : path.length / positionSize;
      let p;
      let prevP;
      for (let i = 0; i < geometrySize - 1; i++) {
        p = isNested ? path[i] : path.slice(i * positionSize, i * positionSize + positionSize);
        p = this.projectPosition(p);
        if (i > 0) {
          result[i] = result[i - 1] + vec3_exports.dist(prevP, p);
        }
        prevP = p;
      }
      return result;
    }
  };
  __publicField(PathStyleExtension, "defaultProps", defaultProps3);
  __publicField(PathStyleExtension, "extensionName", "PathStyleExtension");

  // src/fill-style/fill-style-extension.ts
  var import_core44 = __toESM(require_core());

  // src/fill-style/shaders.glsl.ts
  var import_core43 = __toESM(require_core());
  var patternVs = `
#ifdef NON_INSTANCED_MODEL
  #define FILL_PATTERN_FRAME_ATTRIB fillPatternFrames
  #define FILL_PATTERN_SCALE_ATTRIB fillPatternScales
  #define FILL_PATTERN_OFFSET_ATTRIB fillPatternOffsets
#else
  #define FILL_PATTERN_FRAME_ATTRIB instanceFillPatternFrames
  #define FILL_PATTERN_SCALE_ATTRIB instanceFillPatternScales
  #define FILL_PATTERN_OFFSET_ATTRIB instanceFillPatternOffsets
#endif

attribute vec4 FILL_PATTERN_FRAME_ATTRIB;
attribute float FILL_PATTERN_SCALE_ATTRIB;
attribute vec2 FILL_PATTERN_OFFSET_ATTRIB;

uniform bool fill_patternEnabled;
uniform vec2 fill_patternTextureSize;

varying vec2 fill_uv;
varying vec4 fill_patternBounds;
varying vec4 fill_patternPlacement;
`;
  var patternFs = `
uniform bool fill_patternEnabled;
uniform bool fill_patternMask;
uniform sampler2D fill_patternTexture;
uniform vec2 fill_uvCoordinateOrigin;
uniform vec2 fill_uvCoordinateOrigin64Low;

varying vec4 fill_patternBounds;
varying vec4 fill_patternPlacement;
varying vec2 fill_uv;

const float FILL_UV_SCALE = 512.0 / 40000000.0;
`;
  var inject3 = {
    "vs:DECKGL_FILTER_GL_POSITION": `
    fill_uv = geometry.position.xy;
  `,
    "vs:DECKGL_FILTER_COLOR": `
    if (fill_patternEnabled) {
      fill_patternBounds = FILL_PATTERN_FRAME_ATTRIB / vec4(fill_patternTextureSize, fill_patternTextureSize);
      fill_patternPlacement.xy = FILL_PATTERN_OFFSET_ATTRIB;
      fill_patternPlacement.zw = FILL_PATTERN_SCALE_ATTRIB * FILL_PATTERN_FRAME_ATTRIB.zw;
    }
  `,
    "fs:DECKGL_FILTER_COLOR": `
    if (fill_patternEnabled) {
      vec2 scale = FILL_UV_SCALE * fill_patternPlacement.zw;
      vec2 patternUV = mod(mod(fill_uvCoordinateOrigin, scale) + fill_uvCoordinateOrigin64Low + fill_uv, scale) / scale;
      patternUV = mod(fill_patternPlacement.xy + patternUV, 1.0);

      vec2 texCoords = fill_patternBounds.xy + fill_patternBounds.zw * patternUV;

      vec4 patternColor = texture2D(fill_patternTexture, texCoords);
      color.a *= patternColor.a;
      if (!fill_patternMask) {
        color.rgb = patternColor.rgb;
      }
    }
  `
  };
  function getPatternUniforms(opts, uniforms) {
    if (!opts) {
      return {};
    }
    if ("fillPatternTexture" in opts) {
      const {
        fillPatternTexture
      } = opts;
      return {
        fill_patternTexture: fillPatternTexture,
        fill_patternTextureSize: [fillPatternTexture.width, fillPatternTexture.height]
      };
    }
    if ("viewport" in opts) {
      const {
        fillPatternMask = true,
        fillPatternEnabled = true
      } = opts;
      const {
        project_uCommonOrigin: coordinateOriginCommon
      } = uniforms;
      const coordinateOriginCommon64Low = [(0, import_core43.fp64LowPart)(coordinateOriginCommon[0]), (0, import_core43.fp64LowPart)(coordinateOriginCommon[1])];
      return {
        fill_uvCoordinateOrigin: coordinateOriginCommon.slice(0, 2),
        fill_uvCoordinateOrigin64Low: coordinateOriginCommon64Low,
        fill_patternMask: fillPatternMask,
        fill_patternEnabled: fillPatternEnabled
      };
    }
    return {};
  }
  var patternShaders = {
    name: "fill-pattern",
    vs: patternVs,
    fs: patternFs,
    inject: inject3,
    dependencies: [import_core43.project],
    getUniforms: getPatternUniforms
  };

  // src/fill-style/fill-style-extension.ts
  var defaultProps4 = {
    fillPatternEnabled: true,
    fillPatternAtlas: {
      type: "image",
      value: null,
      async: true,
      parameters: {
        minFilter: "linear"
      }
    },
    fillPatternMapping: {
      type: "object",
      value: {},
      async: true
    },
    fillPatternMask: true,
    getFillPattern: {
      type: "accessor",
      value: (d) => d.pattern
    },
    getFillPatternScale: {
      type: "accessor",
      value: 1
    },
    getFillPatternOffset: {
      type: "accessor",
      value: [0, 0]
    }
  };
  var FillStyleExtension = class extends import_core44.LayerExtension {
    constructor({
      pattern = false
    } = {}) {
      super({
        pattern
      });
    }
    isEnabled(layer) {
      return layer.getAttributeManager() !== null && !("pathTesselator" in layer.state);
    }
    getShaders(extension) {
      if (!extension.isEnabled(this)) {
        return null;
      }
      return {
        modules: [extension.opts.pattern && patternShaders].filter(Boolean)
      };
    }
    initializeState(context, extension) {
      if (!extension.isEnabled(this)) {
        return;
      }
      const attributeManager = this.getAttributeManager();
      if (extension.opts.pattern) {
        attributeManager.add({
          fillPatternFrames: {
            size: 4,
            accessor: "getFillPattern",
            transform: extension.getPatternFrame.bind(this),
            shaderAttributes: {
              fillPatternFrames: {
                divisor: 0
              },
              instanceFillPatternFrames: {
                divisor: 1
              }
            }
          },
          fillPatternScales: {
            size: 1,
            accessor: "getFillPatternScale",
            defaultValue: 1,
            shaderAttributes: {
              fillPatternScales: {
                divisor: 0
              },
              instanceFillPatternScales: {
                divisor: 1
              }
            }
          },
          fillPatternOffsets: {
            size: 2,
            accessor: "getFillPatternOffset",
            shaderAttributes: {
              fillPatternOffsets: {
                divisor: 0
              },
              instanceFillPatternOffsets: {
                divisor: 1
              }
            }
          }
        });
      }
      this.setState({
        emptyTexture: this.context.device.createTexture({
          data: new Uint8Array(4),
          width: 1,
          height: 1
        })
      });
    }
    updateState({
      props,
      oldProps
    }, extension) {
      if (!extension.isEnabled(this)) {
        return;
      }
      if (props.fillPatternMapping && props.fillPatternMapping !== oldProps.fillPatternMapping) {
        this.getAttributeManager().invalidate("getFillPattern");
      }
    }
    draw(params, extension) {
      if (!extension.isEnabled(this)) {
        return;
      }
      const {
        fillPatternAtlas
      } = this.props;
      this.setModuleParameters({
        fillPatternTexture: fillPatternAtlas || this.state.emptyTexture
      });
    }
    finalizeState() {
      const emptyTexture = this.state.emptyTexture;
      emptyTexture?.delete();
    }
    getPatternFrame(name) {
      const {
        fillPatternMapping
      } = this.getCurrentLayer().props;
      const def = fillPatternMapping && fillPatternMapping[name];
      return def ? [def.x, def.y, def.width, def.height] : [0, 0, 0, 0];
    }
  };
  __publicField(FillStyleExtension, "defaultProps", defaultProps4);
  __publicField(FillStyleExtension, "extensionName", "FillStyleExtension");

  // src/clip/clip-extension.ts
  var import_core45 = __toESM(require_core());
  var defaultProps5 = {
    clipBounds: [0, 0, 1, 1],
    clipByInstance: void 0
  };
  var shaderFunction = `
uniform vec4 clip_bounds;

bool clip_isInBounds(vec2 position) {
  return position.x >= clip_bounds[0] && position.y >= clip_bounds[1] && position.x < clip_bounds[2] && position.y < clip_bounds[3];
}
`;
  var shaderModuleVs = {
    name: "clip-vs",
    vs: shaderFunction
  };
  var injectionVs = {
    "vs:#decl": `
varying float clip_isVisible;
`,
    "vs:DECKGL_FILTER_GL_POSITION": `
  clip_isVisible = float(clip_isInBounds(geometry.worldPosition.xy));
`,
    "fs:#decl": `
varying float clip_isVisible;
`,
    "fs:DECKGL_FILTER_COLOR": `
  if (clip_isVisible < 0.5) discard;
`
  };
  var shaderModuleFs = {
    name: "clip-fs",
    fs: shaderFunction
  };
  var injectionFs = {
    "vs:#decl": `
varying vec2 clip_commonPosition;
`,
    "vs:DECKGL_FILTER_GL_POSITION": `
  clip_commonPosition = geometry.position.xy;
`,
    "fs:#decl": `
varying vec2 clip_commonPosition;
`,
    "fs:DECKGL_FILTER_COLOR": `
  if (!clip_isInBounds(clip_commonPosition)) discard;
`
  };
  var ClipExtension = class extends import_core45.LayerExtension {
    getShaders() {
      let clipByInstance = "instancePositions" in this.getAttributeManager().attributes;
      if (this.props.clipByInstance !== void 0) {
        clipByInstance = Boolean(this.props.clipByInstance);
      }
      this.state.clipByInstance = clipByInstance;
      return clipByInstance ? {
        modules: [shaderModuleVs],
        inject: injectionVs
      } : {
        modules: [shaderModuleFs],
        inject: injectionFs
      };
    }
    draw({
      uniforms
    }) {
      const {
        clipBounds
      } = this.props;
      if (this.state.clipByInstance) {
        uniforms.clip_bounds = clipBounds;
      } else {
        const corner0 = this.projectPosition([clipBounds[0], clipBounds[1], 0]);
        const corner1 = this.projectPosition([clipBounds[2], clipBounds[3], 0]);
        uniforms.clip_bounds = [Math.min(corner0[0], corner1[0]), Math.min(corner0[1], corner1[1]), Math.max(corner0[0], corner1[0]), Math.max(corner0[1], corner1[1])];
      }
    }
  };
  __publicField(ClipExtension, "defaultProps", defaultProps5);
  __publicField(ClipExtension, "extensionName", "ClipExtension");

  // src/collision-filter/collision-filter-extension.ts
  var import_core54 = __toESM(require_core());

  // src/collision-filter/shader-module.ts
  var import_core46 = __toESM(require_core());
  var vs3 = `
#ifdef NON_INSTANCED_MODEL
attribute float collisionPriorities;
#else
attribute float instanceCollisionPriorities;
#endif

uniform sampler2D collision_texture;
uniform bool collision_sort;
uniform bool collision_enabled;

vec2 collision_getCoords(vec4 position) {
  vec4 collision_clipspace = project_common_position_to_clipspace(position);
  return (1.0 + collision_clipspace.xy / collision_clipspace.w) / 2.0;
}

float collision_match(vec2 tex, vec3 pickingColor) {
  vec4 collision_pickingColor = texture2D(collision_texture, tex);
  float delta = dot(abs(collision_pickingColor.rgb - pickingColor), vec3(1.0));
  float e = 0.001;
  return step(delta, e);
}

float collision_isVisible(vec2 texCoords, vec3 pickingColor) {
  if (!collision_enabled) {
    return 1.0;
  }

  // Visibility test, sample area of 5x5 pixels in order to fade in/out.
  // Due to the locality, the lookups will be cached
  // This reduces the flicker present when objects are shown/hidden
  const int N = 2;
  float accumulator = 0.0;
  vec2 step = vec2(1.0 / project_uViewportSize);

  const float floatN = float(N);
  vec2 delta = -floatN * step;
  for(int i = -N; i <= N; i++) {
    delta.x = -step.x * floatN;
    for(int j = -N; j <= N; j++) {
      accumulator += collision_match(texCoords + delta, pickingColor);
      delta.x += step.x;
    }
    delta.y += step.y;
  }

  float W = 2.0 * floatN + 1.0;
  return pow(accumulator / (W * W), 2.2);
}
`;
  var inject4 = {
    "vs:#decl": `
  float collision_fade = 1.0;
`,
    "vs:DECKGL_FILTER_GL_POSITION": `
  if (collision_sort) {
    #ifdef NON_INSTANCED_MODEL
    float collisionPriority = collisionPriorities;
    #else
    float collisionPriority = instanceCollisionPriorities;
    #endif
    position.z = -0.001 * collisionPriority * position.w; // Support range -1000 -> 1000
  }

  if (collision_enabled) {
    vec4 collision_common_position = project_position(vec4(geometry.worldPosition, 1.0));
    vec2 collision_texCoords = collision_getCoords(collision_common_position);
    collision_fade = collision_isVisible(collision_texCoords, geometry.pickingColor / 255.0);
    if (collision_fade < 0.0001) {
      // Position outside clip space bounds to discard
      position = vec4(0.0, 0.0, 2.0, 1.0);
    }
  }
  `,
    "vs:DECKGL_FILTER_COLOR": `
  color.a *= collision_fade;
  `
  };
  var getCollisionUniforms = (opts, uniforms) => {
    if (!opts || !("dummyCollisionMap" in opts)) {
      return {};
    }
    const {
      collisionFBO,
      drawToCollisionMap,
      dummyCollisionMap
    } = opts;
    return {
      collision_sort: Boolean(drawToCollisionMap),
      collision_texture: !drawToCollisionMap && collisionFBO ? collisionFBO.colorAttachments[0] : dummyCollisionMap
    };
  };
  var shader_module_default2 = {
    name: "collision",
    dependencies: [import_core46.project],
    vs: vs3,
    inject: inject4,
    getUniforms: getCollisionUniforms
  };

  // src/collision-filter/collision-filter-effect.ts
  var import_core53 = __toESM(require_core());

  // src/collision-filter/collision-filter-pass.ts
  var import_core47 = __toESM(require_core());
  var CollisionFilterPass = class extends import_core47._LayersPass {
    renderCollisionMap(target, options) {
      const padding = 1;
      const clearColor = [0, 0, 0, 0];
      return withGLParameters(this.device, {
        scissorTest: true,
        scissor: [padding, padding, target.width - 2 * padding, target.height - 2 * padding],
        blend: false,
        depthTest: true,
        depthRange: [0, 1]
      }, () => this.render({
        ...options,
        clearColor,
        target,
        pass: "collision"
      }));
    }
    getModuleParameters() {
      return {
        drawToCollisionMap: true,
        pickingActive: 1,
        pickingAttribute: false,
        lightSources: {}
      };
    }
  };

  // src/mask/mask-effect.ts
  var import_core50 = __toESM(require_core());

  // src/mask/mask-pass.ts
  var import_core48 = __toESM(require_core());
  var MaskPass = class extends import_core48._LayersPass {
    constructor(device, props) {
      super(device, props);
      const {
        mapSize = 2048
      } = props;
      this.maskMap = device.createTexture({
        format: "rgba8unorm",
        width: mapSize,
        height: mapSize,
        sampler: {
          minFilter: "linear",
          magFilter: "linear",
          addressModeU: "clamp-to-edge",
          addressModeV: "clamp-to-edge"
        }
      });
      this.fbo = device.createFramebuffer({
        id: "maskmap",
        width: mapSize,
        height: mapSize,
        colorAttachments: [this.maskMap]
      });
    }
    render(options) {
      const colorMask = [false, false, false, false];
      colorMask[options.channel] = true;
      const clearColor = [255, 255, 255, 255];
      return withGLParameters(this.device, {
        blend: true,
        blendFunc: [0, 1],
        blendEquation: 32778,
        colorMask,
        depthTest: false
      }, () => super.render({
        ...options,
        clearColor,
        target: this.fbo,
        pass: "mask"
      }));
    }
    shouldDrawLayer(layer) {
      return layer.props.operation.includes("mask");
    }
    delete() {
      this.fbo.delete();
      this.maskMap.delete();
    }
  };

  // src/utils/projection-utils.ts
  var import_core49 = __toESM(require_core());
  function joinLayerBounds(layers, viewport) {
    const bounds = [Infinity, Infinity, -Infinity, -Infinity];
    for (const layer of layers) {
      const layerBounds = layer.getBounds();
      if (layerBounds) {
        const bottomLeftCommon = layer.projectPosition(layerBounds[0], {
          viewport,
          autoOffset: false
        });
        const topRightCommon = layer.projectPosition(layerBounds[1], {
          viewport,
          autoOffset: false
        });
        bounds[0] = Math.min(bounds[0], bottomLeftCommon[0]);
        bounds[1] = Math.min(bounds[1], bottomLeftCommon[1]);
        bounds[2] = Math.max(bounds[2], topRightCommon[0]);
        bounds[3] = Math.max(bounds[3], topRightCommon[1]);
      }
    }
    if (Number.isFinite(bounds[0])) {
      return bounds;
    }
    return null;
  }
  var MAX_VIEWPORT_SIZE = 2048;
  function makeViewport(opts) {
    const {
      bounds,
      viewport,
      border = 0
    } = opts;
    const {
      isGeospatial
    } = viewport;
    if (bounds[2] <= bounds[0] || bounds[3] <= bounds[1]) {
      return null;
    }
    const centerWorld = viewport.unprojectPosition([(bounds[0] + bounds[2]) / 2, (bounds[1] + bounds[3]) / 2, 0]);
    let {
      width,
      height,
      zoom
    } = opts;
    if (zoom === void 0) {
      width = width - border * 2;
      height = height - border * 2;
      const scale2 = Math.min(width / (bounds[2] - bounds[0]), height / (bounds[3] - bounds[1]));
      zoom = Math.min(Math.log2(scale2), 20);
    } else if (!width || !height) {
      const scale2 = 2 ** zoom;
      width = Math.round(Math.abs(bounds[2] - bounds[0]) * scale2);
      height = Math.round(Math.abs(bounds[3] - bounds[1]) * scale2);
      const maxSize = MAX_VIEWPORT_SIZE - border * 2;
      if (width > maxSize || height > maxSize) {
        const r = maxSize / Math.max(width, height);
        width = Math.round(width * r);
        height = Math.round(height * r);
        zoom += Math.log2(r);
      }
    }
    return isGeospatial ? new import_core49.WebMercatorViewport({
      id: viewport.id,
      x: border,
      y: border,
      width,
      height,
      longitude: centerWorld[0],
      latitude: centerWorld[1],
      zoom,
      orthographic: true
    }) : new import_core49.OrthographicViewport({
      id: viewport.id,
      x: border,
      y: border,
      width,
      height,
      target: centerWorld,
      zoom,
      flipY: false
    });
  }
  function getViewportBounds(viewport, zRange) {
    let viewportBoundsWorld;
    if (zRange && zRange.length === 2) {
      const [minZ, maxZ] = zRange;
      const bounds0 = viewport.getBounds({
        z: minZ
      });
      const bounds1 = viewport.getBounds({
        z: maxZ
      });
      viewportBoundsWorld = [Math.min(bounds0[0], bounds1[0]), Math.min(bounds0[1], bounds1[1]), Math.max(bounds0[2], bounds1[2]), Math.max(bounds0[3], bounds1[3])];
    } else {
      viewportBoundsWorld = viewport.getBounds();
    }
    const viewportBottomLeftCommon = viewport.projectPosition(viewportBoundsWorld.slice(0, 2));
    const viewportTopRightCommon = viewport.projectPosition(viewportBoundsWorld.slice(2, 4));
    return [viewportBottomLeftCommon[0], viewportBottomLeftCommon[1], viewportTopRightCommon[0], viewportTopRightCommon[1]];
  }
  function getRenderBounds(layerBounds, viewport, zRange) {
    if (!layerBounds) {
      return [0, 0, 1, 1];
    }
    const viewportBounds = getViewportBounds(viewport, zRange);
    const paddedBounds = doubleBounds(viewportBounds);
    if (layerBounds[2] - layerBounds[0] <= paddedBounds[2] - paddedBounds[0] && layerBounds[3] - layerBounds[1] <= paddedBounds[3] - paddedBounds[1]) {
      return layerBounds;
    }
    return [Math.max(layerBounds[0], paddedBounds[0]), Math.max(layerBounds[1], paddedBounds[1]), Math.min(layerBounds[2], paddedBounds[2]), Math.min(layerBounds[3], paddedBounds[3])];
  }
  function doubleBounds(bounds) {
    const dx = bounds[2] - bounds[0];
    const dy = bounds[3] - bounds[1];
    const centerX = (bounds[0] + bounds[2]) / 2;
    const centerY = (bounds[1] + bounds[3]) / 2;
    return [centerX - dx, centerY - dy, centerX + dx, centerY + dy];
  }

  // src/mask/mask-effect.ts
  var MaskEffect = class {
    id = "mask-effect";
    props = null;
    useInPicking = true;
    order = 0;
    channels = [];
    masks = null;
    preRender(device, {
      layers,
      layerFilter,
      viewports,
      onViewportActive,
      views,
      isPicking
    }) {
      let didRender = false;
      if (!this.dummyMaskMap) {
        this.dummyMaskMap = device.createTexture({
          width: 1,
          height: 1
        });
      }
      if (isPicking) {
        return {
          didRender
        };
      }
      const maskLayers = layers.filter((l) => l.props.visible && l.props.operation.includes("mask"));
      if (maskLayers.length === 0) {
        this.masks = null;
        this.channels.length = 0;
        return {
          didRender
        };
      }
      this.masks = {};
      if (!this.maskPass) {
        this.maskPass = new MaskPass(device, {
          id: "default-mask"
        });
        this.maskMap = this.maskPass.maskMap;
      }
      const channelMap = this._sortMaskChannels(maskLayers);
      const viewport = viewports[0];
      const viewportChanged = !this.lastViewport || !this.lastViewport.equals(viewport);
      if (viewport.resolution !== void 0) {
        import_core50.log.warn("MaskExtension is not supported in GlobeView")();
        return {
          didRender
        };
      }
      for (const maskId in channelMap) {
        const result = this._renderChannel(channelMap[maskId], {
          layerFilter,
          onViewportActive,
          views,
          viewport,
          viewportChanged
        });
        didRender ||= result;
      }
      return {
        didRender
      };
    }
    _renderChannel(channelInfo, {
      layerFilter,
      onViewportActive,
      views,
      viewport,
      viewportChanged
    }) {
      let didRender = false;
      const oldChannelInfo = this.channels[channelInfo.index];
      if (!oldChannelInfo) {
        return didRender;
      }
      const maskChanged = channelInfo === oldChannelInfo || channelInfo.layers.length !== oldChannelInfo.layers.length || channelInfo.layers.some((layer, i) => layer !== oldChannelInfo.layers[i] || layer.props.transitions) || channelInfo.layerBounds.some((b, i) => b !== oldChannelInfo.layerBounds[i]);
      channelInfo.bounds = oldChannelInfo.bounds;
      channelInfo.maskBounds = oldChannelInfo.maskBounds;
      this.channels[channelInfo.index] = channelInfo;
      if (maskChanged || viewportChanged) {
        this.lastViewport = viewport;
        const layerBounds = joinLayerBounds(channelInfo.layers, viewport);
        channelInfo.bounds = layerBounds && getRenderBounds(layerBounds, viewport);
        if (maskChanged || !equals(channelInfo.bounds, oldChannelInfo.bounds)) {
          const {
            maskPass,
            maskMap
          } = this;
          const maskViewport = layerBounds && makeViewport({
            bounds: channelInfo.bounds,
            viewport,
            width: maskMap.width,
            height: maskMap.height,
            border: 1
          });
          channelInfo.maskBounds = maskViewport ? maskViewport.getBounds() : [0, 0, 1, 1];
          maskPass.render({
            pass: "mask",
            channel: channelInfo.index,
            layers: channelInfo.layers,
            layerFilter,
            viewports: maskViewport ? [maskViewport] : [],
            onViewportActive,
            views,
            moduleParameters: {
              devicePixelRatio: 1
            }
          });
          didRender = true;
        }
      }
      this.masks[channelInfo.id] = {
        index: channelInfo.index,
        bounds: channelInfo.maskBounds,
        coordinateOrigin: channelInfo.coordinateOrigin,
        coordinateSystem: channelInfo.coordinateSystem
      };
      return didRender;
    }
    _sortMaskChannels(maskLayers) {
      const channelMap = {};
      let channelCount = 0;
      for (const layer of maskLayers) {
        const {
          id
        } = layer.root;
        let channelInfo = channelMap[id];
        if (!channelInfo) {
          if (++channelCount > 4) {
            import_core50.log.warn("Too many mask layers. The max supported is 4")();
            continue;
          }
          channelInfo = {
            id,
            index: this.channels.findIndex((c) => c?.id === id),
            layers: [],
            layerBounds: [],
            coordinateOrigin: layer.root.props.coordinateOrigin,
            coordinateSystem: layer.root.props.coordinateSystem
          };
          channelMap[id] = channelInfo;
        }
        channelInfo.layers.push(layer);
        channelInfo.layerBounds.push(layer.getBounds());
      }
      for (let i = 0; i < 4; i++) {
        const channelInfo = this.channels[i];
        if (!channelInfo || !(channelInfo.id in channelMap)) {
          this.channels[i] = null;
        }
      }
      for (const maskId in channelMap) {
        const channelInfo = channelMap[maskId];
        if (channelInfo.index < 0) {
          channelInfo.index = this.channels.findIndex((c) => !c);
          this.channels[channelInfo.index] = channelInfo;
        }
      }
      return channelMap;
    }
    getModuleParameters() {
      return {
        maskMap: this.masks ? this.maskMap : this.dummyMaskMap,
        maskChannels: this.masks
      };
    }
    cleanup() {
      if (this.dummyMaskMap) {
        this.dummyMaskMap.delete();
        this.dummyMaskMap = void 0;
      }
      if (this.maskPass) {
        this.maskPass.delete();
        this.maskPass = void 0;
        this.maskMap = void 0;
      }
      this.lastViewport = void 0;
      this.masks = null;
      this.channels.length = 0;
    }
  };

  // src/collision-filter/collision-filter-effect.ts
  var DOWNSCALE = 2;
  var CollisionFilterEffect = class {
    id = "collision-filter-effect";
    props = null;
    useInPicking = true;
    order = 1;
    channels = {};
    collisionFBOs = {};
    preRender(device, {
      effects: allEffects,
      layers,
      layerFilter,
      viewports,
      onViewportActive,
      views,
      isPicking,
      preRenderStats = {}
    }) {
      if (!this.dummyCollisionMap) {
        this.dummyCollisionMap = device.createTexture({
          width: 1,
          height: 1
        });
      }
      if (isPicking) {
        return;
      }
      const collisionLayers = layers.filter(({
        props: {
          visible,
          collisionEnabled
        }
      }) => visible && collisionEnabled);
      if (collisionLayers.length === 0) {
        this.channels = {};
        return;
      }
      if (!this.collisionFilterPass) {
        this.collisionFilterPass = new CollisionFilterPass(device, {
          id: "default-collision-filter"
        });
      }
      const effects = allEffects?.filter((e) => e.constructor === MaskEffect);
      const maskEffectRendered = preRenderStats["mask-effect"]?.didRender;
      const channels = this._groupByCollisionGroup(device, collisionLayers);
      const viewport = viewports[0];
      const viewportChanged = !this.lastViewport || !this.lastViewport.equals(viewport) || maskEffectRendered;
      for (const collisionGroup in channels) {
        const collisionFBO = this.collisionFBOs[collisionGroup];
        const renderInfo = channels[collisionGroup];
        const [width, height] = device.canvasContext.getPixelSize();
        collisionFBO.resize({
          width: width / DOWNSCALE,
          height: height / DOWNSCALE
        });
        this._render(renderInfo, {
          effects,
          layerFilter,
          onViewportActive,
          views,
          viewport,
          viewportChanged
        });
      }
    }
    _render(renderInfo, {
      effects,
      layerFilter,
      onViewportActive,
      views,
      viewport,
      viewportChanged
    }) {
      const {
        collisionGroup
      } = renderInfo;
      const oldRenderInfo = this.channels[collisionGroup];
      if (!oldRenderInfo) {
        return;
      }
      const needsRender = viewportChanged || renderInfo === oldRenderInfo || !(0, import_core53._deepEqual)(oldRenderInfo.layers, renderInfo.layers, 1) || renderInfo.layerBounds.some((b, i) => !equals(b, oldRenderInfo.layerBounds[i])) || renderInfo.allLayersLoaded !== oldRenderInfo.allLayersLoaded || renderInfo.layers.some((layer) => layer.props.transitions);
      this.channels[collisionGroup] = renderInfo;
      if (needsRender) {
        this.lastViewport = viewport;
        const collisionFBO = this.collisionFBOs[collisionGroup];
        this.collisionFilterPass.renderCollisionMap(collisionFBO, {
          pass: "collision-filter",
          isPicking: true,
          layers: renderInfo.layers,
          effects,
          layerFilter,
          viewports: viewport ? [viewport] : [],
          onViewportActive,
          views,
          moduleParameters: {
            dummyCollisionMap: this.dummyCollisionMap,
            devicePixelRatio: collisionFBO.device.canvasContext.getDevicePixelRatio() / DOWNSCALE
          }
        });
      }
    }
    _groupByCollisionGroup(device, collisionLayers) {
      const channelMap = {};
      for (const layer of collisionLayers) {
        const {
          collisionGroup
        } = layer.props;
        let channelInfo = channelMap[collisionGroup];
        if (!channelInfo) {
          channelInfo = {
            collisionGroup,
            layers: [],
            layerBounds: [],
            allLayersLoaded: true
          };
          channelMap[collisionGroup] = channelInfo;
        }
        channelInfo.layers.push(layer);
        channelInfo.layerBounds.push(layer.getBounds());
        if (!layer.isLoaded) {
          channelInfo.allLayersLoaded = false;
        }
      }
      for (const collisionGroup of Object.keys(channelMap)) {
        if (!this.collisionFBOs[collisionGroup]) {
          this.createFBO(device, collisionGroup);
        }
        if (!this.channels[collisionGroup]) {
          this.channels[collisionGroup] = channelMap[collisionGroup];
        }
      }
      for (const collisionGroup of Object.keys(this.collisionFBOs)) {
        if (!channelMap[collisionGroup]) {
          this.destroyFBO(collisionGroup);
        }
      }
      return channelMap;
    }
    getModuleParameters(layer) {
      const {
        collisionGroup
      } = layer.props;
      const {
        collisionFBOs,
        dummyCollisionMap
      } = this;
      return {
        collisionFBO: collisionFBOs[collisionGroup],
        dummyCollisionMap
      };
    }
    cleanup() {
      if (this.dummyCollisionMap) {
        this.dummyCollisionMap.delete();
        this.dummyCollisionMap = void 0;
      }
      this.channels = {};
      for (const collisionGroup of Object.keys(this.collisionFBOs)) {
        this.destroyFBO(collisionGroup);
      }
      this.collisionFBOs = {};
      this.lastViewport = void 0;
    }
    createFBO(device, collisionGroup) {
      const {
        width,
        height
      } = device.gl.canvas;
      const collisionMap = device.createTexture({
        format: "rgba8unorm",
        width,
        height,
        sampler: {
          minFilter: "nearest",
          magFilter: "nearest",
          addressModeU: "clamp-to-edge",
          addressModeV: "clamp-to-edge"
        }
      });
      const depthBuffer = new WEBGLRenderbuffer(device, {
        format: "depth16unorm",
        width,
        height
      });
      this.collisionFBOs[collisionGroup] = device.createFramebuffer({
        id: `collision-${collisionGroup}`,
        width,
        height,
        colorAttachments: [collisionMap],
        depthStencilAttachment: depthBuffer
      });
    }
    destroyFBO(collisionGroup) {
      const fbo = this.collisionFBOs[collisionGroup];
      fbo.colorAttachments[0]?.destroy();
      fbo.depthStencilAttachment?.destroy();
      fbo.destroy();
      delete this.collisionFBOs[collisionGroup];
    }
  };

  // src/collision-filter/collision-filter-extension.ts
  var defaultProps6 = {
    getCollisionPriority: {
      type: "accessor",
      value: 0
    },
    collisionEnabled: true,
    collisionGroup: {
      type: "string",
      value: "default"
    },
    collisionTestProps: {}
  };
  var CollisionFilterExtension = class extends import_core54.LayerExtension {
    getShaders() {
      return {
        modules: [shader_module_default2]
      };
    }
    draw({
      uniforms,
      context,
      moduleParameters
    }) {
      const {
        collisionEnabled
      } = this.props;
      const {
        collisionFBO,
        drawToCollisionMap
      } = moduleParameters;
      const enabled = collisionEnabled && Boolean(collisionFBO);
      uniforms.collision_enabled = enabled;
      if (drawToCollisionMap) {
        this.props = this.clone(this.props.collisionTestProps).props;
      }
    }
    initializeState(context, extension) {
      if (this.getAttributeManager() === null) {
        return;
      }
      this.context.deck?._addDefaultEffect(new CollisionFilterEffect());
      const attributeManager = this.getAttributeManager();
      attributeManager.add({
        collisionPriorities: {
          size: 1,
          accessor: "getCollisionPriority",
          shaderAttributes: {
            collisionPriorities: {
              divisor: 0
            },
            instanceCollisionPriorities: {
              divisor: 1
            }
          }
        }
      });
    }
    getNeedsPickingBuffer() {
      return this.props.collisionEnabled;
    }
  };
  __publicField(CollisionFilterExtension, "defaultProps", defaultProps6);
  __publicField(CollisionFilterExtension, "extensionName", "CollisionFilterExtension");

  // src/mask/mask-extension.ts
  var import_core56 = __toESM(require_core());

  // src/mask/shader-module.ts
  var import_core55 = __toESM(require_core());
  var vs4 = `
uniform vec4 mask_bounds;
uniform bool mask_maskByInstance;
vec2 mask_getCoords(vec4 position) {
  return (position.xy - mask_bounds.xy) / (mask_bounds.zw - mask_bounds.xy);
}
`;
  var fs3 = `
uniform sampler2D mask_texture;
uniform int mask_channel;
uniform bool mask_enabled;
uniform bool mask_inverted;
bool mask_isInBounds(vec2 texCoords) {
  if (!mask_enabled) {
    return true;
  }
  vec4 maskColor = texture2D(mask_texture, texCoords);
  float maskValue = 1.0;
  if (mask_channel == 0) {
    maskValue = maskColor.r;
  } else if (mask_channel == 1) {
    maskValue = maskColor.g;
  } else if (mask_channel == 2) {
    maskValue = maskColor.b;
  } else if (mask_channel == 3) {
    maskValue = maskColor.a;
  }

  if (mask_inverted) {
    return maskValue >= 0.5;
  } else {
    return maskValue < 0.5;
  }
}
`;
  var inject5 = {
    "vs:#decl": `
varying vec2 mask_texCoords;
`,
    "vs:#main-end": `
   vec4 mask_common_position;
   if (mask_maskByInstance) {
     mask_common_position = project_position(vec4(geometry.worldPosition, 1.0));
   } else {
     mask_common_position = geometry.position;
   }
   mask_texCoords = mask_getCoords(mask_common_position);
`,
    "fs:#decl": `
varying vec2 mask_texCoords;
`,
    "fs:#main-start": `
  if (mask_enabled) {
    bool mask = mask_isInBounds(mask_texCoords);

    // Debug: show extent of render target
    // gl_FragColor = vec4(mask_texCoords, 0.0, 1.0);
    gl_FragColor = texture2D(mask_texture, mask_texCoords);

    if (!mask) discard;
  }
`
  };
  var getMaskUniforms = (opts) => {
    if (opts && "maskMap" in opts) {
      return {
        mask_texture: opts.maskMap
      };
    }
    return {};
  };
  var shader_module_default3 = {
    name: "mask",
    dependencies: [import_core55.project],
    vs: vs4,
    fs: fs3,
    inject: inject5,
    getUniforms: getMaskUniforms
  };

  // src/mask/mask-extension.ts
  var defaultProps7 = {
    maskId: "",
    maskByInstance: void 0,
    maskInverted: false
  };
  var MaskExtension = class extends import_core56.LayerExtension {
    initializeState() {
      this.context.deck?._addDefaultEffect(new MaskEffect());
    }
    getShaders() {
      let maskByInstance = "instancePositions" in this.getAttributeManager().attributes;
      if (this.props.maskByInstance !== void 0) {
        maskByInstance = Boolean(this.props.maskByInstance);
      }
      this.state.maskByInstance = maskByInstance;
      return {
        modules: [shader_module_default3]
      };
    }
    draw({
      uniforms,
      context,
      moduleParameters
    }) {
      uniforms.mask_maskByInstance = this.state.maskByInstance;
      const {
        maskId,
        maskInverted
      } = this.props;
      const {
        maskChannels
      } = moduleParameters;
      const {
        viewport
      } = context;
      if (maskChannels && maskChannels[maskId]) {
        const {
          index,
          bounds,
          coordinateOrigin: fromCoordinateOrigin
        } = maskChannels[maskId];
        let {
          coordinateSystem: fromCoordinateSystem
        } = maskChannels[maskId];
        uniforms.mask_enabled = true;
        uniforms.mask_channel = index;
        uniforms.mask_inverted = maskInverted;
        if (fromCoordinateSystem === import_core56.COORDINATE_SYSTEM.DEFAULT) {
          fromCoordinateSystem = viewport.isGeospatial ? import_core56.COORDINATE_SYSTEM.LNGLAT : import_core56.COORDINATE_SYSTEM.CARTESIAN;
        }
        const opts = {
          modelMatrix: null,
          fromCoordinateOrigin,
          fromCoordinateSystem
        };
        const bl = this.projectPosition([bounds[0], bounds[1], 0], opts);
        const tr = this.projectPosition([bounds[2], bounds[3], 0], opts);
        uniforms.mask_bounds = [bl[0], bl[1], tr[0], tr[1]];
      } else {
        if (maskId) {
          import_core56.log.warn(`Could not find a mask layer with id: ${maskId}`)();
        }
        uniforms.mask_enabled = false;
      }
    }
  };
  __publicField(MaskExtension, "defaultProps", defaultProps7);
  __publicField(MaskExtension, "extensionName", "MaskExtension");

  // src/terrain/terrain-extension.ts
  var import_core61 = __toESM(require_core());

  // src/terrain/terrain-effect.ts
  var import_core60 = __toESM(require_core());

  // src/terrain/shader-module.ts
  var import_core57 = __toESM(require_core());
  var TERRAIN_MODE = {
    NONE: 0,
    WRITE_HEIGHT_MAP: 1,
    USE_HEIGHT_MAP: 2,
    USE_COVER: 3,
    USE_COVER_ONLY: 4,
    SKIP: 5
  };
  var TERRAIN_MODE_CONSTANTS = Object.keys(TERRAIN_MODE).map((key) => `const float TERRAIN_MODE_${key} = ${TERRAIN_MODE[key]}.0;`).join("\n");
  var terrainModule = {
    name: "terrain",
    dependencies: [import_core57.project],
    inject: {
      "vs:#decl": `
uniform float terrain_mode;
uniform sampler2D terrain_map;
uniform vec4 terrain_bounds;
varying vec3 commonPos;
${TERRAIN_MODE_CONSTANTS}
    `,
      "vs:#main-start": `
if (terrain_mode == TERRAIN_MODE_SKIP) {
  gl_Position = vec4(0.0);
  return;
}
`,
      "vs:DECKGL_FILTER_GL_POSITION": `
commonPos = geometry.position.xyz;
if (terrain_mode == TERRAIN_MODE_WRITE_HEIGHT_MAP) {
  vec2 texCoords = (commonPos.xy - terrain_bounds.xy) / terrain_bounds.zw;
  position = vec4(texCoords * 2.0 - 1.0, 0.0, 1.0);
  commonPos.z += project_uCommonOrigin.z;
}
if (terrain_mode == TERRAIN_MODE_USE_HEIGHT_MAP) {
  vec3 anchor = geometry.worldPosition;
  anchor.z = 0.0;
  vec3 anchorCommon = project_position(anchor);
  vec2 texCoords = (anchorCommon.xy - terrain_bounds.xy) / terrain_bounds.zw;
  if (texCoords.x >= 0.0 && texCoords.y >= 0.0 && texCoords.x <= 1.0 && texCoords.y <= 1.0) {
    float terrainZ = texture2D(terrain_map, texCoords).r;
    geometry.position.z += terrainZ;
    position = project_common_position_to_clipspace(geometry.position);
  }
}
    `,
      "fs:#decl": `
uniform float terrain_mode;
uniform sampler2D terrain_map;
uniform vec4 terrain_bounds;
varying vec3 commonPos;
${TERRAIN_MODE_CONSTANTS}
    `,
      "fs:#main-start": `
if (terrain_mode == TERRAIN_MODE_WRITE_HEIGHT_MAP) {
  gl_FragColor = vec4(commonPos.z, 0.0, 0.0, 1.0);
  return;
}
    `,
      "fs:DECKGL_FILTER_COLOR": `
if ((terrain_mode == TERRAIN_MODE_USE_COVER) || (terrain_mode == TERRAIN_MODE_USE_COVER_ONLY)) {
  vec2 texCoords = (commonPos.xy - terrain_bounds.xy) / terrain_bounds.zw;
  vec4 pixel = texture2D(terrain_map, texCoords);
  if (terrain_mode == TERRAIN_MODE_USE_COVER_ONLY) {
    color = pixel;
  } else {
    // pixel is premultiplied
    color = pixel + color * (1.0 - pixel.a);
  }
  return;
}
    `
    },
    getUniforms: (opts = {}, uniforms) => {
      if ("dummyHeightMap" in opts) {
        const {
          drawToTerrainHeightMap,
          heightMap,
          heightMapBounds,
          dummyHeightMap,
          terrainCover,
          useTerrainHeightMap,
          terrainSkipRender
        } = opts;
        const {
          project_uCommonOrigin
        } = uniforms;
        let mode = terrainSkipRender ? TERRAIN_MODE.SKIP : TERRAIN_MODE.NONE;
        let sampler = dummyHeightMap;
        let bounds = null;
        if (drawToTerrainHeightMap) {
          mode = TERRAIN_MODE.WRITE_HEIGHT_MAP;
          bounds = heightMapBounds;
        } else if (useTerrainHeightMap && heightMap) {
          mode = TERRAIN_MODE.USE_HEIGHT_MAP;
          sampler = heightMap;
          bounds = heightMapBounds;
        } else if (terrainCover) {
          const isPicking = opts.pickingActive;
          sampler = isPicking ? terrainCover.getPickingFramebuffer() : terrainCover.getRenderFramebuffer();
          if (isPicking) {
            mode = TERRAIN_MODE.SKIP;
          }
          if (sampler) {
            mode = mode === TERRAIN_MODE.SKIP ? TERRAIN_MODE.USE_COVER_ONLY : TERRAIN_MODE.USE_COVER;
            bounds = terrainCover.bounds;
          } else {
            sampler = dummyHeightMap;
          }
        }
        return {
          terrain_mode: mode,
          terrain_map: sampler,
          terrain_bounds: bounds ? [bounds[0] - project_uCommonOrigin[0], bounds[1] - project_uCommonOrigin[1], bounds[2] - bounds[0], bounds[3] - bounds[1]] : [0, 0, 0, 0]
        };
      }
      return null;
    }
  };

  // src/terrain/utils.ts
  function createRenderTarget(device, opts) {
    return device.createFramebuffer({
      id: opts.id,
      colorAttachments: [device.createTexture({
        ...opts.float && {
          format: device.info.type === "webgl2" ? "rgba32float" : "rgba8unorm",
          type: 5126
        },
        mipmaps: false,
        sampler: {
          minFilter: "linear",
          magFilter: "linear",
          addressModeU: "clamp-to-edge",
          addressModeV: "clamp-to-edge"
        }
      })]
    });
  }

  // src/terrain/terrain-cover.ts
  var TerrainCover = class {
    isDirty = true;
    renderViewport = null;
    bounds = null;
    layers = [];
    targetBounds = null;
    targetBoundsCommon = null;
    constructor(targetLayer) {
      this.targetLayer = targetLayer;
      this.tile = getTile(targetLayer);
    }
    get id() {
      return this.targetLayer.id;
    }
    get isActive() {
      return Boolean(this.targetLayer.getCurrentLayer());
    }
    shouldUpdate({
      targetLayer,
      viewport,
      layers,
      layerNeedsRedraw
    }) {
      if (targetLayer) {
        this.targetLayer = targetLayer;
      }
      const sizeChanged = viewport ? this._updateViewport(viewport) : false;
      let layersChanged = layers ? this._updateLayers(layers) : false;
      if (layerNeedsRedraw) {
        for (const id of this.layers) {
          if (layerNeedsRedraw[id]) {
            layersChanged = true;
            break;
          }
        }
      }
      return layersChanged || sizeChanged;
    }
    _updateLayers(layers) {
      let needsRedraw = false;
      layers = this.tile ? getIntersectingLayers(this.tile, layers) : layers;
      if (layers.length !== this.layers.length) {
        needsRedraw = true;
      } else {
        for (let i = 0; i < layers.length; i++) {
          const id = layers[i].id;
          if (id !== this.layers[i]) {
            needsRedraw = true;
            break;
          }
        }
      }
      if (needsRedraw) {
        this.layers = layers.map((layer) => layer.id);
      }
      return needsRedraw;
    }
    _updateViewport(viewport) {
      const targetLayer = this.targetLayer;
      let shouldRedraw = false;
      if (this.tile && "boundingBox" in this.tile) {
        if (!this.targetBounds) {
          shouldRedraw = true;
          this.targetBounds = this.tile.boundingBox;
          const bottomLeftCommon = viewport.projectPosition(this.targetBounds[0]);
          const topRightCommon = viewport.projectPosition(this.targetBounds[1]);
          this.targetBoundsCommon = [bottomLeftCommon[0], bottomLeftCommon[1], topRightCommon[0], topRightCommon[1]];
        }
      } else if (this.targetBounds !== targetLayer.getBounds()) {
        shouldRedraw = true;
        this.targetBounds = targetLayer.getBounds();
        this.targetBoundsCommon = joinLayerBounds([targetLayer], viewport);
      }
      if (!this.targetBoundsCommon) {
        return false;
      }
      const newZoom = Math.ceil(viewport.zoom + 0.5);
      if (this.tile) {
        this.bounds = this.targetBoundsCommon;
      } else {
        const oldZoom = this.renderViewport?.zoom;
        shouldRedraw = shouldRedraw || newZoom !== oldZoom;
        const newBounds = getRenderBounds(this.targetBoundsCommon, viewport);
        const oldBounds = this.bounds;
        shouldRedraw = shouldRedraw || !oldBounds || newBounds.some((x, i) => x !== oldBounds[i]);
        this.bounds = newBounds;
      }
      if (shouldRedraw) {
        this.renderViewport = makeViewport({
          bounds: this.bounds,
          zoom: newZoom,
          viewport
        });
      }
      return shouldRedraw;
    }
    getRenderFramebuffer() {
      if (!this.renderViewport || this.layers.length === 0) {
        return null;
      }
      if (!this.fbo) {
        this.fbo = createRenderTarget(this.targetLayer.context.device, {
          id: this.id
        });
      }
      return this.fbo;
    }
    getPickingFramebuffer() {
      if (!this.renderViewport || this.layers.length === 0 && !this.targetLayer.props.pickable) {
        return null;
      }
      if (!this.pickingFbo) {
        this.pickingFbo = createRenderTarget(this.targetLayer.context.device, {
          id: `${this.id}-picking`
        });
      }
      return this.pickingFbo;
    }
    filterLayers(layers) {
      return layers.filter(({
        id
      }) => this.layers.includes(id));
    }
    delete() {
      const {
        fbo,
        pickingFbo
      } = this;
      if (fbo) {
        fbo.colorAttachments[0].destroy();
        fbo.destroy();
      }
      if (pickingFbo) {
        pickingFbo.colorAttachments[0].destroy();
        pickingFbo.destroy();
      }
    }
  };
  function getIntersectingLayers(sourceTile, layers) {
    return layers.filter((layer) => {
      const tile = getTile(layer);
      if (tile) {
        return intersect(sourceTile.boundingBox, tile.boundingBox);
      }
      return true;
    });
  }
  function getTile(layer) {
    while (layer) {
      const {
        tile
      } = layer.props;
      if (tile) {
        return tile;
      }
      layer = layer.parent;
    }
    return null;
  }
  function intersect(b1, b2) {
    if (b1 && b2) {
      return b1[0][0] < b2[1][0] && b2[0][0] < b1[1][0] && b1[0][1] < b2[1][1] && b2[0][1] < b1[1][1];
    }
    return false;
  }

  // src/terrain/terrain-pass.ts
  var import_core58 = __toESM(require_core());
  var TerrainPass = class extends import_core58._LayersPass {
    getRenderableLayers(viewport, opts) {
      const {
        layers
      } = opts;
      const result = [];
      const drawParamsByIndex = this._getDrawLayerParams(viewport, opts, true);
      for (let i = 0; i < layers.length; i++) {
        const layer = layers[i];
        if (!layer.isComposite && drawParamsByIndex[i].shouldDrawLayer) {
          result.push(layer);
        }
      }
      return result;
    }
    renderHeightMap(heightMap, opts) {
      const target = heightMap.getRenderFramebuffer();
      const viewport = heightMap.renderViewport;
      if (!target || !viewport) {
        return;
      }
      target.resize(viewport);
      withGLParameters(this.device, {
        clearColor: [0, 0, 0, 0],
        blend: true,
        blendFunc: [1, 1],
        blendEquation: 32776,
        depthTest: false
      }, () => this.render({
        ...opts,
        target,
        pass: "terrain-height-map",
        layers: opts.layers,
        viewports: [viewport],
        effects: []
      }));
    }
    renderTerrainCover(terrainCover, opts) {
      const target = terrainCover.getRenderFramebuffer();
      const viewport = terrainCover.renderViewport;
      if (!target || !viewport) {
        return;
      }
      const layers = terrainCover.filterLayers(opts.layers);
      target.resize(viewport);
      withGLParameters(this.device, {
        clearColor: [0, 0, 0, 0],
        depthTest: false
      }, () => this.render({
        ...opts,
        target,
        pass: `terrain-cover-${terrainCover.id}`,
        layers,
        effects: [],
        viewports: [viewport]
      }));
    }
  };

  // src/terrain/terrain-picking-pass.ts
  var import_core59 = __toESM(require_core());
  var TerrainPickingPass = class extends import_core59._PickLayersPass {
    drawParameters = {};
    getRenderableLayers(viewport, opts) {
      const {
        layers
      } = opts;
      const result = [];
      this.drawParameters = {};
      this._resetColorEncoder(opts.pickZ);
      const drawParamsByIndex = this._getDrawLayerParams(viewport, opts);
      for (let i = 0; i < layers.length; i++) {
        const layer = layers[i];
        if (!layer.isComposite && drawParamsByIndex[i].shouldDrawLayer) {
          result.push(layer);
          this.drawParameters[layer.id] = drawParamsByIndex[i].layerParameters;
        }
      }
      return result;
    }
    renderTerrainCover(terrainCover, opts) {
      const target = terrainCover.getPickingFramebuffer();
      const viewport = terrainCover.renderViewport;
      if (!target || !viewport) {
        return;
      }
      const layers = terrainCover.filterLayers(opts.layers);
      const terrainLayer = terrainCover.targetLayer;
      if (terrainLayer.props.pickable) {
        layers.unshift(terrainLayer);
      }
      target.resize(viewport);
      withGLParameters(this.device, {
        depthTest: false
      }, () => this.render({
        ...opts,
        pickingFBO: target,
        pass: `terrain-cover-picking-${terrainCover.id}`,
        layers,
        effects: [],
        viewports: [viewport],
        cullRect: void 0,
        deviceRect: viewport,
        pickZ: false
      }));
    }
    getLayerParameters(layer, layerIndex, viewport) {
      if (this.drawParameters[layer.id]) {
        return this.drawParameters[layer.id];
      }
      const parameters2 = super.getLayerParameters(layer, layerIndex, viewport);
      parameters2.blend = true;
      return parameters2;
    }
  };

  // src/terrain/height-map-builder.ts
  var MAP_MAX_SIZE = 2048;
  var HeightMapBuilder = class {
    renderViewport = null;
    bounds = null;
    layers = [];
    layersBounds = [];
    layersBoundsCommon = null;
    lastViewport = null;
    static isSupported(device) {
      return device.isTextureFormatRenderable("rgba32float");
    }
    constructor(device) {
      this.device = device;
    }
    getRenderFramebuffer() {
      if (!this.renderViewport) {
        return null;
      }
      if (!this.fbo) {
        this.fbo = createRenderTarget(this.device, {
          id: "height-map",
          float: true
        });
      }
      return this.fbo;
    }
    shouldUpdate({
      layers,
      viewport
    }) {
      const layersChanged = layers.length !== this.layers.length || layers.some((layer, i) => layer !== this.layers[i] || layer.props.transitions || layer.getBounds() !== this.layersBounds[i]);
      if (layersChanged) {
        this.layers = layers;
        this.layersBounds = layers.map((layer) => layer.getBounds());
        this.layersBoundsCommon = joinLayerBounds(layers, viewport);
      }
      const viewportChanged = !this.lastViewport || !viewport.equals(this.lastViewport);
      if (!this.layersBoundsCommon) {
        this.renderViewport = null;
      } else if (layersChanged || viewportChanged) {
        const bounds = getRenderBounds(this.layersBoundsCommon, viewport);
        if (bounds[2] <= bounds[0] || bounds[3] <= bounds[1]) {
          this.renderViewport = null;
          return false;
        }
        this.bounds = bounds;
        this.lastViewport = viewport;
        const scale2 = viewport.scale;
        const pixelWidth = (bounds[2] - bounds[0]) * scale2;
        const pixelHeight = (bounds[3] - bounds[1]) * scale2;
        this.renderViewport = pixelWidth > 0 || pixelHeight > 0 ? makeViewport({
          bounds: [viewport.center[0] - 1, viewport.center[1] - 1, viewport.center[0] + 1, viewport.center[1] + 1],
          zoom: viewport.zoom,
          width: Math.min(pixelWidth, MAP_MAX_SIZE),
          height: Math.min(pixelHeight, MAP_MAX_SIZE),
          viewport
        }) : null;
        return true;
      }
      return false;
    }
    delete() {
      if (this.fbo) {
        this.fbo.colorAttachments[0].delete();
        this.fbo.delete();
      }
    }
  };

  // src/terrain/terrain-effect.ts
  var TerrainEffect = class {
    id = "terrain-effect";
    props = null;
    useInPicking = true;
    isPicking = false;
    isDrapingEnabled = false;
    terrainCovers = /* @__PURE__ */ new Map();
    initialize(device) {
      this.dummyHeightMap = device.createTexture({
        width: 1,
        height: 1,
        data: new Uint8Array([0, 0, 0, 0])
      });
      this.terrainPass = new TerrainPass(device, {
        id: "terrain"
      });
      this.terrainPickingPass = new TerrainPickingPass(device, {
        id: "terrain-picking"
      });
      if (HeightMapBuilder.isSupported(device)) {
        this.heightMap = new HeightMapBuilder(device);
      } else {
        import_core60.log.warn("Terrain offset mode is not supported by this browser")();
      }
      (0, import_core60.getShaderAssembler)().addDefaultModule(terrainModule);
    }
    preRender(device, opts) {
      if (!this.dummyHeightMap) {
        this.initialize(device);
        for (const layer of opts.layers) {
          if (layer.props.operation.includes("terrain")) {
            layer.setChangeFlags({
              extensionsChanged: true
            });
          }
        }
      }
      if (opts.pickZ) {
        this.isDrapingEnabled = false;
        return;
      }
      const {
        viewports,
        isPicking = false
      } = opts;
      this.isPicking = isPicking;
      this.isDrapingEnabled = true;
      const viewport = viewports[0];
      const layers = (isPicking ? this.terrainPickingPass : this.terrainPass).getRenderableLayers(viewport, opts);
      const terrainLayers = layers.filter((l) => l.props.operation.includes("terrain"));
      if (terrainLayers.length === 0) {
        return;
      }
      if (!isPicking) {
        const offsetLayers = layers.filter((l) => l.state.terrainDrawMode === "offset");
        if (offsetLayers.length > 0) {
          this._updateHeightMap(terrainLayers, viewport, opts);
        }
      }
      const drapeLayers = layers.filter((l) => l.state.terrainDrawMode === "drape");
      this._updateTerrainCovers(terrainLayers, drapeLayers, viewport, opts);
    }
    getModuleParameters(layer) {
      const {
        terrainDrawMode
      } = layer.state;
      return {
        heightMap: this.heightMap?.getRenderFramebuffer(),
        heightMapBounds: this.heightMap?.bounds,
        dummyHeightMap: this.dummyHeightMap,
        terrainCover: this.isDrapingEnabled ? this.terrainCovers.get(layer.id) : null,
        useTerrainHeightMap: terrainDrawMode === "offset",
        terrainSkipRender: terrainDrawMode === "drape" || !layer.props.operation.includes("draw")
      };
    }
    cleanup() {
      if (this.dummyHeightMap) {
        this.dummyHeightMap.delete();
        this.dummyHeightMap = void 0;
      }
      if (this.heightMap) {
        this.heightMap.delete();
        this.heightMap = void 0;
      }
      for (const terrainCover of this.terrainCovers.values()) {
        terrainCover.delete();
      }
      this.terrainCovers.clear();
    }
    _updateHeightMap(terrainLayers, viewport, opts) {
      if (!this.heightMap) {
        return;
      }
      const shouldUpdate = this.heightMap.shouldUpdate({
        layers: terrainLayers,
        viewport
      });
      if (!shouldUpdate) {
        return;
      }
      this.terrainPass.renderHeightMap(this.heightMap, {
        ...opts,
        layers: terrainLayers,
        moduleParameters: {
          heightMapBounds: this.heightMap.bounds,
          dummyHeightMap: this.dummyHeightMap,
          devicePixelRatio: 1,
          drawToTerrainHeightMap: true
        }
      });
    }
    _updateTerrainCovers(terrainLayers, drapeLayers, viewport, opts) {
      const layerNeedsRedraw = {};
      for (const layer of drapeLayers) {
        if (layer.state.terrainCoverNeedsRedraw) {
          layerNeedsRedraw[layer.id] = true;
          layer.state.terrainCoverNeedsRedraw = false;
        }
      }
      for (const terrainCover of this.terrainCovers.values()) {
        terrainCover.isDirty = terrainCover.isDirty || terrainCover.shouldUpdate({
          layerNeedsRedraw
        });
      }
      for (const layer of terrainLayers) {
        this._updateTerrainCover(layer, drapeLayers, viewport, opts);
      }
      if (!this.isPicking) {
        this._pruneTerrainCovers();
      }
    }
    _updateTerrainCover(terrainLayer, drapeLayers, viewport, opts) {
      const renderPass = this.isPicking ? this.terrainPickingPass : this.terrainPass;
      let terrainCover = this.terrainCovers.get(terrainLayer.id);
      if (!terrainCover) {
        terrainCover = new TerrainCover(terrainLayer);
        this.terrainCovers.set(terrainLayer.id, terrainCover);
      }
      try {
        const isDirty = terrainCover.shouldUpdate({
          targetLayer: terrainLayer,
          viewport,
          layers: drapeLayers
        });
        if (this.isPicking || terrainCover.isDirty || isDirty) {
          renderPass.renderTerrainCover(terrainCover, {
            ...opts,
            layers: drapeLayers,
            moduleParameters: {
              dummyHeightMap: this.dummyHeightMap,
              terrainSkipRender: false,
              devicePixelRatio: 1
            }
          });
          terrainCover.isDirty = false;
        }
      } catch (err) {
        terrainLayer.raiseError(err, `Error rendering terrain cover ${terrainCover.id}`);
      }
    }
    _pruneTerrainCovers() {
      const idsToRemove = [];
      for (const [id, terrainCover] of this.terrainCovers) {
        if (!terrainCover.isActive) {
          idsToRemove.push(id);
        }
      }
      for (const id of idsToRemove) {
        this.terrainCovers.delete(id);
      }
    }
  };

  // src/terrain/terrain-extension.ts
  var defaultProps8 = {
    terrainDrawMode: void 0
  };
  var TerrainExtension = class extends import_core61.LayerExtension {
    getShaders() {
      return {
        modules: [terrainModule]
      };
    }
    initializeState() {
      this.context.deck?._addDefaultEffect(new TerrainEffect());
    }
    updateState(params) {
      const {
        props,
        oldProps
      } = params;
      if (this.state.terrainDrawMode && props.terrainDrawMode === oldProps.terrainDrawMode && props.extruded === oldProps.extruded) {
        return;
      }
      let {
        terrainDrawMode
      } = props;
      if (!terrainDrawMode) {
        const is3d = this.props.extruded;
        const attributes = this.getAttributeManager()?.attributes;
        const hasAnchor = attributes && "instancePositions" in attributes;
        terrainDrawMode = is3d || hasAnchor ? "offset" : "drape";
      }
      this.setState({
        terrainDrawMode
      });
    }
    onNeedsRedraw() {
      const state = this.state;
      if (state.terrainDrawMode === "drape") {
        state.terrainCoverNeedsRedraw = true;
      }
    }
  };
  __publicField(TerrainExtension, "defaultProps", defaultProps8);
  __publicField(TerrainExtension, "extensionName", "TerrainExtension");
  return __toCommonJS(bundle_exports);
})();
      return __exports__;
      });
